SystemOrganization addCategory: 'SqueakSource-Core-Announcements'!
SystemOrganization addCategory: 'SqueakSource-Core-Magritte'!
SystemOrganization addCategory: 'SqueakSource-Core-Model'!
SystemOrganization addCategory: 'SqueakSource-Core-Server'!
SystemOrganization addCategory: 'SqueakSource-Core-View-Components'!
SystemOrganization addCategory: 'SqueakSource-Core-View-Decorations'!
SystemOrganization addCategory: 'SqueakSource-Core-View-Fake'!

WABatchedList subclass: #SSBatchedList
	instanceVariableNames: 'displayedPages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 11:57'!
basicPageRangeEnd
	^ self maxPages
		min: self currentPage + (self displayedPages / 2)! !

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 11:57'!
basicPageRangeStart
	^ 1 max: self currentPage - (self displayedPages)! !

!SSBatchedList methodsFor: 'accessing' stamp: 'pmm 7/10/2005 11:37'!
displayedPages
	^displayedPages! !

!SSBatchedList methodsFor: 'accessing' stamp: 'pmm 7/10/2005 11:37'!
displayedPages: anInteger
	displayedPages := anInteger! !

!SSBatchedList methodsFor: 'actions' stamp: 'pmm 7/10/2005 14:55'!
firstPage
	self currentPage: 1! !

!SSBatchedList methodsFor: 'initialize-release' stamp: 'pmm 7/10/2005 14:57'!
initialize
	super initialize.
	self displayedPages: 10! !

!SSBatchedList methodsFor: 'accessing' stamp: 'pmm 7/10/2005 15:04'!
items: aCollection
	super items: aCollection.
	self currentPage: (self maxPages min: self currentPage)! !

!SSBatchedList methodsFor: 'actions' stamp: 'pmm 7/10/2005 14:56'!
lastPage
	self currentPage: self maxPages! !

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 15:06'!
maxPages
	^ 1 max: (items size / batchSize) ceiling! !

!SSBatchedList methodsFor: 'actions' stamp: 'pmm 6/8/2006 07:23'!
nextPage
	self isOnLastPage ifFalse: [
		self currentPage:
			(self maxPages min: self currentPage + 1) ]! !

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 12:04'!
pageRangeEnd
	| basicStart increment |
	basicStart := self basicPageRangeStart.
	increment := (self displayedPages / 2) + (self currentPage - basicStart).
	^ self maxPages
		min: self currentPage + increment! !

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 12:03'!
pageRangeStart
	| increment basicEnd |
	basicEnd := self basicPageRangeEnd.
	increment := (self displayedPages / 2) + (basicEnd - self currentPage).
	^ 1 max: self currentPage - increment! !

!SSBatchedList methodsFor: 'actions' stamp: 'pmm 6/8/2006 07:23'!
previousPage
	self isOnFirstPage ifFalse: [
		self currentPage: (1 max: currentPage - 1) ]! !

!SSBatchedList methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:09'!
renderFirstOn: html
	self pageRangeStart = 1 ifFalse: [
		html anchor
			callback: [self currentPage: 1 ];
			with: '1'.
		html space.
		self pageRangeStart = 2 ifFalse: [
			html text: '...'.
			html space ] ]! !

!SSBatchedList methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:09'!
renderLastOn: html
	self pageRangeEnd = self maxPages ifFalse: [
		html space.
		self pageRangeEnd = (self maxPages - 1) ifFalse: [
			html text: '...'.
			html space ].
		html anchor
			callback: [self currentPage: self maxPages ];
			with: self maxPages.
		html space ].! !

!SSBatchedList methodsFor: 'rendering' stamp: 'topa 10/28/2010 12:35'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [
			html anchor
				title: 'next';
				callback: [self nextPage];
				with: [html big: [html html: '&rsaquo;']].
			html space.
			html anchor
				title: 'last';
				callback: [self lastPage];
				with: [html big: [html html: '&raquo;']]]
		ifTrue: [html big: [html html: '&raquo;']].! !

!SSBatchedList methodsFor: 'rendering' stamp: 'pmm 7/10/2005 14:34'!
renderPagesOn: html
	self renderFirstOn: html.
	super renderPagesOn: html.
	self renderLastOn: html.! !

!SSBatchedList methodsFor: 'rendering' stamp: 'topa 10/28/2010 12:36'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ 
			html anchor
				title: 'first';
				callback: [self firstPage];
				with: [html big: [html html: '&laquo;']].
			html space.
			html anchor
				title: 'previous';
				callback: [self previousPage];
				with: [html big: [html html: '&lsaquo;']]]
		ifTrue: [html big: [html html: '&laquo;']].
	html space.! !

!UndefinedObject methodsFor: '*squeaksource-core' stamp: 'pmm 6/21/2006 09:53'!
fullnameOrUnknown
	^'unknown'! !

!Color class methodsFor: '*SqueakSource-Core' stamp: 'lr 2/27/2004 19:46'!
activity: aFloat
	| index hue |
	index := aFloat min: 1.0 max: 0.0.
	hue := 240 - (240 * index).
	^self h: hue s: 1 v: 1! !

WASession subclass: #SSSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Server'!

!SSSession methodsFor: 'accessing' stamp: 'topa 10/27/2010 17:53'!
charSet
	^ 'utf-8'! !

!SSSession methodsFor: 'testing' stamp: 'topa 12/20/2010 08:48'!
isSuperUser

	^ self isValidUser and: [ self user isSuperUser ]! !

!SSSession methodsFor: 'testing' stamp: 'topa 12/20/2010 08:48'!
isValidUser

	^ self user notNil and: [self user notAnonymous]! !

!SSSession methodsFor: 'actions' stamp: 'lr 3/15/2004 17:49'!
login: aMember
	user := aMember! !

!SSSession methodsFor: 'actions' stamp: 'topa 6/21/2010 09:26'!
logout
	self description.
	user := nil.
	self requestContext redirectTo: self application url! !

!SSSession methodsFor: 'accessing' stamp: 'JGF 7/22/2009 09:20'!
projectNamed: aString

	^self projectNamed: aString ifNotAllowed: [:project | nil ]! !

!SSSession methodsFor: 'accessing' stamp: 'pmm 6/27/2010 17:41'!
projectNamed: aString ifNotAllowed: aBlock
	| project |
	project := self repository projectAt: aString ifAbsent: [ ^nil ].
	^(self repository isVisible: project to: self user)
			ifTrue: [ project ]
			ifFalse: [ aBlock value: project ]! !

!SSSession methodsFor: 'private' stamp: 'topa 6/19/2010 20:09'!
relativePathFor: aRequest
	| accessPath |
	accessPath := aRequest uri path.
	^accessPath
		copyFrom: self application url path size + 1
		to: accessPath size! !

!SSSession methodsFor: 'accessing' stamp: 'lr 1/31/2004 17:24'!
repository
	^SSRepository current! !

!SSSession methodsFor: 'actions' stamp: 'al 1/17/2006 16:27'!
save
	"self storage saveRepository: self repository."! !

!SSSession methodsFor: 'accessing' stamp: 'lr 1/31/2004 20:18'!
storage
	^SSRepository storage! !

!SSSession methodsFor: 'accessing' stamp: 'topa 12/20/2010 09:08'!
user
	user ifNil: [user := self repository 
		authenticateUser: self requestContext request user
		password: self requestContext request password].
	^ user! !

WAObject subclass: #SSBareComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Fake'!

!SSBareComponent methodsFor: 'rendering' stamp: 'lr 1/29/2004 11:26'!
renderContentOn: html! !

!SSBareComponent methodsFor: 'accessing' stamp: 'pmm 6/27/2010 17:01'!
repository
	^ SSRepository current! !

!SSBareComponent methodsFor: 'rendering' stamp: 'pmm 6/28/2010 07:18'!
respondRendered
	
	self requestContext respond: [:response |
		response
			contentType: WAMimeType textHtml;
			nextPutAll: (	WARenderCanvas builder
				fullDocument: true;
				rootBlock: [ :root | 
					self updateRoot:root ];
				render: [ :canvas |
					self renderContentOn: canvas ])].! !

!SSBareComponent methodsFor: 'updating' stamp: 'pmm 8/30/2007 10:58'!
updateRoot: html
	"can be overridden by subclasses"! !

SSBareComponent subclass: #SSVersionListing
	instanceVariableNames: 'projects associations user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Fake'!

SSVersionListing subclass: #SSBlessedVersionListing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Fake'!

!SSBlessedVersionListing methodsFor: 'initialization' stamp: 'topa 3/14/2011 23:51'!
appendProject: aProject to: aStream
	
	self repository blessingsEnabled 
		ifTrue: [super appendProject: aProject to: aStream].! !

!SSBlessedVersionListing methodsFor: 'rendering' stamp: 'topa 3/14/2011 18:32'!
renderProject: aProject version: aVersion on: html
	
	html anchor
		url:  aVersion fileName;
		with: aVersion package.! !

SSVersionListing subclass: #SSChangesListing
	instanceVariableNames: 'expand sortedInfos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Fake'!

!SSChangesListing commentStamp: 'bf 3/29/2011 12:05' prior: 0!
SSChangesListing provides an update-stream-like series of changesets corresponding to the uploaded MC packages. It needs MCConfigurations named "update-xx.123" as used e.g. in Squeak Trunk development, mimicing the changes that would be loaded when updating.

WARNING: the resulting series of changesets is NOT 100% equivalent to loading MC packages and might need manual editing.

Instance Variables
expand: if true, intermediate changesets are listed between two configs
sortedInfos: all version infos in project ordered by timestamp!

!SSChangesListing methodsFor: 'accessing' stamp: 'topa 3/31/2011 20:42'!
expand
	^ expand! !

!SSChangesListing methodsFor: 'accessing' stamp: 'topa 3/31/2011 20:42'!
expand: anObject
	expand := anObject! !

!SSChangesListing methodsFor: 'initialization' stamp: 'topa 3/31/2011 20:42'!
initialize
	super initialize.
	self expand: false.! !

!SSChangesListing methodsFor: 'rendering' stamp: 'topa 3/31/2011 08:20'!
renderChangeFrom: oldInfo to: newInfo on: html
	"List changes from old version to new version"
	| intermediate diff cs |
	oldInfo = newInfo ifTrue: [^self].
	intermediate := self versionAfter: oldInfo upTo: newInfo.
	intermediate ifNotNil: [
		cs := (MCDiffyVersion nameForVer: intermediate name base: oldInfo name), '.cs'.
		html anchor url: cs; with: cs. 
		html break.
		self renderChangeFrom: intermediate to: newInfo on: html]
	ifNil: ["should not be reached ever"
		diff := MCDiffyVersion nameForVer: newInfo name base: oldInfo name.
		html text: diff; break].! !

!SSChangesListing methodsFor: 'rendering' stamp: 'topa 3/31/2011 13:47'!
renderChangesFrom: old to: new on: html
	"List changes from old configuration to new configuration"

	| newPackages oldPackages added removed oldDep |
	newPackages := new dependencies collect: [:dep | dep package].
	oldPackages :=  old dependencies collect: [:dep | dep package].
	added := new dependencies reject: [:dep | oldPackages includes: dep package].
	removed := old dependencies reject: [:dep | newPackages includes: dep package].
	added ifNotEmpty: [
		html strong: 'Added: '.
		added do: [:each | html text: each versionInfo name]
			separatedBy: [ html text: ', '].
		html break].
	removed ifNotEmpty: [
		html strong: 'Removed: '.
		removed do: [:each | html text: each versionInfo name]
			separatedBy: [ html text: ', '].
		html break].
	 new dependencies do: [:newDep |
		oldDep := old dependencies detect: [:p | newDep package = p package] ifNone: [].
		oldDep ifNotNil: [
			self renderChangeFrom: oldDep versionInfo to: newDep versionInfo on: html]].! !

!SSChangesListing methodsFor: 'rendering' stamp: 'topa 4/4/2011 13:23'!
renderContentOn: html

	| configs prevConfig latestConfig latestVersions number |
	"find update configs"
	configs := self project configs copy.
	configs keys do: [:key |
		(key beginsWith: 'update-') ifFalse: [configs removeKey: key]].
	configs ifEmpty: [
		self requestContext responseGenerator notFound; respond].
	configs := configs asSortedCollection: [:a :b |
		a name numericSuffix < b name numericSuffix].
	"list changes in update configs"
	html heading level: 1; with: 'Changes for ', self project title.

	self renderExpandOn: html.
	prevConfig := MCConfiguration new.
	configs do: [:config |
		self renderChangesFrom: prevConfig to: config on: html.
		number := config dependencies inject: 0 into: [:sum :dep |
			sum + dep versionInfo name numericSuffix].
		html strong: 'Config: '; text: config fileName; text: ' (', number asString,')'; break.
		prevConfig := config].
	"make up config with latest versions"
	latestVersions := Dictionary new.
	self project latestVersions do: [:ver |
		latestVersions at: ver package asLowercase put: ver versionInfo].
	latestConfig := MCConfiguration new dependencies: (
		prevConfig dependencies collect: [:dep |
			MCVersionDependency package: dep package
				info: (latestVersions at: dep package name asLowercase)]).
	"list latest changes"
	self renderChangesFrom: prevConfig to: latestConfig on: html.! !

!SSChangesListing methodsFor: 'rendering' stamp: 'topa 4/4/2011 13:23'!
renderExpandOn: html

	| action |
	action := expand
		ifTrue: ['collapse']
		ifFalse: ['expand'].
	html text: '[ '.
	html anchor url: '?view=', action; with: action.
	html text: ' ]'; break; break.! !

!SSChangesListing methodsFor: 'private' stamp: 'bf 3/29/2011 11:57'!
versionAfter: oldInfo upTo: newInfoX
	| newInfo i newPkg newVer nextInfo nextPkg nextVer oldVer |
	expand ifFalse: [^newInfoX].
	"look up version with ancestors"
	newInfo := (self project versionAt: newInfoX name, '.mcz' ifAbsent: [^nil]) versionInfo.
	"direct parent"
	(newInfo ancestors includes: oldInfo) ifTrue: [^newInfo].
	"find next version according to timestamp"
	sortedInfos ifNil: [
		sortedInfos := (self project versions asSortedCollection: [:a :b | a timestamp < b timestamp])
			collect: [:each | each versionInfo]].
	newPkg := (newInfo name copyUpToLast: $-) asLowercase.
	oldVer := oldInfo name numericSuffix.
	newVer := newInfo name numericSuffix.
	i := sortedInfos indexOf: oldInfo.
	[i < sortedInfos size] whileTrue: [
		i := i + 1.
		nextInfo := sortedInfos at: i.
		nextPkg := (nextInfo name copyUpToLast: $-) asLowercase.
		nextPkg = newPkg ifTrue: [
			nextVer := nextInfo name numericSuffix.
			nextVer > oldVer ifTrue: [
				^nextVer < newVer 
					ifTrue: [nextInfo]
					ifFalse: [newInfo]]]].
	^newInfo! !

SSVersionListing subclass: #SSDirectoryListing
	instanceVariableNames: 'fakeZips'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Fake'!

!SSDirectoryListing class methodsFor: 'instance creation' stamp: 'pmm 6/30/2010 18:19'!
user: aMember project: aProject fakeZips: aBoolean
	^(super user: aMember project: aProject)
		fakeZips: aBoolean;
		yourself! !

!SSDirectoryListing methodsFor: 'accessing' stamp: 'pmm 10/8/2006 23:54'!
fakeZips
	^fakeZips! !

!SSDirectoryListing methodsFor: 'accessing' stamp: 'pmm 10/8/2006 23:54'!
fakeZips: aBoolean
	fakeZips := aBoolean! !

!SSDirectoryListing methodsFor: 'accessing' stamp: 'pmm 9/9/2007 12:49'!
homepageUrlText
	^self repository title , ' project page'! !

!SSDirectoryListing methodsFor: 'initialize-release' stamp: 'pmm 10/8/2006 23:54'!
initialize
	super initialize.
	self fakeZips: false! !

!SSDirectoryListing methodsFor: 'accessing' stamp: 'pmm 1/20/2006 11:34'!
project
	^self projects first! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'pmm 6/30/2010 17:57'!
renderConfigsOn: html
	projects do: [ :aProject |
		(aProject isMember: self user allowedTo: SSAccessPolicy read)
			ifTrue: [ aProject configs do: [ :each |
				self renderProject: aProject config: each on: html ] ] ]! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'jgf 7/24/2009 09:39'!
renderContentOn: html
	html heading level1; with: self title.
	html anchor
		url: self project fullHomepageUrl;
		with: self homepageUrlText.
	html paragraph: [
		html withLineBreaks: self information ].
	super renderContentOn: html.
	self renderConfigsOn: html.! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'pmm 8/26/2007 11:16'!
renderProject: aProject config: aConfig on: html
	html anchor
		url: aConfig fileName;
		with: aConfig fileName.
	html break.! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'topa 10/28/2010 12:59'!
renderProject: aProject version: aVersion on: html
	| fileName |
	fileName := aVersion fileNameFaked: self fakeZips.
	html anchor
		url: fileName;
		with: fileName.
	html break! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'topa 6/21/2010 09:25'!
respondRendered
	self requestContext request url slash
		ifFalse: [ self requestContext redirectTo: (self requestContext request url slash: true)].
	^super respondRendered.! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'jgf 7/24/2009 09:39'!
updateRoot: root

	super updateRoot: root.
	root title: self title.! !

SSVersionListing subclass: #SSRssListing
	instanceVariableNames: 'timezone cutoff'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Fake'!

!SSRssListing commentStamp: '<historical>' prior: 0!
http://blogs.law.harvard.edu/tech/rss!

!SSRssListing methodsFor: 'initialization' stamp: 'obi 3/16/2011 20:23'!
appendProject: aProject to: aStream
	(aProject isMember: self user allowedTo: SSAccessPolicy read)
		ifFalse: [ ^ self ].
	aProject versionsDo: [ :version |
		cutoff < version timestamp
			ifTrue: [ aStream nextPut: aProject -> version ] ].
	aProject feeds do: [ :feed |
		aStream nextPut: aProject -> feed ]! !

!SSRssListing methodsFor: 'accessing' stamp: 'lr 3/19/2004 10:34'!
associations
	^super associations
		first: (self defaultSize min: super associations size)! !

!SSRssListing methodsFor: 'accessing' stamp: 'lr 5/31/2010 10:15'!
defaultCutoff
	^ TimeStamp current - 3 days! !

!SSRssListing methodsFor: 'accessing' stamp: 'lr 2/19/2004 13:02'!
defaultSize
	^20! !

!SSRssListing methodsFor: 'initialization' stamp: 'lr 5/31/2010 10:14'!
initialize
	super initialize.
	cutoff := self defaultCutoff! !

!SSRssListing methodsFor: 'rendering' stamp: 'topa 5/19/2011 20:48'!
renderContentOn: rss
	rss title: self title.
	rss description: [
		rss withLineBreaks: self information ].
	rss link: self url.
	rss generator: self repository title.
	rss webMaster: self superUserEmail first.
	rss defaultDocumentation.
	super renderContentOn: rss! !

!SSRssListing methodsFor: 'rendering' stamp: 'topa 7/5/2010 13:44'!
renderProject: aProject version: aVersionOrFeedEntry on: rss
	| author |
	rss item: [
		rss title: aVersionOrFeedEntry title.
		rss link: aProject fullHomepageUrl.
		rss description: [
			rss withLineBreaks: aVersionOrFeedEntry message ].
		
		rss publicationDate: (RRRfc822DateTime
			dateAndTime: aVersionOrFeedEntry timestamp
			timezoneString: self timezone) printString.
		
		"author"
		author := aVersionOrFeedEntry author.
		(author notNil and: [ author hasRssAuthorString ]) ifTrue: [
			rss author: author fullEmailAddress ].

		"category"
		rss category: [
			rss text: aProject title.
			aProject tags do: [ :each |
				rss text: ', '.
				rss text: each name ] ].
		
		"enclosure"
		(aVersionOrFeedEntry isVersion and: [ aVersionOrFeedEntry size > 0 ]) ifTrue: [
			rss enclosure
				url: (aVersionOrFeedEntry url: aProject);
				length: aVersionOrFeedEntry size;
				type: (WAMimeType main: 'application' sub: 'x-monticello') ].
		
		"guid"
		aVersionOrFeedEntry hasGuid ifTrue: [
			rss guid
				beNoPermaLink;
				with: (aProject guidStringFor: aVersionOrFeedEntry) ] ]! !

!SSRssListing methodsFor: 'rendering' stamp: 'topa 7/5/2010 13:38'!
respondRendered
	
	self requestContext respond: [:response |
		response
			contentType: WAMimeType applicationRssXml;
			nextPutAll: (RRRssRenderCanvas builder
				fullDocument: true;
				render: [ :canvas |
					self renderContentOn: canvas ]) ]! !

!SSRssListing methodsFor: 'accessing' stamp: 'topa 5/19/2011 21:13'!
superUserEmail
	^String streamContents: [ :stream |
		self repository superUserEmail 
			do: [ :each | stream nextPutAll: each greaseString ]
			separatedBy: [ stream nextPutAll: '; ' ] ]! !

!SSRssListing methodsFor: 'accessing' stamp: 'topa 12/20/2010 11:09'!
timezone
	timezone ifNil: [
		timezone := self repository timezone].
	^timezone! !

!SSRssListing methodsFor: 'path' stamp: 'topa 10/27/2010 17:53'!
updateRoot: rss
	rss charSet: 'utf-8'! !

!SSVersionListing class methodsFor: 'instance creation' stamp: 'pmm 6/30/2010 18:19'!
user: aMember project: aProject
	^self user: aMember projects: (Array with: aProject)! !

!SSVersionListing class methodsFor: 'instance creation' stamp: 'pmm 6/30/2010 18:19'!
user: aMember projects: aCollection
	^self new
		setUser: aMember;
		setProjects: aCollection;
		yourself! !

!SSVersionListing methodsFor: 'initialization' stamp: 'obi 3/16/2011 20:22'!
appendProject: aProject to: aStream
	(aProject isMember: self user allowedTo: SSAccessPolicy read)
		ifFalse: [ ^ self ].
	aProject versionsDo: [ :version |
		aStream nextPut: aProject -> version ]! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:05'!
associations
	^associations! !

!SSVersionListing methodsFor: 'accessing' stamp: 'SR 8/25/2007 17:49'!
information
	^self isOneProject
		ifTrue: [ self project information ]
		ifFalse: [ self title , ' all projects RSS feed' ]! !

!SSVersionListing methodsFor: 'testing' stamp: 'lr 2/14/2004 13:06'!
isOneProject
	^self projects size = 1! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:05'!
project
	^self projects anyOne! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:05'!
projects
	^projects! !

!SSVersionListing methodsFor: 'rendering' stamp: 'lr 2/19/2004 12:06'!
renderContentOn: html
	self associations do: [ :assoc |
		self renderProject: assoc key version: assoc value on: html ]! !

!SSVersionListing methodsFor: 'rendering' stamp: 'dkh 12/10/2009 16:42'!
renderProject: aProject version: aVersion on: html
	self subclassResponsibility! !

!SSVersionListing methodsFor: 'initialization' stamp: 'pmm 8/26/2007 11:14'!
setProjects: aCollection
	projects := aCollection.
	associations := Array streamContents: [ :stream |
		projects do: [ :project |
			self appendProject: project to: stream ] ].
	associations sort: [ :x :y | x value timestamp > y value timestamp ].! !

!SSVersionListing methodsFor: 'initialization' stamp: 'pmm 6/30/2010 18:18'!
setUser: aMember
	user := aMember! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/14/2004 13:08'!
title
	^self isOneProject
		ifTrue: [ self project title ]
		ifFalse: [ self repository title ]! !

!SSVersionListing methodsFor: 'accessing' stamp: 'pmm 8/26/2007 12:30'!
url
	^self repository rootUrl! !

!SSVersionListing methodsFor: 'accessing' stamp: 'topa 12/20/2010 09:20'!
user

	^ user! !

WAObject subclass: #SSCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

!SSCondition methodsFor: 'evaluation' stamp: 'pmm 11/20/2007 14:34'!
numArgs
	"Answer the number of arguments that must be used to evaluate this condition."

	^ 1! !

!SSCondition methodsFor: 'evaluation' stamp: 'pmm 11/20/2007 14:30'!
value: anObject
	"Evaluate the receiver with the argument anObject. Answer a ==Boolean== telling if the condition is met for ==anObject==."

	self subclassResponsibility! !

SSCondition subclass: #SSPortCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

!SSPortCondition methodsFor: 'evaluation' stamp: 'pmm 9/5/2007 19:37'!
value: aNumber
	^aNumber between: 1 and: 16rFFFF! !

SSCondition subclass: #SSProjectNameCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

!SSProjectNameCondition class methodsFor: 'testing' stamp: 'pmm 9/5/2007 19:35'!
isAbstract
	^false! !

!SSProjectNameCondition methodsFor: 'evaluation' stamp: 'topa 5/4/2011 18:36'!
value: aString
	^aString allSatisfy: [ :char | char isLetter or: [ char isDigit  or: [char = $-  or: [ char = $~ ] ] ] ]! !

SSCondition subclass: #SSSizeCondition
	instanceVariableNames: 'boundary comparator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

!SSSizeCondition class methodsFor: 'instance-creation' stamp: 'pmm 9/2/2007 13:02'!
atLeast: anInteger
	^self new
		comparator: #>=;
		boundary: anInteger;
		yourself! !

!SSSizeCondition class methodsFor: 'instance-creation' stamp: 'pmm 9/2/2007 13:13'!
atMost: anInteger
	^self new
		comparator: #<=;
		boundary: anInteger;
		yourself! !

!SSSizeCondition class methodsFor: 'accessing-description' stamp: 'pmm 9/2/2007 13:00'!
descriptionBoundary
	^MANumberDescription new
		priority: 100;
		beInteger;
		beRequired;
		yourself! !

!SSSizeCondition class methodsFor: 'accessing-description' stamp: 'pmm 9/2/2007 13:00'!
descriptionComparator
	^MASymbolDescription new
		priority: 200;
		beRequired;
		yourself! !

!SSSizeCondition class methodsFor: 'testing' stamp: 'pmm 9/2/2007 13:12'!
isAbstract
	^false! !

!SSSizeCondition methodsFor: 'accessing' stamp: 'pmm 9/2/2007 12:57'!
boundary
	^boundary! !

!SSSizeCondition methodsFor: 'accessing' stamp: 'pmm 9/2/2007 12:58'!
boundary: anInteger
	boundary := anInteger! !

!SSSizeCondition methodsFor: 'accessing' stamp: 'pmm 9/2/2007 12:58'!
comparator
	^comparator! !

!SSSizeCondition methodsFor: 'accessing' stamp: 'pmm 9/2/2007 12:58'!
comparator: aSymbol
	comparator := aSymbol! !

!SSSizeCondition methodsFor: 'evaluation' stamp: 'pmm 9/2/2007 13:01'!
value: anObject
	^anObject size
		perform: self comparator
		with: self boundary! !

SSCondition subclass: #SSUniqueGroupIdCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

!SSUniqueGroupIdCondition class methodsFor: 'testing' stamp: 'pmm 9/5/2007 19:28'!
isAbstract
	^false! !

!SSUniqueGroupIdCondition methodsFor: 'evaluation' stamp: 'pmm 9/5/2007 19:29'!
value: anObject
	^SSRepository current isUniqueProjectId: anObject! !

SSCondition subclass: #SSUniqueMemberLoginCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

!SSUniqueMemberLoginCondition class methodsFor: 'testing' stamp: 'pmm 9/5/2007 19:25'!
isAbstract
	^false! !

!SSUniqueMemberLoginCondition methodsFor: 'evaluation' stamp: 'topa 10/21/2010 17:44'!
value: anObject
	^SSRepository current isUniqueMemberLogin: anObject! !

SSCondition subclass: #SSUniqueProjectIdCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

!SSUniqueProjectIdCondition class methodsFor: 'testing' stamp: 'pmm 9/5/2007 19:29'!
isAbstract
	^false! !

!SSUniqueProjectIdCondition methodsFor: 'evaluation' stamp: 'pmm 9/5/2007 19:29'!
value: anObject
	^SSRepository current isUniqueGroupId: anObject! !

SSCondition subclass: #SSYouAreMemberCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

!SSYouAreMemberCondition class methodsFor: 'testing' stamp: 'pmm 9/5/2007 19:33'!
isAbstract
	^false! !

!SSYouAreMemberCondition methodsFor: 'evaluation' stamp: 'topa 12/20/2010 09:13'!
value: admins

	| currentUser |
	currentUser := self session user.
	^ currentUser isSuperUser
		or: [	admins anySatisfy: [:each |
			each isGroup
				ifTrue: [each hasMember: currentUser]
				ifFalse: [each = currentUser]]]! !

WAObject subclass: #SSFullnameReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

!SSFullnameReference methodsFor: 'converting' stamp: 'topa 6/19/2010 18:30'!
toString: anObject
	^anObject greaseString! !

WAObject subclass: #SSModel
	instanceVariableNames: 'timestamp properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Model'!

SSModel subclass: #SSAccessPolicy
	instanceVariableNames: 'admins developers guests globalRight blessing flags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Model'!

!SSAccessPolicy class methodsFor: 'action' stamp: 'al 1/31/2004 13:51'!
admin
	^#admin! !

!SSAccessPolicy class methodsFor: 'global rights' stamp: 'al 2/2/2004 22:28'!
allowAllRead
	^#read! !

!SSAccessPolicy class methodsFor: 'global rights' stamp: 'al 2/2/2004 22:28'!
allowAllWrite
	^#readAndWrite! !

!SSAccessPolicy class methodsFor: 'global rights' stamp: 'al 2/2/2004 22:29'!
allowNothing
	^#noAccess! !

!SSAccessPolicy class methodsFor: 'action' stamp: 'avi 9/23/2004 15:36'!
bless
	^ #bless! !

!SSAccessPolicy class methodsFor: 'global rights' stamp: 'al 7/29/2004 10:12'!
globalRights
	^Array
		with: self allowAllRead
		with: self allowAllWrite
		with: self allowNothing! !

!SSAccessPolicy class methodsFor: 'action' stamp: 'bf 8/14/2009 08:41'!
move
	^#move! !

!SSAccessPolicy class methodsFor: 'action' stamp: 'al 1/31/2004 13:51'!
read
	^#read! !

!SSAccessPolicy class methodsFor: 'action' stamp: 'al 1/31/2004 13:51'!
write
	^#write! !

!SSAccessPolicy methodsFor: 'adding' stamp: 'lr 2/2/2004 13:23'!
addAdmin: aMember
	admins add: aMember! !

!SSAccessPolicy methodsFor: 'adding' stamp: 'lr 2/2/2004 13:23'!
addDeveloper: aMember
	developers add: aMember! !

!SSAccessPolicy methodsFor: 'adding' stamp: 'lr 2/27/2004 18:36'!
addGuest: aMember
	guests add: aMember! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 1/31/2004 13:37'!
admins
	^admins! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 1/31/2004 13:38'!
admins: aCollection
	admins := aCollection! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'lr 2/27/2004 18:55'!
allowAllRead
	^self allowAllWrite 
		or: [ globalRight = self class allowAllRead ]! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 2/7/2004 19:24'!
allowAllWrite
	^globalRight = self class allowAllWrite! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'avi 9/24/2004 10:26'!
canBless
	^ blessing ifNil: [false]! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'avi 9/24/2004 10:26'!
canBless: aBoolean
	blessing := aBoolean! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 1/31/2004 13:37'!
developers
	^developers! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 1/31/2004 13:38'!
developers: aCollection
	developers := aCollection! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'topa 10/7/2010 15:16'!
developersCanMove

	^ self propertyAt: #developersCanMove! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'topa 10/7/2010 15:15'!
developersCanMove: aBoolean

	self propertyAt: #developersCanMove put: aBoolean! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 2/2/2004 22:30'!
globalRight
	^globalRight! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 2/2/2004 22:30'!
globalRight: aSymbol
	globalRight := aSymbol! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'lr 2/27/2004 18:35'!
guests
	^guests! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'lr 2/27/2004 18:34'!
guests: aCollection
	guests := aCollection! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'pmm 6/21/2010 19:45'!
hasMember: aMember
	^(self isMember: aMember in: self admins)
		or: [ (self isMember: aMember in: self developers)
		or: [ self isMember: aMember in: self guests ] ]! !

!SSAccessPolicy methodsFor: 'initialization' stamp: 'al 7/29/2004 10:16'!
initialize
	super initialize.
	self developers: Set new.
	self admins: Set new.
	self guests: Set new.	
	self globalRight: self class allowAllRead.! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'topa 03/10/2010 14:14'!
isEverybodyAllowedTo: aSymbol

	aSymbol = self class read ifTrue: [
		^ self allowAllRead or: [ self allowAllWrite ]].
	aSymbol = self class write ifTrue: [
		^ self allowAllWrite].
	^ false! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'topa 4/4/2011 16:30'!
isMember: aMember allowedTo: aSymbol

	aMember isAnonymous ifTrue: [^ self isEverybodyAllowedTo: aSymbol].
	aMember isSuperUser ifTrue: [^ true].
	aSymbol = self class read ifTrue: [
		^self allowAllRead
			or: [self allowAllWrite
			or: [(self isMember: aMember in: self developers)
			or: [(self isMember: aMember in: self admins)
			or: [self isMember: aMember in: self guests]]]]].
	aSymbol = self class write ifTrue: [
		^self allowAllWrite
			or: [(self isMember: aMember in: self developers)
			or: [self isMember: aMember in: self admins]]].
	aSymbol = self class admin ifTrue: [
		^self isMember: aMember in: self admins].
	aSymbol = self class bless ifTrue: [
		^ self canBless and:
			[(self isMember: aMember in: self developers)	
				or: [self isMember: aMember in: self admins]]].
	aSymbol = self class move ifTrue: [
		^ (self isMember: aMember in: self admins) 
		or: [(self isMember: aMember in: self developers) 
			and: [self developersCanMove]]].
	^ self error: 'Action ', aSymbol, ' unknown'! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'bf 5/24/2005 15:10'!
isMember: aMember in: aList
	^(aList includes: aMember)
		or: [(aList select: [:ea | ea isGroup])
				anySatisfy: [:group | group hasMember: aMember]]! !

SSModel subclass: #SSInstanceSideDescribedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Model'!

SSInstanceSideDescribedObject subclass: #SSFeedEntry
	instanceVariableNames: 'title message author'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Model'!

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:56'!
author
	^author! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:56'!
author: aMember
	author := aMember! !

!SSFeedEntry methodsFor: 'accessing-descriptions' stamp: 'pmm 9/1/2007 16:21'!
descriptionMessage
	^ MAMemoDescription new
		label: 'Message';
		selectorAccessor: #message;
		default: '';
		priority: 150;
		yourself! !

!SSFeedEntry methodsFor: 'accessing-descriptions' stamp: 'pmm 10/5/2007 07:02'!
descriptionTitle
	^ MAStringDescription new
		label: 'Title';
		selectorAccessor: #title;
		addCondition: (self class defaultLengthAtMost: 50) labelled: 'Title must be less than 50 characters';
		priority: 100;
		beRequired;
		yourself! !

!SSFeedEntry methodsFor: 'testing' stamp: 'pmm 10/26/2006 21:19'!
hasGuid
	^false! !

!SSFeedEntry methodsFor: 'testing' stamp: 'pmm 10/9/2006 11:53'!
isVersion
	^false! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:55'!
message
	^message! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:55'!
message: aMessage
	message := aMessage! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:54'!
title
	^title! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:54'!
title: aString
	title := aString! !

!SSFeedEntry methodsFor: 'conveniance' stamp: 'pmm 9/9/2007 12:22'!
url: aProject
	^self repository rootUrl! !

SSInstanceSideDescribedObject subclass: #SSGroup
	instanceVariableNames: 'id fullname members'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Model'!

!SSGroup methodsFor: 'accessing-descriptions' stamp: 'pmm 10/2/2007 21:33'!
descriptionIdentifier
	^ MAStringDescription new
		label: 'Id';
		selectorAccessor: #id;
		addCondition: (self class defaultLengthAtMost: 50) labelled: 'Name must be less than 50 characters';
		addCondition: SSUniqueGroupIdCondition new labelled: 'this group already exists';
		priority: 100;
		beRequired;
		yourself! !

!SSGroup methodsFor: 'accessing-descriptions' stamp: 'jgf 7/24/2009 12:03'!
descriptionMembers
	^ MAMultipleOptionDescription new
		selectorAccessor: #members;
		options: self repository members;
		reference: SSFullnameReference new;
		componentClass: SSListCompositionComponent;
		label: 'Members';
		priority: 300;
		beSorted;
		beDistinct;
		yourself! !

!SSGroup methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 06:58'!
descriptionName
	^ MAStringDescription new
		label: 'Name';
		selectorAccessor: #fullname;
		addCondition: (self class defaultLengthAtMost: 50) labelled: 'Name must be less than 50 characters';
		priority: 200;
		beRequired;
		yourself! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 14:32'!
fullname
	^fullname! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 14:32'!
fullname: aString
	fullname := aString! !

!SSGroup methodsFor: 'accessing' stamp: 'pmm 6/21/2006 09:55'!
fullnameOrUnknown
	^self fullname! !

!SSGroup methodsFor: 'accessing' stamp: 'topa 6/19/2010 18:35'!
greaseString 
	^'* ' ,self fullname! !

!SSGroup methodsFor: 'testing' stamp: 'bf 5/24/2005 15:11'!
hasMember: aMember
	^self members includes: aMember! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 14:32'!
id
	^id! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 14:33'!
id: aString
	id := aString! !

!SSGroup methodsFor: 'testing' stamp: 'bf 5/24/2005 15:10'!
isGroup
	^true! !

!SSGroup methodsFor: 'accessing' stamp: 'topa 10/21/2010 17:47'!
login
	^ self id! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 16:52'!
members
	^members ifNil: [members := Set new]! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 16:52'!
members: someMembers
	members := someMembers! !

!SSGroup methodsFor: 'printing' stamp: 'topa 10/21/2010 17:25'!
printLoginOn: aStream
	self members do: [:each | aStream nextPutAll: each login]
		separatedBy: [aStream nextPutAll: ', '].! !

!SSGroup methodsFor: 'printing' stamp: 'topa 10/21/2010 17:25'!
printOn: aStream
	aStream 
		nextPutAll: '* ';
		nextPutAll: (self fullname ifNil: [ '' ]);
		nextPutAll: ' ('.
	self printLoginOn: aStream.
	aStream nextPut: $)! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 18:22'!
title
	^self fullname! !

!SSGroup methodsFor: 'actions' stamp: 'bf 5/24/2005 18:08'!
view
	^ SSGroupView model: self! !

!SSInstanceSideDescribedObject methodsFor: 'accessing-description' stamp: 'pmm 10/2/2007 21:35'!
asRegisterComponent
	^self instanceSideDescription asComponentOn: self! !

!SSInstanceSideDescribedObject methodsFor: 'accessing-description' stamp: 'topa 1/4/2011 19:42'!
description
	^self instanceSideDescription reject: [ :each |
		#(login id) includes: (self magritteModelAccessIn: each)]! !

!SSInstanceSideDescribedObject methodsFor: 'accessing-description' stamp: 'pmm 10/2/2007 21:32'!
instanceSideDescription
	| description |
	description := super description copy.
	self class selectors do: [ :each |
		each isDescriptionSelector ifTrue: [
			description add: (self perform: each) ] ].
	^description! !

!SSInstanceSideDescribedObject methodsFor: 'accessing-magritte-specific' stamp: 'topa 1/4/2011 19:42'!
magritteModelAccessIn: aDescriptions

	^ (aDescriptions accessor isKindOf: MASelectorAccessor)
			ifTrue: [" normal selectors "
				aDescriptions accessor selector]
			ifFalse: [" dictionary accessor"
				(aDescriptions accessor isKindOf: MAChainAccessor)
				and: [(aDescriptions accessor accessor isKindOf: MADictionaryAccessor)
				and: [aDescriptions accessor accessor key]]]! !

SSInstanceSideDescribedObject subclass: #SSMember
	instanceVariableNames: 'login fullname passwordHash superuser email description favorites'
	classVariableNames: 'AnonymousMember'
	poolDictionaries: ''
	category: 'SqueakSource-Core-Model'!

!SSMember class methodsFor: 'instance creation' stamp: 'topa 10/19/2010 07:27'!
anonymousMember

	^ AnonymousMember
		ifNil: [ AnonymousMember := self new
			login: String new;
			fullname: String new;
			yourself ]! !

!SSMember class methodsFor: 'instance creation' stamp: 'topa 10/19/2010 07:27'!
initials: aString
	
	self flag: #Compatibility.
	^ self login: aString! !

!SSMember class methodsFor: 'instance creation' stamp: 'topa 10/15/2010 16:16'!
login: aString
	^self new
		login: aString;
		yourself! !

!SSMember methodsFor: 'comparing' stamp: 'pmm 7/3/2007 21:40'!
<= aMember
	^self fullname caseInsensitiveLessOrEqual: aMember fullname! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:29'!
addFavorite: aProject

		((self includesFavorite: aProject) not
	and: [(self projects includes: aProject) not])
				ifTrue: [ self favorites add: aProject ]! !

!SSMember methodsFor: 'conveniance' stamp: 'topa 12/20/2010 08:39'!
adminInProjects

	^ self repository visibleProjectsTo: self session user select: [:each |
		each admins includes: self]! !

!SSMember methodsFor: 'private' stamp: 'lr 1/31/2004 19:49'!
buildHash: aString
	^SecureHashAlgorithm new
		hashMessage: aString! !

!SSMember methodsFor: 'accessing-descriptions' stamp: 'topa 10/13/2010 17:32'!
descriptionEmail
	^ MAStringDescription new
		label: 'Email address';
		addCondition: (self class defaultLengthAtMost: 50) labelled: 'Address must be less than 50 characters';
		selectorAccessor: #email;
		priority: 400;
		yourself! !

!SSMember methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 19:03'!
descriptionInformation
	^ MAMemoDescription new
		label: 'Description';
		selectorAccessor: #information;
		priority: 600;
		yourself! !

!SSMember methodsFor: 'accessing-descriptions' stamp: 'topa 10/15/2010 16:14'!
descriptionLogin
	self flag: #topa. "I consider initials historic"
	
	^ MAStringDescription new
		label: 'Login';
		selectorAccessor: #login;
		addCondition: SSUniqueMemberLoginCondition new labelled: 'This login already exist';
		priority: 200;
		beRequired;
		yourself! !

!SSMember methodsFor: 'accessing-descriptions' stamp: 'pmm 9/2/2007 20:56'!
descriptionName
	^ MAStringDescription new
		label: 'Name';
		selectorAccessor: #fullname;
		addCondition: (self class defaultLengthAtMost: 50) labelled: 'Name must be less than 50 characters';
		priority: 100;
		beRequired;
		yourself! !

!SSMember methodsFor: 'accessing-descriptions' stamp: 'topa 10/19/2010 07:37'!
descriptionPassword
	^ MAPasswordDescription new
		label: 'Password';
		selectorAccessor: #password;
		addCondition: (self class defaultLengthAtLeast: 4) labelled: 'Password must have at least 4 characters';
		priority: 300;
		componentClass: MAVerifiedPasswordComponent;
		beRequired;
		yourself! !

!SSMember methodsFor: 'conveniance' stamp: 'topa 12/20/2010 08:39'!
developerInProjects

	^ self repository visibleProjectsTo: self session user select: [:each |
		each developers includes: self]! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:29'!
email

	email ifNil: [^''].
	^email! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:30'!
email: aString

	email := aString.! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:30'!
favorites 

	^ favorites ifNil: [favorites := OrderedCollection new]! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:31'!
fullEmailAddress

	^WAEmailAddress
		address: self email
		username: self fullname! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:31'!
fullname

	^ fullname! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:31'!
fullname: aString

	fullname := aString.! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:31'!
fullnameOrUnknown

	^ self fullname! !

!SSMember methodsFor: 'conveniance' stamp: 'pmm 9/9/2007 12:21'!
groups
	^self repository groups select: [ :each | 
		each hasMember: self]! !

!SSMember methodsFor: 'conveniance' stamp: 'topa 12/20/2010 08:39'!
guestInProjects

	^ self repository visibleProjectsTo: self session user select: [:each |
		each guests includes: self]! !

!SSMember methodsFor: 'testing' stamp: 'pmm 1/17/2006 21:46'!
hasRssAuthorString
	^self email isEmptyOrNil not! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:31'!
includesFavorite: aProject

	^ self favorites includes: aProject! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:38'!
information

	^ description ifNil: [description := '']! !

!SSMember methodsFor: 'accessing' stamp: 'SR 8/25/2007 17:51'!
information: aString
	description := aString! !

!SSMember methodsFor: 'initialization' stamp: 'topa 10/7/2010 15:19'!
initialize
	super initialize.
	superuser := false.! !

!SSMember methodsFor: 'initialization' stamp: 'topa 1/4/2011 09:44'!
initializeStringsSatisfyBlocks

	super initializeStringsSatisfyBlocks.
	self stringsSatisfyBlocks addAll: {
		[:aBlock | aBlock value: self fullname].
		[:aBlock | aBlock value: self login]
	}.! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:27'!
initials

	self flag: #Compatibility.
	^ self login! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:28'!
initials: anObject

	self flag: #Compatibility.
	self login: anObject.! !

!SSMember methodsFor: 'conveniance' stamp: 'topa 12/20/2010 08:45'!
isAnonymous

	^ self == self class anonymousMember! !

!SSMember methodsFor: 'testing' stamp: 'bf 5/24/2005 15:10'!
isGroup
	^false! !

!SSMember methodsFor: 'testing' stamp: 'lr 1/31/2004 19:51'!
isPasswordValid: aString
	^(self buildHash: aString) = passwordHash! !

!SSMember methodsFor: 'testing' stamp: 'lr 2/6/2004 18:43'!
isSuperUser
	^superuser! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/15/2010 16:15'!
login
	"Answer the value of login"

	^ login! !

!SSMember methodsFor: 'accessing' stamp: 'topa 4/1/2011 17:18'!
login: anObject
	"Set the value of login"
	
	self flag: #NeedsReview. 
	"self login isEmptyOrNil ifFalse: [ ^self error: 'Member login is immutable' ]."
	login := anObject! !

!SSMember methodsFor: 'conveniance' stamp: 'topa 12/20/2010 08:45'!
notAnonymous

	^ self isAnonymous not! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:33'!
password

	^ passwordHash ifNotNil: ['****************']! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:33'!
password: aString

	aString = self password ifFalse: [
		passwordHash := self buildHash: aString ]! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/15/2010 16:15'!
passwordHash
	"Answer the value of passwordHash"

	^ passwordHash! !

!SSMember methodsFor: 'accessing' stamp: 'topa 10/15/2010 16:15'!
passwordHash: anObject
	"Set the value of passwordHash"

	passwordHash := anObject! !

!SSMember methodsFor: 'printing' stamp: 'topa 1/4/2011 09:54'!
printOn: aStream

	self isAnonymous
		ifTrue: [aStream nextPutAll: 'Anonymous']
		ifFalse: [
			fullname isEmpty 
				ifTrue: [aStream nextPutAll: '***'] 
				ifFalse: [aStream nextPutAll: fullname]].! !

!SSMember methodsFor: 'conveniance' stamp: 'pmm 10/16/2006 13:10'!
projects
	^Array streamContents: [ :stream |
		self projectsDo: [ :each |
			stream nextPut: each ] ]! !

!SSMember methodsFor: 'conveniance' stamp: 'pmm 10/16/2006 12:00'!
projectsDo: aBlock
	^self repository projectsDo: [ :each |
		(each hasMember: self) ifTrue: [
			aBlock value: each ] ]! !

!SSMember methodsFor: 'accessing' stamp: 'obi 9/4/2009 21:13'!
removeFavorite: aProject
	self favorites remove: aProject ifAbsent: []! !

!SSMember methodsFor: 'accessing' stamp: 'lr 2/4/2004 23:52'!
superuser
	^superuser! !

!SSMember methodsFor: 'accessing' stamp: 'lr 2/4/2004 23:52'!
superuser: aBoolean
	superuser := aBoolean! !

!SSMember methodsFor: 'actions' stamp: 'bf 5/24/2005 18:08'!
view
	^ SSMemberView model: self! !

SSInstanceSideDescribedObject subclass: #SSProject
	instanceVariableNames: 'id title description creator accessPolicy versions dateCreated feeds wiki blessings configs tags license'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Model'!

!SSProject class methodsFor: 'instance creation' stamp: 'topa 12/20/2010 08:13'!
creator: aMember
	^self new
		creator: aMember;
		yourself! !

!SSProject class methodsFor: 'defaults' stamp: 'topa 12/20/2010 08:19'!
defaultGlobalRights

	^ SSAccessPolicy globalRights collect: [ :each | each -> each asCapitalizedPhrase ]! !

!SSProject class methodsFor: 'defaults' stamp: 'topa 12/20/2010 08:18'!
defaultLicenses

	^ self licenses collect: [ :each | each -> each first ]! !

!SSProject class methodsFor: 'defaults' stamp: 'topa 12/20/2010 08:19'!
defaultTags

	^ self repository tags collect: [ :each | each -> each name ]! !

!SSProject class methodsFor: 'data' stamp: 'topa 12/20/2010 08:20'!
licenses

	^#(
		('MIT' 'http://www.opensource.org/licenses/mit-license.php')
		('BSD' 'http://www.opensource.org/licenses/bsd-license.php')
		('Old Squeak' 'http://wiki.squeak.org/squeak/159')
		('GPLv2' 'http://www.opensource.org/licenses/gpl-2.0.php')
		('GPLv3' 'http://www.opensource.org/licenses/gpl-3.0.html')
		('LGPLv2' 'http://www.opensource.org/licenses/lgpl-2.1.php') 
		('LGPLv3' 'http://www.opensource.org/licenses/lgpl-3.0.html') 
		('WTFPL' 'http://sam.zoy.org/wtfpl/COPYING')
		('Other' '')
	)! !

!SSProject methodsFor: 'comparing' stamp: 'lr 3/15/2004 16:44'!
<= anObject
	^self title <= anObject title! !

!SSProject methodsFor: 'accessing' stamp: 'al 1/31/2004 16:08'!
accessPolicy
	^accessPolicy! !

!SSProject methodsFor: 'accessing' stamp: 'al 1/31/2004 16:08'!
accessPolicy: anAccessPolicy
	accessPolicy := anAccessPolicy! !

!SSProject methodsFor: 'convenience' stamp: 'pmm 10/16/2006 11:38'!
activity
	| activity |
	activity := 0.0.
	self versionsDo: [ :each |
		activity := activity + each activity ].
	^activity! !

!SSProject methodsFor: 'accessing-configs' stamp: 'dkh 05/17/2011 23:29'!
addConfig: aString author: aUser url: anUrl
	| config |
	config := (MCMcmReader on: aString readStream fileName: anUrl asString) version.
	self fixConfig: config.
	self configs at: config fileName put: config.
	self configAdded: config.
	^ config! !

!SSProject methodsFor: 'accessing-versions' stamp: 'dkh 05/17/2011 23:29'!
addVersion: aString author: aUser
	| array version versionName |
	array := aString asByteArray.
	version := SSVersion 
		array: array 
		author: aUser.
	versionName := version fileName.
	(versions includesKey: versionName)
		ifTrue: [ SSVersionAlreadyExists signal: versionName ].
		
	SSRepository storage saveMonticello: array of: version to: self.
	versions at: version fileName put: version.
	self versionAdded: version.
	^ version! !

!SSProject methodsFor: 'accessing-policy' stamp: 'topa 10/21/2010 17:43'!
adminNames
	^String streamContents: [ :stream |
		self admins 
			do: [ :each | stream nextPutAll: each login ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 1/31/2004 16:44'!
admins
	^self accessPolicy admins! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 2/3/2004 21:06'!
admins: aCollection
	self accessPolicy admins: aCollection! !

!SSProject methodsFor: 'accessing-versions' stamp: 'avi 9/23/2004 21:50'!
allBlessedVersions
	^ self blessings keys asSortedCollection collect: [:ea | self blessedVersionForPackage: ea]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'pmm 3/1/2006 22:14'!
blessedVersionForPackage: aPackage
	| list |
	list := self blessedVersionListForPackage: aPackage.
	^ list isEmpty ifFalse: [list last]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'avi 9/23/2004 15:49'!
blessedVersionListForPackage: aPackage
	^ self blessings at: aPackage ifAbsentPut: [OrderedCollection new]! !

!SSProject methodsFor: 'accessing' stamp: 'dkh 05/18/2011 09:13'!
blessings
	^ blessings ifNil: [blessings := GRPlatform current reducedConflictDictionary new]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'topa 3/14/2011 18:37'!
blessVersion: aVersion ifForbidden: errorBlock
	
		((self repository blessingsEnabled) 
	and: [self canBless] 
	and: [self canBlessVersion: aVersion])
		ifFalse: [^ errorBlock value].
	(self blessedVersionListForPackage: aVersion package) addLast: aVersion! !

!SSProject methodsFor: 'accessing-policy' stamp: 'avi 9/24/2004 10:29'!
canBless
	^ self accessPolicy canBless! !

!SSProject methodsFor: 'accessing-policy' stamp: 'avi 9/24/2004 10:29'!
canBless: aBoolean
	self accessPolicy canBless: aBoolean! !

!SSProject methodsFor: 'testing' stamp: 'avi 9/23/2004 16:05'!
canBlessVersion: aVersion
	| previous |
	previous := self blessedVersionForPackage: aVersion package.
	^ previous isNil or: [aVersion hasAncestor: previous project: self]! !

!SSProject methodsFor: 'accessing-configs' stamp: 'dkh 05/18/2011 09:13'!
configs
	^configs ifNil: [configs := GRPlatform current reducedConflictDictionary new].! !

!SSProject methodsFor: 'accessing-configs' stamp: 'gk 7/14/2007 17:08'!
configs: aDictionary
	configs := aDictionary! !

!SSProject methodsFor: 'statistics' stamp: 'pmm 11/15/2006 12:07'!
countVersions: aBlock
	| count |
	count := 0.
	self versionsDo: [ :each |
		(aBlock value: each)
			ifTrue: [ count := count + 1 ] ].
	^count! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:14'!
creator

	^ creator! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:13'!
creator: aMember

	self accessPolicy addAdmin: (creator := aMember).! !

!SSProject methodsFor: 'convenience' stamp: 'topa 10/21/2010 17:43'!
creatorName
	^self creator login! !

!SSProject methodsFor: 'convenience' stamp: 'lr 2/3/2004 16:27'!
creators
	^Array with: creator! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:14'!
defaultMoveTarget
	
	^ self propertyAt: #defaultMoveTarget! !

!SSProject methodsFor: 'accessing' stamp: 'topa 10/7/2010 16:23'!
defaultMoveTarget: aTarget

	self propertyAt: #defaultMoveTarget put: aTarget.! !

!SSProject methodsFor: 'accessing-versions' stamp: 'pmm 3/16/2006 17:25'!
deleteVersion: aVersion
	aVersion beDeleted! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 3/14/2011 18:27'!
description

	| desc |
	desc := super description.
	
	desc := self repository projectsCanHaveParent
		ifTrue: [desc]
		ifFalse: [desc reject: [ :each |
			#(parentProject defaultMoveTarget) includes: (self magritteModelAccessIn: each)]].
	
	desc := self repository blessingsEnabled
		ifTrue: [desc]
		ifFalse: [desc reject: [ :each |
			#(canBless) includes: (self magritteModelAccessIn: each)]].
	
	^ desc! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 10/7/2010 15:58'!
descriptionAdmins

	^ MAMultipleOptionDescription new
		selectorAccessor: #admins;
		label: 'Administrators';
		options: self repository members, self repository groups;
		priority: 800;
		reference: SSFullnameReference new;
		componentClass: SSListCompositionComponent;
		addCondition: SSYouAreMemberCondition new labelled: 'You can''t remove yourself from the list of administrators';
		beSorted;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 10/13/2010 17:31'!
descriptionBlessing

	^ MABooleanDescription new
		label: 'Enable Blessing';
		selectorAccessor: #canBless;
		priority: 600;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 1/4/2011 20:05'!
descriptionDefaultMoveTarget

	^ MASingleOptionDescription new
		propertyAccessor: #defaultMoveTarget;
		label: 'Default move target';
		options: (self repository visibleProjectsTo: self session user);
		priority: 1000;
		beSorted;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 10/7/2010 15:58'!
descriptionDevelopers

	^ MAMultipleOptionDescription new
		selectorAccessor: #developers;
		label: 'Developers';
		options: self repository members, self repository groups ;
		priority: 900;
		reference: SSFullnameReference new;
		componentClass: SSListCompositionComponent;
		beSorted;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 10/4/2010 17:21'!
descriptionDevelopersCanMove

	^ MASingleOptionDescription new
		selectorAccessor: #developersCanMove;
		label: 'Who can move versions';
		priority: 1100;
		optionsAndLabels: { true -> 'Developers' . false -> 'Administrators' };
		beRequired;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 12/20/2010 08:18'!
descriptionGlobalRight

	^ MASingleOptionDescription new
		selectorAccessor: #globalRight;
		label: 'Global Right';
		priority: 700;
		optionsAndLabels: self class defaultGlobalRights;
		beRequired;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 10/7/2010 15:59'!
descriptionGuests

	^ MAMultipleOptionDescription new
		selectorAccessor: #guests;
		label: 'Guests';
		priority: 1000;
		options: self repository members, self repository groups;
		reference: SSFullnameReference new;
		componentClass: SSListCompositionComponent;
		beSorted;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 5/4/2011 18:37'!
descriptionIdentifier

	^ MAStringDescription new
		label: 'Unique Name';
		comment: 'used to construct the URL of the homepage';
		selectorAccessor: #id;
		addCondition: (self class defaultLengthAtMost: 50) labelled: 'Name must be not more than 50 characters';
		addCondition: SSProjectNameCondition new labelled: 'Name can only contain letters and digits';
		addCondition: SSUniqueProjectIdCondition new labelled: 'There is a project having this Name';
		priority: 100;
		beRequired;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 10/7/2010 15:54'!
descriptionInformation

	^ MAMemoDescription new
		label: 'Description';
		selectorAccessor: #information;
		priority: 300;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 12/20/2010 08:17'!
descriptionLicense

	^ MASingleOptionDescription new
		selectorAccessor: #license;
		label: 'License';
		priority: 500;
		optionsAndLabels: self class defaultLicenses;
		beRequired;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 1/4/2011 20:06'!
descriptionParentProject

	^ MASingleOptionDescription new
		propertyAccessor: #parentProject;
		label: 'Parent Project';
		options: (self repository visibleProjectsTo: self session user);
		priority: 1000;
		beSorted;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 12/20/2010 08:19'!
descriptionTags

	^ MAMultipleOptionDescription new
		selectorAccessor: #tags;
		label: 'Tags';
		priority: 400;
		optionsAndLabels: self class defaultTags;
		componentClass: MACheckboxGroupComponent;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'topa 10/13/2010 17:31'!
descriptionTitle

	^ MAStringDescription new
		label: 'Title';
		comment: 'the human readable title';
		selectorAccessor: #title;
		addCondition: (self class defaultLengthAtMost: 50) labelled: 'Title must be less than 50 characters';
		priority: 200;
		beRequired;
		yourself! !

!SSProject methodsFor: 'accessing-policy' stamp: 'topa 10/21/2010 17:43'!
developerNames
	^String streamContents: [ :stream |
		self developers 
			do: [ :each | stream nextPutAll: each login ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 1/31/2004 16:43'!
developers
	^self accessPolicy developers! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 2/3/2004 21:07'!
developers: aCollection
	self accessPolicy developers: aCollection! !

!SSProject methodsFor: 'accessing-policy' stamp: 'bf 8/14/2009 09:10'!
developersCanMove
	^ self accessPolicy developersCanMove! !

!SSProject methodsFor: 'accessing-policy' stamp: 'bf 8/14/2009 09:11'!
developersCanMove: aBoolean
	self accessPolicy developersCanMove: aBoolean! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:28'!
feeds

	feeds ifNil: [ feeds := OrderedCollection new ].
	^ feeds! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:15'!
feeds: aCollection

	feeds := aCollection.! !

!SSProject methodsFor: 'accessing-configs' stamp: 'bf 3/23/2006 14:17'!
fixConfig: aConfig
	"SSProject allInstancesDo: [:prj | prj configs do: [:cfg | prj fixConfig: cfg]]"
	aConfig repositories: (aConfig repositories collect: [:repo |
		repo class == MCHttpRepository
			ifTrue: [MCHttpRepository new location: repo description]
			ifFalse: [self flag: #todo. repo copy]]).
	^aConfig! !

!SSProject methodsFor: 'convenience' stamp: 'obi 8/31/2009 21:46'!
fullDirectoryUrl
	"http://www.squeaksource.com/Seaside"
	^self repository rootUrl, self id! !

!SSProject methodsFor: 'convenience' stamp: 'pmm 9/9/2007 12:48'!
fullHomepageUrl
	"http://www.squeaksource.com/Seaside.html"
	^self fullDirectoryUrl, '.html'! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 2/2/2004 22:30'!
globalRight
	^self accessPolicy globalRight! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 2/2/2004 22:31'!
globalRight: aSymbol
	self accessPolicy globalRight: aSymbol! !

!SSProject methodsFor: 'accessing-policy' stamp: 'topa 10/21/2010 17:43'!
guestNames
	^String streamContents: [ :stream |
		self guests 
			do: [ :each | stream nextPutAll: each login ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !

!SSProject methodsFor: 'accessing-policy' stamp: 'lr 2/27/2004 18:48'!
guests
	^self accessPolicy guests! !

!SSProject methodsFor: 'accessing-policy' stamp: 'lr 2/27/2004 18:48'!
guests: aCollection
	self accessPolicy guests: aCollection! !

!SSProject methodsFor: 'convenience' stamp: 'topa 6/19/2010 18:33'!
guidStringFor: aVersion
	^String streamContents: [ :stream |
		stream nextPutAll: 'mcz'.
		stream nextPutAll: (self fullDirectoryUrl allButFirst: 4). "replace http:// with mcz://"
		stream nextPut: $/.
		stream nextPutAll: aVersion versionInfo id greaseString ]! !

!SSProject methodsFor: 'convenience' stamp: 'bf 2/3/2006 11:51'!
hasConfigs
	^self configs isEmpty not! !

!SSProject methodsFor: 'testing' stamp: 'bf 5/25/2005 10:57'!
hasMember: aMember
	^self accessPolicy hasMember: aMember! !

!SSProject methodsFor: 'convenience' stamp: 'bf 2/3/2006 11:47'!
hasReleases
	^self versions 
		anySatisfy: [ :each | each isRelease ]! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:35'!
hasTag: aLabel
	^self tags includes: aLabel! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:37'!
hasTagNamed: aString
	^self tags anySatisfy: [ :each |
		each name = aString ]! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:52'!
hasTags
	^self tags isEmpty not! !

!SSProject methodsFor: 'accessing' stamp: 'lr 1/28/2004 23:03'!
id
	^id! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 11:23'!
id: aString

	id isEmptyOrNil ifFalse: [ self error: 'Cannot redefine id of a project' ].
	id := aString! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 11:23'!
idAndIMeanIt: aString

	" this is for administrative tasks only. don't use it unless you know 
	what you're doing. IDs are rarely meant to change"
	self flag: #dangerous.
	id := aString.! !

!SSProject methodsFor: 'accessing-versions' stamp: 'al 3/16/2006 15:01'!
includesVersionAt: aFileName
	"Takes deleted versions into account"
		
	^versions includesKey: aFileName! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:28'!
information
	"naming because of Magritte"
	
	description ifNil: [description := ''].
	^ description! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:17'!
information: aString

	description := aString.! !

!SSProject methodsFor: 'initialization' stamp: 'dkh 05/18/2011 09:08'!
initialize
	
	super initialize.
	id := title := description := String new.
	accessPolicy := SSAccessPolicy new.
	versions := GRPlatform current reducedConflictDictionary new.
	dateCreated := Date today.
	tags := SortedCollection new.! !

!SSProject methodsFor: 'initialization' stamp: 'obi 3/15/2011 21:05'!
initializeStringsSatisfyBlocks
	
	super initializeStringsSatisfyBlocks.
	self stringsSatisfyBlocks addAll: {
		[:aBlock | aBlock value: self title].
		[:aBlock | aBlock value: self information].
		[:aBlock | self tags anySatisfy: [ :any | aBlock value: any name]].
		[:aBlock | self versions anySatisfy: [ :any | aBlock value: any versionInfo name]]
	}.! !

!SSProject methodsFor: 'testing' stamp: 'topa 12/20/2010 09:16'!
isMember: aMember allowedTo: aSymbol

	^ self accessPolicy isMember: aMember allowedTo: aSymbol! !

!SSProject methodsFor: 'testing' stamp: 'lr 2/7/2004 21:22'!
isMember: aMember allowedTo: aSymbol for: aVersion
	^(self isMember: aMember allowedTo: aSymbol)
		or: [ aVersion isRelease
		and: [ SSAccessPolicy read = aSymbol ] ]! !

!SSProject methodsFor: 'testing' stamp: 'avi 9/23/2004 15:31'!
isVersionBlessed: aVersion
	^ (self blessedVersionForPackage: aVersion package) = aVersion! !

!SSProject methodsFor: 'accessing-versions' stamp: 'bf 3/18/2005 17:10'!
latestVersions
	| latest |
	latest := Dictionary new.
	self versions do: [:each |
		| last |
		last := -1.
		latest at: each packageName ifPresent: [:v | last := v packageVersion].
		each packageVersion > last
			ifTrue: [latest at: each packageName put: each]].
	^latest asSortedCollection! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:17'!
license

	^ license! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:17'!
license: aCollection

	license := aCollection.! !

!SSProject methodsFor: 'statistics' stamp: 'obi 9/5/2009 19:38'!
mostCommitsByMembers
	| authorDict  result |
	authorDict := Dictionary new.
	self versionsDo: [:each | | member commits |
			member := each author.
			commits := authorDict at: member ifAbsentPut: [OrderedCollection new].
			commits add: each ].
	result := OrderedCollection new.
	authorDict keys asSortedCollection do: [:each | 
		 result add: each -> (authorDict at: each) size].
	^(result asSortedCollection: [:a :b | a value > b value]) asOrderedCollection copyFrom: 1 to: (result size min: 10)! !

!SSProject methodsFor: 'accessing' stamp: 'topa 10/7/2010 16:24'!
parentProject

	^ self propertyAt: #parentProject! !

!SSProject methodsFor: 'accessing' stamp: 'topa 10/7/2010 16:24'!
parentProject: aProject

	self propertyAt: #parentProject put: aProject.! !

!SSProject methodsFor: 'printing' stamp: 'pmm 9/11/2007 22:18'!
printOn: aStream
	aStream nextPutAll: self title! !

!SSProject methodsFor: 'convenience' stamp: 'pmm 9/9/2007 12:50'!
relativeHomepageUrl
	"Seaside.html"
	^self id, '.html'! !

!SSProject methodsFor: 'convenience' stamp: 'lr 2/13/2004 12:34'!
releases
	^self versions 
		select: [ :each | each isRelease ]! !

!SSProject methodsFor: 'convenience' stamp: 'lr 2/13/2004 12:35'!
releasesSorted
	^self releases
		asSortedCollection! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:36'!
removeTag: aTag
	self tags remove: aTag! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:36'!
reSortTags
	self tags reSort! !

!SSProject methodsFor: 'accessing-configs' stamp: 'bf 2/3/2006 13:41'!
sortedConfigs
	^self configs asSortedCollection: [:a :b | a name < b name].! !

!SSProject methodsFor: 'accessing-tags' stamp: 'topa 12/20/2010 08:29'!
tags

	tags ifNil: [tags := SortedCollection new].
	^ tags! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:36'!
tags: aCollection
	tags := aCollection asSortedCollection! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:20'!
title

	^ title! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:20'!
title: aString

	title := aString.! !

!SSProject methodsFor: 'accessing-versions' stamp: 'topa 12/20/2010 08:21'!
unblessVersion: aVersion

	(self blessedVersionListForPackage: aVersion package) remove: aVersion ifAbsent: [].! !

!SSProject methodsFor: 'accessing-versions' stamp: 'lr 2/4/2004 17:52'!
versionAt: aFilename
	^self versionAt: aFilename ifAbsent: [ nil ]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'pmm 10/18/2006 21:56'!
versionAt: aFileName ifAbsent: aBlock
	| key |
	key := (aFileName endsWith: '.zip')
		ifTrue: [ (aFileName allButLast: 4), '.mcz'  ]
		ifFalse: [ aFileName ].
	^self versions
		at: key
		ifAbsent: aBlock! !

!SSProject methodsFor: 'accessing-versions' stamp: 'pmm 3/16/2006 17:25'!
versions
	^versions reject: [:each | each isDeleted ]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'pmm 10/16/2006 11:12'!
versionsDo: aBlock
	versions do: [ :each |
		each isDeleted ifFalse: [
			aBlock value: each ] ]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'al 1/17/2006 16:26'!
versionsSorted
	^self versions 
		asSortedCollection! !

!SSProject methodsFor: 'actions' stamp: 'bf 5/24/2005 18:07'!
view
	^ SSProjectView model: self! !

!SSProject methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:21'!
wiki
	wiki ifNil: [ wiki := TWFolder new ].
	^wiki! !

SSInstanceSideDescribedObject subclass: #SSRepository
	instanceVariableNames: 'title members projects groups tags'
	classVariableNames: 'Current StatisticsThread Storage'
	poolDictionaries: ''
	category: 'SqueakSource-Core-Model'!

SSRepository class
	instanceVariableNames: 'cacheTread'!

!SSRepository class methodsFor: 'accessing' stamp: 'topa 10/4/2010 10:23'!
current

	^ Current! !

!SSRepository class methodsFor: 'initialization' stamp: 'topa 10/4/2010 09:58'!
initialize

	GRPlatform current
		addToStartUpList: self;
		addToShutDownList: self
	" -- initialize default repository -- "
	" Current := self defaultRepository.
	  RootUrl := self defaultRootUrl.
	  Storage := self defaultStorage. "

	" -- save the current repository -- "
	" self storage saveRepository: self current. "
	
	" -- load the last repository -- "
	" Current := self storage loadRepository. "
	
	" -- clear seaside caches -- "
	" WARegistry clearAllHandlers.
	  Smalltalk garbageCollect. "! !

!SSRepository class methodsFor: 'initialization' stamp: 'dkh 05/24/2011 11:44'!
setRepository: aRepository storage: anSSStorage

	Current := aRepository.
	Storage := anSSStorage.
	
	self storage saveRepository: self current.! !

!SSRepository class methodsFor: 'system startup' stamp: 'topa 4/4/2011 15:59'!
shutDown
	"DoIts""Smalltalk addToShutDownList: self"
	"shutDown registry for SqueakSoure"
		
	(Pragma allNamed: #shutDown in: self) do: [:pragma |
		self perform: pragma selector].! !

!SSRepository class methodsFor: 'system startup' stamp: 'topa 10/25/2010 12:13'!
shutDownStorage
	<shutDown>
	
	"allow the storage to settle"
	self storage shutDownStorage.! !

!SSRepository class methodsFor: 'system startup' stamp: 'topa 4/4/2011 15:59'!
startUp
	"DoIts""Smalltalk removeFromStartUpList: self. Smalltalk addToStartUpList: self"
	"startUp registry for SqueakSoure"
		
	(Pragma allNamed: #startUp in: self) do: [:pragma |
		self perform: pragma selector].! !

!SSRepository class methodsFor: 'system startup' stamp: 'topa 10/4/2010 09:25'!
startUpStorage
	<startUp>
	
	"allow the storage to re-initialize"
	self storage startUpStorage.! !

!SSRepository class methodsFor: 'accessing' stamp: 'topa 10/4/2010 10:23'!
storage

	^ Storage! !

!SSRepository class methodsFor: 'initialization' stamp: 'topa 10/4/2010 10:03'!
unload
	GRPlatform current
		removeFromStartUpList: self;
		removeFromShutDownList: self! !

!SSRepository methodsFor: 'accessing-groups' stamp: 'bf 5/24/2005 14:36'!
addGroup: aGroup
	self groups. "init"
	groups at: aGroup id put: aGroup! !

!SSRepository methodsFor: 'accessing-members' stamp: 'topa 10/21/2010 17:43'!
addMember: aMember
	members at: aMember login put: aMember! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'lr 2/1/2004 18:41'!
addProject: aProject
	projects at: aProject id put: aProject! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:34'!
addTag: aTag
	tags at: aTag name put: aTag! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/4/2010 10:42'!
allowCreateTag
	^self propertyAt: #allowCreateTag
		ifAbsent: [false]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/4/2010 10:42'!
allowCreateTag: aBoolean
	^self propertyAt: #allowCreateTag
		put: aBoolean! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/4/2010 10:42'!
allowRegisterProject
	^self propertyAt: #allowRegisterProject
		ifAbsent: [true]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/4/2010 10:42'!
allowRegisterProject: aBoolean
	^self propertyAt: #allowRegisterProject
		put: aBoolean! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/4/2010 10:41'!
allProjectsVisible
	^self propertyAt: #allProjectsVisible
		ifAbsent: [true]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/4/2010 10:42'!
allProjectsVisible: aBoolean
	^self propertyAt: #allProjectsVisible
		put: aBoolean! !

!SSRepository methodsFor: 'authentication' stamp: 'topa 12/20/2010 09:20'!
authenticateUser: aUsername password: aPassword
	" return the authenticated user object, or the anonymous one, if something failed "
	
	| user anon |
	anon := SSMember anonymousMember.
	user := self 
		memberAt: aUsername 
		ifAbsent: [^ anon].
	aPassword isEmpty ifTrue: [^ anon].
	^(user isPasswordValid: aPassword)
		ifTrue: [user]
		ifFalse: [anon].! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/4/2010 10:42'!
batchSize
	^self propertyAt: #batchSize
		ifAbsent: [20]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/4/2010 10:42'!
batchSize: anInteger
	^self propertyAt: #batchSize
		put: anInteger! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 3/14/2011 18:23'!
blessingsEnabled

	^self propertyAt: #blessingsEnabled
		ifAbsent: [false]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 3/14/2011 18:23'!
blessingsEnabled: aBoolean

	^self propertyAt: #blessingsEnabled
		put: aBoolean! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:34'!
createTagNamed: aString
	self addTag: (SSTag name: aString)! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:39'!
deleteTag: aTag
	self projectsDo: [ :each |
		(each hasTag: aTag) ifTrue: [
			each removeTag: aTag ] ].
	tags removeKey: aTag name! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 10/13/2010 17:34'!
descriptionBatchSize

	^ MANumberDescription  new
		label: 'Batch size for table reports';
		selectorAccessor: #batchSize;
		default: 20;
		priority: 450;
		addCondition: [ :each | each > 1 ] "asCondition" labelled: 'Batch size must be greater than 1';
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 3/14/2011 18:23'!
descriptionBlessingsEnabled

	^ MABooleanDescription  new
		label: 'Enable version blessings';
		selectorAccessor: #blessingsEnabled;
		default: true;
		priority: 350;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 10/15/2010 08:04'!
descriptionGoogleAnalysticsAccount

	^ MAStringDescription  new
		label: 'Google Analytics Account';
		selectorAccessor: #googleAnalyticsAccount;
		default: '';
		priority: 900;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 10/22/2010 18:20'!
descriptionGoogleWebmasterAccount

	^ MAStringDescription  new
		label: 'Google Webmaster Account';
		selectorAccessor: #googleWebmasterAccount;
		default: '';
		priority: 900;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 10/13/2010 17:34'!
descriptionIntroductionText

	^ MAMemoDescription  new
		label: 'Override home text';
		selectorAccessor: #introText;
		priority: 700;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 10/13/2010 17:35'!
descriptionLogo

	^ MAFileDescription  new
		kind: MAMemoryFileModel;
		label: 'logo';
		selectorAccessor: #logo;
		priority: 600;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 10/13/2010 17:35'!
descriptionProjectRegistration

	^ MABooleanDescription  new
		label: 'Everyone can register projects';
		selectorAccessor: #allowRegisterProject;
		default: true;
		priority: 350;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 10/15/2010 08:03'!
descriptionProjectsCanHaveParent

	^ MABooleanDescription  new
		label: 'Projects can have a parent';
		selectorAccessor: #projectsCanHaveParent;
		default: false;
		priority: 400;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 10/13/2010 17:35'!
descriptionProjectVisibility

	^ MABooleanDescription  new
		label: 'Everyone can see all projects';
		selectorAccessor: #allProjectsVisible;
		default: true;
		priority: 300;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 10/12/2010 18:39'!
descriptionRootUrl

	^ MAStringDescription new
		label: 'Root URL';
		selectorAccessor: #rootUrl;
		priority: 100;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 10/13/2010 17:35'!
descriptionStyleColor

	^ MAColorDescription  new
		label: 'Style color';
		selectorAccessor: #styleColor;
		componentClass: SSColorComponent;
		default: Color blue;
		priority: 500;
		addCondition: [ :each | each ~= Color white ] "asCondition" labelled: 'Color must not be white';
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 5/19/2011 21:10'!
descriptionSuperUserEmail

	^ MAStringDescription new
		label: 'Super User E-mail';
		accessor: (MAPluggableAccessor 
			read: [:repo | String streamContents: [:stream |
				 repo superUserEmail 
					do: [:mail | stream nextPutAll: mail address ]
					separatedBy: [stream nextPutAll: ', ']]]
			 write: [:repo :value | repo superUserEmail: value]);
		priority: 250;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 10/13/2010 17:35'!
descriptionTagCreation

	^ MABooleanDescription  new
		label: 'Everyone can create tags';
		selectorAccessor: #allowCreateTag;
		default: true;
		priority: 400;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'topa 10/13/2010 17:35'!
descriptionTimezone

	^ MAStringDescription  new
		label: 'Timezone';
		selectorAccessor: #timezone;
		priority: 800;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 5/10/2011 11:53'!
favicon
	^ #(0 0 1 0 5 0 0 0 0 0 1 0 32 0 110 34 0 0 86 0 0 0 48 48 0 0 1 0 32 0 104 38 0 0 196 34 0 0 32 32 0 0 1 0 32 0 40 17 0 0 44 73 0 0 24 24 0 0 1 0 32 0 184 9 0 0 84 90 0 0 16 16 0 0 1 0 32 0 104 4 0 0 12 100 0 0 137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 1 0 0 0 1 0 8 6 0 0 0 92 114 168 102 0 0 32 0 73 68 65 84 120 1 237 157 75 146 219 72 146 134 75 109 181 23 110 32 148 205 126 196 62 129 32 155 3 136 125 2 65 155 222 138 117 2 65 39 16 107 219 27 33 79 80 212 1 198 10 121 130 166 102 63 54 200 19 52 117 130 158 255 207 10 164 145 76 60 2 17 1 16 143 63 204 92 120 132 187 135 199 135 8 71 0 36 83 63 253 164 34 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 235 33 240 98 61 93 93 126 79 255 254 247 191 191 65 47 55 144 8 146 64 88 146 199 127 237 254 41 140 218 17 219 19 132 199 167 127 252 227 31 223 177 85 89 32 1 37 128 153 94 84 76 246 151 8 61 57 19 78 252 33 75 1 231 76 12 148 2 73 225 1 91 21 16 248 239 255 252 15 94 11 91 254 167 255 250 159 255 157 76 66 157 68 2 192 96 126 5 128 49 132 37 121 252 183 254 159 18 167 41 44 229 218 6 161 153 244 91 244 189 146 71 16 55 250 167 68 187 69 37 75 191 22 152 228 175 209 215 24 194 137 78 137 206 182 216 237 93 78 176 56 26 41 177 45 110 145 24 70 79 0 103 203 212 4 157 142 33 132 233 83 74 24 83 42 152 199 165 45 89 77 130 204 208 199 45 36 130 76 177 144 127 65 1 255 111 83 12 208 54 38 76 118 222 144 18 200 198 8 247 199 40 39 52 82 64 14 220 34 33 60 96 59 104 25 60 1 92 221 181 18 244 38 26 180 71 127 58 175 64 22 56 228 128 156 204 146 171 79 223 77 178 204 96 147 244 177 155 128 46 249 239 192 253 110 2 177 116 134 96 150 240 9 20 41 91 72 12 153 66 57 34 136 61 228 128 100 240 99 136 128 6 75 0 102 240 166 8 154 114 235 82 34 128 3 100 143 65 249 112 235 96 186 218 63 187 227 167 93 186 19 174 103 226 125 59 213 248 204 164 231 100 175 100 170 161 50 174 19 132 227 55 11 189 42 8 158 0 48 120 223 35 208 29 100 3 153 98 41 16 84 134 193 121 63 197 224 192 239 19 226 34 191 104 138 241 245 136 105 146 9 0 19 159 227 115 107 164 71 119 38 163 154 35 146 96 137 32 88 2 48 119 252 61 130 219 76 6 85 123 32 71 84 115 153 58 137 68 0 126 124 201 148 67 124 248 149 176 63 64 216 183 178 169 111 104 171 122 107 205 182 40 91 72 4 9 90 208 126 176 241 229 19 152 121 166 223 193 71 10 9 222 79 159 216 60 108 247 176 101 34 240 122 52 240 190 64 102 48 229 8 102 235 209 153 91 154 38 77 19 101 172 160 192 144 119 37 94 80 151 193 121 130 93 78 65 63 156 223 117 32 134 55 240 145 26 193 198 191 220 58 1 96 226 179 79 59 200 214 191 55 147 244 192 107 159 34 9 124 115 141 206 43 1 96 208 188 67 195 57 36 114 13 224 198 118 188 75 254 114 203 24 192 240 11 218 231 32 117 41 25 140 248 94 195 235 46 112 222 48 226 121 133 99 250 77 33 190 229 38 201 213 76 252 12 193 39 190 29 152 137 253 1 113 50 17 244 30 7 63 187 118 208 115 224 86 205 30 177 83 66 170 45 247 219 74 140 202 115 217 224 56 130 184 150 189 171 97 8 59 48 252 10 63 169 131 47 242 218 98 226 63 56 216 182 154 24 159 31 16 27 217 228 144 77 171 193 132 42 87 56 241 43 250 91 236 20 232 63 147 64 175 85 96 239 21 0 6 6 159 31 115 8 27 237 91 74 24 28 32 5 37 196 157 11 241 240 142 149 156 73 140 125 155 114 130 82 28 34 6 155 198 174 117 60 38 127 142 152 63 92 251 27 226 216 92 235 61 124 167 142 254 51 196 250 217 209 214 218 12 3 159 99 128 113 110 173 141 150 169 200 49 189 69 18 184 183 237 94 175 4 96 6 68 1 231 27 219 6 140 94 142 45 7 174 117 96 61 253 63 169 35 198 215 56 72 33 28 12 49 164 169 112 233 252 107 83 229 144 231 231 48 249 207 251 143 120 63 226 120 127 126 206 114 127 240 4 128 201 255 9 177 236 32 145 101 76 107 80 227 74 224 206 166 163 214 9 192 113 242 231 8 130 131 224 193 38 152 208 58 136 249 13 124 114 112 108 107 124 199 183 136 11 49 113 192 102 53 241 116 157 98 2 253 208 165 52 84 61 226 126 15 223 121 79 255 5 98 126 219 211 198 90 29 147 255 119 40 215 93 91 107 31 14 138 39 216 28 141 93 97 97 31 65 103 3 169 182 22 38 65 84 172 146 64 159 4 208 7 54 1 77 233 35 182 87 136 39 131 164 16 150 155 76 38 76 162 119 104 251 240 24 65 191 127 6 157 72 182 161 32 254 175 208 77 109 245 161 119 68 2 248 107 15 253 94 170 230 238 159 245 50 234 167 92 64 157 82 82 250 44 173 161 95 91 16 243 107 84 48 33 36 70 98 108 135 42 155 174 119 2 86 9 0 23 254 11 34 220 89 70 153 83 23 23 190 247 27 73 75 255 206 106 232 199 27 24 239 77 124 247 206 142 28 12 209 54 147 208 17 18 245 52 63 65 127 3 158 15 61 237 6 81 71 63 254 128 227 196 214 57 226 182 26 99 182 254 206 245 48 153 94 226 184 132 244 101 122 238 230 124 255 128 131 130 210 53 113 206 141 124 246 77 66 216 194 71 10 137 33 33 203 227 216 65 95 26 199 78 231 197 193 5 239 115 215 74 113 193 239 66 246 96 41 190 250 78 156 179 126 103 96 250 249 236 248 166 187 232 71 223 73 23 33 254 193 110 6 158 171 0 78 16 78 122 126 215 254 219 77 193 162 113 244 133 115 109 7 73 32 161 202 17 125 107 92 133 181 38 128 158 23 91 147 191 225 146 129 227 123 84 229 13 213 109 167 75 76 158 95 218 20 110 81 135 254 244 185 41 36 232 195 253 80 113 58 174 2 56 233 243 41 76 250 58 46 232 83 181 82 221 212 213 59 156 203 208 215 218 155 200 95 58 156 101 168 143 58 116 88 173 201 223 0 201 36 209 125 67 117 215 105 87 187 46 191 94 245 152 208 188 91 22 150 78 98 75 61 39 53 12 108 174 46 108 56 149 208 219 65 34 216 252 109 170 147 31 241 253 132 216 238 33 188 107 51 222 16 37 67 82 121 93 231 168 49 1 96 224 210 192 38 128 28 3 226 174 206 185 206 61 18 120 28 116 142 44 114 71 187 49 204 82 203 70 98 75 61 31 181 61 140 79 13 14 10 156 223 98 66 253 2 249 13 194 132 49 139 194 120 17 232 6 82 6 8 152 140 158 149 198 4 0 205 90 131 43 15 37 142 119 87 231 116 104 8 152 187 191 43 159 3 18 235 100 7 43 98 123 64 55 115 139 139 29 91 232 120 169 152 73 157 95 57 41 112 156 160 238 45 228 219 85 221 108 14 17 251 119 4 187 129 28 61 131 78 204 59 134 11 55 181 9 0 3 151 111 172 147 11 205 250 3 46 253 39 59 72 235 67 30 245 108 138 214 34 199 22 15 142 118 99 154 101 22 141 197 22 58 33 84 246 198 73 129 109 53 241 7 123 247 16 34 96 91 31 38 193 37 208 247 77 2 21 163 167 166 107 19 0 106 179 39 141 230 29 222 161 22 1 184 185 139 222 53 59 15 15 133 135 237 40 166 102 21 112 232 104 108 211 81 31 164 26 147 132 43 146 24 91 222 241 23 55 46 3 37 129 216 188 96 124 98 222 148 0 182 79 26 205 59 89 115 149 106 204 59 148 216 145 196 201 76 46 71 243 81 205 246 29 173 69 29 245 193 170 77 18 8 230 111 106 142 76 18 72 17 215 201 35 182 221 185 237 179 4 128 129 203 143 120 186 46 90 129 1 202 103 19 149 102 2 105 115 85 103 205 177 83 99 34 10 102 21 88 182 133 99 146 97 155 138 234 44 9 32 9 112 222 101 150 234 117 106 91 172 2 94 86 21 207 18 0 42 182 85 101 203 54 111 169 83 213 159 4 108 56 54 177 58 53 85 76 244 252 190 35 174 168 163 94 213 61 8 32 9 252 6 245 99 15 147 107 213 109 117 162 46 1 36 85 101 203 246 208 82 183 250 42 243 18 53 246 0 225 115 113 61 154 117 54 237 26 15 27 103 207 50 108 34 176 107 170 176 56 191 173 116 46 18 128 229 192 229 242 95 111 254 43 130 245 219 164 254 244 50 207 154 247 21 199 150 222 69 45 117 170 114 32 128 85 0 95 116 182 49 111 243 90 159 0 96 177 105 179 50 117 174 141 90 184 94 140 138 13 199 197 116 214 116 36 111 233 208 26 121 180 224 8 86 181 119 245 84 125 26 112 177 2 128 51 155 11 117 116 109 116 69 118 54 28 219 112 68 109 149 19 173 59 180 196 53 199 254 180 116 103 50 85 109 204 187 130 220 80 225 58 1 196 93 86 168 47 45 116 214 174 18 123 2 120 188 56 158 62 70 53 239 120 12 72 70 13 102 37 141 153 143 5 143 142 221 141 105 231 146 0 28 219 91 149 89 236 217 219 200 211 254 86 230 69 67 195 77 231 27 212 117 186 7 1 87 182 143 55 153 159 123 52 84 169 186 102 156 202 94 219 110 2 143 23 167 91 109 114 26 185 137 168 196 150 227 164 52 43 3 115 90 155 1 8 184 206 199 152 177 184 36 128 8 118 250 20 128 244 106 74 168 47 189 208 15 38 15 191 244 49 155 98 226 253 117 54 1 47 35 208 210 177 27 49 237 174 31 1 108 124 61 26 218 40 174 84 135 9 50 68 73 66 56 145 143 197 19 40 125 122 232 146 0 124 218 147 173 61 129 212 94 85 154 107 37 128 23 129 252 17 148 115 113 73 0 161 238 112 206 65 175 196 112 99 190 152 181 146 238 170 155 183 32 112 157 0 78 22 65 108 44 116 86 171 130 231 224 144 63 69 205 86 11 82 29 31 133 192 117 2 56 90 180 170 4 96 1 41 144 74 170 85 64 32 146 114 83 75 224 58 1 148 181 90 151 39 147 203 67 29 213 16 176 89 73 213 152 213 158 218 215 158 213 73 17 0 129 234 43 189 174 48 92 18 64 20 234 163 46 215 160 103 96 103 179 146 178 237 198 22 188 249 55 26 84 68 32 56 129 139 4 208 227 249 53 13 30 201 178 28 134 76 0 36 147 35 9 60 253 17 135 101 161 82 111 60 9 108 28 237 11 218 93 36 0 227 232 177 194 236 55 109 248 108 170 1 217 68 199 253 103 154 77 30 35 84 20 98 222 132 103 213 231 99 159 222 215 37 128 131 133 67 14 200 173 133 222 90 85 138 1 58 190 129 207 124 0 191 114 57 111 2 137 99 248 5 237 92 19 0 109 247 186 35 17 195 243 130 71 41 126 57 163 124 94 227 125 134 239 3 190 122 123 145 131 69 16 48 127 219 143 55 6 151 82 210 232 89 2 48 131 247 96 225 49 130 78 102 161 183 86 21 27 134 46 108 248 248 245 79 37 95 23 116 139 179 73 60 122 84 208 246 89 2 48 14 247 102 219 181 217 97 32 242 63 50 84 121 78 32 127 126 42 216 153 13 60 241 157 192 235 96 30 229 104 142 4 182 142 65 151 213 87 136 107 19 128 249 52 224 104 233 252 128 129 200 255 73 72 229 140 0 24 242 151 124 182 12 207 44 173 119 171 36 160 143 8 173 145 45 71 209 44 255 93 19 64 81 145 168 77 0 166 114 87 41 117 108 35 212 51 9 232 83 129 231 160 246 207 79 5 61 83 177 255 34 254 65 185 206 193 217 22 65 242 250 187 148 67 101 212 152 0 204 42 224 73 177 50 104 216 110 112 94 31 83 93 193 1 195 59 156 42 175 78 15 113 184 131 211 35 146 128 30 199 134 160 59 77 159 153 99 88 39 216 21 149 109 99 2 48 10 28 88 52 176 41 27 40 233 185 244 57 169 236 249 169 65 206 196 240 74 254 90 13 12 130 119 58 78 205 215 127 121 189 93 202 193 252 45 193 71 219 214 4 128 59 24 63 206 98 18 176 45 85 18 208 115 169 33 102 86 1 133 45 192 0 122 188 94 37 18 193 251 0 190 228 98 154 4 246 30 97 229 231 182 173 9 128 138 102 0 95 24 157 59 168 217 143 112 142 239 4 190 212 212 173 245 20 39 229 152 133 215 32 199 53 224 199 133 122 44 24 147 252 192 109 225 238 207 196 190 113 108 230 136 187 255 197 207 213 95 216 58 194 64 250 3 186 137 173 190 209 59 98 187 67 18 185 104 180 167 143 69 168 131 223 39 116 36 187 81 103 14 104 151 215 129 43 58 149 153 18 48 111 254 75 132 207 4 239 82 82 36 128 187 115 195 62 9 128 111 249 11 136 75 246 201 97 199 1 184 234 63 38 202 59 178 35 63 152 5 41 57 188 100 74 4 65 88 142 238 4 9 128 171 234 157 99 195 252 236 255 151 107 91 235 4 64 67 12 96 159 36 112 130 139 61 101 173 137 192 240 43 193 32 130 220 178 228 104 124 245 9 249 150 23 160 111 219 152 252 239 96 115 232 107 119 166 191 69 2 248 118 118 252 184 219 43 1 208 194 51 9 208 5 19 65 6 201 215 152 8 192 239 53 250 94 64 110 157 4 120 29 246 148 53 94 7 244 123 54 5 147 255 21 130 61 66 92 199 76 129 201 255 182 174 195 189 19 64 229 4 3 249 43 246 211 234 216 97 187 218 1 8 118 239 193 43 119 96 54 132 201 106 175 195 16 48 67 251 52 207 253 5 252 110 60 124 199 72 0 15 117 246 206 9 128 206 48 144 63 98 179 175 115 220 227 28 7 224 1 178 170 103 211 137 37 1 94 46 94 7 94 75 173 8 72 99 34 5 9 224 119 132 178 245 8 39 195 228 255 220 100 239 149 0 232 20 3 153 75 90 78 224 24 226 91 10 56 224 0 124 246 172 226 235 120 138 246 19 76 2 196 196 68 192 247 3 119 83 100 182 166 152 48 249 125 87 217 252 216 239 175 109 204 188 19 0 157 99 32 191 196 38 131 236 32 33 74 9 39 57 5 3 241 1 219 197 22 176 123 135 206 229 144 104 98 157 44 17 15 19 193 42 146 241 196 216 243 143 125 250 78 126 38 242 77 211 210 191 234 111 144 4 80 57 195 96 126 131 253 28 18 67 66 149 3 28 113 85 112 31 202 225 212 252 128 27 87 81 5 100 106 73 128 168 24 87 186 244 68 204 142 78 165 4 152 252 236 74 237 91 255 235 62 6 77 0 149 115 12 232 79 216 223 65 66 14 232 35 252 49 17 220 85 237 44 105 11 102 92 69 21 144 205 68 251 149 33 46 242 255 49 209 248 102 31 22 38 62 199 192 30 146 122 118 102 135 59 255 111 54 62 6 73 0 108 216 12 232 12 187 59 30 7 44 37 124 241 133 225 82 19 193 23 244 47 52 179 80 248 201 94 143 5 161 104 158 249 49 147 191 192 41 223 27 64 142 201 255 225 204 117 235 238 96 9 160 106 21 137 224 21 246 51 72 10 9 89 74 56 91 100 34 0 179 119 232 91 14 137 32 83 44 7 4 197 199 2 173 6 2 92 29 76 254 215 112 83 64 124 175 119 175 201 207 208 7 79 0 108 132 197 36 130 20 187 59 136 111 71 225 226 169 148 216 91 220 93 201 172 160 114 244 109 11 153 98 41 17 20 147 192 253 20 131 155 75 76 152 252 124 92 206 2 196 219 123 242 179 205 209 18 64 213 65 51 176 57 168 51 72 12 9 85 10 56 98 34 248 30 202 225 20 252 204 96 53 192 85 216 231 41 176 154 83 12 152 248 92 25 231 144 4 226 91 156 38 63 27 29 61 1 156 247 20 131 251 13 142 83 35 231 85 62 251 123 24 115 80 46 102 121 106 146 102 134 126 237 124 192 12 104 91 192 247 118 73 204 7 100 197 143 248 62 194 127 6 137 2 180 227 60 249 217 246 77 19 64 213 249 179 85 1 7 248 166 58 239 177 45 97 187 184 229 169 73 152 25 250 150 64 166 86 74 4 196 36 176 168 21 88 72 200 230 89 127 15 159 73 32 191 214 111 251 155 218 155 68 2 56 15 14 131 156 75 35 38 130 20 18 65 124 202 30 3 242 87 31 7 83 180 5 163 247 136 43 131 196 144 41 149 19 130 73 148 4 46 47 137 89 238 103 56 155 94 214 56 31 145 115 138 183 253 223 156 61 24 195 201 37 128 170 67 103 171 130 12 231 226 234 188 195 246 8 27 14 202 197 60 18 144 129 225 179 195 46 37 226 185 137 148 19 226 224 187 152 187 137 196 115 179 48 48 241 95 146 133 145 80 215 232 8 127 252 146 207 67 136 142 77 54 1 156 119 14 131 157 31 139 17 100 114 126 190 199 254 137 182 75 188 51 153 68 176 71 255 210 30 60 198 80 229 35 216 42 147 192 64 19 159 215 108 143 137 31 116 69 59 139 4 80 141 86 12 118 190 52 204 33 49 164 111 97 18 224 160 244 94 54 245 109 120 12 125 176 225 163 83 6 73 33 83 40 139 77 186 77 112 7 88 234 87 77 149 216 225 146 255 190 58 17 106 59 171 4 80 117 26 131 157 207 192 188 235 69 213 185 30 219 69 223 153 192 134 95 42 33 155 164 7 147 161 84 87 145 4 48 241 57 30 83 72 2 9 93 50 56 228 157 127 144 71 216 89 38 0 18 198 64 231 243 85 6 217 65 250 22 190 173 94 228 74 160 2 1 62 92 45 49 17 108 170 115 55 218 30 209 46 31 191 6 25 192 55 234 19 63 202 99 162 77 141 68 3 196 81 192 39 223 242 127 31 192 247 147 203 217 38 128 170 7 102 160 231 56 142 171 115 22 219 19 116 56 40 7 133 107 17 199 224 42 224 195 187 83 6 137 33 183 42 7 176 254 219 173 26 15 213 238 217 164 223 194 103 28 202 239 149 159 18 199 156 248 223 174 206 15 114 56 251 4 64 42 102 53 144 99 151 23 198 182 48 9 196 75 187 51 213 117 222 240 217 161 46 171 171 31 233 220 236 86 93 152 240 92 101 38 16 142 43 110 99 200 80 165 132 227 12 19 255 110 168 6 234 252 46 34 1 84 29 195 64 255 68 136 213 177 197 182 64 2 120 107 161 183 8 21 240 121 133 142 236 33 28 208 99 151 19 26 156 116 194 197 132 39 159 13 36 49 194 253 161 75 137 6 70 159 248 85 167 22 149 0 216 41 12 114 46 121 115 238 91 22 126 102 253 155 165 238 34 212 192 232 29 58 178 135 196 35 119 40 7 235 15 35 183 89 219 156 89 206 179 255 213 132 231 62 101 172 114 64 67 124 185 119 63 86 131 117 237 188 168 59 57 247 115 61 147 192 9 253 157 244 157 105 136 235 1 70 62 47 81 125 66 34 235 7 31 7 77 182 230 14 30 163 158 147 58 186 210 171 206 85 219 171 234 81 14 75 180 146 83 48 241 7 97 0 223 189 202 34 19 0 9 96 128 127 196 102 111 73 99 50 119 38 203 120 131 169 129 211 27 56 59 64 162 96 78 219 29 13 198 26 9 224 19 154 206 218 155 31 189 246 132 22 201 151 147 254 126 244 214 59 26 92 108 2 96 191 49 184 191 98 147 114 223 162 12 118 103 178 104 251 166 42 102 53 192 65 154 140 20 200 32 172 145 0 126 71 252 219 145 250 208 214 76 137 74 242 44 48 233 71 121 155 223 22 76 91 221 95 218 42 23 80 183 67 31 74 203 126 100 150 122 139 83 195 146 252 7 228 45 58 54 22 131 116 32 136 209 64 126 251 186 61 194 224 49 1 244 53 28 91 127 209 43 0 194 52 75 220 194 18 108 196 201 96 169 187 72 53 240 234 251 18 213 133 67 9 206 191 184 24 182 217 96 5 240 47 212 79 37 9 84 161 150 216 41 42 153 202 179 63 226 121 44 75 95 1 252 132 129 118 143 158 230 127 118 183 243 223 109 167 198 194 21 192 235 14 93 220 64 78 3 118 53 70 162 121 61 128 255 169 77 126 118 49 134 164 144 28 82 34 73 253 147 239 42 32 67 244 31 77 244 43 139 79 0 6 71 102 137 101 245 9 128 156 144 4 190 99 147 64 134 76 2 65 89 99 66 241 101 230 28 202 6 65 102 144 163 73 6 31 177 125 121 171 192 87 145 0 48 160 31 0 56 183 128 188 53 47 196 44 84 151 173 114 150 4 134 234 104 50 148 227 25 249 101 50 216 67 78 72 2 95 33 163 175 10 86 145 0 204 128 56 88 14 140 196 82 111 241 106 38 9 164 3 117 52 9 236 55 180 191 192 225 117 186 75 161 193 85 193 31 144 209 86 51 171 73 0 24 204 252 56 230 212 121 25 254 124 254 181 80 91 135 10 184 241 157 0 239 82 193 75 224 247 0 81 240 0 111 227 48 65 179 5 146 192 239 144 87 67 135 176 154 4 96 64 218 172 2 120 1 84 46 9 100 56 44 47 79 5 57 138 131 120 249 211 201 38 160 175 41 184 218 34 8 190 52 228 11 195 193 222 17 252 60 133 158 142 24 67 129 182 210 142 246 226 142 250 213 85 99 21 240 3 119 235 20 29 47 2 119 158 147 54 212 23 101 98 19 219 9 219 163 217 63 223 20 231 7 61 247 25 103 100 132 251 99 150 12 141 165 72 2 233 16 223 36 92 91 2 168 27 24 215 23 51 190 62 161 227 199 79 6 238 145 4 10 176 72 32 147 43 152 28 191 140 21 148 89 154 51 17 80 18 179 141 176 29 170 196 112 204 199 130 12 253 252 28 178 145 23 33 157 205 193 23 6 241 191 45 226 244 250 170 42 218 224 146 109 11 225 23 94 238 45 218 155 133 10 250 197 151 83 69 192 96 247 224 243 107 64 127 55 115 133 201 201 55 248 188 230 148 205 128 129 20 108 3 137 224 71 136 54 214 182 2 32 179 35 164 235 2 197 208 121 128 88 23 76 142 119 80 78 140 84 254 15 56 94 76 2 96 50 67 63 109 248 161 219 86 165 226 100 165 60 101 37 76 200 239 136 143 242 217 172 16 182 216 223 65 98 72 200 146 192 25 87 3 124 36 96 123 94 101 109 47 1 9 235 228 69 172 198 24 147 226 43 78 31 32 188 224 155 51 149 237 217 254 82 118 247 75 233 200 80 253 192 196 124 128 252 6 249 5 109 36 144 2 18 178 112 140 49 9 112 213 225 85 214 152 0 188 128 53 24 151 13 231 249 91 4 174 12 150 84 138 37 117 102 232 190 32 9 220 67 222 162 157 4 82 64 66 149 8 142 188 147 128 18 64 152 203 81 182 184 89 212 42 0 143 1 15 232 235 177 165 191 125 170 66 249 233 211 230 77 116 175 18 65 168 126 71 232 140 87 18 88 99 2 40 6 24 1 101 139 207 37 126 189 56 212 0 62 181 112 91 100 149 73 4 127 69 231 178 64 29 100 18 200 241 56 240 210 197 223 26 19 64 226 2 170 195 166 108 169 231 5 218 182 212 207 177 170 156 99 208 83 138 25 137 224 51 226 217 64 142 1 226 162 159 131 139 159 53 38 0 23 78 173 54 102 89 220 166 147 182 85 206 176 46 196 160 101 183 67 249 153 33 194 159 126 66 18 224 91 252 4 226 52 121 175 58 157 96 21 240 233 234 92 231 161 18 64 61 34 151 129 89 214 187 122 60 155 224 101 224 171 150 250 185 85 157 2 5 92 6 242 51 91 55 72 2 63 32 127 67 7 242 0 157 200 144 4 248 93 13 235 178 198 4 176 233 162 131 59 250 143 46 157 154 250 178 230 220 249 169 236 252 64 251 79 127 119 64 40 64 0 73 224 3 54 121 0 24 189 124 172 42 1 224 46 204 23 37 81 7 100 151 187 63 93 118 217 45 241 101 96 7 202 214 234 162 181 118 133 149 129 146 64 220 231 81 96 85 9 0 99 170 243 238 15 157 210 113 236 157 58 236 34 212 239 58 116 214 84 125 92 83 103 109 251 26 40 9 236 108 63 21 88 91 2 216 90 92 136 194 66 167 78 197 198 110 103 86 33 117 246 107 59 119 88 91 135 123 244 151 55 10 159 4 25 193 158 62 58 203 218 18 64 210 73 196 253 219 90 39 11 223 214 23 198 194 215 45 85 18 207 198 79 252 93 129 167 143 197 154 99 21 192 119 80 41 196 102 76 53 113 176 90 5 172 38 1 152 183 240 155 38 90 230 60 7 38 63 154 233 93 122 216 45 97 21 192 68 230 83 14 62 198 107 176 69 18 224 56 204 60 250 202 107 180 235 178 95 77 2 176 129 1 29 223 129 121 236 2 142 122 94 152 189 133 222 148 85 54 158 193 229 158 246 171 48 71 18 248 13 29 45 61 58 155 118 217 174 34 1 152 231 238 78 24 128 117 232 2 214 81 127 234 168 175 170 83 196 212 235 243 218 202 112 34 219 196 35 142 163 150 255 189 232 165 189 180 47 149 249 137 64 235 56 91 69 2 0 147 29 36 186 100 243 236 136 127 188 227 219 179 179 253 78 20 61 212 247 61 116 39 163 138 196 229 251 19 212 89 246 251 86 23 0 171 0 190 43 41 60 218 223 182 217 46 62 1 152 103 255 93 27 4 83 151 91 232 116 169 148 93 10 103 245 27 196 246 233 236 120 46 187 169 71 160 76 178 119 30 246 107 53 245 73 154 235 78 0 24 49 57 36 234 24 57 39 212 251 64 174 220 151 213 142 229 54 11 112 71 181 108 42 152 90 235 128 234 104 101 215 81 175 234 26 2 88 5 112 101 90 214 84 217 156 226 99 192 171 38 197 69 175 0 48 185 62 162 227 73 83 231 207 206 243 111 211 253 56 59 118 218 117 124 182 61 32 78 167 159 114 58 5 233 97 132 56 223 193 60 118 116 81 4 120 196 114 108 122 17 102 7 143 94 36 77 182 139 77 0 230 206 106 115 87 63 1 142 141 94 19 195 235 243 229 245 137 142 227 24 245 62 23 183 195 125 208 234 157 135 183 212 195 86 166 126 191 19 72 154 0 46 50 1 152 201 95 52 117 250 234 252 46 196 221 255 204 103 121 182 111 187 203 95 11 126 181 85 190 133 158 185 251 39 142 109 147 241 131 163 173 204 64 192 124 47 128 55 43 151 18 55 25 61 37 0 92 224 151 144 127 66 90 63 54 104 114 52 149 243 136 159 111 169 11 72 100 17 19 151 165 161 95 74 177 109 151 194 143 6 39 153 4 16 23 31 81 246 46 157 130 13 25 243 243 108 21 127 2 133 163 139 164 201 238 41 1 64 129 203 187 13 164 224 64 132 52 190 56 104 114 118 235 243 136 153 207 168 5 196 102 242 159 160 151 66 66 151 163 135 195 169 38 129 61 250 20 59 244 171 132 205 214 193 78 38 245 4 138 250 211 238 103 175 19 64 229 41 197 206 17 19 234 19 132 217 127 242 5 113 126 65 144 7 72 100 25 236 118 160 101 105 105 217 126 147 218 164 146 0 184 126 68 160 105 83 176 45 231 79 168 35 99 239 151 171 45 109 172 173 234 232 218 225 166 47 4 189 160 67 92 228 247 216 228 220 175 41 188 144 123 202 20 47 38 98 231 35 75 14 137 33 182 37 69 95 66 47 253 159 218 70 76 255 126 58 112 223 57 192 148 113 222 108 2 117 140 139 182 158 113 204 36 136 253 123 155 146 234 250 17 48 63 241 37 91 151 146 152 47 21 93 216 86 43 128 236 226 236 229 65 132 67 214 159 48 32 248 104 192 9 119 243 130 56 94 67 254 64 32 5 36 134 216 150 124 200 201 111 130 40 108 131 105 209 219 162 142 171 176 155 240 70 187 159 208 126 222 18 95 83 149 38 127 19 25 207 243 152 192 193 111 6 63 227 66 191 71 92 177 101 108 41 244 184 68 45 177 61 64 56 153 70 205 242 104 155 207 249 59 72 2 233 91 184 138 249 181 175 145 131 254 17 54 137 131 221 181 73 140 19 5 250 188 199 54 67 236 193 7 192 117 131 104 139 143 124 57 100 123 93 103 113 124 130 142 238 252 22 160 60 84 74 216 198 30 246 23 166 252 191 1 211 139 51 118 7 49 212 118 20 147 12 10 236 31 32 71 12 210 7 108 131 21 51 32 19 56 228 128 164 68 16 151 146 34 182 59 23 67 7 155 2 54 59 7 187 38 19 250 98 226 221 13 217 7 248 231 243 126 6 113 97 124 100 140 136 111 212 27 2 218 92 91 41 209 225 56 84 167 153 0 124 157 209 62 53 194 247 9 37 246 57 24 42 57 113 31 3 163 243 238 5 219 87 208 141 33 27 179 77 204 62 54 206 133 237 115 96 126 115 246 208 223 144 125 15 93 34 56 204 193 104 143 45 37 71 159 30 124 27 129 63 222 241 83 200 14 18 67 92 202 1 70 100 220 121 141 93 156 203 102 56 2 47 204 0 200 208 4 7 192 24 229 132 70 142 103 13 37 103 251 161 119 11 56 228 192 244 158 40 125 3 3 215 255 131 77 220 215 174 167 62 57 30 32 5 250 120 111 107 139 216 222 64 119 3 73 32 91 136 79 225 170 228 55 31 7 178 181 39 128 23 129 127 64 59 177 183 120 210 172 125 9 248 162 170 198 160 120 141 253 61 36 169 206 205 120 123 66 236 217 45 7 38 120 126 65 12 187 145 25 150 104 143 194 254 31 33 85 217 96 39 50 194 253 16 165 128 19 78 254 239 33 156 201 135 29 129 193 18 64 213 188 185 59 236 112 188 173 206 205 108 155 35 94 14 204 155 47 71 193 242 29 99 129 36 144 165 148 19 58 66 190 119 75 233 208 156 250 49 120 2 168 96 96 240 242 121 156 131 55 133 68 144 169 151 28 1 242 174 255 48 181 64 77 82 77 17 23 101 174 133 19 127 79 153 66 114 157 43 68 223 184 145 0 254 5 31 46 243 113 99 126 79 112 17 194 211 35 192 197 217 171 3 115 39 219 226 52 197 165 241 43 143 193 14 75 120 202 41 83 156 248 136 235 162 152 164 154 226 36 37 134 204 161 148 8 114 15 33 227 155 175 170 230 0 108 200 24 145 0 254 237 226 31 147 191 118 174 215 158 108 107 192 220 205 152 8 18 200 166 77 119 160 186 18 126 15 16 14 200 217 62 127 130 35 223 185 164 16 178 140 33 83 43 21 227 111 83 11 108 173 241 96 242 115 85 94 186 244 63 88 2 56 111 28 131 248 37 142 153 4 18 179 229 126 12 9 89 142 112 70 41 40 115 184 211 35 206 94 197 36 131 45 140 18 35 189 236 3 41 159 224 167 128 28 40 186 219 131 194 196 10 18 192 27 132 84 56 132 85 32 1 188 173 179 235 189 2 168 115 114 125 206 172 18 120 58 49 117 49 182 148 182 194 73 206 65 200 82 64 78 115 190 195 179 19 174 197 240 75 96 191 49 18 99 27 186 148 112 72 230 20 38 214 123 108 85 38 76 0 9 224 35 194 219 59 132 152 35 1 124 168 179 27 36 1 212 53 164 115 126 4 76 82 136 224 101 99 60 113 203 99 155 82 24 165 18 219 82 147 221 208 152 217 6 9 224 43 66 78 29 194 206 144 0 62 215 217 41 1 212 81 209 57 17 152 32 1 36 128 255 67 88 177 67 104 181 95 2 162 31 37 0 7 154 50 17 129 177 9 96 242 7 127 1 200 62 252 101 236 142 168 61 17 16 1 39 2 91 39 171 203 111 132 62 115 161 4 240 12 137 78 136 192 36 9 164 142 81 29 218 236 148 0 218 232 168 78 4 38 64 192 44 255 249 210 215 165 40 1 184 80 147 141 8 76 136 64 234 24 75 137 183 255 173 95 150 211 10 192 145 172 204 68 96 68 2 59 199 182 90 239 254 244 169 4 224 72 86 102 34 48 6 1 44 255 223 163 157 200 177 173 188 203 78 9 160 139 144 234 69 224 182 4 50 199 230 143 93 203 127 250 85 2 112 164 43 51 17 24 154 0 238 254 159 208 70 236 216 206 222 198 78 9 192 134 146 116 68 96 100 2 152 252 252 161 157 235 179 255 9 182 7 155 144 149 0 108 40 73 71 4 198 39 144 163 201 200 177 217 61 150 255 86 127 187 65 9 192 145 176 204 68 96 40 2 184 251 191 131 239 173 163 127 222 253 247 182 182 74 0 182 164 164 39 2 35 16 48 75 255 220 163 41 235 187 63 219 80 2 240 32 45 83 17 24 128 192 1 62 35 71 191 37 236 172 239 254 108 67 9 128 20 84 68 96 2 4 112 247 255 138 48 18 143 80 118 182 207 254 85 27 74 0 21 9 109 69 224 134 4 48 249 249 133 159 212 35 132 3 38 127 239 191 223 168 4 224 65 92 166 34 16 130 128 153 252 185 135 175 19 108 119 46 246 74 0 46 212 100 35 2 129 8 4 152 252 140 132 75 255 7 151 144 148 0 92 168 201 70 4 2 16 8 52 249 249 7 63 239 92 195 81 2 112 37 39 59 17 240 32 128 201 207 191 240 155 123 184 160 233 17 226 180 244 175 218 213 223 4 172 72 104 43 2 35 17 192 228 231 219 254 212 179 57 62 247 243 143 125 182 254 222 191 171 13 37 128 46 66 170 23 129 64 4 48 241 95 193 213 1 178 9 224 178 241 47 253 246 241 173 71 128 62 180 164 43 2 142 4 48 249 249 245 222 35 36 196 228 79 113 231 191 119 12 229 194 76 43 128 11 28 58 16 129 176 4 48 241 249 171 190 28 178 13 228 153 147 255 46 144 47 125 19 48 20 72 249 17 129 107 2 152 252 124 209 87 66 38 57 249 25 175 86 0 164 160 34 2 1 9 96 226 191 129 187 61 36 196 114 191 138 44 232 157 191 114 170 4 80 145 208 86 4 60 9 152 137 159 193 77 226 233 234 218 124 144 201 207 70 148 0 174 81 235 88 4 122 18 24 112 226 159 16 10 39 127 239 239 248 219 118 65 9 192 150 148 244 26 9 96 2 188 70 229 1 146 113 139 1 107 245 215 104 160 59 235 130 126 243 7 60 59 72 200 165 126 197 164 196 206 22 44 189 62 231 175 156 53 109 127 110 170 208 121 17 232 65 32 133 110 12 201 33 39 76 12 38 3 167 95 167 193 110 210 197 36 59 78 250 45 36 26 40 216 130 254 199 72 164 90 1 12 116 5 215 228 22 147 226 95 232 111 221 100 56 225 252 129 50 228 50 118 104 214 102 210 167 104 103 11 137 33 67 150 12 172 62 15 217 192 185 111 37 128 115 26 218 239 77 0 147 227 29 140 56 201 109 74 1 165 71 193 32 191 183 49 184 133 14 250 196 111 236 37 70 56 233 35 200 208 165 68 3 124 222 31 149 139 18 192 208 151 117 225 254 49 89 190 114 224 58 118 179 128 221 177 18 12 254 65 159 119 235 98 68 252 47 113 126 3 73 204 150 251 49 100 204 178 71 99 188 243 143 254 238 68 9 96 204 203 188 192 182 48 129 154 150 255 174 189 101 66 56 65 10 227 160 218 30 93 39 8 98 228 231 242 44 241 149 112 178 71 144 91 149 18 13 143 126 215 63 239 172 18 192 57 13 237 247 34 128 137 213 103 249 223 203 183 133 114 209 162 115 235 137 221 18 218 99 21 19 220 30 9 237 115 151 226 143 100 131 162 0 0 2 41 73 68 65 84 208 245 250 20 96 104 194 203 246 191 189 97 247 146 27 182 237 211 116 14 227 157 235 106 198 167 225 58 91 37 128 58 42 58 103 75 224 150 9 192 54 198 169 232 229 8 132 207 249 15 83 9 136 113 40 1 76 233 106 204 40 22 179 252 143 102 20 242 173 66 205 209 240 228 38 126 5 67 9 160 34 161 109 95 2 154 252 205 196 78 168 202 33 124 206 159 212 29 255 58 100 189 4 188 38 162 99 107 2 230 237 250 14 6 91 107 163 101 43 30 209 189 61 228 48 149 103 252 46 220 74 0 93 132 84 223 73 0 137 128 95 156 97 34 72 33 17 100 77 229 132 206 230 20 76 250 209 191 199 224 11 90 9 192 151 160 236 47 8 152 119 3 91 156 164 44 53 25 112 210 31 40 152 244 223 176 157 109 81 2 152 237 165 155 126 224 38 25 36 136 148 178 129 204 185 28 17 124 1 153 229 157 190 9 188 18 64 19 25 157 15 74 0 201 128 95 185 77 140 48 25 112 127 202 165 154 240 5 130 44 230 242 76 223 23 168 18 64 95 98 210 15 70 0 73 225 53 156 197 144 42 33 68 102 31 155 81 75 129 214 74 8 39 253 17 147 253 30 219 85 20 37 128 85 92 230 121 117 18 137 129 47 21 99 200 121 66 224 49 165 42 49 118 40 109 133 19 250 100 20 184 229 49 75 117 158 147 125 244 31 224 252 25 130 254 21 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 152 4 129 255 7 43 226 4 233 145 30 174 153 0 0 0 0 73 69 78 68 174 66 96 130 40 0 0 0 48 0 0 0 96 0 0 0 1 0 32 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 63 35 46 189 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 127 35 46 189 191 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 239 35 46 189 175 35 46 189 111 35 46 189 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 79 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 175 35 46 189 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 255 35 46 189 255 35 46 189 191 35 46 189 127 35 46 189 95 35 46 189 63 35 46 189 63 35 46 189 63 35 46 189 111 35 46 189 143 35 46 189 223 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 159 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 207 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 207 35 46 189 255 35 46 189 255 35 46 189 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 239 35 46 189 255 35 46 189 255 35 46 189 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 127 35 46 189 255 35 46 189 255 35 46 189 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 63 102 102 102 63 102 102 102 63 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 255 35 46 189 255 35 46 189 207 0 0 0 0 102 102 102 15 102 102 102 95 102 102 102 175 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 159 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 159 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 223 35 46 189 255 35 46 189 255 0 0 0 0 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 143 102 102 102 127 102 102 102 127 102 102 102 191 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 95 102 102 102 63 102 102 102 111 102 102 102 191 102 102 102 255 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 191 35 46 189 255 35 46 189 255 0 0 0 0 102 102 102 191 102 102 102 159 102 102 102 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 175 102 102 102 255 102 102 102 207 102 102 102 15 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 255 102 102 102 255 102 102 102 239 102 102 102 79 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 159 102 102 102 255 102 102 102 255 102 102 102 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 239 35 46 189 255 35 46 189 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 175 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 255 102 102 102 255 102 102 102 79 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 223 102 102 102 255 102 102 102 255 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 255 35 46 189 255 35 46 189 223 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 255 102 102 102 223 0 0 0 0 0 0 0 0 102 102 102 127 102 102 102 255 102 102 102 159 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 159 102 102 102 255 102 102 102 255 102 102 102 175 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 191 35 46 189 255 35 46 189 255 35 46 189 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 207 102 102 102 255 0 0 0 0 0 0 0 0 102 102 102 191 102 102 102 255 102 102 102 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 127 102 102 102 255 102 102 102 255 102 102 102 239 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 159 35 46 189 255 35 46 189 255 35 46 189 239 35 46 189 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 191 102 102 102 255 0 0 0 0 0 0 0 0 102 102 102 191 102 102 102 175 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 175 102 102 102 255 102 102 102 255 102 102 102 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 79 35 46 189 207 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 239 102 102 102 255 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 143 35 46 189 143 35 46 189 127 35 46 189 127 35 46 189 127 35 46 189 191 35 46 189 239 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 223 35 46 189 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 255 102 102 102 207 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 207 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 207 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 143 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 111 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 239 102 102 102 255 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 79 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 95 35 46 189 191 35 46 189 191 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 223 35 46 189 127 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 111 102 102 102 239 102 102 102 255 102 102 102 159 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 191 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 143 35 46 189 223 35 46 189 255 35 46 189 255 35 46 189 239 35 46 189 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 111 102 102 102 223 102 102 102 255 102 102 102 255 102 102 102 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 159 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 95 35 46 189 239 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 159 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 79 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 143 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 175 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 79 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 159 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 159 35 46 189 255 35 46 189 255 35 46 189 191 0 0 0 0 0 0 0 0 102 102 102 79 102 102 102 255 102 102 102 255 102 102 102 175 102 102 102 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 223 35 46 189 255 35 46 189 255 35 46 189 63 0 0 0 0 102 102 102 239 102 102 102 255 102 102 102 111 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 191 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 111 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 95 35 46 189 255 35 46 189 255 35 46 189 159 102 102 102 79 102 102 102 255 102 102 102 207 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 79 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 255 35 46 189 255 35 46 189 223 102 102 102 127 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 255 35 46 189 255 35 46 189 255 102 102 102 127 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 159 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 255 35 46 189 255 35 46 189 239 102 102 102 95 102 102 102 255 102 102 102 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 207 102 102 102 223 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 95 35 46 189 255 35 46 189 255 35 46 189 175 102 102 102 15 102 102 102 239 102 102 102 239 102 102 102 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 175 102 102 102 255 102 102 102 255 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 255 102 102 102 191 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 127 35 46 189 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 239 35 46 189 255 35 46 189 255 35 46 189 95 0 0 0 0 102 102 102 127 102 102 102 255 102 102 102 207 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 255 102 102 102 255 102 102 102 207 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 207 102 102 102 255 102 102 102 159 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 255 35 46 189 255 35 46 189 239 35 46 189 159 35 46 189 95 35 46 189 63 35 46 189 31 35 46 189 63 35 46 189 79 35 46 189 159 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 191 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 143 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 127 102 102 102 127 102 102 102 143 102 102 102 207 102 102 102 255 102 102 102 239 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 31 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 207 102 102 102 255 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 127 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 191 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 175 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 191 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 79 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 111 35 46 189 191 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 111 102 102 102 127 102 102 102 127 102 102 102 127 102 102 102 127 102 102 102 63 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 63 35 46 189 63 35 46 189 63 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 40 0 0 0 32 0 0 0 64 0 0 0 1 0 32 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 1 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 1 1 0 0 1 1 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 3 3 1 2 6 9 1 2 7 11 1 1 6 9 1 1 5 7 1 1 5 8 1 2 7 10 1 2 7 10 1 1 4 5 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 4 6 1 1 5 5 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 4 5 20 23 14 19 78 99 24 32 130 169 29 38 159 209 31 41 170 226 31 41 167 222 27 36 147 193 19 25 104 134 8 10 40 47 0 0 0 0 0 0 0 1 1 1 4 5 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0 0 1 2 7 8 0 0 0 0 22 29 120 142 41 54 220 255 31 41 168 223 27 35 147 192 24 31 130 170 25 33 136 178 30 39 161 214 36 48 196 251 39 52 213 255 30 39 159 210 9 12 50 58 0 0 0 0 1 1 4 5 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 1 3 4 0 0 0 0 5 7 29 34 6 8 32 37 0 0 0 0 0 1 2 3 0 0 0 0 0 0 0 0 0 0 0 0 2 3 10 9 13 17 70 89 32 42 175 221 40 52 214 255 18 24 98 123 0 0 0 0 1 1 3 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0 0 1 1 4 6 1 2 7 10 1 2 8 11 1 2 8 11 1 1 5 8 0 0 0 0 0 0 1 2 1 1 4 3 23 30 124 154 41 54 221 255 16 22 89 111 0 0 0 0 1 1 1 2 4 4 4 10 5 5 5 13 3 3 3 7 2 2 2 5 4 4 4 10 5 5 5 11 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 2 2 2 4 3 3 3 9 2 2 2 7 0 0 0 1 0 0 0 0 3 3 3 7 4 4 4 11 0 0 2 2 0 0 2 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 5 6 1 1 4 7 0 1 2 0 28 36 149 192 37 49 200 255 5 7 29 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 2 2 5 1 1 1 3 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 4 4 4 6 5 5 5 9 0 0 0 0 0 0 0 0 1 1 0 2 1 1 0 2 0 0 0 0 0 0 1 1 0 0 1 1 0 0 1 1 0 0 0 0 0 0 1 1 0 0 0 0 1 1 6 7 0 0 0 0 10 13 55 67 40 52 215 255 18 23 96 119 7 7 7 11 39 39 39 90 74 74 74 177 83 83 83 201 84 84 84 202 80 80 80 191 50 50 50 117 3 3 3 6 0 0 0 1 1 1 1 2 0 0 0 0 21 21 21 44 60 60 60 141 89 89 89 219 94 94 94 226 84 84 84 200 84 84 84 201 54 54 54 125 5 5 5 9 1 1 1 3 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 2 2 0 0 0 0 3 4 17 18 36 47 195 255 25 34 138 177 51 51 51 106 94 94 94 226 48 48 48 113 28 28 28 66 23 23 23 55 36 36 36 82 83 83 83 197 90 90 90 215 9 9 9 16 0 0 0 1 1 1 1 0 88 88 88 205 119 119 119 255 67 67 67 159 16 16 16 37 10 10 10 22 23 23 23 54 91 91 91 213 94 94 94 223 13 13 13 29 0 0 0 0 1 1 1 1 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 0 0 0 1 1 0 0 0 0 3 4 15 15 35 47 193 255 27 36 147 188 4 4 4 7 3 3 3 6 0 0 0 0 1 1 1 1 0 0 0 0 4 4 4 9 0 0 0 0 72 72 72 166 78 78 78 179 0 0 0 0 12 12 12 25 102 102 102 250 59 59 59 139 0 0 0 0 2 2 2 5 0 0 0 0 0 0 0 0 12 12 12 24 107 107 107 255 85 85 85 197 0 0 0 0 1 1 1 3 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0 0 2 3 10 13 0 0 0 0 9 12 48 56 39 51 210 255 22 29 120 151 1 1 1 1 2 2 2 7 5 5 5 13 4 4 4 8 2 2 2 5 7 7 7 17 0 0 0 1 14 14 14 33 102 102 102 239 3 3 3 3 25 25 25 56 102 102 102 237 5 5 5 9 3 3 3 9 3 3 3 8 0 0 0 0 3 3 3 9 4 4 4 7 80 80 80 193 112 112 112 255 28 28 28 59 0 0 0 0 3 3 4 7 0 0 4 5 1 2 7 10 1 1 4 7 0 0 0 0 0 0 1 2 1 1 4 2 27 35 143 183 40 52 214 255 10 13 53 62 0 0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 9 9 9 21 101 101 101 239 10 10 10 19 31 31 31 73 61 61 61 142 0 0 0 0 5 5 5 11 0 0 0 0 1 1 1 1 1 1 1 3 5 5 5 8 88 88 88 212 113 113 113 255 44 44 44 98 0 0 0 0 3 4 4 9 0 0 0 0 0 0 0 1 0 0 0 0 2 2 8 7 11 14 57 72 31 40 164 207 40 52 215 255 19 25 102 131 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0 0 0 1 0 0 0 0 7 7 7 17 0 0 0 0 21 21 21 49 102 102 102 239 8 8 8 15 0 0 0 0 3 3 3 5 0 0 0 1 0 0 0 1 2 2 2 5 4 4 4 10 0 0 0 0 48 48 48 109 105 105 105 255 106 106 104 255 41 42 45 95 0 0 0 0 11 13 44 56 31 40 172 223 28 38 154 207 29 37 154 204 31 40 165 218 34 45 184 242 30 39 160 211 14 18 73 89 0 0 2 0 0 0 2 3 0 0 0 0 0 0 0 0 0 0 0 1 4 4 4 11 1 1 1 3 2 2 2 5 0 0 0 0 89 89 89 205 73 73 73 168 0 0 0 0 4 4 4 10 0 0 0 0 2 2 2 4 2 2 2 5 0 0 0 0 3 3 3 4 56 56 56 129 103 103 103 250 101 101 102 252 100 100 100 235 10 11 12 24 0 0 0 0 4 6 21 24 22 30 123 160 28 36 148 194 33 44 181 238 38 51 208 255 30 39 160 202 7 8 35 39 0 0 0 0 1 1 6 8 0 0 1 2 0 0 0 0 1 1 1 3 2 2 2 5 0 0 0 0 3 3 3 6 36 36 36 82 98 98 98 235 83 83 83 196 5 5 5 9 0 0 0 2 0 0 0 0 1 1 1 2 1 1 1 5 0 0 0 0 37 37 37 83 88 88 88 212 106 106 106 255 103 103 103 251 109 109 109 255 37 37 37 85 0 0 0 0 2 2 2 5 0 0 0 0 0 0 0 1 0 0 0 0 1 1 6 4 10 13 52 62 27 35 145 188 40 52 213 255 25 33 136 173 3 4 15 16 0 0 0 2 0 0 0 0 1 1 1 3 2 2 2 2 53 53 53 124 98 98 98 236 96 96 96 231 46 46 46 108 0 0 0 0 2 2 2 5 0 0 0 0 1 1 1 1 0 0 0 0 11 11 11 21 76 76 76 183 107 107 107 255 106 106 106 252 107 107 107 255 90 90 90 219 28 28 28 61 0 0 0 0 2 2 2 4 0 0 0 0 1 1 2 2 2 2 8 11 1 2 7 10 0 0 0 1 0 0 2 3 0 0 0 0 11 15 61 76 38 49 203 254 31 40 166 211 3 4 18 21 0 0 0 0 9 9 9 16 89 89 89 210 96 96 96 230 34 34 34 78 2 2 2 4 0 0 0 0 2 2 2 6 1 1 1 2 0 0 0 0 0 0 0 0 9 9 9 18 92 92 92 214 108 108 108 255 104 104 104 254 94 94 94 227 46 46 46 107 4 4 4 7 0 0 0 0 1 1 1 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 3 4 1 2 8 12 0 0 0 0 10 13 54 64 39 52 212 255 25 32 133 166 0 0 0 0 79 79 79 182 83 83 83 191 0 0 0 0 2 2 2 5 1 1 1 3 4 4 4 11 1 1 1 1 0 0 0 0 3 3 3 8 0 0 0 0 64 64 64 146 109 109 109 255 101 101 101 248 69 69 69 160 6 6 6 10 0 0 0 0 1 1 1 3 3 3 3 6 2 2 2 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 2 0 0 0 0 0 0 0 1 0 0 0 0 2 2 9 13 0 0 0 0 24 32 132 170 38 50 205 255 11 11 11 23 102 102 102 241 18 18 18 40 0 0 0 0 6 6 6 14 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 1 2 2 2 2 86 86 86 204 111 111 111 255 66 66 66 153 0 0 0 0 3 3 3 8 3 3 3 7 1 1 1 2 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 1 1 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0 0 1 1 5 7 0 0 0 0 15 20 82 105 40 53 217 255 19 19 19 41 96 96 96 228 11 11 11 25 2 2 2 5 0 0 0 0 0 0 0 0 0 0 0 0 3 3 3 7 2 2 2 3 0 0 0 0 4 4 4 6 88 88 88 213 110 110 110 255 25 25 25 55 0 0 0 0 2 2 2 4 0 0 0 1 0 0 0 0 15 15 15 34 38 38 38 86 0 0 0 0 2 2 2 4 0 0 0 0 1 1 2 4 1 2 8 11 1 1 6 7 1 1 4 5 0 0 0 0 2 3 12 17 0 0 0 0 16 21 87 111 40 53 216 255 1 1 1 1 98 98 98 227 30 30 30 67 0 0 0 0 5 5 5 13 2 2 2 6 2 2 2 4 0 0 0 0 0 0 0 0 2 2 2 6 0 0 0 0 74 74 74 171 111 111 111 255 19 19 19 44 0 0 0 0 4 4 4 11 10 10 10 24 0 0 0 0 54 54 54 122 78 78 77 173 0 0 0 0 4 4 2 8 0 1 10 8 3 4 14 14 0 0 0 0 0 0 2 2 0 0 0 0 0 0 0 0 0 0 0 1 2 2 9 6 29 38 157 203 37 48 198 255 0 0 0 0 46 46 46 105 101 101 101 235 20 20 20 44 0 0 0 0 1 1 1 4 0 0 0 0 29 29 29 65 15 15 15 34 0 0 0 0 0 0 0 0 22 22 22 50 115 115 115 255 62 62 62 141 0 0 0 0 3 3 3 6 0 0 0 0 5 5 5 6 98 98 99 237 51 51 48 119 0 0 0 0 1 0 0 0 16 21 92 106 38 50 204 255 20 27 109 144 11 15 60 75 5 7 30 37 6 8 32 38 13 17 68 85 30 39 161 203 41 54 220 255 19 24 100 127 2 2 2 5 0 0 0 0 43 43 43 99 93 93 93 222 83 83 83 199 83 83 83 197 86 86 86 207 100 100 100 238 32 32 32 71 0 0 0 0 4 4 4 10 0 0 0 0 33 33 33 76 100 100 100 241 75 75 75 176 44 44 44 103 54 54 54 131 95 95 95 220 117 117 117 255 36 36 35 84 0 0 0 0 3 3 2 6 2 2 14 14 18 24 98 125 33 43 177 233 38 49 203 255 38 50 205 255 38 50 207 255 39 52 213 255 34 45 183 239 16 21 85 107 0 0 2 0 0 0 0 0 2 2 2 4 0 0 0 0 4 4 4 7 24 24 24 55 30 30 30 73 23 23 23 52 4 4 4 8 0 0 0 0 0 0 0 1 0 0 0 0 2 2 2 4 0 0 0 0 6 6 6 12 45 45 45 104 60 60 60 148 63 63 63 156 49 49 49 116 23 23 23 51 3 3 3 6 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 4 6 26 29 10 13 56 69 12 15 63 78 8 11 44 53 2 2 9 7 0 0 0 0 1 1 3 4 0 0 0 1 0 0 0 0 4 4 4 9 2 2 2 5 0 0 0 0 0 0 0 1 0 0 0 0 1 1 1 4 2 2 2 4 0 0 0 0 0 0 0 1 0 0 0 0 2 2 2 6 1 1 1 3 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 1 2 2 1 2 8 10 1 1 4 6 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 2 1 1 5 7 0 0 1 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 1 3 3 3 7 4 4 4 9 3 3 3 6 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 1 1 1 1 5 5 5 11 5 5 5 13 5 5 5 13 4 4 4 11 2 2 2 5 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 3 3 1 1 5 7 1 1 6 7 1 1 4 5 0 0 1 1 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 40 0 0 0 24 0 0 0 48 0 0 0 1 0 32 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 1 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 2 2 9 12 1 1 4 6 0 0 0 0 0 0 0 0 0 0 1 2 2 2 8 12 1 2 7 9 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 2 10 12 3 3 15 18 0 1 3 3 0 0 0 0 0 0 0 0 1 1 4 6 1 1 3 4 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 1 2 0 0 0 0 2 3 11 12 24 31 128 166 32 42 171 225 33 43 176 232 33 43 178 236 33 43 175 230 28 37 152 199 14 18 75 96 0 0 1 1 0 1 2 3 0 0 2 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 2 0 0 0 0 2 3 12 14 21 27 110 142 12 15 63 82 6 8 33 41 5 7 30 38 9 12 50 64 19 24 100 130 34 44 181 237 31 41 167 217 5 6 26 30 0 0 0 0 1 1 1 1 4 4 4 9 5 5 5 12 5 5 5 11 5 5 5 12 1 1 1 3 0 0 0 0 0 0 0 0 0 0 0 0 3 3 3 7 5 5 5 13 3 3 3 9 5 5 5 12 2 2 2 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 3 4 0 0 0 0 25 32 133 166 35 45 186 233 3 3 14 17 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 2 2 4 2 2 2 4 0 0 0 0 1 1 1 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 2 4 4 11 17 1 1 6 8 1 1 3 5 1 1 3 5 1 1 5 7 2 2 7 10 2 2 9 12 0 0 0 0 32 41 170 216 23 30 123 155 4 4 4 7 30 30 30 71 53 53 53 126 56 56 56 132 45 45 45 108 9 9 9 21 0 0 0 0 1 1 1 2 3 3 3 6 32 32 32 75 64 64 64 153 62 62 62 145 55 55 55 131 19 19 19 42 0 0 0 0 2 2 1 3 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0 0 2 2 8 11 0 0 0 0 17 23 94 122 33 43 178 231 44 44 44 91 72 72 72 172 38 38 38 89 34 34 34 81 50 50 50 118 82 82 82 196 24 24 24 56 0 0 0 0 54 54 54 125 115 115 115 255 51 51 51 121 23 23 23 55 34 34 34 79 92 92 92 221 44 44 45 107 0 0 0 0 2 2 3 7 0 0 0 0 0 0 1 2 0 0 0 0 2 2 8 11 0 0 0 0 15 20 82 107 35 45 186 242 1 1 1 2 1 1 1 2 0 0 0 0 4 4 4 8 0 0 0 0 29 29 29 67 84 84 84 195 0 0 0 0 83 83 83 193 48 48 48 113 0 0 0 0 8 8 8 18 0 0 0 0 38 38 38 88 113 113 113 255 15 15 15 35 0 0 0 0 2 3 6 10 0 1 8 10 1 1 4 6 2 2 8 12 0 0 0 0 26 34 139 178 30 40 165 208 0 0 0 1 4 4 4 10 4 4 4 10 2 2 2 4 7 7 7 16 5 5 5 12 79 79 79 184 12 12 12 24 64 64 64 151 9 9 9 21 0 0 0 0 9 9 9 20 0 0 0 1 25 25 25 58 115 115 115 255 44 44 44 101 0 0 0 0 3 3 3 8 0 0 0 0 1 1 1 2 2 2 9 11 22 29 120 152 38 50 207 255 9 12 49 62 0 0 0 1 0 0 0 0 0 0 0 1 5 5 5 12 0 0 0 0 15 15 15 33 86 86 86 199 2 2 2 4 6 6 6 13 2 2 2 4 0 0 0 0 1 1 1 3 0 0 0 0 66 66 66 159 116 116 115 255 41 41 44 97 0 0 0 0 25 32 121 158 28 37 157 207 29 38 153 204 32 42 171 225 25 33 137 177 8 10 43 53 0 0 0 0 0 0 0 0 3 3 3 7 1 1 1 2 0 0 0 1 7 7 7 15 83 83 83 198 51 51 51 121 0 0 0 0 5 5 5 11 0 0 0 0 0 0 0 0 18 18 18 38 74 74 74 178 112 112 112 255 95 95 95 225 10 11 12 26 0 0 0 0 10 13 52 66 17 23 95 122 25 33 134 176 33 43 178 233 19 26 104 133 1 1 5 5 0 0 1 2 1 1 1 3 0 0 0 0 18 18 18 41 65 65 65 155 86 86 86 206 45 45 45 106 0 0 0 0 2 2 2 4 0 0 0 0 6 6 6 10 59 59 59 142 106 106 106 248 115 115 115 255 87 87 87 214 21 21 21 46 0 0 0 0 1 1 1 3 0 0 0 0 0 0 0 0 0 0 0 0 3 4 16 20 27 35 144 185 35 46 188 240 6 7 31 39 0 0 0 0 38 38 38 88 92 92 92 221 45 45 45 105 7 7 7 14 0 0 0 0 2 2 2 4 0 0 0 0 3 3 3 5 79 79 79 190 118 118 118 255 93 93 93 223 44 44 44 105 5 5 5 9 1 1 1 3 1 1 2 3 0 0 0 0 1 1 4 6 2 2 10 13 1 1 5 8 1 2 8 10 0 0 0 0 22 29 121 151 34 44 182 230 10 10 10 21 92 92 92 212 14 14 14 32 0 0 0 0 2 2 2 6 0 0 0 0 3 3 3 7 0 0 0 0 41 41 41 93 117 117 117 255 70 70 70 170 8 8 8 16 0 0 0 0 1 1 1 3 1 1 1 4 0 0 0 0 0 0 1 1 0 1 2 3 0 0 0 0 0 0 0 0 0 1 2 3 0 0 2 3 3 4 17 21 37 48 198 255 34 34 34 75 70 70 70 162 0 0 0 0 14 14 14 34 3 3 3 6 2 2 2 5 5 5 5 13 0 0 0 0 59 59 59 134 108 108 108 255 16 16 16 35 0 0 0 0 7 7 7 16 2 2 2 5 17 17 17 39 2 2 2 5 0 0 0 0 0 0 0 0 1 1 5 7 2 2 10 14 1 2 8 10 1 2 7 11 1 1 4 4 34 44 183 241 15 15 15 35 84 84 84 193 3 3 3 5 0 0 0 0 1 1 1 1 0 0 0 0 4 4 4 9 0 0 0 0 42 42 42 96 110 110 110 255 5 5 5 13 0 0 0 1 0 0 0 0 8 8 7 17 75 75 76 174 2 2 1 3 0 1 3 4 7 10 39 47 0 0 2 3 0 0 0 0 1 1 5 6 0 0 0 0 12 15 63 77 39 51 210 255 0 0 0 0 51 51 51 118 75 75 75 178 34 34 34 80 31 31 31 72 58 58 58 137 29 29 29 66 0 0 0 0 3 3 3 5 83 83 83 199 67 67 67 157 7 7 7 15 6 6 6 15 75 75 74 174 83 83 83 188 0 0 0 0 5 6 10 14 26 35 150 190 31 41 167 220 22 30 121 159 20 27 111 146 26 34 139 182 38 50 206 255 19 25 104 132 1 1 1 3 0 0 0 0 27 27 27 64 57 57 57 135 57 57 57 138 50 50 50 119 12 12 12 27 0 0 0 0 1 1 1 3 3 3 3 7 53 53 53 125 65 65 65 156 67 67 67 163 75 75 76 182 28 28 28 67 0 0 0 0 1 1 1 3 0 0 3 2 12 15 62 79 21 28 116 150 25 33 134 174 23 30 122 159 9 11 47 59 0 0 0 0 0 0 0 0 2 2 2 6 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 2 1 1 1 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 1 1 0 1 3 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 4 5 0 0 0 0 0 0 0 0 3 3 3 8 5 5 5 12 5 5 5 11 5 5 5 13 2 2 2 4 0 0 0 0 0 0 0 0 0 0 0 1 4 4 4 11 2 2 2 4 1 1 1 3 4 4 4 11 2 2 2 5 0 0 0 0 0 0 0 0 0 0 0 0 1 2 7 9 2 2 10 13 2 2 9 13 2 2 9 13 1 1 4 6 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 40 0 0 0 16 0 0 0 32 0 0 0 1 0 32 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 2 3 1 2 7 10 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 4 5 7 8 34 44 9 12 52 69 8 10 41 53 1 2 7 9 0 0 0 0 1 1 4 5 0 0 0 1 3 3 3 6 3 3 3 9 2 2 2 4 0 0 0 0 0 0 0 0 1 1 0 0 5 5 9 16 1 0 0 0 12 17 71 89 25 33 136 177 20 27 109 143 23 30 122 160 27 35 144 188 15 20 82 106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 2 2 2 2 4 0 0 0 1 1 1 0 2 0 0 0 0 0 0 0 0 2 3 5 8 1 1 1 2 0 0 0 0 1 1 2 3 1 2 7 8 25 34 138 180 18 24 99 129 2 2 2 5 18 18 18 44 28 28 28 65 11 11 11 26 0 0 0 0 0 0 0 0 11 11 11 26 33 33 33 78 22 22 23 53 2 2 1 4 1 2 5 8 1 2 7 9 1 1 4 6 0 0 0 0 2 3 13 16 29 39 158 201 31 31 31 66 51 51 51 121 28 28 28 66 61 61 61 144 24 24 24 57 14 14 14 33 93 93 93 225 31 31 31 73 43 43 43 102 66 66 66 158 2 2 2 4 0 0 1 2 0 0 2 2 3 3 14 18 0 0 0 0 27 36 147 187 0 0 0 0 1 1 1 3 0 0 0 0 9 9 9 21 49 49 49 114 43 43 43 98 35 35 35 81 0 0 0 0 0 0 0 0 79 79 79 187 46 46 47 111 0 0 0 0 6 6 10 18 0 0 0 0 13 17 70 89 31 41 167 211 1 1 1 2 6 6 6 14 0 0 0 0 9 9 9 21 60 60 60 142 7 7 7 14 5 5 5 11 0 0 0 0 8 8 7 16 102 102 105 249 45 45 38 99 0 1 34 32 28 35 131 178 26 34 147 192 25 33 135 176 3 4 16 19 0 0 0 1 2 2 2 5 26 26 26 61 65 65 65 154 27 27 27 62 0 0 0 0 2 2 2 4 39 39 39 95 105 105 105 252 86 86 87 206 5 5 3 11 1 2 8 9 8 10 42 54 15 20 85 110 23 30 124 161 8 11 45 58 1 1 1 2 60 60 60 143 50 50 50 119 9 9 9 20 2 2 2 4 0 0 0 0 71 71 71 166 110 110 110 255 46 46 46 113 4 4 5 8 0 0 0 2 0 0 0 0 0 1 2 3 0 0 0 0 6 7 31 39 31 41 170 218 37 37 37 85 44 44 44 102 0 0 0 0 7 7 7 17 0 0 0 0 23 23 23 51 102 102 102 246 15 15 15 36 0 0 0 0 4 4 4 9 2 2 2 4 0 0 0 0 0 0 0 0 3 4 17 22 0 0 0 0 20 27 109 140 29 29 29 68 48 48 48 113 0 0 0 0 7 7 7 15 0 0 0 0 17 17 17 42 87 87 87 206 4 4 5 9 0 0 0 0 47 48 50 115 16 16 11 32 1 3 30 30 9 11 39 52 0 0 0 0 2 3 12 14 29 39 159 204 0 0 0 0 43 43 43 102 48 48 48 113 53 53 53 124 27 27 27 63 0 0 0 0 46 46 46 110 52 52 52 124 42 42 40 98 77 77 79 188 1 1 0 0 7 10 41 51 24 31 128 166 22 30 124 162 27 36 147 192 17 23 93 121 1 1 1 3 0 0 0 0 5 5 5 12 5 5 5 12 0 0 0 0 1 1 1 3 0 0 0 0 9 9 9 21 17 17 17 41 2 2 2 6 0 0 0 0 0 0 1 1 0 0 0 0 2 2 10 12 1 1 6 7 0 0 0 0 0 0 0 0 3 3 3 7 0 0 0 0 0 0 0 0 1 1 1 2 0 0 0 0 2 2 2 6 1 1 1 2 0 0 0 0 1 1 2 4 0 0 0 0 1 1 4 5 1 1 6 8 0 0 0 0 0 0 2 3 1 1 6 9 0 0 0 0 0 0 0 0 1 1 1 2 1 1 1 2 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 3 2 2 2 6 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 2 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0) asByteArray! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 2/25/2011 11:39'!
faviconFilename

	^ 'favicon.ico'! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 2/25/2011 11:39'!
faviconMimeType

	^ 'image/x-icon'! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 5/10/2011 12:16'!
favicons
	^ #(0 0 1 0 5 0 0 0 0 0 1 0 32 0 110 34 0 0 86 0 0 0 48 48 0 0 1 0 32 0 104 38 0 0 196 34 0 0 32 32 0 0 1 0 32 0 40 17 0 0 44 73 0 0 24 24 0 0 1 0 32 0 184 9 0 0 84 90 0 0 16 16 0 0 1 0 32 0 104 4 0 0 12 100 0 0 137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 1 0 0 0 1 0 8 6 0 0 0 92 114 168 102 0 0 32 0 73 68 65 84 120 1 237 157 75 146 219 72 146 134 75 109 181 23 110 32 148 205 126 196 62 129 32 155 3 136 125 2 65 155 222 138 117 2 65 39 16 107 219 27 33 79 80 212 1 198 10 121 130 166 102 63 54 200 19 52 117 130 158 255 207 10 164 145 76 60 2 17 1 16 143 63 204 92 120 132 187 135 199 135 8 71 0 36 83 63 253 164 34 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 34 32 2 235 33 240 98 61 93 93 126 79 255 254 247 191 191 65 47 55 144 8 146 64 88 146 199 127 237 254 41 140 218 17 219 19 132 199 167 127 252 227 31 223 177 85 89 32 1 37 128 153 94 84 76 246 151 8 61 57 19 78 252 33 75 1 231 76 12 148 2 73 225 1 91 21 16 248 239 255 252 15 94 11 91 254 167 255 250 159 255 157 76 66 157 68 2 192 96 126 5 128 49 132 37 121 252 183 254 159 18 167 41 44 229 218 6 161 153 244 91 244 189 146 71 16 55 250 167 68 187 69 37 75 191 22 152 228 175 209 215 24 194 137 78 137 206 182 216 237 93 78 176 56 26 41 177 45 110 145 24 70 79 0 103 203 212 4 157 142 33 132 233 83 74 24 83 42 152 199 165 45 89 77 130 204 208 199 45 36 130 76 177 144 127 65 1 255 111 83 12 208 54 38 76 118 222 144 18 200 198 8 247 199 40 39 52 82 64 14 220 34 33 60 96 59 104 25 60 1 92 221 181 18 244 38 26 180 71 127 58 175 64 22 56 228 128 156 204 146 171 79 223 77 178 204 96 147 244 177 155 128 46 249 239 192 253 110 2 177 116 134 96 150 240 9 20 41 91 72 12 153 66 57 34 136 61 228 128 100 240 99 136 128 6 75 0 102 240 166 8 154 114 235 82 34 128 3 100 143 65 249 112 235 96 186 218 63 187 227 167 93 186 19 174 103 226 125 59 213 248 204 164 231 100 175 100 170 161 50 174 19 132 227 55 11 189 42 8 158 0 48 120 223 35 208 29 100 3 153 98 41 16 84 134 193 121 63 197 224 192 239 19 226 34 191 104 138 241 245 136 105 146 9 0 19 159 227 115 107 164 71 119 38 163 154 35 146 96 137 32 88 2 48 119 252 61 130 219 76 6 85 123 32 71 84 115 153 58 137 68 0 126 124 201 148 67 124 248 149 176 63 64 216 183 178 169 111 104 171 122 107 205 182 40 91 72 4 9 90 208 126 176 241 229 19 152 121 166 223 193 71 10 9 222 79 159 216 60 108 247 176 101 34 240 122 52 240 190 64 102 48 229 8 102 235 209 153 91 154 38 77 19 101 172 160 192 144 119 37 94 80 151 193 121 130 93 78 65 63 156 223 117 32 134 55 240 145 26 193 198 191 220 58 1 96 226 179 79 59 200 214 191 55 147 244 192 107 159 34 9 124 115 141 206 43 1 96 208 188 67 195 57 36 114 13 224 198 118 188 75 254 114 203 24 192 240 11 218 231 32 117 41 25 140 248 94 195 235 46 112 222 48 226 121 133 99 250 77 33 190 229 38 201 213 76 252 12 193 39 190 29 152 137 253 1 113 50 17 244 30 7 63 187 118 208 115 224 86 205 30 177 83 66 170 45 247 219 74 140 202 115 217 224 56 130 184 150 189 171 97 8 59 48 252 10 63 169 131 47 242 218 98 226 63 56 216 182 154 24 159 31 16 27 217 228 144 77 171 193 132 42 87 56 241 43 250 91 236 20 232 63 147 64 175 85 96 239 21 0 6 6 159 31 115 8 27 237 91 74 24 28 32 5 37 196 157 11 241 240 142 149 156 73 140 125 155 114 130 82 28 34 6 155 198 174 117 60 38 127 142 152 63 92 251 27 226 216 92 235 61 124 167 142 254 51 196 250 217 209 214 218 12 3 159 99 128 113 110 173 141 150 169 200 49 189 69 18 184 183 237 94 175 4 96 6 68 1 231 27 219 6 140 94 142 45 7 174 117 96 61 253 63 169 35 198 215 56 72 33 28 12 49 164 169 112 233 252 107 83 229 144 231 231 48 249 207 251 143 120 63 226 120 127 126 206 114 127 240 4 128 201 255 9 177 236 32 145 101 76 107 80 227 74 224 206 166 163 214 9 192 113 242 231 8 130 131 224 193 38 152 208 58 136 249 13 124 114 112 108 107 124 199 183 136 11 49 113 192 102 53 241 116 157 98 2 253 208 165 52 84 61 226 126 15 223 121 79 255 5 98 126 219 211 198 90 29 147 255 119 40 215 93 91 107 31 14 138 39 216 28 141 93 97 97 31 65 103 3 169 182 22 38 65 84 172 146 64 159 4 208 7 54 1 77 233 35 182 87 136 39 131 164 16 150 155 76 38 76 162 119 104 251 240 24 65 191 127 6 157 72 182 161 32 254 175 208 77 109 245 161 119 68 2 248 107 15 253 94 170 230 238 159 245 50 234 167 92 64 157 82 82 250 44 173 161 95 91 16 243 107 84 48 33 36 70 98 108 135 42 155 174 119 2 86 9 0 23 254 11 34 220 89 70 153 83 23 23 190 247 27 73 75 255 206 106 232 199 27 24 239 77 124 247 206 142 28 12 209 54 147 208 17 18 245 52 63 65 127 3 158 15 61 237 6 81 71 63 254 128 227 196 214 57 226 182 26 99 182 254 206 245 48 153 94 226 184 132 244 101 122 238 230 124 255 128 131 130 210 53 113 206 141 124 246 77 66 216 194 71 10 137 33 33 203 227 216 65 95 26 199 78 231 197 193 5 239 115 215 74 113 193 239 66 246 96 41 190 250 78 156 179 126 103 96 250 249 236 248 166 187 232 71 223 73 23 33 254 193 110 6 158 171 0 78 16 78 122 126 215 254 219 77 193 162 113 244 133 115 109 7 73 32 161 202 17 125 107 92 133 181 38 128 158 23 91 147 191 225 146 129 227 123 84 229 13 213 109 167 75 76 158 95 218 20 110 81 135 254 244 185 41 36 232 195 253 80 113 58 174 2 56 233 243 41 76 250 58 46 232 83 181 82 221 212 213 59 156 203 208 215 218 155 200 95 58 156 101 168 143 58 116 88 173 201 223 0 201 36 209 125 67 117 215 105 87 187 46 191 94 245 152 208 188 91 22 150 78 98 75 61 39 53 12 108 174 46 108 56 149 208 219 65 34 216 252 109 170 147 31 241 253 132 216 238 33 188 107 51 222 16 37 67 82 121 93 231 168 49 1 96 224 210 192 38 128 28 3 226 174 206 185 206 61 18 120 28 116 142 44 114 71 187 49 204 82 203 70 98 75 61 31 181 61 140 79 13 14 10 156 223 98 66 253 2 249 13 194 132 49 139 194 120 17 232 6 82 6 8 152 140 158 149 198 4 0 205 90 131 43 15 37 142 119 87 231 116 104 8 152 187 191 43 159 3 18 235 100 7 43 98 123 64 55 115 139 139 29 91 232 120 169 152 73 157 95 57 41 112 156 160 238 45 228 219 85 221 108 14 17 251 119 4 187 129 28 61 131 78 204 59 134 11 55 181 9 0 3 151 111 172 147 11 205 250 3 46 253 39 59 72 235 67 30 245 108 138 214 34 199 22 15 142 118 99 154 101 22 141 197 22 58 33 84 246 198 73 129 109 53 241 7 123 247 16 34 96 91 31 38 193 37 208 247 77 2 21 163 167 166 107 19 0 106 179 39 141 230 29 222 161 22 1 184 185 139 222 53 59 15 15 133 135 237 40 166 102 21 112 232 104 108 211 81 31 164 26 147 132 43 146 24 91 222 241 23 55 46 3 37 129 216 188 96 124 98 222 148 0 182 79 26 205 59 89 115 149 106 204 59 148 216 145 196 201 76 46 71 243 81 205 246 29 173 69 29 245 193 170 77 18 8 230 111 106 142 76 18 72 17 215 201 35 182 221 185 237 179 4 128 129 203 143 120 186 46 90 129 1 202 103 19 149 102 2 105 115 85 103 205 177 83 99 34 10 102 21 88 182 133 99 146 97 155 138 234 44 9 32 9 112 222 101 150 234 117 106 91 172 2 94 86 21 207 18 0 42 182 85 101 203 54 111 169 83 213 159 4 108 56 54 177 58 53 85 76 244 252 190 35 174 168 163 94 213 61 8 32 9 252 6 245 99 15 147 107 213 109 117 162 46 1 36 85 101 203 246 208 82 183 250 42 243 18 53 246 0 225 115 113 61 154 117 54 237 26 15 27 103 207 50 108 34 176 107 170 176 56 191 173 116 46 18 128 229 192 229 242 95 111 254 43 130 245 219 164 254 244 50 207 154 247 21 199 150 222 69 45 117 170 114 32 128 85 0 95 116 182 49 111 243 90 159 0 96 177 105 179 50 117 174 141 90 184 94 140 138 13 199 197 116 214 116 36 111 233 208 26 121 180 224 8 86 181 119 245 84 125 26 112 177 2 128 51 155 11 117 116 109 116 69 118 54 28 219 112 68 109 149 19 173 59 180 196 53 199 254 180 116 103 50 85 109 204 187 130 220 80 225 58 1 196 93 86 168 47 45 116 214 174 18 123 2 120 188 56 158 62 70 53 239 120 12 72 70 13 102 37 141 153 143 5 143 142 221 141 105 231 146 0 28 219 91 149 89 236 217 219 200 211 254 86 230 69 67 195 77 231 27 212 117 186 7 1 87 182 143 55 153 159 123 52 84 169 186 102 156 202 94 219 110 2 143 23 167 91 109 114 26 185 137 168 196 150 227 164 52 43 3 115 90 155 1 8 184 206 199 152 177 184 36 128 8 118 250 20 128 244 106 74 168 47 189 208 15 38 15 191 244 49 155 98 226 253 117 54 1 47 35 208 210 177 27 49 237 174 31 1 108 124 61 26 218 40 174 84 135 9 50 68 73 66 56 145 143 197 19 40 125 122 232 146 0 124 218 147 173 61 129 212 94 85 154 107 37 128 23 129 252 17 148 115 113 73 0 161 238 112 206 65 175 196 112 99 190 152 181 146 238 170 155 183 32 112 157 0 78 22 65 108 44 116 86 171 130 231 224 144 63 69 205 86 11 82 29 31 133 192 117 2 56 90 180 170 4 96 1 41 144 74 170 85 64 32 146 114 83 75 224 58 1 148 181 90 151 39 147 203 67 29 213 16 176 89 73 213 152 213 158 218 215 158 213 73 17 0 129 234 43 189 174 48 92 18 64 20 234 163 46 215 160 103 96 103 179 146 178 237 198 22 188 249 55 26 84 68 32 56 129 139 4 208 227 249 53 13 30 201 178 28 134 76 0 36 147 35 9 60 253 17 135 101 161 82 111 60 9 108 28 237 11 218 93 36 0 227 232 177 194 236 55 109 248 108 170 1 217 68 199 253 103 154 77 30 35 84 20 98 222 132 103 213 231 99 159 222 215 37 128 131 133 67 14 200 173 133 222 90 85 138 1 58 190 129 207 124 0 191 114 57 111 2 137 99 248 5 237 92 19 0 109 247 186 35 17 195 243 130 71 41 126 57 163 124 94 227 125 134 239 3 190 122 123 145 131 69 16 48 127 219 143 55 6 151 82 210 232 89 2 48 131 247 96 225 49 130 78 102 161 183 86 21 27 134 46 108 248 248 245 79 37 95 23 116 139 179 73 60 122 84 208 246 89 2 48 14 247 102 219 181 217 97 32 242 63 50 84 121 78 32 127 126 42 216 153 13 60 241 157 192 235 96 30 229 104 142 4 182 142 65 151 213 87 136 107 19 128 249 52 224 104 233 252 128 129 200 255 73 72 229 140 0 24 242 151 124 182 12 207 44 173 119 171 36 160 143 8 173 145 45 71 209 44 255 93 19 64 81 145 168 77 0 166 114 87 41 117 108 35 212 51 9 232 83 129 231 160 246 207 79 5 61 83 177 255 34 254 65 185 206 193 217 22 65 242 250 187 148 67 101 212 152 0 204 42 224 73 177 50 104 216 110 112 94 31 83 93 193 1 195 59 156 42 175 78 15 113 184 131 211 35 146 128 30 199 134 160 59 77 159 153 99 88 39 216 21 149 109 99 2 48 10 28 88 52 176 41 27 40 233 185 244 57 169 236 249 169 65 206 196 240 74 254 90 13 12 130 119 58 78 205 215 127 121 189 93 202 193 252 45 193 71 219 214 4 128 59 24 63 206 98 18 176 45 85 18 208 115 169 33 102 86 1 133 45 192 0 122 188 94 37 18 193 251 0 190 228 98 154 4 246 30 97 229 231 182 173 9 128 138 102 0 95 24 157 59 168 217 143 112 142 239 4 190 212 212 173 245 20 39 229 152 133 215 32 199 53 224 199 133 122 44 24 147 252 192 109 225 238 207 196 190 113 108 230 136 187 255 197 207 213 95 216 58 194 64 250 3 186 137 173 190 209 59 98 187 67 18 185 104 180 167 143 69 168 131 223 39 116 36 187 81 103 14 104 151 215 129 43 58 149 153 18 48 111 254 75 132 207 4 239 82 82 36 128 187 115 195 62 9 128 111 249 11 136 75 246 201 97 199 1 184 234 63 38 202 59 178 35 63 152 5 41 57 188 100 74 4 65 88 142 238 4 9 128 171 234 157 99 195 252 236 255 151 107 91 235 4 64 67 12 96 159 36 112 130 139 61 101 173 137 192 240 43 193 32 130 220 178 228 104 124 245 9 249 150 23 160 111 219 152 252 239 96 115 232 107 119 166 191 69 2 248 118 118 252 184 219 43 1 208 194 51 9 208 5 19 65 6 201 215 152 8 192 239 53 250 94 64 110 157 4 120 29 246 148 53 94 7 244 123 54 5 147 255 21 130 61 66 92 199 76 129 201 255 182 174 195 189 19 64 229 4 3 249 43 246 211 234 216 97 187 218 1 8 118 239 193 43 119 96 54 132 201 106 175 195 16 48 67 251 52 207 253 5 252 110 60 124 199 72 0 15 117 246 206 9 128 206 48 144 63 98 179 175 115 220 227 28 7 224 1 178 170 103 211 137 37 1 94 46 94 7 94 75 173 8 72 99 34 5 9 224 119 132 178 245 8 39 195 228 255 220 100 239 149 0 232 20 3 153 75 90 78 224 24 226 91 10 56 224 0 124 246 172 226 235 120 138 246 19 76 2 196 196 68 192 247 3 119 83 100 182 166 152 48 249 125 87 217 252 216 239 175 109 204 188 19 0 157 99 32 191 196 38 131 236 32 33 74 9 39 57 5 3 241 1 219 197 22 176 123 135 206 229 144 104 98 157 44 17 15 19 193 42 146 241 196 216 243 143 125 250 78 126 38 242 77 211 210 191 234 111 144 4 80 57 195 96 126 131 253 28 18 67 66 149 3 28 113 85 112 31 202 225 212 252 128 27 87 81 5 100 106 73 128 168 24 87 186 244 68 204 142 78 165 4 152 252 236 74 237 91 255 235 62 6 77 0 149 115 12 232 79 216 223 65 66 14 232 35 252 49 17 220 85 237 44 105 11 102 92 69 21 144 205 68 251 149 33 46 242 255 49 209 248 102 31 22 38 62 199 192 30 146 122 118 102 135 59 255 111 54 62 6 73 0 108 216 12 232 12 187 59 30 7 44 37 124 241 133 225 82 19 193 23 244 47 52 179 80 248 201 94 143 5 161 104 158 249 49 147 191 192 41 223 27 64 142 201 255 225 204 117 235 238 96 9 160 106 21 137 224 21 246 51 72 10 9 89 74 56 91 100 34 0 179 119 232 91 14 137 32 83 44 7 4 197 199 2 173 6 2 92 29 76 254 215 112 83 64 124 175 119 175 201 207 208 7 79 0 108 132 197 36 130 20 187 59 136 111 71 225 226 169 148 216 91 220 93 201 172 160 114 244 109 11 153 98 41 17 20 147 192 253 20 131 155 75 76 152 252 124 92 206 2 196 219 123 242 179 205 209 18 64 213 65 51 176 57 168 51 72 12 9 85 10 56 98 34 248 30 202 225 20 252 204 96 53 192 85 216 231 41 176 154 83 12 152 248 92 25 231 144 4 226 91 156 38 63 27 29 61 1 156 247 20 131 251 13 142 83 35 231 85 62 251 123 24 115 80 46 102 121 106 146 102 134 126 237 124 192 12 104 91 192 247 118 73 204 7 100 197 143 248 62 194 127 6 137 2 180 227 60 249 217 246 77 19 64 213 249 179 85 1 7 248 166 58 239 177 45 97 187 184 229 169 73 152 25 250 150 64 166 86 74 4 196 36 176 168 21 88 72 200 230 89 127 15 159 73 32 191 214 111 251 155 218 155 68 2 56 15 14 131 156 75 35 38 130 20 18 65 124 202 30 3 242 87 31 7 83 180 5 163 247 136 43 131 196 144 41 149 19 130 73 148 4 46 47 137 89 238 103 56 155 94 214 56 31 145 115 138 183 253 223 156 61 24 195 201 37 128 170 67 103 171 130 12 231 226 234 188 195 246 8 27 14 202 197 60 18 144 129 225 179 195 46 37 226 185 137 148 19 226 224 187 152 187 137 196 115 179 48 48 241 95 146 133 145 80 215 232 8 127 252 146 207 67 136 142 77 54 1 156 119 14 131 157 31 139 17 100 114 126 190 199 254 137 182 75 188 51 153 68 176 71 255 210 30 60 198 80 229 35 216 42 147 192 64 19 159 215 108 143 137 31 116 69 59 139 4 80 141 86 12 118 190 52 204 33 49 164 111 97 18 224 160 244 94 54 245 109 120 12 125 176 225 163 83 6 73 33 83 40 139 77 186 77 112 7 88 234 87 77 149 216 225 146 255 190 58 17 106 59 171 4 80 117 26 131 157 207 192 188 235 69 213 185 30 219 69 223 153 192 134 95 42 33 155 164 7 147 161 84 87 145 4 48 241 57 30 83 72 2 9 93 50 56 228 157 127 144 71 216 89 38 0 18 198 64 231 243 85 6 217 65 250 22 190 173 94 228 74 160 2 1 62 92 45 49 17 108 170 115 55 218 30 209 46 31 191 6 25 192 55 234 19 63 202 99 162 77 141 68 3 196 81 192 39 223 242 127 31 192 247 147 203 217 38 128 170 7 102 160 231 56 142 171 115 22 219 19 116 56 40 7 133 107 17 199 224 42 224 195 187 83 6 137 33 183 42 7 176 254 219 173 26 15 213 238 217 164 223 194 103 28 202 239 149 159 18 199 156 248 223 174 206 15 114 56 251 4 64 42 102 53 144 99 151 23 198 182 48 9 196 75 187 51 213 117 222 240 217 161 46 171 171 31 233 220 236 86 93 152 240 92 101 38 16 142 43 110 99 200 80 165 132 227 12 19 255 110 168 6 234 252 46 34 1 84 29 195 64 255 68 136 213 177 197 182 64 2 120 107 161 183 8 21 240 121 133 142 236 33 28 208 99 151 19 26 156 116 194 197 132 39 159 13 36 49 194 253 161 75 137 6 70 159 248 85 167 22 149 0 216 41 12 114 46 121 115 238 91 22 126 102 253 155 165 238 34 212 192 232 29 58 178 135 196 35 119 40 7 235 15 35 183 89 219 156 89 206 179 255 213 132 231 62 101 172 114 64 67 124 185 119 63 86 131 117 237 188 168 59 57 247 115 61 147 192 9 253 157 244 157 105 136 235 1 70 62 47 81 125 66 34 235 7 31 7 77 182 230 14 30 163 158 147 58 186 210 171 206 85 219 171 234 81 14 75 180 146 83 48 241 7 97 0 223 189 202 34 19 0 9 96 128 127 196 102 111 73 99 50 119 38 203 120 131 169 129 211 27 56 59 64 162 96 78 219 29 13 198 26 9 224 19 154 206 218 155 31 189 246 132 22 201 151 147 254 126 244 214 59 26 92 108 2 96 191 49 184 191 98 147 114 223 162 12 118 103 178 104 251 166 42 102 53 192 65 154 140 20 200 32 172 145 0 126 71 252 219 145 250 208 214 76 137 74 242 44 48 233 71 121 155 223 22 76 91 221 95 218 42 23 80 183 67 31 74 203 126 100 150 122 139 83 195 146 252 7 228 45 58 54 22 131 116 32 136 209 64 126 251 186 61 194 224 49 1 244 53 28 91 127 209 43 0 194 52 75 220 194 18 108 196 201 96 169 187 72 53 240 234 251 18 213 133 67 9 206 191 184 24 182 217 96 5 240 47 212 79 37 9 84 161 150 216 41 42 153 202 179 63 226 121 44 75 95 1 252 132 129 118 143 158 230 127 118 183 243 223 109 167 198 194 21 192 235 14 93 220 64 78 3 118 53 70 162 121 61 128 255 169 77 126 118 49 134 164 144 28 82 34 73 253 147 239 42 32 67 244 31 77 244 43 139 79 0 6 71 102 137 101 245 9 128 156 144 4 190 99 147 64 134 76 2 65 89 99 66 241 101 230 28 202 6 65 102 144 163 73 6 31 177 125 121 171 192 87 145 0 48 160 31 0 56 183 128 188 53 47 196 44 84 151 173 114 150 4 134 234 104 50 148 227 25 249 101 50 216 67 78 72 2 95 33 163 175 10 86 145 0 204 128 56 88 14 140 196 82 111 241 106 38 9 164 3 117 52 9 236 55 180 191 192 225 117 186 75 161 193 85 193 31 144 209 86 51 171 73 0 24 204 252 56 230 212 121 25 254 124 254 181 80 91 135 10 184 241 157 0 239 82 193 75 224 247 0 81 240 0 111 227 48 65 179 5 146 192 239 144 87 67 135 176 154 4 96 64 218 172 2 120 1 84 46 9 100 56 44 47 79 5 57 138 131 120 249 211 201 38 160 175 41 184 218 34 8 190 52 228 11 195 193 222 17 252 60 133 158 142 24 67 129 182 210 142 246 226 142 250 213 85 99 21 240 3 119 235 20 29 47 2 119 158 147 54 212 23 101 98 19 219 9 219 163 217 63 223 20 231 7 61 247 25 103 100 132 251 99 150 12 141 165 72 2 233 16 223 36 92 91 2 168 27 24 215 23 51 190 62 161 227 199 79 6 238 145 4 10 176 72 32 147 43 152 28 191 140 21 148 89 154 51 17 80 18 179 141 176 29 170 196 112 204 199 130 12 253 252 28 178 145 23 33 157 205 193 23 6 241 191 45 226 244 250 170 42 218 224 146 109 11 225 23 94 238 45 218 155 133 10 250 197 151 83 69 192 96 247 224 243 107 64 127 55 115 133 201 201 55 248 188 230 148 205 128 129 20 108 3 137 224 71 136 54 214 182 2 32 179 35 164 235 2 197 208 121 128 88 23 76 142 119 80 78 140 84 254 15 56 94 76 2 96 50 67 63 109 248 161 219 86 165 226 100 165 60 101 37 76 200 239 136 143 242 217 172 16 182 216 223 65 98 72 200 146 192 25 87 3 124 36 96 123 94 101 109 47 1 9 235 228 69 172 198 24 147 226 43 78 31 32 188 224 155 51 149 237 217 254 82 118 247 75 233 200 80 253 192 196 124 128 252 6 249 5 109 36 144 2 18 178 112 140 49 9 112 213 225 85 214 152 0 188 128 53 24 151 13 231 249 91 4 174 12 150 84 138 37 117 102 232 190 32 9 220 67 222 162 157 4 82 64 66 149 8 142 188 147 128 18 64 152 203 81 182 184 89 212 42 0 143 1 15 232 235 177 165 191 125 170 66 249 233 211 230 77 116 175 18 65 168 126 71 232 140 87 18 88 99 2 40 6 24 1 101 139 207 37 126 189 56 212 0 62 181 112 91 100 149 73 4 127 69 231 178 64 29 100 18 200 241 56 240 210 197 223 26 19 64 226 2 170 195 166 108 169 231 5 218 182 212 207 177 170 156 99 208 83 138 25 137 224 51 226 217 64 142 1 226 162 159 131 139 159 53 38 0 23 78 173 54 102 89 220 166 147 182 85 206 176 46 196 160 101 183 67 249 153 33 194 159 126 66 18 224 91 252 4 226 52 121 175 58 157 96 21 240 233 234 92 231 161 18 64 61 34 151 129 89 214 187 122 60 155 224 101 224 171 150 250 185 85 157 2 5 92 6 242 51 91 55 72 2 63 32 127 67 7 242 0 157 200 144 4 248 93 13 235 178 198 4 176 233 162 131 59 250 143 46 157 154 250 178 230 220 249 169 236 252 64 251 79 127 119 64 40 64 0 73 224 3 54 121 0 24 189 124 172 42 1 224 46 204 23 37 81 7 100 151 187 63 93 118 217 45 241 101 96 7 202 214 234 162 181 118 133 149 129 146 64 220 231 81 96 85 9 0 99 170 243 238 15 157 210 113 236 157 58 236 34 212 239 58 116 214 84 125 92 83 103 109 251 26 40 9 236 108 63 21 88 91 2 216 90 92 136 194 66 167 78 197 198 110 103 86 33 117 246 107 59 119 88 91 135 123 244 151 55 10 159 4 25 193 158 62 58 203 218 18 64 210 73 196 253 219 90 39 11 223 214 23 198 194 215 45 85 18 207 198 79 252 93 129 167 143 197 154 99 21 192 119 80 41 196 102 76 53 113 176 90 5 172 38 1 152 183 240 155 38 90 230 60 7 38 63 154 233 93 122 216 45 97 21 192 68 230 83 14 62 198 107 176 69 18 224 56 204 60 250 202 107 180 235 178 95 77 2 176 129 1 29 223 129 121 236 2 142 122 94 152 189 133 222 148 85 54 158 193 229 158 246 171 48 71 18 248 13 29 45 61 58 155 118 217 174 34 1 152 231 238 78 24 128 117 232 2 214 81 127 234 168 175 170 83 196 212 235 243 218 202 112 34 219 196 35 142 163 150 255 189 232 165 189 180 47 149 249 137 64 235 56 91 69 2 0 147 29 36 186 100 243 236 136 127 188 227 219 179 179 253 78 20 61 212 247 61 116 39 163 138 196 229 251 19 212 89 246 251 86 23 0 171 0 190 43 41 60 218 223 182 217 46 62 1 152 103 255 93 27 4 83 151 91 232 116 169 148 93 10 103 245 27 196 246 233 236 120 46 187 169 71 160 76 178 119 30 246 107 53 245 73 154 235 78 0 24 49 57 36 234 24 57 39 212 251 64 174 220 151 213 142 229 54 11 112 71 181 108 42 152 90 235 128 234 104 101 215 81 175 234 26 2 88 5 112 101 90 214 84 217 156 226 99 192 171 38 197 69 175 0 48 185 62 162 227 73 83 231 207 206 243 111 211 253 56 59 118 218 117 124 182 61 32 78 167 159 114 58 5 233 97 132 56 223 193 60 118 116 81 4 120 196 114 108 122 17 102 7 143 94 36 77 182 139 77 0 230 206 106 115 87 63 1 142 141 94 19 195 235 243 229 245 137 142 227 24 245 62 23 183 195 125 208 234 157 135 183 212 195 86 166 126 191 19 72 154 0 46 50 1 152 201 95 52 117 250 234 252 46 196 221 255 204 103 121 182 111 187 203 95 11 126 181 85 190 133 158 185 251 39 142 109 147 241 131 163 173 204 64 192 124 47 128 55 43 151 18 55 25 61 37 0 92 224 151 144 127 66 90 63 54 104 114 52 149 243 136 159 111 169 11 72 100 17 19 151 165 161 95 74 177 109 151 194 143 6 39 153 4 16 23 31 81 246 46 157 130 13 25 243 243 108 21 127 2 133 163 139 164 201 238 41 1 64 129 203 187 13 164 224 64 132 52 190 56 104 114 118 235 243 136 153 207 168 5 196 102 242 159 160 151 66 66 151 163 135 195 169 38 129 61 250 20 59 244 171 132 205 214 193 78 38 245 4 138 250 211 238 103 175 19 64 229 41 197 206 17 19 234 19 132 217 127 242 5 113 126 65 144 7 72 100 25 236 118 160 101 105 105 217 126 147 218 164 146 0 184 126 68 160 105 83 176 45 231 79 168 35 99 239 151 171 45 109 172 173 234 232 218 225 166 47 4 189 160 67 92 228 247 216 228 220 175 41 188 144 123 202 20 47 38 98 231 35 75 14 137 33 182 37 69 95 66 47 253 159 218 70 76 255 126 58 112 223 57 192 148 113 222 108 2 117 140 139 182 158 113 204 36 136 253 123 155 146 234 250 17 48 63 241 37 91 151 146 152 47 21 93 216 86 43 128 236 226 236 229 65 132 67 214 159 48 32 248 104 192 9 119 243 130 56 94 67 254 64 32 5 36 134 216 150 124 200 201 111 130 40 108 131 105 209 219 162 142 171 176 155 240 70 187 159 208 126 222 18 95 83 149 38 127 19 25 207 243 152 192 193 111 6 63 227 66 191 71 92 177 101 108 41 244 184 68 45 177 61 64 56 153 70 205 242 104 155 207 249 59 72 2 233 91 184 138 249 181 175 145 131 254 17 54 137 131 221 181 73 140 19 5 250 188 199 54 67 236 193 7 192 117 131 104 139 143 124 57 100 123 93 103 113 124 130 142 238 252 22 160 60 84 74 216 198 30 246 23 166 252 191 1 211 139 51 118 7 49 212 118 20 147 12 10 236 31 32 71 12 210 7 108 131 21 51 32 19 56 228 128 164 68 16 151 146 34 182 59 23 67 7 155 2 54 59 7 187 38 19 250 98 226 221 13 217 7 248 231 243 126 6 113 97 124 100 140 136 111 212 27 2 218 92 91 41 209 225 56 84 167 153 0 124 157 209 62 53 194 247 9 37 246 57 24 42 57 113 31 3 163 243 238 5 219 87 208 141 33 27 179 77 204 62 54 206 133 237 115 96 126 115 246 208 223 144 125 15 93 34 56 204 193 104 143 45 37 71 159 30 124 27 129 63 222 241 83 200 14 18 67 92 202 1 70 100 220 121 141 93 156 203 102 56 2 47 204 0 200 208 4 7 192 24 229 132 70 142 103 13 37 103 251 161 119 11 56 228 192 244 158 40 125 3 3 215 255 131 77 220 215 174 167 62 57 30 32 5 250 120 111 107 139 216 222 64 119 3 73 32 91 136 79 225 170 228 55 31 7 178 181 39 128 23 129 127 64 59 177 183 120 210 172 125 9 248 162 170 198 160 120 141 253 61 36 169 206 205 120 123 66 236 217 45 7 38 120 126 65 12 187 145 25 150 104 143 194 254 31 33 85 217 96 39 50 194 253 16 165 128 19 78 254 239 33 156 201 135 29 129 193 18 64 213 188 185 59 236 112 188 173 206 205 108 155 35 94 14 204 155 47 71 193 242 29 99 129 36 144 165 148 19 58 66 190 119 75 233 208 156 250 49 120 2 168 96 96 240 242 121 156 131 55 133 68 144 169 151 28 1 242 174 255 48 181 64 77 82 77 17 23 101 174 133 19 127 79 153 66 114 157 43 68 223 184 145 0 254 5 31 46 243 113 99 126 79 112 17 194 211 35 192 197 217 171 3 115 39 219 226 52 197 165 241 43 143 193 14 75 120 202 41 83 156 248 136 235 162 152 164 154 226 36 37 134 204 161 148 8 114 15 33 227 155 175 170 230 0 108 200 24 145 0 254 237 226 31 147 191 118 174 215 158 108 107 192 220 205 152 8 18 200 166 77 119 160 186 18 126 15 16 14 200 217 62 127 130 35 223 185 164 16 178 140 33 83 43 21 227 111 83 11 108 173 241 96 242 115 85 94 186 244 63 88 2 56 111 28 131 248 37 142 153 4 18 179 229 126 12 9 89 142 112 70 41 40 115 184 211 35 206 94 197 36 131 45 140 18 35 189 236 3 41 159 224 167 128 28 40 186 219 131 194 196 10 18 192 27 132 84 56 132 85 32 1 188 173 179 235 189 2 168 115 114 125 206 172 18 120 58 49 117 49 182 148 182 194 73 206 65 200 82 64 78 115 190 195 179 19 174 197 240 75 96 191 49 18 99 27 186 148 112 72 230 20 38 214 123 108 85 38 76 0 9 224 35 194 219 59 132 152 35 1 124 168 179 27 36 1 212 53 164 115 126 4 76 82 136 224 101 99 60 113 203 99 155 82 24 165 18 219 82 147 221 208 152 217 6 9 224 43 66 78 29 194 206 144 0 62 215 217 41 1 212 81 209 57 17 152 32 1 36 128 255 67 88 177 67 104 181 95 2 162 31 37 0 7 154 50 17 129 177 9 96 242 7 127 1 200 62 252 101 236 142 168 61 17 16 1 39 2 91 39 171 203 111 132 62 115 161 4 240 12 137 78 136 192 36 9 164 142 81 29 218 236 148 0 218 232 168 78 4 38 64 192 44 255 249 210 215 165 40 1 184 80 147 141 8 76 136 64 234 24 75 137 183 255 173 95 150 211 10 192 145 172 204 68 96 68 2 59 199 182 90 239 254 244 169 4 224 72 86 102 34 48 6 1 44 255 223 163 157 200 177 173 188 203 78 9 160 139 144 234 69 224 182 4 50 199 230 143 93 203 127 250 85 2 112 164 43 51 17 24 154 0 238 254 159 208 70 236 216 206 222 198 78 9 192 134 146 116 68 96 100 2 152 252 252 161 157 235 179 255 9 182 7 155 144 149 0 108 40 73 71 4 198 39 144 163 201 200 177 217 61 150 255 86 127 187 65 9 192 145 176 204 68 96 40 2 184 251 191 131 239 173 163 127 222 253 247 182 182 74 0 182 164 164 39 2 35 16 48 75 255 220 163 41 235 187 63 219 80 2 240 32 45 83 17 24 128 192 1 62 35 71 191 37 236 172 239 254 108 67 9 128 20 84 68 96 2 4 112 247 255 138 48 18 143 80 118 182 207 254 85 27 74 0 21 9 109 69 224 134 4 48 249 249 133 159 212 35 132 3 38 127 239 191 223 168 4 224 65 92 166 34 16 130 128 153 252 185 135 175 19 108 119 46 246 74 0 46 212 100 35 2 129 8 4 152 252 140 132 75 255 7 151 144 148 0 92 168 201 70 4 2 16 8 52 249 249 7 63 239 92 195 81 2 112 37 39 59 17 240 32 128 201 207 191 240 155 123 184 160 233 17 226 180 244 175 218 213 223 4 172 72 104 43 2 35 17 192 228 231 219 254 212 179 57 62 247 243 143 125 182 254 222 191 171 13 37 128 46 66 170 23 129 64 4 48 241 95 193 213 1 178 9 224 178 241 47 253 246 241 173 71 128 62 180 164 43 2 142 4 48 249 249 245 222 35 36 196 228 79 113 231 191 119 12 229 194 76 43 128 11 28 58 16 129 176 4 48 241 249 171 190 28 178 13 228 153 147 255 46 144 47 125 19 48 20 72 249 17 129 107 2 152 252 124 209 87 66 38 57 249 25 175 86 0 164 160 34 2 1 9 96 226 191 129 187 61 36 196 114 191 138 44 232 157 191 114 170 4 80 145 208 86 4 60 9 152 137 159 193 77 226 233 234 218 124 144 201 207 70 148 0 174 81 235 88 4 122 18 24 112 226 159 16 10 39 127 239 239 248 219 118 65 9 192 150 148 244 26 9 96 2 188 70 229 1 146 113 139 1 107 245 215 104 160 59 235 130 126 243 7 60 59 72 200 165 126 197 164 196 206 22 44 189 62 231 175 156 53 109 127 110 170 208 121 17 232 65 32 133 110 12 201 33 39 76 12 38 3 167 95 167 193 110 210 197 36 59 78 250 45 36 26 40 216 130 254 199 72 164 90 1 12 116 5 215 228 22 147 226 95 232 111 221 100 56 225 252 129 50 228 50 118 104 214 102 210 167 104 103 11 137 33 67 150 12 172 62 15 217 192 185 111 37 128 115 26 218 239 77 0 147 227 29 140 56 201 109 74 1 165 71 193 32 191 183 49 184 133 14 250 196 111 236 37 70 56 233 35 200 208 165 68 3 124 222 31 149 139 18 192 208 151 117 225 254 49 89 190 114 224 58 118 179 128 221 177 18 12 254 65 159 119 235 98 68 252 47 113 126 3 73 204 150 251 49 100 204 178 71 99 188 243 143 254 238 68 9 96 204 203 188 192 182 48 129 154 150 255 174 189 101 66 56 65 10 227 160 218 30 93 39 8 98 228 231 242 44 241 149 112 178 71 144 91 149 18 13 143 126 215 63 239 172 18 192 57 13 237 247 34 128 137 213 103 249 223 203 183 133 114 209 162 115 235 137 221 18 218 99 21 19 220 30 9 237 115 151 226 143 100 131 162 0 0 2 41 73 68 65 84 208 245 250 20 96 104 194 203 246 191 189 97 247 146 27 182 237 211 116 14 227 157 235 106 198 167 225 58 91 37 128 58 42 58 103 75 224 150 9 192 54 198 169 232 229 8 132 207 249 15 83 9 136 113 40 1 76 233 106 204 40 22 179 252 143 102 20 242 173 66 205 209 240 228 38 126 5 67 9 160 34 161 109 95 2 154 252 205 196 78 168 202 33 124 206 159 212 29 255 58 100 189 4 188 38 162 99 107 2 230 237 250 14 6 91 107 163 101 43 30 209 189 61 228 48 149 103 252 46 220 74 0 93 132 84 223 73 0 137 128 95 156 97 34 72 33 17 100 77 229 132 206 230 20 76 250 209 191 199 224 11 90 9 192 151 160 236 47 8 152 119 3 91 156 164 44 53 25 112 210 31 40 152 244 223 176 157 109 81 2 152 237 165 155 126 224 38 25 36 136 148 178 129 204 185 28 17 124 1 153 229 157 190 9 188 18 64 19 25 157 15 74 0 201 128 95 185 77 140 48 25 112 127 202 165 154 240 5 130 44 230 242 76 223 23 168 18 64 95 98 210 15 70 0 73 225 53 156 197 144 42 33 68 102 31 155 81 75 129 214 74 8 39 253 17 147 253 30 219 85 20 37 128 85 92 230 121 117 18 137 129 47 21 99 200 121 66 224 49 165 42 49 118 40 109 133 19 250 100 20 184 229 49 75 117 158 147 125 244 31 224 252 25 130 254 21 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 16 1 17 152 4 129 255 7 43 226 4 233 145 30 174 153 0 0 0 0 73 69 78 68 174 66 96 130 40 0 0 0 48 0 0 0 96 0 0 0 1 0 32 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 63 35 46 189 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 127 35 46 189 191 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 239 35 46 189 175 35 46 189 111 35 46 189 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 79 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 175 35 46 189 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 255 35 46 189 255 35 46 189 191 35 46 189 127 35 46 189 95 35 46 189 63 35 46 189 63 35 46 189 63 35 46 189 111 35 46 189 143 35 46 189 223 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 159 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 207 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 207 35 46 189 255 35 46 189 255 35 46 189 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 239 35 46 189 255 35 46 189 255 35 46 189 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 127 35 46 189 255 35 46 189 255 35 46 189 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 63 102 102 102 63 102 102 102 63 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 255 35 46 189 255 35 46 189 207 0 0 0 0 102 102 102 15 102 102 102 95 102 102 102 175 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 159 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 159 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 223 35 46 189 255 35 46 189 255 0 0 0 0 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 143 102 102 102 127 102 102 102 127 102 102 102 191 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 95 102 102 102 63 102 102 102 111 102 102 102 191 102 102 102 255 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 191 35 46 189 255 35 46 189 255 0 0 0 0 102 102 102 191 102 102 102 159 102 102 102 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 175 102 102 102 255 102 102 102 207 102 102 102 15 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 255 102 102 102 255 102 102 102 239 102 102 102 79 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 159 102 102 102 255 102 102 102 255 102 102 102 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 239 35 46 189 255 35 46 189 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 175 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 255 102 102 102 255 102 102 102 79 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 223 102 102 102 255 102 102 102 255 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 255 35 46 189 255 35 46 189 223 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 255 102 102 102 223 0 0 0 0 0 0 0 0 102 102 102 127 102 102 102 255 102 102 102 159 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 159 102 102 102 255 102 102 102 255 102 102 102 175 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 191 35 46 189 255 35 46 189 255 35 46 189 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 207 102 102 102 255 0 0 0 0 0 0 0 0 102 102 102 191 102 102 102 255 102 102 102 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 127 102 102 102 255 102 102 102 255 102 102 102 239 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 159 35 46 189 255 35 46 189 255 35 46 189 239 35 46 189 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 191 102 102 102 255 0 0 0 0 0 0 0 0 102 102 102 191 102 102 102 175 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 175 102 102 102 255 102 102 102 255 102 102 102 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 79 35 46 189 207 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 239 102 102 102 255 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 143 35 46 189 143 35 46 189 127 35 46 189 127 35 46 189 127 35 46 189 191 35 46 189 239 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 223 35 46 189 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 255 102 102 102 207 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 207 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 207 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 143 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 111 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 239 102 102 102 255 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 79 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 95 35 46 189 191 35 46 189 191 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 223 35 46 189 127 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 111 102 102 102 239 102 102 102 255 102 102 102 159 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 191 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 143 35 46 189 223 35 46 189 255 35 46 189 255 35 46 189 239 35 46 189 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 111 102 102 102 223 102 102 102 255 102 102 102 255 102 102 102 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 159 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 95 35 46 189 239 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 159 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 79 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 143 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 175 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 79 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 159 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 159 35 46 189 255 35 46 189 255 35 46 189 191 0 0 0 0 0 0 0 0 102 102 102 79 102 102 102 255 102 102 102 255 102 102 102 175 102 102 102 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 223 35 46 189 255 35 46 189 255 35 46 189 63 0 0 0 0 102 102 102 239 102 102 102 255 102 102 102 111 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 191 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 111 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 95 35 46 189 255 35 46 189 255 35 46 189 159 102 102 102 79 102 102 102 255 102 102 102 207 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 79 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 255 35 46 189 255 35 46 189 223 102 102 102 127 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 255 35 46 189 255 35 46 189 255 102 102 102 127 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 159 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 255 35 46 189 255 35 46 189 239 102 102 102 95 102 102 102 255 102 102 102 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 207 102 102 102 223 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 95 35 46 189 255 35 46 189 255 35 46 189 175 102 102 102 15 102 102 102 239 102 102 102 239 102 102 102 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 175 102 102 102 255 102 102 102 255 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 255 102 102 102 191 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 127 35 46 189 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 239 35 46 189 255 35 46 189 255 35 46 189 95 0 0 0 0 102 102 102 127 102 102 102 255 102 102 102 207 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 255 102 102 102 255 102 102 102 207 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 207 102 102 102 255 102 102 102 159 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 255 35 46 189 255 35 46 189 239 35 46 189 159 35 46 189 95 35 46 189 63 35 46 189 31 35 46 189 63 35 46 189 79 35 46 189 159 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 191 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 143 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 127 102 102 102 127 102 102 102 143 102 102 102 207 102 102 102 255 102 102 102 239 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 31 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 207 102 102 102 255 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 127 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 191 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 175 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 191 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 79 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 111 35 46 189 191 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 111 102 102 102 127 102 102 102 127 102 102 102 127 102 102 102 127 102 102 102 63 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 63 35 46 189 63 35 46 189 63 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 40 0 0 0 32 0 0 0 64 0 0 0 1 0 32 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 95 35 46 189 127 35 46 189 127 35 46 189 127 35 46 189 63 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 223 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 175 35 46 189 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 239 35 46 189 143 35 46 189 95 35 46 189 63 35 46 189 63 35 46 189 63 35 46 189 127 35 46 189 207 35 46 189 255 35 46 189 255 35 46 189 175 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 207 35 46 189 255 35 46 189 207 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 207 35 46 189 255 35 46 189 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 255 35 46 189 239 35 46 189 15 0 0 0 0 102 102 102 31 102 102 102 95 102 102 102 127 102 102 102 127 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 95 102 102 102 127 102 102 102 127 102 102 102 127 102 102 102 79 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 191 35 46 189 255 35 46 189 63 102 102 102 191 102 102 102 255 102 102 102 223 102 102 102 191 102 102 102 191 102 102 102 255 102 102 102 223 102 102 102 47 0 0 0 0 0 0 0 0 102 102 102 79 102 102 102 255 102 102 102 255 102 102 102 223 102 102 102 143 102 102 102 159 102 102 102 239 102 102 102 239 102 102 102 79 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 127 35 46 189 255 35 46 189 127 102 102 102 143 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 175 102 102 102 239 102 102 102 31 0 0 0 0 102 102 102 127 102 102 102 255 102 102 102 159 102 102 102 15 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 239 102 102 102 255 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 191 35 46 189 255 35 46 189 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 223 102 102 102 143 0 0 0 0 102 102 102 191 102 102 102 223 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 127 102 102 102 255 102 102 102 191 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 255 35 46 189 255 35 46 189 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 143 102 102 102 191 0 0 0 0 102 102 102 223 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 127 102 102 102 255 102 102 102 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 207 35 46 189 255 35 46 189 175 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 159 102 102 102 191 0 0 0 0 102 102 102 111 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 191 102 102 102 255 102 102 102 255 0 0 0 0 0 0 0 0 35 46 189 95 35 46 189 127 35 46 189 127 35 46 189 127 35 46 189 175 35 46 189 255 35 46 189 255 35 46 189 175 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 239 102 102 102 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 159 102 102 102 255 102 102 102 255 102 102 102 223 0 0 0 0 0 0 0 0 35 46 189 191 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 191 35 46 189 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 223 102 102 102 239 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 207 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 111 0 0 0 0 0 0 0 0 35 46 189 47 35 46 189 63 35 46 189 111 35 46 189 175 35 46 189 255 35 46 189 255 35 46 189 159 35 46 189 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 207 102 102 102 255 102 102 102 191 102 102 102 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 191 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 159 35 46 189 255 35 46 189 239 35 46 189 47 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 223 102 102 102 255 102 102 102 191 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 207 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 95 35 46 189 255 35 46 189 239 35 46 189 31 102 102 102 31 102 102 102 239 102 102 102 207 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 239 102 102 102 255 102 102 102 255 102 102 102 223 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 143 35 46 189 255 35 46 189 159 102 102 102 143 102 102 102 239 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 255 102 102 102 255 102 102 102 191 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 255 35 46 189 239 102 102 102 191 102 102 102 191 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 127 102 102 102 255 102 102 102 255 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 255 35 46 189 255 102 102 102 175 102 102 102 191 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 111 102 102 102 255 102 102 102 191 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 223 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 255 35 46 189 223 102 102 102 95 102 102 102 255 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 255 102 102 102 255 102 102 102 15 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 255 102 102 102 63 0 0 0 0 0 0 0 0 35 46 189 191 35 46 189 111 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 239 35 46 189 255 35 46 189 127 0 0 0 0 102 102 102 159 102 102 102 255 102 102 102 159 102 102 102 127 102 102 102 127 102 102 102 159 102 102 102 239 102 102 102 15 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 255 102 102 102 175 102 102 102 31 0 0 0 0 102 102 102 63 102 102 102 239 102 102 102 255 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 223 35 46 189 255 35 46 189 255 35 46 189 223 35 46 189 191 35 46 189 223 35 46 189 255 35 46 189 255 35 46 189 207 35 46 189 15 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 159 102 102 102 191 102 102 102 191 102 102 102 175 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 79 102 102 102 207 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 239 102 102 102 175 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 79 35 46 189 159 35 46 189 191 35 46 189 255 35 46 189 239 35 46 189 191 35 46 189 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 40 0 0 0 24 0 0 0 48 0 0 0 1 0 32 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 95 35 46 189 127 35 46 189 191 35 46 189 159 35 46 189 127 35 46 189 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 175 35 46 189 255 35 46 189 191 35 46 189 191 35 46 189 191 35 46 189 239 35 46 189 255 35 46 189 207 35 46 189 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 79 35 46 189 207 35 46 189 255 35 46 189 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 207 35 46 189 239 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 63 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 255 35 46 189 111 102 102 102 175 102 102 102 255 102 102 102 207 102 102 102 223 102 102 102 223 102 102 102 79 0 0 0 0 0 0 0 0 102 102 102 207 102 102 102 255 102 102 102 207 102 102 102 191 102 102 102 239 102 102 102 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 255 35 46 189 127 102 102 102 111 102 102 102 15 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 239 102 102 102 63 102 102 102 63 102 102 102 255 102 102 102 127 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 255 102 102 102 143 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 255 35 46 189 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 143 102 102 102 127 102 102 102 95 102 102 102 191 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 207 102 102 102 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 175 35 46 189 255 35 46 189 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 127 102 102 102 127 102 102 102 79 102 102 102 79 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 255 102 102 102 255 0 0 0 0 35 46 189 63 35 46 189 79 35 46 189 63 35 46 189 127 35 46 189 223 35 46 189 255 35 46 189 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 223 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 207 102 102 102 255 102 102 102 239 0 0 0 0 35 46 189 79 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 239 35 46 189 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 111 102 102 102 239 102 102 102 159 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 15 102 102 102 143 102 102 102 255 102 102 102 255 102 102 102 255 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 111 35 46 189 223 35 46 189 239 35 46 189 79 0 0 0 0 0 0 0 0 102 102 102 111 102 102 102 239 102 102 102 207 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 223 102 102 102 255 102 102 102 255 102 102 102 223 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 159 35 46 189 255 35 46 189 79 102 102 102 111 102 102 102 239 102 102 102 63 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 223 102 102 102 255 102 102 102 239 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 223 35 46 189 207 102 102 102 191 102 102 102 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 102 102 102 255 102 102 102 239 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 143 35 46 189 255 102 102 102 191 102 102 102 79 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 255 102 102 102 191 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 111 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 159 35 46 189 255 102 102 102 127 102 102 102 207 102 102 102 15 0 0 0 0 0 0 0 0 102 102 102 47 0 0 0 0 0 0 0 0 102 102 102 207 102 102 102 223 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 223 102 102 102 111 0 0 0 0 35 46 189 127 35 46 189 175 35 46 189 79 35 46 189 47 35 46 189 63 35 46 189 127 35 46 189 255 35 46 189 159 0 0 0 0 102 102 102 143 102 102 102 255 102 102 102 191 102 102 102 239 102 102 102 223 102 102 102 15 0 0 0 0 102 102 102 47 102 102 102 207 102 102 102 207 102 102 102 127 102 102 102 207 102 102 102 255 102 102 102 63 0 0 0 0 35 46 189 63 35 46 189 175 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 255 35 46 189 159 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 63 102 102 102 63 102 102 102 63 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 63 35 46 189 15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 40 0 0 0 16 0 0 0 32 0 0 0 1 0 32 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 159 35 46 189 191 35 46 189 191 35 46 189 175 35 46 189 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 111 35 46 189 63 35 46 189 63 35 46 189 95 35 46 189 223 35 46 189 191 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 15 35 46 189 207 35 46 189 127 102 102 102 143 102 102 102 191 102 102 102 191 102 102 102 79 0 0 0 0 102 102 102 111 102 102 102 191 102 102 102 159 102 102 102 159 102 102 102 31 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 95 35 46 189 191 102 102 102 95 0 0 0 0 102 102 102 15 102 102 102 175 102 102 102 63 102 102 102 223 102 102 102 79 0 0 0 0 102 102 102 111 102 102 102 223 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 143 35 46 189 175 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 127 102 102 102 143 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 255 0 0 0 0 35 46 189 63 35 46 189 63 35 46 189 143 35 46 189 239 35 46 189 63 0 0 0 0 0 0 0 0 102 102 102 31 102 102 102 207 102 102 102 63 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 239 102 102 102 239 0 0 0 0 35 46 189 191 35 46 189 223 35 46 189 239 35 46 189 95 0 0 0 0 102 102 102 15 102 102 102 159 102 102 102 223 102 102 102 79 0 0 0 0 102 102 102 15 102 102 102 207 102 102 102 255 102 102 102 223 102 102 102 47 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 239 35 46 189 95 102 102 102 191 102 102 102 111 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 175 102 102 102 255 102 102 102 111 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 63 35 46 189 239 102 102 102 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 102 102 102 191 102 102 102 143 0 0 0 0 0 0 0 0 102 102 102 127 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35 46 189 31 35 46 189 255 102 102 102 143 102 102 102 143 102 102 102 63 102 102 102 111 102 102 102 15 102 102 102 127 102 102 102 191 102 102 102 15 102 102 102 127 102 102 102 159 35 46 189 15 35 46 189 223 35 46 189 143 35 46 189 127 35 46 189 223 35 46 189 191 0 0 0 0 102 102 102 95 102 102 102 127 102 102 102 95 0 0 0 0 0 0 0 0 102 102 102 95 102 102 102 127 102 102 102 127 102 102 102 63 0 0 0 0 35 46 189 31 35 46 189 111 35 46 189 127 35 46 189 95 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0) asByteArray! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/15/2010 08:05'!
googleAnalyticsAccount

	^self propertyAt: #googleAnalyticsAccount ifAbsent: [ '' ]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/15/2010 08:05'!
googleAnalyticsAccount: aString

	self propertyAt: #googleAnalyticsAccount put: aString! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/15/2010 08:05'!
googleWebmasterAccount

	^self propertyAt: #googleWebmasterAccount ifAbsent: [ '' ]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/15/2010 08:05'!
googleWebmasterAccount: aString

	self propertyAt: #googleWebmasterAccount put: aString! !

!SSRepository methodsFor: 'accessing-groups' stamp: 'topa 05/07/2010 15:15'!
groupAt: aString
	^groups at: aString ifAbsent: [nil]! !

!SSRepository methodsFor: 'accessing-groups' stamp: 'topa 05/07/2010 15:15'!
groupAt: aString ifAbsent: aBlock
	^groups at: aString ifAbsent: aBlock! !

!SSRepository methodsFor: 'accessing-groups' stamp: 'dkh 05/18/2011 09:10'!
groups
	groups ifNil: [groups := GRPlatform current reducedConflictDictionary new].
	^groups values! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 23:31'!
hasTagNamed: aString
	^tags includesKey: aString asSymbol! !

!SSRepository methodsFor: 'initialization' stamp: 'dkh 05/18/2011 09:10'!
initialize

	super initialize.
	title := String new.
	members := GRPlatform current reducedConflictDictionary new.
	projects := GRPlatform current reducedConflictDictionary new.
	" rest is initialized lazily "! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/4/2010 10:44'!
introText
	^self propertyAt:  #introText
		ifAbsent: [String new]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 12/20/2010 08:29'!
introText: aString

	^ self propertyAt:  #introText
		put: (aString ifNil: [String new] ifNotNil: [aString])! !

!SSRepository methodsFor: 'testing' stamp: 'bf 5/24/2005 14:26'!
isUniqueGroupId: aString
	^self groups 
		allSatisfy: [ :each | each id ~= aString ]! !

!SSRepository methodsFor: 'testing' stamp: 'topa 10/21/2010 17:44'!
isUniqueMemberLogin: aString
	^self members 
		allSatisfy: [ :each | each login ~= aString ]! !

!SSRepository methodsFor: 'testing' stamp: 'topa 10/15/2010 16:00'!
isUniqueProjectId: aString
	self flag: #NeedsReview. "were do these come from?"
	^((#('files' 'home' 'projects'  'tags' 'members' 'groups' 'help' 'search') includes: aString) not)
		and: [ self projects  allSatisfy: [ :each | each id ~= aString ] ]! !

!SSRepository methodsFor: 'testing' stamp: 'topa 12/20/2010 08:37'!
isVisible: aProject to: aUser

	^ self allProjectsVisible
		or: [aProject isMember: aUser allowedTo: SSAccessPolicy read]! !

!SSRepository methodsFor: 'accessing' stamp: 'pmm 9/13/2007 06:53'!
logo
	^SSFileLibrary logoFileModel! !

!SSRepository methodsFor: 'accessing' stamp: 'pmm 9/13/2007 06:54'!
logo: aMAMemoryFileModel
	^SSFileLibrary logoFileModel: aMAMemoryFileModel! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'pmm 6/27/2010 17:55'!
maxActivity
	^(self visibleProjectsTo: SSMember anonymousMember)
		inject: 1.0
		into: [ :result :each | result max: each activity ]! !

!SSRepository methodsFor: 'accessing-members' stamp: 'lr 2/1/2004 18:40'!
memberAt: aString
	^self memberAt: aString ifAbsent: [ nil ]! !

!SSRepository methodsFor: 'accessing-members' stamp: 'dkh 05/23/2011 15:01'!
memberAt: aString ifAbsent: aBlock
	aString ifNil: [ ^aBlock value ].
	^members at: aString ifAbsent: aBlock! !

!SSRepository methodsFor: 'accessing-members' stamp: 'lr 2/1/2004 18:40'!
members
	^members values! !

!SSRepository methodsFor: 'accessing-members' stamp: 'al 3/1/2004 21:52'!
membersCount
	^members size! !

!SSRepository methodsFor: 'accessing-members' stamp: 'pmm 10/16/2006 12:44'!
membersDo: aBlock
	members valuesDo: aBlock! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'lr 2/1/2004 18:40'!
projectAt: aString
	^self projectAt: aString ifAbsent: [ nil ]! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'lr 2/1/2004 18:40'!
projectAt: aString ifAbsent: aBlock
	^projects at: aString ifAbsent: aBlock! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'lr 2/1/2004 18:40'!
projects
	^projects values! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/15/2010 08:02'!
projectsCanHaveParent

	^ self propertyAt: #projectsCanHaveParent ifAbsent: [false]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/13/2010 17:57'!
projectsCanHaveParent: aBoolean

	self propertyAt: #projectsCanHaveParent put: aBoolean! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'al 3/1/2004 21:52'!
projectsCount
	^projects size! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'pmm 1/26/2006 21:38'!
projectsDo: aBlock
	projects valuesDo: aBlock! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'pmm 10/16/2006 11:58'!
projectsSelect: aBlock
	^Array streamContents: [ :stream |
		self projectsDo: [ :each |
			(aBlock value: each) ifTrue: [
				stream nextPut: each ] ] ]! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'obi 9/4/2009 21:30'!
removeProject: aProject
	self membersDo: [:aUser | aUser removeFavorite: aProject ].
	projects removeKey: aProject id.! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:37'!
renameTag: aTag to: aString
	| oldName |
	oldName := aTag name.
	aTag name: aString.
	self projectsDo: [ :each |
		(each hasTagNamed: aString) ifTrue: [
			each reSortTags ] ].
	tags removeKey: oldName.	
	self addTag: aTag! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 6/21/2010 19:10'!
rootUrl

	| url |
	url := self application url asString.
	url last = $/ ifFalse: [url := url , '/'].
	^ (url beginsWith: 'http://')
		ifTrue: [url]
		ifFalse: ['http://', (self requestContext request headers at: 'host'), url]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/4/2010 10:44'!
rootUrl: aString
	^self propertyAt: #rootUrl
		put: aString! !

!SSRepository methodsFor: 'accessing-members' stamp: 'pmm 7/3/2007 21:36'!
sortedMembers
	^self members asSortedCollection! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 9/16/2007 21:42'!
styleColor
	^SSFileLibrary default styleColor! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 9/16/2007 21:42'!
styleColor: aColor
	^SSFileLibrary default styleColor: aColor! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 5/19/2011 20:48'!
superUserEmail

	^ self propertyAt: #superUserEmail
		ifAbsent: [Array streamContents: [:strm |
			self members do: [:ea |
				ea isSuperUser ifTrue: [
					strm nextPut: ea fullEmailAddress]]]]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 5/24/2011 16:42'!
superUserEmail: aStringWithCommas

	self propertyAt: #superUserEmail
		put: (Array streamContents: [:strm |
			(aStringWithCommas findTokens: ',') do: [:ea |
					strm nextPut: (WAEmailAddress address: ea withBlanksTrimmed) ]])! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:49'!
tagActiviy
	| activity |
	activity := Bag new.
	self projectsDo: [ :project |
		project tags do: [ :each |
			activity add: each ] ].
	^activity! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:50'!
tagAt: aString
	^tags at: aString! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'dkh 05/18/2011 09:11'!
tags

	tags ifNil: [
		tags := GRPlatform current reducedConflictDictionary new.
		SSTag defaultInstances do: [ :each |
			self addTag: each]].
	^tags asSortedCollection! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/4/2010 10:45'!
timezone
	^self propertyAt: #timezone
		ifAbsent: [ '+0100' ]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'topa 10/4/2010 10:45'!
timezone: aString
	self propertyAt: #timezone
		put: aString! !

!SSRepository methodsFor: 'accessing' stamp: 'lr 1/27/2004 11:09'!
title
	^title! !

!SSRepository methodsFor: 'accessing' stamp: 'lr 1/27/2004 11:13'!
title: aString
	title := aString! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'pmm 6/27/2010 17:49'!
visibleProjectsTo: aUser
	^Array streamContents: [ :stream |
		self visibleProjectsTo: aUser do: [ :each |
			stream nextPut: each ] ]! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'pmm 6/27/2010 17:42'!
visibleProjectsTo: aUser do: aBlock
	self allProjectsVisible ifTrue: [
		^self projectsDo: aBlock ].
	self projectsDo: [:each |
		(self isVisible: each to: aUser) ifTrue: [
			aBlock value: each ] ]! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'topa 12/20/2010 08:39'!
visibleProjectsTo: aMember select: aBlock

	^ Array streamContents: [:stream |
		self visibleProjectsTo: aMember do: [:each |
			(aBlock value: each) ifTrue: [
				stream nextPut: each ]]]! !

!SSModel class methodsFor: 'accessing-defaults' stamp: 'pmm 9/2/2007 13:03'!
defaultLengthAtLeast: anInteger
	^ SSSizeCondition atLeast: anInteger! !

!SSModel class methodsFor: 'accessing-defaults' stamp: 'pmm 9/2/2007 13:03'!
defaultLengthAtMost: anInteger
	^ SSSizeCondition atMost: anInteger! !

!SSModel class methodsFor: 'instance creation' stamp: 'topa 11/2/2010 10:46'!
new

	^ super new postInitialize! !

!SSModel class methodsFor: 'accessing' stamp: 'topa 1/4/2011 09:46'!
repository

	^ SSRepository current! !

!SSModel methodsFor: 'accessing' stamp: 'dkh 05/17/2011 16:43'!
configAdded: config
	"noop ... used for subscriptions"
	self flag: #NEEDSREVIEW "should be a better way"! !

!SSModel methodsFor: 'initialization' stamp: 'topa 5/24/2011 15:52'!
finalize

	self runFinalizationHooksIn: self class.
	super initialize.! !

!SSModel methodsFor: 'initialization' stamp: 'pmm 3/1/2006 21:51'!
initialize
	super initialize.
	timestamp := TimeStamp current.! !

!SSModel methodsFor: 'initialization' stamp: 'topa 11/2/2010 11:24'!
initializeStringsSatisfyBlocks
	
	<initialize>
	self stringsSatisfyBlocks: OrderedCollection new.! !

!SSModel methodsFor: 'initialization' stamp: 'topa 11/2/2010 11:21'!
postInitialize
	" run pluggable initialization hooks "
	
	self runInitializeHooksIn: self class.
	
	^ self! !

!SSModel methodsFor: 'accessing-properties' stamp: 'topa 11/2/2010 12:00'!
properties

	^ properties! !

!SSModel methodsFor: 'accessing-properties' stamp: 'bf 3/27/2010 13:43'!
propertyAt: aSymbol

	^self propertyAt: aSymbol ifAbsent: [nil]! !

!SSModel methodsFor: 'accessing-properties' stamp: 'topa 11/2/2010 12:00'!
propertyAt: aSymbol ifAbsent: aBlock

	^ self properties 
		ifNil: aBlock
		ifNotNilDo: [:props | props at: aSymbol ifAbsent: aBlock]! !

!SSModel methodsFor: 'accessing-properties' stamp: 'bf 3/27/2010 13:52'!
propertyAt: aSymbol ifAbsentPut: aBlock

	^(self propertyAt: aSymbol) ifNil: [
		self propertyAt: aSymbol put: aBlock value].! !

!SSModel methodsFor: 'accessing-properties' stamp: 'topa 11/2/2010 12:01'!
propertyAt: aSymbol put: aValue

	^aValue
		ifNil: [
			self properties ifNotNil: [
				self properties removeKey: aSymbol ifAbsent: [].
				self properties ifEmpty: [properties := nil]]]
		ifNotNil: [
			self properties ifNil: [properties := GRPlatform current reducedConflictDictionary new].
			self properties at: aSymbol put: aValue]! !

!SSModel methodsFor: 'accessing-properties' stamp: 'topa 11/2/2010 11:59'!
propertyIncludes: aSymbol

	^self properties includesKey: aSymbol! !

!SSModel methodsFor: 'accessing' stamp: 'topa 1/4/2011 09:46'!
repository

	^ self class repository! !

!SSModel methodsFor: 'initialization' stamp: 'topa 5/24/2011 15:53'!
runFinalizationHooksIn: aClass

	(Pragma allNamed: #finalize in: aClass) do: [:pragma| 
		self perform: pragma selector].

	aClass name = #SSModel
		ifFalse: [self runFinalizationHooksIn: aClass superclass].! !

!SSModel methodsFor: 'initialization' stamp: 'topa 11/2/2010 11:37'!
runInitializeHooksIn: aClass

	aClass name = #SSModel
		ifFalse: [self runInitializeHooksIn: aClass superclass].

	(Pragma allNamed: #initialize in: aClass) do: [:pragma| 
		self perform: pragma selector].! !

!SSModel methodsFor: 'fileIn-out' stamp: 'obi 3/15/2011 08:25'!
storeDataOn: aDataStream
	self stringsSatisfyBlocks: OrderedCollection new.
	super storeDataOn: aDataStream.
	self initializeStringsSatisfyBlocks.! !

!SSModel methodsFor: 'testing' stamp: 'topa 11/2/2010 11:26'!
stringsSatisfy: aBlock

	^ self stringsSatisfyBlocks	anySatisfy: aBlock! !

!SSModel methodsFor: 'accessing' stamp: 'topa 11/2/2010 11:25'!
stringsSatisfyBlocks

	^ self propertyAt: #stringsSatisfyBlocks ifAbsent: [#()]! !

!SSModel methodsFor: 'accessing' stamp: 'topa 11/2/2010 11:25'!
stringsSatisfyBlocks: aCollection

	self 
		propertyAt: #stringsSatisfyBlocks
		put: aCollection.! !

!SSModel methodsFor: 'accessing' stamp: 'lr 2/6/2004 17:26'!
timestamp
	^timestamp! !

!SSModel methodsFor: 'accessing' stamp: 'dkh 05/17/2011 16:42'!
versionAdded: version
	"noop ... used for subscriptions"
	self flag: #NEEDSREVIEW "should be a better way"! !

SSModel subclass: #SSTag
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Model'!

!SSTag class methodsFor: 'accessing-defaults' stamp: 'pmm 1/24/2006 20:04'!
defaultInstances
	^self defaultNames collect: [ :each |
		self name: each ]! !

!SSTag class methodsFor: 'accessing-defaults' stamp: 'pmm 1/26/2006 18:48'!
defaultNames
	^#(
		client
		server
		protocol
		fileformat
		
		seaside
		
		algorithm
		
		persistency
		
		education
		children
		teaching
		learning
		exercise
				
		xml
		compiler
		research
		collection
	)! !

!SSTag class methodsFor: 'instance creation' stamp: 'pmm 1/24/2006 20:03'!
name: aString
	^self new
		name: aString;
		yourself! !

!SSTag methodsFor: 'comparing' stamp: 'pmm 2/5/2006 15:48'!
< aLabel
	^(self name compare: aLabel name) = 1! !

!SSTag methodsFor: 'comparing' stamp: 'pmm 1/24/2006 20:05'!
<= aLabel
	^self name caseInsensitiveLessOrEqual: aLabel name! !

!SSTag methodsFor: 'converting' stamp: 'pmm 1/24/2006 21:47'!
asString
	^self name! !

!SSTag methodsFor: 'accessing' stamp: 'pmm 3/15/2006 23:34'!
maxActivity
	^self projects size! !

!SSTag methodsFor: 'accessing' stamp: 'pmm 1/24/2006 20:04'!
name
	^name! !

!SSTag methodsFor: 'accessing' stamp: 'pmm 1/24/2006 20:05'!
name: aString
	name := aString! !

!SSTag methodsFor: 'accessing' stamp: 'pmm 1/24/2006 21:55'!
numberOfProjects
	^self projects size! !

!SSTag methodsFor: 'printing' stamp: 'topa 12/20/2010 11:10'!
printOn: aStream
	super printOn: aStream.
	self name ifNotNil: [
		aStream
			nextPut: $(;
			nextPutAll: self name;
			nextPut: $) ].! !

!SSTag methodsFor: 'accessing' stamp: 'pmm 6/27/2010 17:59'!
projects
	^self repository
		visibleProjectsTo: self session user
		select: [ :each | each hasTag: self ]! !

SSModel subclass: #SSVersion
	instanceVariableNames: 'author versionInfo dependencies downloadStatistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Model'!

!SSVersion class methodsFor: 'instance creation' stamp: 'dkh 05/20/2011 12:08'!
array: anArray author: aMember
	^(self stream: (RWBinaryOrTextStream on: anArray) author: aMember)
		size: anArray size;
		yourself! !

!SSVersion class methodsFor: 'properties' stamp: 'pmm 10/9/2006 11:45'!
deletedProperty
	^ #deleted! !

!SSVersion class methodsFor: 'properties' stamp: 'pmm 10/9/2006 11:47'!
diffsProperty
	^ #diffs! !

!SSVersion class methodsFor: 'migration' stamp: 'topa 10/21/2010 18:05'!
migrate
	
	self flag: #NeedsReview. "Is this needed any longer? --topa"
	self allInstances do: [ :version |
		version dependencies do: [ :dependency |
			(dependency isKindOf: MCVersionDependency)
				ifTrue: [ dependency become: dependency versionInfo ].
			dependency clearAncestors ].
		version versionInfo ancestors do: [ :each |
			each clearAncestors ] ].! !

!SSVersion class methodsFor: 'properties' stamp: 'avi 9/23/2004 15:46'!
packageProperty
	^ #package! !

!SSVersion class methodsFor: 'properties' stamp: 'lr 2/8/2004 11:44'!
releaseProperty
	^ #release! !

!SSVersion class methodsFor: 'properties' stamp: 'pmm 10/9/2006 11:44'!
sizeProperty
	^ #size! !

!SSVersion class methodsFor: 'properties' stamp: 'lr 2/11/2004 11:41'!
smPackageProperty
	^ #smPackage! !

!SSVersion class methodsFor: 'properties' stamp: 'lr 2/11/2004 11:41'!
smPasswordProperty
	^ #smPassword! !

!SSVersion class methodsFor: 'properties' stamp: 'lr 2/11/2004 11:41'!
smUsernameProperty
	^ #smUsername! !

!SSVersion class methodsFor: 'properties' stamp: 'al 3/3/2004 18:14'!
smVersionCommentProperty
	^ #smVersionComment! !

!SSVersion class methodsFor: 'instance creation' stamp: 'topa 4/4/2011 13:39'!
stream: aStream author: aMember
	^self basicNew
		initializeFromStream: aStream author: aMember;
		yourself! !

!SSVersion methodsFor: 'comparing' stamp: 'bf 12/16/2004 19:30'!
<= aVersion
	^self packageName = aVersion packageName
		ifFalse: [ self packageName < aVersion packageName ]
		ifTrue: [ self packageVersion > aVersion packageVersion ]! !

!SSVersion methodsFor: 'convenience' stamp: 'lr 3/22/2004 19:23'!
activity
	"This is non-trivial code with physical background: it calculates an artifical float representing the activity of the receiver. The bigger the number, the more siginification is this publication in the past days. This codes uses the halflife-time known from radioactive elements, in this example the constant lambda has been set to 3 days."
	
	| lambda time |
	lambda := 2 ln / (3 * 24 * 60 * 60).
	time := self timestamp asSeconds - TimeStamp current asSeconds.
	^(time * lambda) exp.! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'lr 2/4/2004 17:37'!
ancestors
	^self versionInfo ancestors! !

!SSVersion methodsFor: 'accessing' stamp: 'al 1/31/2004 17:22'!
author
	^author! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:45'!
author: aMember
	author := aMember! !

!SSVersion methodsFor: 'convenience' stamp: 'pmm 6/21/2006 09:55'!
authorString
	^self author fullnameOrUnknown! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 3/16/2006 17:25'!
beDeleted
	self deleted: true! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 3/1/2006 21:59'!
beRelease
	self release: true! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'bf 5/30/2005 18:33'!
buildDiff: aFileName in: aProject
	| baseName base |
	baseName := MCDiffyVersion baseNameFrom: aFileName.
	base := aProject versionAt: baseName, '.', self readerClass extension ifAbsent: [^nil].
	^self buildDiffFrom: (base reader: aProject)
		to: (self reader: aProject).! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'dkh 05/18/2011 14:04'!
buildDiffFrom: baseReader to: versionReader

	| diff strm |
	versionReader info = baseReader info ifTrue: [^nil].
	(versionReader info hasAncestor: baseReader info) ifFalse: [^nil].
	GRPlatform  current squeaksourceDoWithoutProgressNotification: 
	[
		diff := MCDiffyVersion
			package: versionReader package
			info: versionReader info
			dependencies: versionReader dependencies
			baseInfo: baseReader info
			patch: (versionReader snapshot patchRelativeToBase: baseReader snapshot).
		strm := RWBinaryOrTextStream on: String new.
		strm binary.
		diff fileOutOn: strm.
		^strm contents
	].! !

!SSVersion methodsFor: 'accessing-project' stamp: 'topa 3/31/2011 09:40'!
changesUrl: aProject
	| ancestorAndProject diffName |
	ancestorAndProject := (self versionInfo latestAncestorAndProject: aProject)
		ifNil: [(self reader: aProject) info latestAncestorAndProject: aProject].
	(ancestorAndProject isNil or: [ancestorAndProject second ~= aProject])
		ifTrue: [^nil].
	diffName := MCDiffyVersion
		nameForVer: self versionInfo name
		base: ancestorAndProject first versionInfo name.
	^String streamContents: [ :stream |
		stream nextPutAll: aProject fullDirectoryUrl.
		stream nextPutAll: '/changes/'.
		stream nextPutAll: diffName.
		stream nextPutAll: '.cs' ]! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:45'!
deleted
	^self
		propertyAt: self class deletedProperty
		ifAbsent: [ false ]! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:45'!
deleted: aBoolean
	^self
		propertyAt: self class deletedProperty
		put: aBoolean! !

!SSVersion methodsFor: 'accessing' stamp: 'lr 2/20/2004 14:12'!
dependencies
	^dependencies! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'pmm 10/9/2006 11:49'!
diffNamesDo: aBlock
	^self diffs keysAndValuesDo: [:diffName :valid |
		valid ifTrue: [ aBlock value: diffName ] ]! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'topa 5/24/2011 16:50'!
diffs
	^self
		propertyAt: self class diffsProperty
		ifAbsentPut: [ GRPlatform current reducedConflictDictionary new ]! !

!SSVersion methodsFor: 'accessing-project' stamp: 'topa 3/31/2011 09:40'!
diffUrl: aProject
	^String streamContents: [ :stream |
		stream nextPutAll: aProject fullDirectoryUrl.
		stream nextPutAll: '/'.
		stream nextPutAll: self versionInfo name.
		stream nextPutAll: '.diff' ]! !

!SSVersion methodsFor: 'accessing-statistics' stamp: 'dkh 05/23/2011 14:45'!
downloadCountForType: aSymbol
	^self downloadStatistics 
		at: aSymbol 
		ifAbsent: [ 
			self downloadStatistics 
				at: aSymbol 
				put: GRPlatform current reducedConflictCounter ]! !

!SSVersion methodsFor: 'accessing-statistics' stamp: 'dkh 05/24/2011 09:11'!
downloadStatistics
	^downloadStatistics! !

!SSVersion methodsFor: 'convenience' stamp: 'bf 3/28/2006 14:59'!
fileName
	^self propertyAt: #fileName ifAbsentPut: [
		String streamContents: [ :stream |
			stream nextPutAll: self versionInfo name.
			stream nextPut: $..
			stream nextPutAll: self readerClass extension ]]! !

!SSVersion methodsFor: 'convenience' stamp: 'pmm 10/9/2006 00:00'!
fileNameFaked: aBoolean
	| basicFileName |
	basicFileName := self fileName.
	^(aBoolean and: [ basicFileName endsWith: '.mcz' ])
		ifTrue: [ (basicFileName allButLast: 4), '.zip' ]
		ifFalse: [ basicFileName ]! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'topa 3/31/2011 10:25'!
getDiffyVersion: aFileName in: aProject
	| diffName data |
	diffName := MCDiffyVersion canonicalNameFor: aFileName.
	self diffs at: diffName ifPresent: [:hasDiff | 
		^hasDiff ifTrue: [SSRepository storage loadDiffNamed: diffName from: aProject]].

	data := [self buildDiff: diffName in: aProject]
		value.
"		on: Error do: [:ex | ex return: nil]."
	data ifNotNil: [SSRepository storage saveDiff: data named: diffName to: aProject].
	self diffs at: diffName put: data notNil.
	^data! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/11/2006 00:56'!
guessedAuthor
	^self repository
		memberAt: (self versionInfo name copyAfterLast: $-)
		ifAbsent: [ nil ]! !

!SSVersion methodsFor: 'testing' stamp: 'avi 9/23/2004 16:04'!
hasAncestor: aVersion project: aProject
	^ (self readVersionInfoFromProject: aProject) hasAncestor: aVersion versionInfo! !

!SSVersion methodsFor: 'testing' stamp: 'pmm 10/23/2006 12:53'!
hasGuid
	^self versionInfo notNil
		and: [ self versionInfo id notNil ]! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'lr 1/31/2004 21:35'!
id
	^self versionInfo id! !

!SSVersion methodsFor: 'accessing-statistics' stamp: 'dkh 05/23/2011 14:44'!
increaseDownloadCounterForType: aSymbol
	(self downloadCountForType: aSymbol) increment! !

!SSVersion methodsFor: 'initialization' stamp: 'dkh 05/24/2011 11:54'!
initialize
	super initialize.
	properties := GRPlatform current reducedConflictDictionary new.
	downloadStatistics := GRPlatform current reducedConflictDictionary new.
	"prime the downloadStats with standard downloadTypes to avoid commit conflicts in GemStone"
	#(#Squeak #Web) do: [:downloadType | self downloadCountForType: downloadType ]! !

!SSVersion methodsFor: 'initialization' stamp: 'topa 4/4/2011 13:40'!
initializeFromReader: aReader
	
	self initialize.
	dependencies := aReader dependencies
		collect: [ :each | each versionInfo clearAncestors ].
	(versionInfo := aReader info) ancestors
		do: [ :each | each clearAncestors ].
	self package: (aReader package name)! !

!SSVersion methodsFor: 'initialization' stamp: 'pmm 10/26/2006 21:21'!
initializeFromStream: aStream
	self initializeFromReader: (self readerClass on: aStream)! !

!SSVersion methodsFor: 'initialization' stamp: 'pmm 10/23/2006 16:16'!
initializeFromStream: aStream author: aMember
	author := aMember.
	self initializeFromStream: aStream.! !

!SSVersion methodsFor: 'initialization' stamp: 'topa 3/14/2011 17:39'!
initializeStringsSatisfyBlocks

	super initializeStringsSatisfyBlocks.
	self stringsSatisfyBlocks addAll: {
		[:aBlock | aBlock value: self versionInfo name].
		[:aBlock | aBlock value: self versionInfo message].
		[:aBlock | self author notNil and: [ self author stringsSatisfy: aBlock ]]
	}.! !

!SSVersion methodsFor: 'testing' stamp: 'pmm 3/16/2006 17:25'!
isDeleted
	^self deleted! !

!SSVersion methodsFor: 'testing' stamp: 'pmm 3/1/2006 21:54'!
isRelease
	^self 
		propertyAt: self class releaseProperty
		ifAbsent: [ false ]! !

!SSVersion methodsFor: 'testing' stamp: 'pmm 10/9/2006 11:53'!
isVersion
	^true! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'lr 1/31/2004 21:32'!
message
	^self versionInfo message! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 3/1/2006 21:59'!
noRelease
	self release: false! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:44'!
package
	^ self
		propertyAt: self class packageProperty
		ifAbsent: [ self packageName ]! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:46'!
package: aString
	self
		propertyAt: self class packageProperty
		put: aString! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'bf 12/14/2004 13:39'!
packageName
	^self versionInfo name copyUpToLast: $-.! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'al 2/2/2006 13:23'!
packageVersion
	^[ (self versionInfo name copyAfterLast: $.) asNumber ]
		ifError: [ :e | 0 ]! !

!SSVersion methodsFor: 'printing' stamp: 'bf 3/27/2010 15:40'!
printOn: aStream
	aStream
		nextPutAll: self class name;
		nextPut: $(;
		print: self versionInfo name;
		nextPut: $)! !

!SSVersion methodsFor: 'accessing-project' stamp: 'dkh 05/17/2011 15:50'!
reader: aProject
	| data |
	data := SSRepository storage loadMonticello: self from: aProject.
	^self readerClass on: (ReadStream on: data asByteArray).! !

!SSVersion methodsFor: 'convenience' stamp: 'lr 3/15/2004 16:06'!
readerClass
	^MCMczReader! !

!SSVersion methodsFor: 'accessing-project' stamp: 'avi 9/23/2004 16:06'!
readVersionInfoFromProject: aProject
	^ (self reader: aProject) info! !

!SSVersion methodsFor: 'convenience' stamp: 'topa 3/14/2011 17:11'!
registerSqueakMap: aProject
	"Copyied from MCSMReleaseRepository>>releaseVersion:url: and slightly modified. This message returns an error string in case of any problem, else nil is returned."

	| result |
	result := HTTPSocket
		httpPost: self squeakMapUrl, '/packagebyname/' , (self propertyAt: self class smPackageProperty) , '/newrelease'
		args: {
			'version' -> { (self versionInfo name copyAfter: $.) extractNumber asString }.
			'note' -> { self propertyAt: self class smVersionCommentProperty }.
			'downloadURL' -> { self url: aProject } }
		user: (self propertyAt: self class smUsernameProperty)
		passwd: (self propertyAt: self class smPasswordProperty).
	^result contents size > 4 
		ifTrue: [ result contents ]
		ifFalse: [ nil ]! !

!SSVersion methodsFor: 'convenience' stamp: 'topa 3/14/2011 17:11'!
registerSqueakMapCurl: aProject

	| ursername password url arguments postdata curl proxyServer proxyPort |
	ursername := (self propertyAt: self class smUsernameProperty).
	password := (self propertyAt: self class smPasswordProperty).
	url := Url absoluteFromText: (self squeakMapUrl, '/packagebyname/' , (self propertyAt: self class smPackageProperty) , '/newrelease').
	arguments := {
		'version' -> { (self versionInfo name copyAfter: $.) extractNumber asString }.
		'note' -> { self propertyAt: self class smVersionCommentProperty }.
		'downloadURL' -> { self url: aProject } }.
	postdata := String streamContents: [ :stream |
		arguments do: [ :each |
			stream nextPutAll: each key encodeForHTTP.
			stream nextPut: $=.
			stream nextPutAll: each value encodeForHTTP ] ].

	curl := (self class environment classNamed: 'Curl') new.

	HTTPSocket httpProxyServer isNil ifFalse: [ "use proxy"
		proxyServer := HTTPSocket httpProxyServer.
		proxyPort := HTTPSocket httpProxyPort.
		proxyPort isNil
			ifTrue: [ curl proxy: proxyServer ]
			ifFalse: [ curl proxy: proxyServer, ':' , proxyPort asString ] ].

	curl onHttpAuthAny.
	curl onPost.
	curl userPwd: ursername, ':' , password.
	^curl putContents: postdata url: url printString.! !

!SSVersion methodsFor: 'accessing' stamp: 'lr 2/8/2004 11:44'!
release: aBoolean
	self 
		propertyAt: self class releaseProperty
		put: aBoolean! !

!SSVersion methodsFor: 'initialization' stamp: 'pmm 9/9/2007 12:04'!
setTimestampFromVersionInfo
        timestamp := TimeStamp date: versionInfo date time: versionInfo time.! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:44'!
size
	^ self
		propertyAt: self class sizeProperty
		ifAbsent: [ 0 ]! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:45'!
size: anInteger
	^ self
		propertyAt: self class sizeProperty
		put: anInteger! !

!SSVersion methodsFor: 'convenience' stamp: 'topa 3/14/2011 17:12'!
squeakMapUrl

	^ 'http://map.squeak.org/'! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'bf 3/29/2011 20:44'!
title
	^self versionInfo name! !

!SSVersion methodsFor: 'accessing-statistics' stamp: 'dkh 05/23/2011 14:17'!
totalDownloads

	^ self downloadStatistics inject: 0 into: [:sum :each | sum + each value].! !

!SSVersion methodsFor: 'convenience' stamp: 'lr 2/7/2004 13:43'!
truncatedMessage
	^self message truncateWithElipsisTo: 35! !

!SSVersion methodsFor: 'accessing-project' stamp: 'pmm 9/9/2007 12:47'!
url: aProject
	^aProject fullDirectoryUrl, '/' , self fileName! !

!SSVersion methodsFor: 'accessing' stamp: 'lr 1/31/2004 21:31'!
versionInfo
	^versionInfo! !

WAObject subclass: #SSSiteMapBuilder
	instanceVariableNames: 'document urlset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Server'!

!SSSiteMapBuilder class methodsFor: 'convenience' stamp: 'pmm 10/8/2006 21:54'!
buildForCurrentRepository
	"self buildForCurrentRepository"
	^self buildForRepository: SSRepository current! !

!SSSiteMapBuilder class methodsFor: 'convenience' stamp: 'pmm 10/8/2006 21:53'!
buildForRepository: aRepository
	^self new buildForRepository: aRepository! !

!SSSiteMapBuilder class methodsFor: 'convenience' stamp: 'jgf 7/22/2009 15:13'!
buildGzForCurrentRepository
	"self buildForCurrentRepository"
	^self buildGzForRepository: SSRepository current! !

!SSSiteMapBuilder class methodsFor: 'convenience' stamp: 'jgf 7/22/2009 15:13'!
buildGzForRepository: aRepository
	^self new buildGzForRepository: aRepository! !

!SSSiteMapBuilder class methodsFor: 'convenience' stamp: 'topa 6/19/2010 19:46'!
writeCurrentToFile
	"self writeCurrentToFile
	validate with: 
xmllint --schema http://www.google.com/schemas/sitemap/0.84/sitemap.xsd  --noout sitemap.xml"

	GRPlatform current
		write: self buildForCurrentRepository
		toFile: 'sitemap.xml'
		inFolder: ''.! !

!SSSiteMapBuilder class methodsFor: 'convenience' stamp: 'topa 6/19/2010 19:46'!
writeCurrentToGzFile
	"self writeCurrentToGzFile
	validate with: 
xmllint --schema http://www.google.com/schemas/sitemap/0.84/sitemap.xsd  --noout sitemap.xml"

	GRPlatform current
		write: self buildGzForCurrentRepository
		toFile: 'sitemap.xml.gz'
		inFolder: ''.! !

!SSSiteMapBuilder methodsFor: 'private' stamp: 'pmm 10/8/2006 22:03'!
addLocation: aString
	| url loc |
	url := XMLElement named: 'url'.
	urlset addElement: url.
	loc := XMLElement named: 'loc'.
	loc addContent: (XMLStringNode string: aString).
	url addElement: loc! !

!SSSiteMapBuilder methodsFor: 'private' stamp: 'pmm 9/9/2007 12:47'!
addProject: aProject
	self addLocation: aProject fullDirectoryUrl, '/'! !

!SSSiteMapBuilder methodsFor: 'private' stamp: 'pmm 6/30/2010 18:14'!
addRepository: aRepository
	aRepository visibleProjectsTo: SSMember anonymousMember do: [ :each |
		self addProject: each ]! !

!SSSiteMapBuilder methodsFor: 'public' stamp: 'jgf 7/22/2009 15:15'!
buildForRepository: aRepository
	self addRepository: aRepository.
	^String streamContents: [ :stream |
		document printCanonicalOn: stream ]! !

!SSSiteMapBuilder methodsFor: 'public' stamp: 'topa 6/19/2010 19:46'!
buildGzForRepository: aRepository

	^ (GRPlatform current magritteClassNamed: #'GZipWriteStream')
		ifNotNil: [:class | 
			self addRepository: aRepository.
			String streamContents: [ :stream |
				| gzip |
				gzip := class on: stream.
				document printCanonicalOn: gzip.
				gzip finish ] ].! !

!SSSiteMapBuilder methodsFor: 'initialize-release' stamp: 'pmm 10/8/2006 21:48'!
initialize
	super initialize.
	document := XMLDocument new.
	urlset := (XMLElement named: 'urlset')
		attributeAt: 'xmlns' put: 'http://www.google.com/schemas/sitemap/0.84';
		attributeAt: 'xmlns:xsi' put: 'http://www.w3.org/2001/XMLSchema-instance';
		attributeAt: 'xsi:schemaLocation' put: 'http://www.google.com/schemas/sitemap/0.84
	http://www.google.com/schemas/sitemap/0.84/sitemap.xsd';
		yourself.
	document addElement: urlset! !

WAObject subclass: #SSTodo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Fake'!

!SSTodo commentStamp: 'pmm 11/24/2007 17:01' prior: 0!
- senders of #render: -> #children
- style stuff for tables, cells, batch
- color icon in table not again table
- SSProject licenses
- incomment storage code - check with impara
- null storage!

WAComponent subclass: #SSComponent
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

SSComponent subclass: #SSAddLinkComponent
	instanceVariableNames: 'tokens delimiter url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSAddLinkComponent class methodsFor: 'instance creation' stamp: 'pmm 9/17/2007 20:36'!
string: aString delimiter: aDelimiter url: aUrl
	| splitIndex tokens |
	splitIndex := aString findString: aDelimiter.
	tokens := Array
		with: (aString copyFrom: 1 to: splitIndex - 1)
		with: (aString copyFrom: splitIndex + aDelimiter size to: aString size).
	^self new
		tokens: tokens;
		delimiter: aDelimiter;
		url: aUrl;
		yourself! !

!SSAddLinkComponent methodsFor: 'accessing' stamp: 'pmm 9/17/2007 20:19'!
delimiter
	^delimiter! !

!SSAddLinkComponent methodsFor: 'accessing' stamp: 'pmm 9/17/2007 20:19'!
delimiter: aString
	delimiter := aString! !

!SSAddLinkComponent methodsFor: 'rendering' stamp: 'pmm 9/17/2007 20:19'!
renderContentOn: html
	self tokens
		do: [ :each | html text: each ]
		separatedBy: [
			html anchor
				url: self url;
				with: self delimiter ]! !

!SSAddLinkComponent methodsFor: 'accessing' stamp: 'pmm 9/17/2007 20:18'!
tokens
	^tokens! !

!SSAddLinkComponent methodsFor: 'accessing' stamp: 'pmm 9/17/2007 20:18'!
tokens: aString
	tokens := aString! !

!SSAddLinkComponent methodsFor: 'accessing' stamp: 'pmm 9/17/2007 20:19'!
url
	^url! !

!SSAddLinkComponent methodsFor: 'accessing' stamp: 'pmm 9/17/2007 20:19'!
url: aString
	url := aString! !

SSComponent subclass: #SSBrowser
	instanceVariableNames: 'heading'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSBrowser class methodsFor: 'instance creation' stamp: 'lr 2/8/2004 12:17'!
model: aModel heading: aString
	^(self model: aModel)
		heading: aString;
		yourself! !

!SSBrowser methodsFor: 'accessing' stamp: 'lr 2/8/2004 12:16'!
heading
	^heading! !

!SSBrowser methodsFor: 'accessing' stamp: 'pmm 8/25/2007 15:19'!
heading: aString
	heading := aString! !

!SSBrowser methodsFor: 'rendering' stamp: 'pmm 8/26/2007 14:50'!
renderButtonsOn: html
	html form: [
		html div: [
			html submitButton
				callback: [ self model switchBeInstance ];
				text: 'Instance'.
			html space.
			html submitButton
				callback: [ self model switchBeComment ];
				text: 'Comment'.
			html space.
			html submitButton
				callback: [ self model switchBeClass ];
				text: 'Class' ] ]! !

!SSBrowser methodsFor: 'rendering' stamp: 'topa 6/21/2010 09:28'!
renderColumn: aSelector on: html
	| aList listIndex |
	aList := self model perform: (aSelector , 'List') asSymbol.
	listIndex := self model perform: (aSelector , 'Selection') asSymbol.
	html form: [
			self flag: #smell:onChange:.
			html select
				size: 10;
				onChange: 'submit()';
				list: aList;
				selected: (listIndex > 0 ifTrue: [aList at: listIndex] ifFalse: []);
				callback: [ :item |
					self model
						perform: (aSelector , 'Selection:') asSymbol
						with: (aList indexOf: item) ] ]! !

!SSBrowser methodsFor: 'rendering' stamp: 'obi 9/2/2009 23:07'!
renderColumnsOn: html
	| columns |
	columns := #(category class protocol method).
	html table
		cellspacing: 0;
		cellpadding: 0;
		with: [
		html tableRow: [
			columns do: [ :each | 
				html tableData: [self renderColumn: each on: html ] ] ] ]! !

!SSBrowser methodsFor: 'rendering' stamp: 'lr 2/4/2004 19:11'!
renderContentOn: html
	self renderTitleOn: html.
	self renderColumnsOn: html.
	self renderButtonsOn: html.
	self renderTextOn: html.! !

!SSBrowser methodsFor: 'rendering' stamp: 'topa 4/4/2011 13:41'!
renderTextOn: html
	html preformatted: [
		html code: self model text ].! !

!SSBrowser methodsFor: 'rendering' stamp: 'pmm 8/25/2007 15:19'!
renderTitleOn: html
	html heading: self heading! !

!SSComponent class methodsFor: 'instance creation' stamp: 'topa 5/4/2011 17:31'!
model: aModel

	| component |
	component := self new
		setModel: aModel;
		yourself.
	
	(Pragma allNamed: #decoration in: self class) do: [:pragma |
		component := self perform: pragma selector with: component].
	
	^ component! !

!SSComponent methodsFor: 'actions-accessing' stamp: 'topa 10/28/2010 19:12'!
actionPragmas

	^ {
		"simple actions"	#actionNamed:priority: . [true] .
		"restricted actions"	#actionNamed:priority:access: . [:pragma | self isMember: self user allowedTo: (pragma argumentAt: 3)] .
		"conditionally shown actions" #actionNamed:priority:condition: . [:pragma | self perform: (pragma argumentAt: 3)]
	}! !

!SSComponent methodsFor: 'accessing' stamp: 'topa 10/28/2010 19:18'!
actions

	^ Array streamContents: [:stream |
			self priorizedActions sorted 
				do: [:association | stream nextPutAll: association value]]! !

!SSComponent methodsFor: 'testing' stamp: 'topa 10/28/2010 13:06'!
always
	" When to show some action / tab unconditionally "

	^ true! !

!SSComponent methodsFor: 'testing' stamp: 'topa 12/20/2010 08:36'!
canEditSettings

	^ self isValidUser
		ifFalse: [false]
		ifTrue: [self user isSuperUser and:
			[self isHome]]! !

!SSComponent methodsFor: 'testing' stamp: 'topa 2/25/2011 11:59'!
canRegisterProject

	^ self isHome
	and: [self isValidUser
	and: [self repository allowRegisterProject
		or: [self session user superuser]]]! !

!SSComponent methodsFor: 'actions' stamp: 'pmm 3/15/2006 21:56'!
displayProjectsWithTag: aTag
	self call: (SSProjectsWithTag model: aTag)! !

!SSComponent methodsFor: 'actions' stamp: 'pmm 9/9/2007 12:38'!
editMember
	self editMember: 'Edit Member'! !

!SSComponent methodsFor: 'actions' stamp: 'jgf 12/21/2008 10:03'!
editMember: aTitleString
	| editor |
	editor := self session user asComponent
		addTitle: aTitleString;
		addValidatedForm;
		yourself.
	(self call: editor)
		ifNotNil: [ self session save ]! !

!SSComponent methodsFor: 'actions' stamp: 'topa 10/28/2010 21:11'!
editSettings
	
	<actionNamed: 'Edit Settings' priority: 50 condition: #canEditSettings>
	
	| editor |
	self session isValidUser ifFalse: [
		self call: (SSLogin model: self repository) ].
	self session isSuperUser ifFalse: [
			self informOnlyAdmin: 'Only the administrator is allowed to change repository settings!!'.
			^self answer ].
	editor := self repository asComponent
		addTitle: 'Repository Settings';
		addValidatedForm;
		yourself.
	(self call: editor)
		ifNotNil: [ self session save ]! !

!SSComponent methodsFor: 'convenience' stamp: 'topa 5/19/2011 20:42'!
informOnlyAdmin: aString
	| message |
	message := SSAddLinkComponent
		string: aString
		delimiter: 'administrator'
		url: 'mailto:', self repository superUserEmail first address.
	self call: message! !

!SSComponent methodsFor: 'testing' stamp: 'topa 10/28/2010 18:59'!
isHome
	"meanigfull in a frame"
	
	^ false! !

!SSComponent methodsFor: 'testing' stamp: 'topa 2/25/2011 11:58'!
isHomeAndSuperUser

	^ self isHome 
	and: [ self isValidUser 
	and: [ self session isSuperUser]]! !

!SSComponent methodsFor: 'private' stamp: 'topa 3/14/2011 09:48'!
isMember: aMember allowedTo: anAccessSymbol

	"per default, deny anything"
	^ false! !

!SSComponent methodsFor: 'convenience' stamp: 'topa 1/4/2011 09:42'!
isValidUser

	^ self session isValidUser! !

!SSComponent methodsFor: 'actions' stamp: 'lr 3/19/2004 13:31'!
loginMember
	self call: (SSLogin model: self model)! !

!SSComponent methodsFor: 'actions' stamp: 'lr 3/19/2004 13:30'!
logoutMember
	self session logout! !

!SSComponent methodsFor: 'accessing' stamp: 'lr 1/26/2004 16:20'!
model
	^model! !

!SSComponent methodsFor: 'actions-accessing' stamp: 'topa 10/28/2010 19:15'!
priorizedActions

	^ self priorizedActionsIn: self class! !

!SSComponent methodsFor: 'actions-accessing' stamp: 'topa 4/4/2011 16:10'!
priorizedActionsIn: aClass	
	^ Array streamContents: [ :stream | 

		"look for actions in superclasses"
		(aClass name = #SSComponent) 
			ifFalse: [stream nextPutAll: (self priorizedActionsIn: aClass superclass)].

		"simple link actions"
		(Pragma allNamed: #linkNamed:priority:condition: in: aClass) 
			do: [:pragma |
				stream 	nextPut: (pragma argumentAt: 2) ->  
					{ pragma argumentAt: 1. self perform: pragma selector}].

		self actionPragmas pairsDo: [:pragmaName :condition |
			(Pragma allNamed: pragmaName in: aClass) 
				do: [:pragma |
					(condition valueWithPossibleArgument: pragma) ifTrue: [
						stream 	nextPut: 
							(pragma argumentAt: 2) ->  
								{ pragma argumentAt: 1. pragma selector }]]]].! !

!SSComponent methodsFor: 'actions' stamp: 'topa 2/25/2011 12:00'!
registerGroup
	<actionNamed: 'Register Group' priority: 30 condition: #isHomeAndSuperUser>

	| editor |
	editor := SSGroup new asRegisterComponent
		addTitle: 'Register Group'; 
		addValidatedForm;
		yourself.
	(self call: editor)
		ifNotNilDo: [ :group | 
			self model addGroup: group.
			self session save ].! !

!SSComponent methodsFor: 'actions' stamp: 'topa 2/25/2011 11:59'!
registerMember
	<actionNamed: 'Register Member' priority: 20 condition: #isHome>

	| editor |
	editor := SSMember new asRegisterComponent
		addTitle: 'Register Member'; 
		addValidatedForm;
		yourself.
	(self call: editor) ifNotNilDo: [ :member | 
		self model addMember: member.
		self session isValidUser ifFalse: [
			self session login: member ].
		self session save ].! !

!SSComponent methodsFor: 'actions' stamp: 'topa 2/25/2011 12:00'!
registerProject
	<actionNamed: 'Register Project' priority: 40 condition: #canRegisterProject>

	| editor |
	editor := (SSProject creator: self session user) asRegisterComponent
		addDecoration: SSExplanationDecoration new;
		addDecoration: SSIntroductionDecoration new;
		addTitle: 'Register Project';
		addValidatedForm;
		yourself.
	(self call: editor) ifNotNilDo: [ :project | 
		self model addProject: project.
		self session save.
		self call: project view ]! !

!SSComponent methodsFor: 'accessing' stamp: 'topa 10/26/2010 11:38'!
repository

	^ self session repository! !

!SSComponent methodsFor: 'initialization' stamp: 'lr 2/4/2004 09:55'!
resetModel
	self setModel: self model.! !

!SSComponent methodsFor: 'initialization' stamp: 'lr 1/26/2004 16:21'!
setModel: aModel
	model := aModel! !

!SSComponent methodsFor: 'accessing' stamp: 'topa 10/26/2010 11:39'!
user

	^ self session user! !

SSComponent subclass: #SSFilenameRenderer
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSFilenameRenderer methodsFor: 'accessing' stamp: 'pmm 10/8/2007 07:04'!
announcer
	^announcer! !

!SSFilenameRenderer methodsFor: 'accessing' stamp: 'pmm 10/8/2007 07:04'!
announcer: anObject
	announcer := anObject! !

!SSFilenameRenderer methodsFor: 'actions' stamp: 'pmm 10/8/2007 07:02'!
callOnView: aComponent
	| announcement |
	announcement := SSVersionViewCallAnnoucement component: aComponent.
	self announcer announce: announcement! !

!SSFilenameRenderer methodsFor: 'accessing' stamp: 'pmm 10/8/2007 07:01'!
project
	self subclassResponsibility! !

!SSFilenameRenderer methodsFor: 'actions' stamp: 'topa 12/20/2010 08:24'!
renderFilename: aString of: aVersion on: html
	aVersion 
		ifNil: [ html text: aString ]
		ifNotNil: [ 
			(self project isMember: self session user  allowedTo: SSAccessPolicy allowAllRead for: aVersion)
				ifFalse: [ html text: aString ]
				ifTrue: [
					html anchor
						callback: [ self callOnView: (SSVersionView project: self project version: aVersion) ];
						with: aString ] ]! !

SSFilenameRenderer subclass: #SSVersionView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

SSVersionView subclass: #SSVersionHistoryItems
	instanceVariableNames: 'infos project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSVersionHistoryItems methodsFor: 'accessing' stamp: 'pmm 10/8/2007 06:49'!
infos
	^infos! !

!SSVersionHistoryItems methodsFor: 'accessing' stamp: 'pmm 10/8/2007 06:49'!
infos: aCollectionOfVersionInfos 
	infos := aCollectionOfVersionInfos! !

!SSVersionHistoryItems methodsFor: 'accessing' stamp: 'pmm 10/8/2007 06:48'!
project
	^project! !

!SSVersionHistoryItems methodsFor: 'accessing' stamp: 'pmm 10/8/2007 06:48'!
project: aProject 
	project := aProject! !

!SSVersionHistoryItems methodsFor: 'rendering' stamp: 'topa 6/19/2010 18:34'!
renderContentOn: html
	self infos do: [ :each |
		html paragraph: [
			html strong: [
				self renderFilename: each name
					of: (self project versionAt: each name, '.mcz')
					on: html].
			html text: ' (', each date greaseString, ', ', each time greaseString, ')'; break.
			each ancestors size > 1
				ifTrue: [ html strong: 'MERGED ', each ancestorString; break].
			each stepChildren isEmpty ifFalse: [
				html strong: 'BACKPORT '.
				html text: each stepChildrenString; break].
			html withLineBreaks: each message ] ]! !

!SSVersionView class methodsFor: 'instance creation' stamp: 'lr 2/4/2004 17:35'!
project: aProject version: aVersion
	^self model: (Array 
		with: aProject 
		with: aVersion)! !

!SSVersionView methodsFor: 'rendering' stamp: 'avi 9/23/2004 15:52'!
bless
	self project blessVersion: self version ifForbidden: [self blessingForbidden]! !

!SSVersionView methodsFor: 'rendering' stamp: 'avi 9/23/2004 16:01'!
blessingForbidden
	self inform: 'You cannot bless ', self version fileName, ', because ', (self project blessedVersionForPackage: self version package) fileName , ' is not among its ancestors.  Please merge these two versions together first.'! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 5/5/2011 17:00'!
browse
	<actionNamed: 'Browse Code' priority: 20 access: #read>

	| reader browser |
	[ reader := self version reader: self project.
	browser := SSSnapshotBrowser forSnapshot: reader snapshot.
	self call: (SSBrowser model: browser heading: 'Browse ' , self version fileName) ] 
		on: Error do: [ self errorNotFound: self version fileName ]! !

!SSVersionView methodsFor: 'accessing' stamp: 'pmm 10/8/2007 07:03'!
callFromFilename: anAnnoucement
	self call: anAnnoucement component! !

!SSVersionView methodsFor: 'private' stamp: 'topa 5/10/2011 15:48'!
confirmDelete: aCollection
	"decoration := SSVersionListingDecoration
		version: self version
		versions: aCollection."
	^ self call: (WAYesOrNoDialog new
		addDecoration: (SSVersionListingDecoration
		actionName: 'delete all versions'
		version: self version
		versions: aCollection);
		yourself)! !

!SSVersionView methodsFor: 'private' stamp: 'topa 5/10/2011 15:47'!
confirmDeleteDependents: aCollection
	"decoration := SSVersionListingDecoration
		version: self version
		versions: aCollection."
	^ self call: (WAYesOrNoDialog new
		addDecoration: (SSVersionListingDecoration
		actionName: 'delete dependents'
		version: self version
		versions: aCollection);
		yourself)! !

!SSVersionView methodsFor: 'private' stamp: 'topa 3/14/2011 18:00'!
confirmMove: aCollection

	^ self call: (WAYesOrNoDialog new
		addDecoration: (SSVersionListingDecoration
		actionName: 'move'
		version: self version
		versions: aCollection);
		yourself)! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 12/20/2010 11:12'!
copy
	<actionNamed: 'Copy Version' priority: 40 access: #read>

	| result |
	result := self call: (SSSimpleObjectChooser 
		model: self writableProjectsForUser
		heading: 'Select the project to copy "' , self version fileName , '" to:').
	result ifNil: [^ self].
	result 
		addVersion: (SSRepository storage
			loadMonticello: self version
			from: self project)
		author: self version author.
	self session save.! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 3/14/2011 17:46'!
copyAll
	<actionNamed: 'Copy Package' priority: 50 access: #read>

	| versions project |
	versions := self project versions
		select: [ :each | each packageName = self version packageName ].
	project := self call: ((SSSimpleObjectChooser 
		model: self writableProjectsForUser
		heading: 'Select the project to copy the following versions to')
			infoBlock: [:html |
				html unorderedList: [
					versions asSortedCollection do: [ :each | 
						html listItem: [html text: each fileName]]]];
			yourself).
	project ifNil: [ ^ self ].
	versions do: [ :each |
		project 
			addVersion: (SSRepository storage
				loadMonticello: each
				from: self project)
			author: self user ].
	self session save.
	self answer! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 3/14/2011 17:56'!
copyDependencies
	<actionNamed: 'Copy Dependencies' priority: 60 access: #read>

	| versions project |
	versions := OrderedCollection with: self version.
	self version dependencies do: [ :dependency | 
		versions addAll: (self project versions
			select: [ :each | each versionInfo name = dependency name ]) ].
	project := self call: ((SSSimpleObjectChooser 
		model: self writableProjectsForUser
		heading: 'Select the project to copy the following versions to')
			infoBlock: [:html |
				html unorderedList: [
					versions asSortedCollection do: [ :each | 
						html listItem: [html text: each fileName]]]];
			yourself).
	project ifNil: [ ^ self ].
	versions do: [ :each |
		project 
			addVersion: (SSRepository storage
				loadMonticello: each
				from: self project)
			author: self user ].
	self session save.
	self answer! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 10/25/2010 16:15'!
delete
	<actionNamed: 'Delete Version' priority: 100 access: #admin>

	(self confirm: 'Really delete version "', self version fileName,'"?')
		ifTrue: [
			self project deleteVersion: self version.
			self session save.
			self answer ]! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 5/10/2011 15:50'!
deleteAll

	<actionNamed: 'Delete Package' priority: 110 access: #admin>

	| all |
	all := (self project versions select: [ :each |
		each packageName = self version packageName ]) sorted.

	(self confirmDelete: all) ifTrue: [
		all do: [:each | self project deleteVersion: each].
		self session save.
		self answer ]! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 5/10/2011 15:46'!
deleteDependencies
	<actionNamed: 'Delete Dependencies' priority: 120 access: #admin>

	| all |
	all := self version dependencies
		inject: (OrderedCollection with: self version) 
		into: [ :dependencies :dependency | 
			dependencies 
				addAll: (self project versions select: [ :each | each versionInfo name = dependency name ]);
				yourself].
			
	(self confirmDeleteDependents:  all)
			ifTrue: [
				all do: [:each | self project deleteVersion: each].
				self session save.
				self answer ]! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 10/25/2010 16:10'!
download
	<actionNamed: 'Download Package' priority: 10 access: #read>
	self requestContext redirectTo: (self version url: self project).! !

!SSVersionView methodsFor: 'private' stamp: 'pmm 6/30/2010 17:40'!
errorNotFound: aString
	self requestContext responseGenerator notFound; respond! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 10/25/2010 16:11'!
history
	<actionNamed: 'Show History' priority: 30 access: #read>

	self call: (SSWindow new
		title: 'Version History';
		content: (SSVersionHistoryItems new
			infos: (self version reader: self project) info withBreadthFirstAncestors;
			project: self project;
			announcer: self announcer;
			yourself))! !

!SSVersionView methodsFor: 'initialize-release' stamp: 'pmm 10/8/2007 07:04'!
initialize
	super initialize.
	announcer := Announcer new.
	announcer on: SSVersionViewCallAnnoucement send: #callFromFilename: to: self! !

!SSVersionView methodsFor: 'private' stamp: 'topa 10/25/2010 16:32'!
isMember: aMember allowedTo: aACLSymbol

	^ self project isMember: aMember allowedTo: aACLSymbol! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 10/25/2010 16:13'!
move
	<actionNamed: 'Move Version' priority: 70 access: #write>

	self move: {self version}! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 3/14/2011 17:58'!
move: versions

	| target |
	(self project isMember: self session user allowedTo: SSAccessPolicy move for: self version)
		ifFalse: [
			^ self project developersCanMove
				ifTrue: [ self inform: 'Only developers and admins can move versions!!' ]
				ifFalse: [ self inform: 'Only admins can move versions!!' ] ].
	target :=  self call: ((SSSimpleObjectChooser 
		model: self writableProjectsForUser
		heading: 'Select the project to move the following versions to')
			infoBlock: [:html |
				html unorderedList: [
					versions asSortedCollection do: [ :each | 
						html listItem: [html text: each fileName]]]];
			yourself).
	target ifNil: [ ^ self ].
	self move: versions to: target.! !

!SSVersionView methodsFor: 'actions' stamp: 'bf 5/28/2010 10:28'!
move: someVersions to: targetProject
	someVersions do: [ :each |
		targetProject 
			addVersion: (SSRepository storage
				loadMonticello: each
				from: self project)
			author: self user.
		self project deleteVersion: each ].
	self session save.
	self answer.! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 3/14/2011 17:59'!
moveAll
	<actionNamed: 'Move Package' priority: 80 access: #write>

	| versions |
	versions := self project versions
		select: [ :each | each packageName = self version packageName ].

	(self confirmMove: versions) ifTrue: [
		self move: versions.
		self session save.
		self answer]! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 10/25/2010 16:14'!
moveDependencies
	<actionNamed: 'Move Dependencies' priority: 90 access: #write>

	| versions |
	versions := OrderedCollection with: self version.
	self version dependencies do: [ :dependency | 
		versions addAll: (self project versions
			select: [ :each | each versionInfo name = dependency name ]) ].
	self move: versions.! !

!SSVersionView methodsFor: 'accessing' stamp: 'lr 2/4/2004 17:30'!
project
	^self model first! !

!SSVersionView methodsFor: 'actions' stamp: 'pmm 3/1/2006 21:59'!
releaseCreate
	self version beRelease.
	self session save.! !

!SSVersionView methodsFor: 'actions' stamp: 'topa 5/10/2011 15:55'!
releaseCreateSqueakMap

	(self call: (SSRegisterSqueakMap model: self model))
		ifNotNil: [
			(self version registerSqueakMap: self project)
				ifNil: [ self version beRelease. self session save ]
				ifNotNil: [:result |
					self requestContext respond: [:response |
						response
							contentType: WAMimeType textHtml;
							document: result contents mimeType: WAMimeType textHtml]]]! !

!SSVersionView methodsFor: 'actions' stamp: 'pmm 3/1/2006 22:00'!
releaseRemove
	self version noRelease.
	self session save.! !

!SSVersionView methodsFor: 'rendering' stamp: 'topa 3/31/2011 08:12'!
renderAncestorsOn: html
	self version ancestors isEmpty ifFalse: [
		html tableRow: [
			html tableData
				class: 'label';
				with: 'Ancestors:'.
			html tableData: [  
			self version ancestors 
				do: [ :each | 
					self renderFilename: each name
						of: (self project versionAt: each name, '.mcz')
						on: html]
				separatedBy: [html text: ', ']]]].! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 16:59'!
renderAuthorOn: html
	html tableRow: [
		html tableData
			class: 'label';
			with: 'Author:'.
		html tableData: [
			html anchor
				callback: [ self call: self version author view ];
				with: self version authorString ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'topa 3/14/2011 18:40'!
renderBlessingInfoOn: html
	| blessed |
	
	((self repository blessingsEnabled) and: [self project canBless]) ifFalse: [^ self].
	
	blessed := self project blessedVersionForPackage: self version package.
	blessed ifNotNil: [
		blessed = self version
			ifTrue: [ html strong: 'This is the currently blessed version for package ', blessed package printString ]
			ifFalse: [ html string: 'The currently blessed version of package ', blessed package printString, ' is ', blessed fileName ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'topa 3/14/2011 18:29'!
renderButtonsOn: html
	html break.
	html form: [
		html div: [
			(self project isMember: self session user allowedTo: SSAccessPolicy admin)
				ifTrue: [
					self version isRelease 
						ifFalse: [
							html submitButton
								callback: [ self releaseCreate ];
								text: 'Create Release' ]
						ifTrue: [
							html submitButton
								callback: [ self releaseRemove ];
								text: 'Remove Release' ].
					html space.
					html submitButton
						callback: [self releaseCreateSqueakMap];
						text: 'SqueakMap Release'].
			
			(self repository blessingsEnabled and: 
			[self project isMember: self session user allowedTo: SSAccessPolicy bless])
				ifTrue: [
					html space.
					(self project isVersionBlessed: self version)
						ifFalse: [
							html submitButton
								callback: [ self bless ];
								text: 'Bless' ]
						ifTrue: [
							html submitButton
								callback: [ self unbless ];
								text: 'Remove Blessing' ] ] ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'topa 3/31/2011 08:08'!
renderChangesOn: html
	| url |
	(url := self version changesUrl: self project)
		ifNotNil: [
			html tableRow: [
				html tableData
					class: 'mediumLabel';
					with: 'Changeset:'.
				html tableData: [
					html anchor url: url; with: (url copyAfterLast: $/)]]].! !

!SSVersionView methodsFor: 'rendering' stamp: 'topa 3/31/2011 08:13'!
renderContentOn: html
	html heading: self version title , (self version isRelease
		ifTrue: [ ' (Release)' ]
		ifFalse: [ String new ]).
	html table
		cellspacing: 0;
		cellpadding: 0;
		with: [
			self renderFilenameOn: html.
			self renderAuthorOn: html.
			self renderTimestampOn: html.
			self renderUUIDOn: html.	
			self
				renderPackageList: self version ancestors 
				label: 'Ancestors:' on: html.
			self
				renderPackageList: self version dependencies 
				label: 'Dependencies:' on: html.
			self renderReleaseOn: html.
			self renderMessageOn: html.
			self renderDiffOn: html.
			self renderChangesOn: html.
			self renderStatisticsOn: html ].
	self renderButtonsOn: html.
	self renderBlessingInfoOn: html.! !

!SSVersionView methodsFor: 'rendering' stamp: 'topa 3/31/2011 08:09'!
renderDiffOn: html
	| url |
	url := self version diffUrl: self project.
	html tableRow: [
		html tableData
			class: 'mediumLabel';
			with: 'Diff:'.
		html tableData: [
			html anchor url: url; with: (url copyAfterLast: $/)]].! !

!SSVersionView methodsFor: 'rendering' stamp: 'topa 3/31/2011 08:04'!
renderFilenameOn: html
	html tableRow: [
		html tableData
			class: 'mediumLabel';
			with: 'File:'.
		html tableData: [
			html anchor
				url: (self version url: self project);
				with: self version fileName ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:04'!
renderMessageOn: html
	html tableRow: [
		html tableData
			class: 'label';
			with: 'Message:'.
		html tableData: [
			html withLineBreaks: self version message ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'topa 3/31/2011 08:04'!
renderPackageList: aCollection label: aString on: html
	aCollection isEmpty 
		ifTrue: [ ^self ]. 
	html tableRow: [
		html tableData
			class: 'label';
			with: aString.
		html tableData: [
			aCollection 
				do: [ :each |
					self renderFilename: each name
						of: ( self project versionAt: each name, '.mcz' )
						on: html ]
				separatedBy: [ html text: ', ' ] ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:05'!
renderReleaseOn: html
	self version isRelease ifTrue: [
		html tableRow: [
			html tableData
				class: 'label';
				with: 'Release:'.
			html tableData: 'This is a release that can be read by anybody.' ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'dkh 05/23/2011 14:15'!
renderStatisticsOn: html
	html tableRow: [
		html tableData
			class: 'label';
			with:  'Downloads:'.
		html tableData: [
			self version downloadStatistics isEmpty
				ifTrue: [ html text: '0' ]
				ifFalse: [
					self version downloadStatistics associationsDo: [ :assoc |
						html text: assoc key greaseString, ': '.
						html text: assoc value value.
						html break ] ] ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:07'!
renderTimestampOn: html
	html tableRow: [
		html tableData
			class: 'label';
			with: 'Timestamp:'.
		html tableData: self version timestamp ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:07'!
renderUUIDOn: html
	html tableRow: [
		html tableData
			class: 'label';
			with: 'UUID:'.
		html tableData: self version id ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'avi 9/23/2004 15:49'!
unbless
	self project unblessVersion: self version! !

!SSVersionView methodsFor: 'accessing' stamp: 'lr 2/4/2004 17:30'!
version
	^self model second! !

!SSVersionView methodsFor: 'accessing' stamp: 'topa 12/20/2010 11:13'!
writableProjectsForUser

	^(self repository visibleProjectsTo: self user select: [ :each |
		self project ~= each
			and: [ each isMember: self user allowedTo: SSAccessPolicy write ] ])
				asSortedCollection: [ :x :y | x name <= y name ]! !

SSComponent subclass: #SSFilteringComponent
	instanceVariableNames: 'report searchText announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSFilteringComponent class methodsFor: 'instance creation' stamp: 'pmm 9/8/2007 19:18'!
model: anObject announcer: anAnnouncer searchTerm: aString
	^(self model: anObject)
		setAnnouncer: anAnnouncer;
		searchText: aString;
		resetReport;
		yourself! !

!SSFilteringComponent methodsFor: 'private' stamp: 'topa 12/20/2010 08:26'!
addColumnsToReport
	report addColumn: (MAColumn new
		accessor: #fileName;
		label: 'Filename';
		renderer: [ :each :html | 
			html anchor
				callback: [ self callOnParent: (SSVersionView project: self model version: each) ];
				with: each fileName ];
		yourself).
	report addColumn: (MAColumn new
		accessor: #author;
		label: 'Author';
		renderer: [ :each :html |
			| author |
			author := each author.
			author 
				ifNil: [ html text: 'unknown' ]
				ifNotNil: [ 
					html anchor
						callback: [ self callOnParent: author view ];
						with: author name ] ];
		yourself).
	report addColumn: (MAColumn new
		accessor: #timestamp;
		label: 'Timestamp';
		renderer: [ :each :html |
			| timestamp |
			timestamp := each timestamp.
			html render: (timestamp date yyyymmdd , ' ' , timestamp time print24) ];
		sorter: [ :a :b | a timestamp > b timestamp ];
		yourself).
	report addColumn: (MAColumn new
		accessor: #yourself ;
		label: 'Actions';
		renderer: [ :each :html | 
			html anchor
				callback: [ self callOnParent: (SSVersionView project: self model version: each) ];
				with: 'details'.
			html space.
			html anchor
				url: (each url: self model);
				with: 'download' ];
		sorter: nil;
		yourself)! !

!SSFilteringComponent methodsFor: 'accessing' stamp: 'pmm 9/8/2007 18:43'!
announcer
	^announcer! !

!SSFilteringComponent methodsFor: 'private' stamp: 'pmm 9/18/2007 19:55'!
buildReport
	report := MAReport new
		rowPeriod: 1;
		batchSize: self repository batchSize;
		yourself.
	self addColumnsToReport! !

!SSFilteringComponent methodsFor: 'actions' stamp: 'pmm 10/8/2007 06:58'!
callOnParent: aComponent
	| announcement |
	announcement := SSProjectViewCallAnnoucement component: aComponent.
	self announcer announce: announcement! !

!SSFilteringComponent methodsFor: 'accessing' stamp: 'pmm 9/8/2007 08:45'!
children
	^Array with: report! !

!SSFilteringComponent methodsFor: 'private' stamp: 'obi 3/15/2011 21:10'!
filter: someVersions
	searchText isEmptyOrNil ifTrue: [
		^someVersions].
	^(searchText includes: $*)
		ifTrue: [
			someVersions select: [ :each |
				each stringsSatisfy: [:aBlock | aBlock value:  [ :str |
					str notNil and: [ searchText match: str ] ] ] ] ]
		ifFalse: [
			someVersions select: [ :each |
				each stringsSatisfy: [:aBlock | aBlock value:  [ :str |
					str notNil and: [ str includesSubstring: searchText
						caseSensitive: false ] ] ] ] ]! !

!SSFilteringComponent methodsFor: 'initialize-release' stamp: 'pmm 9/8/2007 19:42'!
initialize
	super initialize.
	self buildReport! !

!SSFilteringComponent methodsFor: 'rendering' stamp: 'pmm 11/27/2007 19:03'!
renderSearchOn: html
	html form
		defaultAction: [ self search ];
		with: [
			html div: [
				html textInput
					on: #searchText of: self.
				html space.
				html submitButton
					callback: [ self search ];
					text: 'Search' ] ]! !

!SSFilteringComponent methodsFor: 'private' stamp: 'pmm 9/8/2007 19:20'!
resetReport
	report rows: (self filter: self rows)! !

!SSFilteringComponent methodsFor: 'private' stamp: 'pmm 9/8/2007 08:44'!
rows
	self subclassResponsibility! !

!SSFilteringComponent methodsFor: 'actions' stamp: 'pmm 9/8/2007 18:45'!
search
	| announcement |
	announcement := SSSearchAnnoucement searchText: self searchText.
	self announcer announce: announcement! !

!SSFilteringComponent methodsFor: 'actions' stamp: 'pmm 9/8/2007 19:20'!
search: anAnnoucement
	searchText := anAnnoucement searchText.
	self resetReport! !

!SSFilteringComponent methodsFor: 'accessing' stamp: 'pmm 9/8/2007 08:51'!
searchText
	^searchText! !

!SSFilteringComponent methodsFor: 'accessing' stamp: 'pmm 9/8/2007 08:51'!
searchText: aString
	searchText := aString! !

!SSFilteringComponent methodsFor: 'initialize-release' stamp: 'pmm 9/8/2007 18:46'!
setAnnouncer: anAnnouncer
	announcer := anAnnouncer.
	announcer on: SSSearchAnnoucement send: #search: to: self! !

SSFilteringComponent subclass: #SSProjectBlessedVersions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSProjectBlessedVersions methodsFor: 'private' stamp: 'jgf 7/24/2009 11:33'!
addColumnsToReport
	report addColumn: (MAColumn new
		accessor: #package;
		label: 'Package';
		yourself).
	super addColumnsToReport! !

!SSProjectBlessedVersions methodsFor: 'rendering' stamp: 'pmm 9/8/2007 08:55'!
renderContentOn: html
	html break.
	self renderSearchOn: html.
	html break.
	report rows isEmpty
		ifFalse: [ html render: report ]
		ifTrue: [ html emphasis: (String streamContents: [:stream |
			stream nextPutAll: 'No '.
			searchText isEmptyOrNil ifFalse: [
				stream nextPutAll: 'matching ' ].
			self session isValidUser ifFalse: [
				stream nextPutAll: 'public ' ].
			stream nextPutAll: 'blessed versions available'])]! !

!SSProjectBlessedVersions methodsFor: 'private' stamp: 'topa 12/20/2010 08:43'!
rows

	^ self model allBlessedVersions
		select: [ :each |
			each notNil
				and: [
					self model 
						isMember: self user 
						allowedTo: SSAccessPolicy read
						for: each ] ]! !

SSFilteringComponent subclass: #SSProjectLatestVersions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSProjectLatestVersions methodsFor: 'rendering' stamp: 'pmm 9/8/2007 18:27'!
renderContentOn: html
	html break.
	self renderSearchOn: html.
	html break.
	report rows isEmpty
		ifFalse: [ html render: report ]
		ifTrue: [
			html emphasis: (String streamContents: [:stream |
				stream nextPutAll: 'No '.
				searchText isEmptyOrNil ifFalse: [
					stream nextPutAll: 'matching ' ].
				self session isValidUser ifFalse: [
					stream nextPutAll: 'public ' ].
				stream nextPutAll: 'versions available'])]! !

!SSProjectLatestVersions methodsFor: 'private' stamp: 'topa 12/20/2010 08:44'!
rows

	^ self model latestVersions select: [:each |
		self model 
			isMember: self user 
			allowedTo: SSAccessPolicy read
			for: each]! !

SSFilteringComponent subclass: #SSProjectReleases
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSProjectReleases methodsFor: 'rendering' stamp: 'pmm 9/8/2007 08:52'!
renderContentOn: html
	html break.
	self renderSearchOn: html.
	html break.
	report rows isEmpty
		ifFalse: [ html render: report ]
		ifTrue: [ html emphasis: 'No ',
			(searchText isEmptyOrNil
				ifTrue: [ '' ]
				ifFalse: [ 'matching ' ]),
			'releases available' ]! !

!SSProjectReleases methodsFor: 'private' stamp: 'pmm 9/8/2007 18:54'!
rows
	^self model releasesSorted! !

SSFilteringComponent subclass: #SSProjectVersions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSProjectVersions methodsFor: 'rendering' stamp: 'pmm 9/8/2007 18:25'!
renderContentOn: html
	html break.
	self renderSearchOn: html.
	html break.
	report rows isEmpty
		ifFalse: [ html render: report ]
		ifTrue: [
			html emphasis: (String streamContents: [ :stream |
				stream nextPutAll: 'No '.
				searchText isEmptyOrNil ifFalse: [
					stream nextPutAll: 'matching ' ].
				self session isValidUser ifFalse: [
					stream nextPutAll: 'public ' ].
				stream nextPutAll: 'versions available']) ]! !

!SSProjectVersions methodsFor: 'private' stamp: 'topa 12/20/2010 08:44'!
rows

	^ self model versionsSorted select: [ :each |
		each isRelease not and: [
			self model 
				isMember: self user 
				allowedTo: SSAccessPolicy read
				for: each ] ]! !

SSComponent subclass: #SSGenericFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

SSGenericFrame subclass: #SSFrame
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSFrame class methodsFor: 'testing' stamp: 'pmm 8/29/2007 10:28'!
canBeRoot
	^true! !

!SSFrame class methodsFor: 'registration' stamp: 'jgf 12/21/2008 09:43'!
description

	^SSRepository current title.! !

!SSFrame class methodsFor: 'registration' stamp: 'topa 5/3/2011 16:31'!
registerAsApplication: aString

	^ (WAAdmin 
		register: self
		asApplicationAt: aString)
			preferenceAt: #sessionClass put: SSSession;
			addLibrary: SSFileLibrary;
			addFilter: SSUrlFilter new;
			yourself! !

!SSFrame methodsFor: 'accessing' stamp: 'topa 2/25/2011 11:10'!
actions

	| controller |
	controller := self component activeComponent.
	^Array streamContents: [:stream |
		stream nextPutAll: super actions.
		(controller respondsTo: #actions)
			ifTrue: [stream nextPutAll: controller actions]]! !

!SSFrame methodsFor: 'actions' stamp: 'topa 2/25/2011 11:15'!
back

	<actionNamed: #back priority: 1 condition: #notHome>
	| parent |
	component delegations isEmpty ifTrue: [ ^self ].
	parent := component.
	[ parent := parent delegations first delegate ]
		doWhileFalse: [ parent delegations isEmpty ].
	parent answer: nil! !

!SSFrame methodsFor: 'private' stamp: 'pmm 8/29/2007 14:03'!
call: aComponent
	^self component
		home;
		call: aComponent! !

!SSFrame methodsFor: 'accessing' stamp: 'pmm 8/30/2007 09:17'!
children
	^Array with: component! !

!SSFrame methodsFor: 'accessing' stamp: 'pmm 8/29/2007 13:36'!
component
	^component activeComponent! !

!SSFrame methodsFor: 'actions' stamp: 'topa 2/25/2011 11:12'!
feedUrl

	<linkNamed: 'RSS Feed' priority: 10 condition: #isHome>
	
	^ super feedUrl! !

!SSFrame methodsFor: 'configuration' stamp: 'bf 5/24/2005 15:20'!
groupsClass
	^SSGroups! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 3/15/2004 18:31'!
helpClass
	^SSHelp! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 1/26/2004 17:07'!
homeClass
	^SSHome! !

!SSFrame methodsFor: 'configuration' stamp: 'pmm 3/15/2006 21:58'!
homeClasses
	^Array streamContents: [ :stream |
		stream
			nextPut: self homeClass;
			nextPut: self projectsClass;
			nextPut: self tagsClass;
			nextPut: self membersClass;
			nextPut: self groupsClass;
			nextPut: self helpClass;
			nextPut: self loginClass ]! !

!SSFrame methodsFor: 'initialization' stamp: 'pmm 8/26/2007 11:08'!
initialize
	super initialize.
	component := self homeClass 
		model: self model! !

!SSFrame methodsFor: 'initialization' stamp: 'DaleHenrichs 07/10/2010 12:30'!
initialRequest: aRequest
	| accessPath |
	super initialRequest: aRequest.
	accessPath := self session relativePathFor: aRequest.
	accessPath isEmpty 
		ifFalse: [ | project |
		project := self session projectNamed: (accessPath first copyUpToLast: $.).
		project ~~ nil
			ifTrue: [ | view |
				view := project view.
				accessPath size >= 2
					ifTrue: [ view selectTab: (accessPath at: 2) ].
				^self setComponent: view ].
		accessPath first = 'Projects'
			ifTrue: [ ^self setComponent: (self projectsClass model: self model) ].
		accessPath first = 'Tags'
			ifTrue: [ ^self setComponent: (self tagsClass model: self model) ].
		accessPath first = 'Members'
			ifTrue: [ ^self setComponent: (self membersClass model: self model) ].
		accessPath first = 'Groups'
			ifTrue: [ ^self setComponent: (self groupsClass model: self model) ].
		accessPath first = 'Help'
			ifTrue: [ ^self setComponent: (self helpClass model: self model) ].
 ].! !

!SSFrame methodsFor: 'testing' stamp: 'lr 3/15/2004 18:34'!
isHome
	^self homeClasses includes: self component class! !

!SSFrame methodsFor: 'actions' stamp: 'bf 5/25/2005 11:32'!
login
	self call: (self loginClass model: self model).
	self component resetModel.! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 3/15/2004 18:09'!
loginClass
	^SSLogin! !

!SSFrame methodsFor: 'actions' stamp: 'bf 5/25/2005 11:32'!
logout
	self session logout.
	self component resetModel.! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 3/15/2004 18:28'!
membersClass
	^SSMembers! !

!SSFrame methodsFor: 'accessing' stamp: 'topa 1/4/2011 20:13'!
model

	^ self repository! !

!SSFrame methodsFor: 'testing' stamp: 'topa 2/25/2011 11:09'!
notHome

	^ self isHome not! !

!SSFrame methodsFor: 'private' stamp: 'topa 2/25/2011 11:31'!
performAction: aSymbol

	(self component respondsTo: aSymbol)
		ifTrue: [self component perform: aSymbol]
		ifFalse: [self perform: aSymbol].! !

!SSFrame methodsFor: 'private' stamp: 'pmm 8/27/2007 11:01'!
projectNamed: aString

	^self projectNamed: aString ifNotAllowed: [ nil ]! !

!SSFrame methodsFor: 'private' stamp: 'pmm 6/27/2010 17:41'!
projectNamed: aString ifNotAllowed: aBlock
	| project |
	project := self repository projectAt: aString ifAbsent: [ ^nil ].
	^(self repository isVisible: project to: self user)
			ifTrue: [ project ]
			ifFalse: [ aBlock value: project ]! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 3/15/2004 18:28'!
projectsClass
	^SSProjects! !

!SSFrame methodsFor: 'rendering' stamp: 'topa 2/25/2011 11:31'!
renderActionDescription: description on: html
	" Print the description as text, if its not a symbol.
	If a symbol,  send a message that renders the description symbol onto html.
	E.g., #back -> renderDescriptionBackOn: html"
	
	description isSymbol
		ifFalse: [html text: description]
		ifTrue: [ | descriptionGetter |
			descriptionGetter := ('renderDescription', description capitalized, 'On:') asSymbol.
			(self respondsTo: descriptionGetter)
				ifTrue: [self perform: descriptionGetter with: html]
				ifFalse: [html text: description]]! !

!SSFrame methodsFor: 'rendering' stamp: 'topa 2/25/2011 11:19'!
renderActionsOn: html
	self renderMenu: 'Actions' do: [
		self actions pairsDo: [:description :selector |
			self renderMenuItem: [
				selector isSymbol 
					ifTrue: [ html anchor
							callback: [self performAction: selector ];
							with: [self renderActionDescription: description on: html]]
					ifFalse: [ html anchor
							url: selector;
							with: [self renderActionDescription: description on: html]]]
				 on: html]
		] on: html! !

!SSFrame methodsFor: 'rendering' stamp: 'obi 9/4/2009 21:11'!
renderAuthenticationOn: html
	self session isValidUser 
		ifTrue: [
			self renderMenu: self user do: [
				self
					renderMenuItem: [
						html anchor
							callback: [ self logout ];
							with: 'Logout' ]
					on: html.
				self 
					renderMenuItem: [
						html anchor
							callback: [ self editMember ];
							with: 'Edit Account' ] 
					on: html.
				self renderMenu: 'My Projects' do: [
					self user projects asSortedCollection do: [ :each |
						self 
							renderMenuItem: [
								html anchor
									callback: [ self showProject: each ];
									with: each title ] 
							on: html ]  ] on: html.
				self renderMenu: 'Favorites' do: [
					self user favorites asSortedCollection do: [ :each |
						self 
							renderMenuItem: [
								html anchor
									callback: [ self showProject: each ];
									with: each title ] 
							on: html ]  ] on: html  ] on: html ]
		ifFalse: [
			self renderMenu: 'Authentication' do: [
				self 
					renderMenuItem: [
						html anchor
							callback: [ self login ];
							with: 'Login' ] 
					on: html ] on: html ]! !

!SSFrame methodsFor: 'rendering' stamp: 'topa 6/21/2010 11:56'!
renderContentsOn: html
	html div: [html render: component.]! !

!SSFrame methodsFor: 'rendering' stamp: 'topa 2/25/2011 11:26'!
renderDescriptionBackOn: html

	html html:  '&larr; Back'.! !

!SSFrame methodsFor: 'rendering' stamp: 'topa 2/25/2011 11:32'!
renderHeadingOn: html

	html title: self model title.
	html text: self model title.! !

!SSFrame methodsFor: 'rendering' stamp: 'topa 2/25/2011 11:32'!
renderNavigationOn: html

	self renderActionsOn: html.
	self renderAuthenticationOn: html.! !

!SSFrame methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:29'!
renderToolbarOn: html
	html anchor
		callback: [ self showHome ];
		with: 'Home'.
	html anchor
		callback: [ self showProjects ];
		with: 'Projects'.
	html anchor
		callback: [ self showTags ];
		with: 'Tags'.
	html anchor
		callback: [ self showMembers ];
		with: 'Members'.
	html anchor
		callback: [ self showGroups ];
		with: 'Groups'.
	html anchor
		callback: [ self showHelp ];
		with: 'Help'.! !

!SSFrame methodsFor: 'rendering' stamp: 'topa 4/4/2011 13:42'!
renderTopOn: html
	self isValidUser
		ifFalse: [ 
			html anchor
				callback: [self login];
				with: 'Not logged in']
		ifTrue: [
			html anchor
				callback: [self editMember];
				with: self user asString.
			html space; html: '&#x2022;'; space.
			html anchor
				callback: [self logout];
				with: 'Logout'].
	html space.! !

!SSFrame methodsFor: 'initialization' stamp: 'pmm 8/26/2007 17:25'!
setComponent: aComponent
	component := aComponent! !

!SSFrame methodsFor: 'actions' stamp: 'bf 5/24/2005 15:19'!
showGroups
	self call: (self groupsClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 18:30'!
showHelp
	self call: (self helpClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 18:30'!
showHome
	self call: (self homeClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 18:29'!
showMembers
	self call: (self membersClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'bf 5/24/2005 18:12'!
showProject: aProject
	self call: aProject view! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 18:29'!
showProjects
	self call: (self projectsClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'pmm 3/15/2006 21:59'!
showTags
	self call: (self tagsClass model: self model)! !

!SSFrame methodsFor: 'rendering' stamp: ''!
style ^ ''! !

!SSFrame methodsFor: 'configuration' stamp: 'pmm 3/15/2006 22:00'!
tagsClass
	^SSTags! !

!SSFrame methodsFor: 'rendering' stamp: 'topa 10/15/2010 15:47'!
updateRoot: html
	super updateRoot: html.
	"google sitemaps verification"
	self model googleWebmasterAccount
		isEmptyOrNil ifFalse: [
			html meta
				name: 'verify-v1';
				content: self model googleWebmasterAccount].
	html title: self model title! !

!SSGenericFrame methodsFor: 'accessing' stamp: 'topa 2/25/2011 11:40'!
feedUrl
	
	^ self application url
		addToPath: 'feed.rss';
		yourself! !

!SSGenericFrame methodsFor: 'accessing' stamp: 'topa 2/25/2011 11:41'!
feedValidationUrl

	^ WAUrl new
		host: 'validator.w3.org';
		addToPath: 'feed/check.cgi';
		addField: 'url' value: self feedUrl;
		yourself! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'topa 4/4/2011 13:36'!
renderAnalyticsOn: html
	| account |
	account := self repository googleAnalyticsAccount.
	account isEmptyOrNil ifFalse: [
		html script url: 'http://www.google-analytics.com/urchin.js'.
		html script: '_uacct = "', account, '"; urchinTracker();'].! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'topa 10/25/2010 16:47'!
renderBottomOn: html

	html div
		style: 'width: 100%';
		with: [
			html span
				style: 'float: left';
				with: [
					html anchor url: 'http://validator.w3.org/check/referer'; with: 'XHTML'.
					html text: ' | '.
					html anchor url: 'http://jigsaw.w3.org/css-validator/check/referer'; with: 'CSS'.
					html text: ' | '.
					html anchor url: self feedValidationUrl; with: 'RSS' ].
			html span style: 'float: right'; with: Date today].
			html break style: 'clear: both'.! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'topa 5/3/2011 16:42'!
renderContainerOn: html

	html div
		id: 'top';
		with: [ self renderTopOn: html ].
	html div
		id: 'sstoolbar';
		with: [ self renderToolbarOn: html ].
	html div
		id: 'page';
		with: [ self renderPageOn: html ].
"	html div
		id: 'bottom';
		with: [ self renderBottomOn: html ]"! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'topa 10/25/2010 16:47'!
renderContentOn: html

	html div
		id: 'container';
		with: [ self renderContainerOn: html ].
	self renderAnalyticsOn: html! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/12/2004 22:46'!
renderContentsOn: html! !

!SSGenericFrame methodsFor: 'rendering-tools' stamp: 'pmm 8/26/2007 11:50'!
renderMenu: aString do: aBlock on: html
	html div
		class: 'title';
		with: aString.
	html div
		class: 'list';
		with: aBlock! !

!SSGenericFrame methodsFor: 'rendering-tools' stamp: 'pmm 8/26/2007 11:50'!
renderMenuItem: aBlock on: html
	html div
		class: 'item';
		with: aBlock! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/12/2004 22:46'!
renderNavigationOn: html! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'topa 5/3/2011 12:50'!
renderPageOn: html

	html div
		id: 'contents';
		with: [ self renderContentsOn: html ].
	html div
		id: 'navigation';
		with: [ self renderNavigationOn: html ].! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/12/2004 22:45'!
renderToolbarOn: html! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/15/2004 15:02'!
renderTopOn: html! !

!SSGenericFrame methodsFor: 'updating' stamp: 'topa 5/10/2011 12:00'!
updateRoot: html

	| repository |
	super updateRoot: html.
	repository := self repository.
	html link beAlternate; beRss; title: repository title; url: self feedUrl.
	html link beShortcutIcon; 
		type: repository faviconMimeType;
		url: (repository rootUrl, repository faviconFilename).! !

SSComponent subclass: #SSGroups
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSGroups methodsFor: 'accessing' stamp: 'pmm 8/25/2007 15:45'!
children
	^Array with: report! !

!SSGroups methodsFor: 'actions' stamp: 'bf 5/24/2005 15:21'!
registerGroup
	super registerGroup.
	self resetModel.! !

!SSGroups methodsFor: 'rendering' stamp: 'pmm 7/10/2005 10:49'!
renderContentOn: html
	html heading: 'Groups'.
	self renderGroupsOn: html.! !

!SSGroups methodsFor: 'rendering' stamp: 'obi 9/5/2009 17:05'!
renderGroupsOn: html
	self report rows isEmpty
		ifFalse: [ html render: self report ]
		ifTrue: [
			html emphasis: 'No groups available' ]! !

!SSGroups methodsFor: 'accessing' stamp: 'bf 12/15/2005 23:53'!
report
	^report! !

!SSGroups methodsFor: 'accessing' stamp: 'topa 10/21/2010 17:45'!
setModel: aModel
	| sort |
	super setModel: aModel.
	report := MAReport new
		rowPeriod: 1;
		batchSize: self repository batchSize;
		rows: aModel groups;
		addColumn: (sort := (MAColumn new
				accessor: #fullname ;
				label: 'Name';
				renderer: [ :each :html | 
					html anchor
						callback: [ self call: each view ];
						with: each fullname ];
				sorter: [ :a :b |
					a fullname caseInsensitiveLessOrEqual: b fullname ];
				yourself));
		addColumn: (MAColumn new
				accessor: #id;
				label: 'id';
				yourself);
		addColumn: (MAColumn new
				accessor: #members;
				label: 'Members';
				renderer: [ :item :html | 
					item members
						do: [ :each | html anchor
							callback: [ self call: each view ];
							with: each login ]
						separatedBy: [ html text: ', ' ] ];
				sorter: nil;
				yourself);
		sortColumn: sort;
		yourself.! !

!SSGroups methodsFor: 'updating' stamp: 'topa 4/4/2011 13:34'!
updateUrl: anUrl
	super updateUrl: anUrl.
	anUrl addToPath: 'Groups'! !

SSComponent subclass: #SSGroupView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSGroupView methodsFor: 'actions' stamp: 'topa 2/25/2011 11:46'!
edit
	<actionNamed: 'Edit group' priority: 30 access: #admin>

	| component |
	component := self model asComponent
		addTitle: 'Edit Group'; 
		addValidatedForm;
		yourself.
	(self call: component)
		ifNotNil: [ self session save ]! !

!SSGroupView methodsFor: 'private' stamp: 'topa 3/14/2011 09:52'!
isMember: aMember allowedTo: anAccessSymbol

	" only admins can modify groups "
	^ (anAccessSymbol = #admin) 
		ifTrue: [aMember isSuperUser]
		ifFalse: [super isMember: aMember allowedTo: anAccessSymbol]! !

!SSGroupView methodsFor: 'rendering' stamp: 'bf 5/24/2005 16:27'!
renderContentOn: html
	self renderTitleOn: html.
	self renderTableOn: html.! !

!SSGroupView methodsFor: 'rendering' stamp: 'pmm 8/25/2007 15:38'!
renderList: aCollection label: aString on: html
	aCollection isEmpty ifFalse: [
		html tableRow: [
			html tableData: aString.
			html tableData: [
				aCollection
					do: [ :each | 
						html anchor
							callback: [ self call: each view ];
							with: each fullname ]
					separatedBy: [ html text: ', ' ] ] ] ].! !

!SSGroupView methodsFor: 'rendering' stamp: 'jgf 7/24/2009 11:23'!
renderTableOn: html
	html table
		cellspacing: 0;
		cellpadding: 0;
		with: [
			self renderList: self model members label: 'Members:' on: html ]! !

!SSGroupView methodsFor: 'rendering' stamp: 'bf 5/24/2005 16:26'!
renderTitleOn: html
	html heading: self model fullname , ' (' , self model id , ')'! !

SSComponent subclass: #SSHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSHelp methodsFor: 'rendering' stamp: 'pmm 8/25/2007 15:50'!
renderContentOn: html
	self renderHeadingOn: html.
	self renderWhatIsOn: html.
	self renderHowToSqueakOn: html.
	self renderHowToProjectOn: html.! !

!SSHelp methodsFor: 'rendering' stamp: 'pmm 8/25/2007 15:50'!
renderHeadingOn: html
	html heading: 'Help'! !

!SSHelp methodsFor: 'rendering' stamp: 'topa 5/19/2011 20:45'!
renderHowToProjectOn: html
	self flag: #smell; flag: #needsWork.
	html heading level2; with: 'How to create a project?'.
	self repository allowRegisterProject
		ifTrue: [
			html paragraph: [
				html text: 'To create a new project you need to have a SqueakSource account ('.
				html anchor
					callback: [ self registerMember ];
					with: 'Register member'.
				html text: ') and you need to be logged-in ('.
				html anchor
					callback: [ self loginMember ];
					with: 'Login'.
				html text: '). Then you are able to create any number of new projects ('.
				html anchor
					callback: [ self registerProject ];
					with: 'Register Project'.
				html text: '), by filling-in the project form. '.
				html text: 'You will find some additional information concerning this step at the top of the project-registration dialog.' ]]
		ifFalse: [
			html paragraph: [
				html text: 'On this server, only the  '.
				html anchor
					url: 'mailto:', self repository superUserEmail first address;
					with: 'administrator'.
				html text: ' can create new projects ('.
				html anchor
					callback: [ self registerProject ];
					with: 'Register Project'.
				html text: ').' ] ].
	html paragraph: [
		html text: 'The newly created project is now shown in the list with all the projects you are involved in below your name on the left. The following tabs are available in the project-view:' ].
	html unorderedList: [
		html listItem: 'Overview: Project''s description, members, registration template and some statistics. Use the registration template to create a new repository in your monticello client.'.
		html listItem: [ 
			html text: 'Wiki: Each project has its own wiki that can be modified by developers and admins. The syntax is similar to the one of SmallWiki:'.
			html unorderedList: [
				html 
					listItem: 'Paragraph: A carriage return becomes a new paragraph.';
					listItem: [html text: 'Headers: A line starting with one or more '; code: '!!'; text: ' becomes a header.'];
					listItem: [html text: 'Horizontal Rule: A line starting with '; code: '_'; text: ' becomes a horizotal rule.'];
					listItem: [html text: 'Lists: A block of lines starting with '; code: '#'; text: ' or '; code: '-'; text:' becomes a ordered-/unordered list.'];
					listItem: [html text: 'Preformatted: A block of lines starting with '; code: '='; text: ' becomes preformatted.'];
					listItem: [html text: 'Links: Text beteween stars becomes an internal (e.g. '; code: '*My Page*'; text: ') or an external reference (e.g. '; code: '*http://www.google.com*'; text: ').'];
					listItem: 'XHTML: Use any valid XHTML tags withing your code.' ] ].
		html listItem: 'RSS-Feed: Administrators are able to add custom messages to the project-feed by clicking on ''Add Message''. They will show up on this tab-panel and in the rss-feed of the project.'.
		html listItem: 'Releases: Releases are committed versions that have been released. They are public and readable by everybody. To remove a release select ''details->Remove Release''. Releases do show up automatically in the rss-feed of the project.'.
		html listItem: 'Versions: This list shows all commits that have not been tagged as releases. To create a release or create a SqueakMap release, click on ''details/release''. This view shows details about the versions and let you make a release or browse the code in your web-browser.' ]! !

!SSHelp methodsFor: 'rendering' stamp: 'jgf 7/22/2009 10:38'!
renderHowToSqueakOn: html
	html heading level2; with: 'How to use SqueakSource?'.
	html paragraph: [
		html text: 'To use SqueakSource you have to create a project, what is described below, and to install the '.
		html anchor
			url: 'http://wiki.squeak.org/squeak/1287';
			with: 'Monticello'.
		html text: ' client into your Squeak image:' ].
	html orderedList: [
		html listItem: 'Open the ''Package Loader'' from the world-menu.'.
		html listItem: 'Load the most recent versions of ''MCInstaller'' and ''Monticello''.'.
		html listItem: 'Open the ''Monticello Browser'' from the world-menu.'.
		html listItem: 'Click ''+Repository'' and choose ''HTTP'' to add the SqueakSource repository to the ''Monticello Browser''.'.
		html listItem: 'Copy and paste the registration-string from the overview-tab of your project into the dialog and add your password manually.'.
		html listItem: 'Now you should be able to open and save versions of your project into that repository.' ]! !

!SSHelp methodsFor: 'rendering' stamp: 'jgf 7/22/2009 10:38'!
renderWhatIsOn: html
	html heading level2; with: 'What is SqueakSource?'. 
	html paragraph: 'SqueakSource is a monticello code repository server which hosts your projects. You  connect to it with the monticello client to commit and load code. SqueakSource also implements a web-frontend (which you are looking at) which makes it easy to create and admin your projects or browse other public projects.'.
	html paragraph: 'The creator of a project assigns the global access-policy and which people are administrators, developers and guests. Further-on the committed versions of your code can be marked as releases to be public accessible. Other feature are to automatically register a release on SqueakMap or browse the code with your web-browser using a similar interface like the code-browser of squeak. RSS-Feeds of all SqueakSource projects and of single projects are available: They show all public versions and releases plus additional items created by the project admin.'.! !

!SSHelp methodsFor: 'updating' stamp: 'topa 4/4/2011 13:34'!
updateUrl: anUrl
	super updateUrl: anUrl.
	anUrl addToPath: 'Help'! !

SSComponent subclass: #SSHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSHome methodsFor: 'rendering' stamp: 'topa 3/14/2011 09:13'!
renderContentOn: html
	self renderTitleOn: html.
	self renderIntroductionOn: html.

	"non-modular statistics addon"
	(self respondsTo: #renderStatisticsOn:)
		ifTrue: [self renderStatisticsOn: html].

	self session isSuperUser ifTrue: [
		self renderLogOn: html ]! !

!SSHome methodsFor: 'rendering' stamp: 'jgf 12/21/2008 10:07'!
renderIntroductionOn: html
	self repository introText withBlanksTrimmed isEmpty ifFalse: [
		^(self repository introText findTokens: String cr) do: [ :paragraph | 
			html paragraph: [
				html html: paragraph ] ] ].

	html paragraph: [
		html text: 'Welcome to SqueakSource, the smart Monticello code-repository for Squeak. To get started register your personal account and create any number of projects to host on our server. You''ll immediately get all the necessary permissions to create and manage your account, projects and versions. Detailed instructions can be found on the '.
		html anchor
			callback: [ self call: (SSHelp model: self model) ];
			with: 'Help'.
		html text: ' page.' ].
	
	html paragraph: [
		html text: 'Please report any problems or suggestions to the '.
		html anchor
			url: 'mailto:', 'squeak-dev@lists.squeakfoundation.org';
			with: 'Squeak Mailing-List'.
		html text: '. Enjoy!!' ]! !

!SSHome methodsFor: 'rendering' stamp: 'pmm 6/27/2010 17:05'!
renderLogOn: html
	| log |
	log := self session storage getLogOfSize: 2000.
	log ifNil: [^self].

	html heading level2; with: 'Log'.
	html text: '(showing last 2 KB, up to 100 KB '.
	html anchor
		callback: [
			self requestContext respond: [:response | 
				response
					contentType: WAMimeType textPlain;
					nextPutAll: (self session storage getLogOfSize: 100000) ] ];
		with: 'here'.
	html text: ')'.
	html preformatted: log.! !

!SSHome methodsFor: 'rendering' stamp: 'lr 3/15/2004 19:28'!
renderTitleOn: html
	html heading: 'Home'.! !

SSComponent subclass: #SSLogin
	instanceVariableNames: 'username password loginFailed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSLogin methodsFor: 'actions' stamp: 'lr 3/15/2004 18:04'!
cancel
	self answer! !

!SSLogin methodsFor: 'initialize-release' stamp: 'pmm 3/1/2006 23:16'!
initialize
	super initialize.
	loginFailed := false.! !

!SSLogin methodsFor: 'actions' stamp: 'topa 12/20/2010 09:09'!
login
	self session login: (self model
		authenticateUser: self username
		password: self password).
	self session isValidUser
		ifTrue: [self answer]
		ifFalse: [loginFailed := true]! !

!SSLogin methodsFor: 'accessing' stamp: 'pmm 3/1/2006 23:09'!
loginFailed
	^loginFailed! !

!SSLogin methodsFor: 'accessing' stamp: 'lr 3/15/2004 17:57'!
password
	^password! !

!SSLogin methodsFor: 'accessing' stamp: 'pmm 8/25/2007 16:18'!
password: aString
	password := aString! !

!SSLogin methodsFor: 'rendering' stamp: 'al 3/29/2004 22:10'!
renderContentOn: html
	self renderTitleOn: html.
	self renderFormOn: html.
	self renderForgottonpasswordOn: html! !

!SSLogin methodsFor: 'rendering' stamp: 'pmm 8/25/2007 16:20'!
renderForgottonpasswordLinkOn: html
	html anchor
		callback: [ self sendPassword ];
		with: 'I forgot my password'! !

!SSLogin methodsFor: 'rendering' stamp: 'pmm 8/25/2007 16:21'!
renderForgottonpasswordOn: html
	html break.
	self loginFailed
		ifTrue: [ html strong: [
			self renderForgottonpasswordLinkOn: html ] ]
		ifFalse: [ self renderForgottonpasswordLinkOn: html ]! !

!SSLogin methodsFor: 'rendering' stamp: 'topa 10/21/2010 17:36'!
renderFormOn: html
	html form
		defaultAction: [ self login ];
		with: [
			html div: [
				html table
					cellspacing: 0;
					cellpadding: 0;
					with: [
						html tableRow: [
							html tableData
								class: 'smallLabel';
								with: 'Login: '.
							html tableData: [
								html textInput
									on: #username of: self ] ].
						html tableRow: [
							html tableData: 'Password:'.
							html tableData: [
								html passwordInput
									on: #password of: self ] ] ].
				html break.
				html submitButton
					callback: [ self login ];
					text: 'Login'.
				html space.
				html submitButton
					callback: [ self cancel ];
					text: 'Cancel' ] ]! !

!SSLogin methodsFor: 'rendering' stamp: 'lr 3/15/2004 17:59'!
renderTitleOn: html
	html heading: 'Login'.! !

!SSLogin methodsFor: 'actions' stamp: 'al 3/29/2004 22:07'!
sendPassword
	self call: (SSSendPassword model: self model)! !

!SSLogin methodsFor: 'accessing' stamp: 'lr 3/15/2004 17:57'!
username
	^username! !

!SSLogin methodsFor: 'accessing' stamp: 'pmm 8/25/2007 16:34'!
username: aString
	username := aString! !

SSComponent subclass: #SSMemberView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSMemberView methodsFor: 'actions' stamp: 'topa 3/14/2011 09:55'!
edit
	<actionNamed: 'Edit Account' priority: 30 access: #self>
	
	(self call: self editMember)
		ifNotNil: [self session save]! !

!SSMemberView methodsFor: 'private' stamp: 'topa 3/14/2011 09:51'!
isMember: aMember allowedTo: anAccessSymbol

	" only admins or the same member can modify a member "
	^ (anAccessSymbol = #self) 
		ifTrue: [aMember = self model or: [aMember isSuperUser]]
		ifFalse: [super isMember: aMember allowedTo: anAccessSymbol]! !

!SSMemberView methodsFor: 'rendering' stamp: 'lr 3/15/2004 20:03'!
renderContentOn: html
	self renderTitleOn: html.
	self renderDescriptionOn: html.
	self renderTableOn: html.! !

!SSMemberView methodsFor: 'rendering' stamp: 'topa 12/20/2010 08:26'!
renderDescriptionOn: html

	self model description ifNotNil: [
		self
			withLineBreaks: self model information
			on: html].! !

!SSMemberView methodsFor: 'rendering' stamp: 'pmm 9/5/2007 19:46'!
renderEmailOn: html
	self model email isEmptyOrNil ifFalse: [
		html tableRow: [
			html tableData
				class: 'mediumLabel';
				with: 'E-Mail:'.
		 	html tableData: [ 
				html anchor
					url: 'mailto:', self model email;
					with: self model email ] ] ]! !

!SSMemberView methodsFor: 'rendering' stamp: 'pmm 8/25/2007 16:38'!
renderList: aCollection label: aString on: html
	aCollection isEmpty ifFalse: [
		html tableRow: [
			html tableData
				class: 'mediumLabel';
				with: aString.
			html tableData: [
				aCollection
					do: [ :each | 
						html anchor
							callback: [ self call: each view ];
							with: each title ]
					separatedBy: [ html text: ', ' ] ] ] ].! !

!SSMemberView methodsFor: 'rendering' stamp: 'jgf 7/24/2009 11:23'!
renderTableOn: html
	html table
		cellspacing: 0;
		cellpadding: 0;
		with: [
			self renderEmailOn: html.
			self renderList: self model adminInProjects label: 'Admin:' on: html.
			self renderList: self model developerInProjects label: 'Developer:' on: html.
			self renderList: self model guestInProjects label: 'Guest:' on: html.
			self renderList: self model groups label: 'Groups:' on: html ]! !

!SSMemberView methodsFor: 'rendering' stamp: 'topa 10/21/2010 17:42'!
renderTitleOn: html
	html heading: self model fullname , ' (' , self model login , ')'! !

!SSMemberView methodsFor: 'rendering' stamp: 'pmm 10/9/2007 07:08'!
withLineBreaks: aString on: html
	| stream |
	stream := aString readStream.
	[ stream atEnd ] whileFalse: [
		html html: stream nextLine.
		stream atEnd ifFalse: [ html break ] ]! !

SSComponent subclass: #SSOverview
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSOverview methodsFor: 'accessing' stamp: 'pmm 10/9/2007 06:42'!
announcer
	^announcer! !

!SSOverview methodsFor: 'accessing' stamp: 'pmm 10/9/2007 06:42'!
announcer: anObject
	announcer := anObject! !

!SSOverview methodsFor: 'actions' stamp: 'pmm 10/9/2007 06:42'!
callOnParent: aComponent
	| announcement |
	announcement := SSProjectViewCallAnnoucement component: aComponent.
	self announcer announce: announcement! !

!SSOverview methodsFor: 'actions' stamp: 'pmm 10/9/2007 07:11'!
displayProjectsWithTag: aTag
	self callOnParent: (SSProjectsWithTag model: aTag)! !

!SSOverview methodsFor: 'rendering' stamp: 'topa 10/27/2010 16:19'!
renderCodeTabContentWith: aBlock on: html
	
	"see renderCodeTabHeaderWith:on:"
	html document nextPutAll: '<!!--[if lte IE 6]><table><tr><td><!![endif]-->'.
	html unorderedList: [
		html listItem: aBlock].
	html document nextPutAll: '<!!--[if lte IE 6]></td></tr></table></a><!![endif]-->'.! !

!SSOverview methodsFor: 'rendering' stamp: 'topa 10/27/2010 16:19'!
renderCodeTabHeaderWith: aBlock on: html

	html anchor: [
		aBlock value.
		"html revealedIf greaterThan; ie7; do: [
			html text: '<!!-->']]"
		"Canvas does not know about conditional comments"
		html document nextPutAll: '<!!--[if gte IE 7]><!!-->'].
	html document nextPutAll: '<!!--<!![endif]-->'.! !

!SSOverview methodsFor: 'rendering' stamp: 'topa 4/4/2011 13:36'!
renderCodeTabWith: aBlock on: html

	html listItem: aBlock! !

!SSOverview methodsFor: 'rendering' stamp: 'topa 10/27/2010 08:48'!
renderContentOn: html

	self 
		renderDescriptionOn: html;
		renderMembersOn: html;
		renderTagsOn: html;
		renderLicencseOn: html;
		renderMeansOfAccessOn: html;
		renderLinksOn: html;
		renderPermissionsOn: html.! !

!SSOverview methodsFor: 'rendering' stamp: 'topa 10/27/2010 08:18'!
renderDescriptionOn: html
	html heading level2; with: 'Project Description'.
	html paragraph: self model information! !

!SSOverview methodsFor: 'rendering' stamp: 'topa 10/27/2010 16:20'!
renderGoferOn: html

	self 
		renderCodeTabHeaderWith: [html text: 'Gofer'] on: html;
		renderCodeTabContentWith: [
			html preformatted: [
				html text: 'Gofer new'; break.
				html text: '    repository: '; text: self model fullDirectoryUrl printString; text: ';'; break.
				(self versions collect: [ :each | each packageName ]) asSet asSortedCollection
					do: [ :each | html text: '    package: '; text: each printString; text: ';'; break ].
				html text: '    load'; break ]]
		on: html.! !

!SSOverview methodsFor: 'rendering' stamp: 'topa 10/27/2010 16:21'!
renderInstallerOn: html

	self 
		renderCodeTabHeaderWith: [html text: 'Installer'] on: html;
		renderCodeTabContentWith: [
			html preformatted: [
				html text: '(Installer url: '; text: self repository rootUrl printString; text: ')'; break.
				html text: '    project: '; text: self model id printString; text: ';'; break.
				(self versions collect: [ :each | each packageName ]) asSet asSortedCollection
					do: [ :each | html text: '    install: '; text: each printString]
					separatedBy: [html text: ';'; break]]]
		on: html! !

!SSOverview methodsFor: 'rendering' stamp: 'topa 12/20/2010 08:28'!
renderLicencseOn: html

	| license |
	license := self model license.
	(license isNil or: [license first isNil])
		ifTrue: [^self].
	
	html heading level2; with: 'License'.
	html text: 'Code commited to this repository will be automatically under '.
	html anchor
		url: license second;
		with: license first.
	html text: ' license.'! !

!SSOverview methodsFor: 'rendering' stamp: 'pmm 9/9/2007 12:48'!
renderLinksOn: html
	html heading level2; with: 'Links'.
	html anchor
		title: 'static project url';
		url: self model fullHomepageUrl;
		with: self model fullHomepageUrl.
	html break.
	html anchor
		title: 'static listing url';
		url: self model fullDirectoryUrl;
		with: self model fullDirectoryUrl! !

!SSOverview methodsFor: 'rendering' stamp: 'pmm 10/9/2007 06:42'!
renderList: aCollection label: aString on: html
	aCollection isEmpty ifFalse: [
		html tableRow: [
			html tableData
				class: 'largeLabel';
				with: aString.
			html tableData: [
				aCollection
					do: [ :each |
						html anchor
							callback: [ self callOnParent: each view ];
							with: each fullname ]
					separatedBy: [ html text: ', ' ] ] ] ]! !

!SSOverview methodsFor: 'rendering' stamp: 'obi 3/15/2011 08:37'!
renderMeansOfAccessOn: html
	
	html heading level2; with: 'Getting the Code'.
	html div class: 'codetab'; with: [
		html unorderedList: [
			self 
				renderCodeTabWith: [self renderRegistrationOn: html] on: html;
				renderCodeTabWith: [self renderGoferOn: html] on: html;
				renderCodeTabWith: [self renderInstallerOn: html] on: html]].
	html div style: 'clear:both'.! !

!SSOverview methodsFor: 'rendering' stamp: 'jgf 7/24/2009 11:23'!
renderMembersOn: html
	html heading level2; with: 'Members'.
	html table
		cellspacing: 0;
		cellpadding: 0;
		with: [
			self renderList: self model creators label: 'Creator:' on: html.
			self renderList: self model admins label: 'Admin:' on: html.
			self renderList: self model developers label: 'Developer:' on: html.
			self renderList: self model guests label: 'Guests:' on: html ]! !

!SSOverview methodsFor: 'rendering' stamp: 'topa 10/27/2010 08:48'!
renderPermissionsOn: html
	html heading level2; with: 'Permissions'.
	html table
		cellspacing: 0;
		cellpadding: 0;
		with: [
			html tableRow: [
				html tableData
					class: 'largeLabel';
					with: 'Global:'.
				html tableData: self model accessPolicy globalRight asCapitalizedPhrase ] ]! !

!SSOverview methodsFor: 'rendering' stamp: 'topa 10/27/2010 16:21'!
renderRegistrationOn: html
	
	self 
		renderCodeTabHeaderWith: [html text: 'Monticello Registration'] on: html;
		renderCodeTabContentWith: [
			html preformatted: [
				html text: 'MCHttpRepository'; break.
				html text: '    location: '; text: self model fullDirectoryUrl printString; break.
				html text: '    user: '; text: (self session isValidUser
					ifTrue: [ self session user login ]
					ifFalse: [ String new ]) printString; break.
				html text: '    password: '; text: String new printString; break ]]
		on: html.! !

!SSOverview methodsFor: 'rendering' stamp: 'topa 4/4/2011 13:43'!
renderTagsOn: html
	html heading level2; with: 'Tags'.
	self model hasTags
		ifFalse: [ html text: 'This project doesn''t yet have tags.' ]
		ifTrue: [ 
			self model tags
				do: [ :each |
					html anchor
						callback: [ self displayProjectsWithTag: each ];
						with: each name ]
				separatedBy: [ html text: ', ' ] ]! !

!SSOverview methodsFor: 'actions' stamp: 'dkh 01/04/2010 16:18'!
resetReport! !

!SSOverview methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:43'!
versions

	^ self model versionsSorted select: [:each |
		each isRelease not and: [
			self model 
				isMember: self session user 
				allowedTo: SSAccessPolicy read
				for: each]]! !

SSComponent subclass: #SSProjectRSS
	instanceVariableNames: 'batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSProjectRSS methodsFor: 'accessing' stamp: 'pmm 8/25/2007 16:48'!
children
	^Array with: batchedList! !

!SSProjectRSS methodsFor: 'rendering' stamp: 'pmm 9/8/2007 08:59'!
renderContentOn: html
	html break.
	batchedList batch isEmpty
		ifTrue: [ html emphasis: 'No feed available' ]
		ifFalse: [ self renderFeedListingOn: html ]! !

!SSProjectRSS methodsFor: 'rendering' stamp: 'jgf 7/24/2009 11:23'!
renderFeedListingOn: html
	html table
		cellspacing: 0;
		cellpadding: 0;
		with: [ 
			batchedList batch do: [ :each |
				html tableRow
					class: 'TabUnselected';
					with: [
						html tableData
							class: 'left';
							with: [
								html strong: each title ].
						html tableData
							align: 'right';
							with: [
								html render: each author.
								html text: ', '.
								html render: each timestamp ] ].
				html tableRow: [
					html tableData
						colSpan: 3;
						with: [ html withLineBreaks: each message ] ].
				html tableRow: [
					html tableData
						colSpan: 3;
						with: [ html space ] ] ] ].
	batchedList maxPages > 1 ifTrue: [ 
		html render: batchedList ]! !

!SSProjectRSS methodsFor: 'actions' stamp: 'dkh 01/04/2010 16:16'!
resetReport! !

!SSProjectRSS methodsFor: 'initialization' stamp: 'pmm 8/25/2007 16:47'!
setModel: aModel
	super setModel: aModel.
	batchedList := SSBatchedList new
		batchSize: 10;
		items: self sortedItems;
		yourself! !

!SSProjectRSS methodsFor: 'accessing' stamp: 'obi 8/31/2009 21:58'!
sortedItems
	^(SortedCollection sortBlock: [:a :b | a timestamp > b timestamp])
		addAll: model feeds;
		addAll: model versions;
		yourself! !

SSComponent subclass: #SSProjectView
	instanceVariableNames: 'tabPanel searchText announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSProjectView methodsFor: 'actions' stamp: 'topa 3/14/2011 15:46'!
addMessage
	<actionNamed: 'Add Message' priority: 20 access: #admin>

	| entry component |
	entry := SSFeedEntry new
		author: self session user;
		title: self model title;
		message: String new;
		yourself.
		
	component := entry asComponent
		addTitle: 'Add Message'; 
		addValidatedForm;
		yourself.
	entry := self call: component.
	entry ifNotNil: [
		self model feeds add: entry.
		self resetModel.
		self session save ].! !

!SSProjectView methodsFor: 'actions' stamp: 'topa 10/22/2010 21:53'!
addToFavorites
	<actionNamed: 'Add to favorites' priority: 100 condition: #isNotInFavorites>

	self user addFavorite: self model.
	self saveSession.! !

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 9/8/2007 19:01'!
announcer
	^announcer! !

!SSProjectView methodsFor: 'accessing' stamp: 'topa 10/26/2010 19:20'!
announcer: anObject
	"Set the value of announcer"

	announcer := anObject! !

!SSProjectView methodsFor: 'actions' stamp: 'pmm 9/8/2007 20:09'!
callFromTabContent: anAnnoucement
	self call: anAnnoucement component! !

!SSProjectView methodsFor: 'testing' stamp: 'topa 10/27/2010 08:57'!
canCleanup

	^ (self model isMember: self session user allowedTo: SSAccessPolicy move)
			and: [self project parentProject notNil and: [self project defaultMoveTarget notNil]]! !

!SSProjectView methodsFor: 'accessing' stamp: 'topa 10/27/2010 08:54'!
children

	^ Array with: self tabPanel! !

!SSProjectView methodsFor: 'actions' stamp: 'topa 10/27/2010 08:58'!
cleanup
	<actionNamed:  'Cleanup Versions' priority: 65 condition: #canCleanup>
	
	| parent target merged latestVersions latestInfos latestInfo ok |
	parent := self project parentProject ifNil: [^self].
	target := self project defaultMoveTarget ifNil: [^self].
	(self confirm: 'Looking for versions from ', self project title ,' that were merged into ', parent title, ' might take a while. To search, click yes once and wait.') ifFalse: [^self].
	latestVersions := Dictionary new.
	parent latestVersions do: [:pv |
		latestVersions at: pv packageName put: pv].
	latestInfos := Dictionary new.
	merged := Dictionary new.
	self project versions do: [:my |
		latestVersions at: my packageName ifPresent: [:latestVer |
			latestInfo := latestInfos at: my packageName
				ifAbsentPut: [(latestVer reader: parent) info].
			(latestInfo hasAncestor: my versionInfo alreadySeen: Set new)
				ifTrue: [
					(merged at: latestInfo name ifAbsentPut: [SortedCollection new])
						add: my]]].
	merged ifEmpty: [^self inform: 'No versions found in ', self project title, ' that were merged to ', parent title, '.'].

	ok := self confirm: (String streamContents: [:s |
		s nextPutAll: 'These versions are already merged into ', parent title, ':<ul>'.
		merged keysSortedSafely do: [:parentVersion |
			s nextPutAll: '<li>'.
			(merged at: parentVersion)
				do: [:myVersion | s nextPutAll: myVersion versionInfo name]
				separatedBy: [s nextPutAll: ', ']].
		s nextPutAll: '</ul><br>Okay to move these from ', self project title, ' to ', target title, '?'] ).
	
	ok ifTrue: [
		merged do: [ :versions |
			versions do: [:each |
				target 
					addVersion: (self repository storage
						loadMonticello: each
						from: self project)
					author: each author.
				self project deleteVersion: each ] ].
		self session save.
		self inform: 'Moved ', merged size asString, ' versions from ', self project title, ' to ', target title, '.'].

	self answer.! !

!SSProjectView methodsFor: 'actions' stamp: 'pmm 9/18/2007 21:49'!
confirmDelete: aConfiguration
	^ self call: (WAYesOrNoDialog new
		addDecoration: (SSConfirmConfigurationDeleteDecoration configuration: aConfiguration);
		yourself)! !

!SSProjectView methodsFor: 'actions' stamp: 'topa 10/22/2010 18:55'!
delete
	<actionNamed: 'Delete project' priority: 40 access: #admin>

	(self confirm: 'You are about to delete the project ''', self model title, '''.
	All data and version information will be lost!!
	Are you sure you really want to delete this project?') ifTrue: [
		self repository removeProject: self model.
		self saveSession.
		self answer: nil 
		"self session expire" ]! !

!SSProjectView methodsFor: 'actions' stamp: 'topa 10/22/2010 18:45'!
edit
	<actionNamed: 'Edit project' priority: 30 access: #admin>
	| component |
	component := self model asComponent
		addDecoration: SSExplanationDecoration new;
		addTitle: 'Edit Project'; 
		addValidatedForm;
		yourself.
	(self call: component)
		ifNotNil: [ self saveSession ].! !

!SSProjectView methodsFor: 'actions' stamp: 'topa 10/22/2010 18:55'!
editConfigs	
	<actionNamed: 'Edit configs' priority: 50 condition: #hasConfigs>
	[
		| cfgName configuration message |
		cfgName := self call: (SSSimpleObjectChooser 
			model: (self model sortedConfigs collect: [ :each | each fileName])
			heading: 'Choose config	').

		cfgName ifNil: [^self].

		configuration := self model configs at: cfgName ifAbsent: [ ^self ].
		(self confirmDelete: configuration) ifTrue: [
			self model configs
				removeKey: cfgName
				ifAbsent: [ self inform: 'Delete failed!!' ].
			self saveSession ] .
	] repeat! !

!SSProjectView methodsFor: 'tab components' stamp: 'topa 10/26/2010 12:02'!
feed

	<tabNamed: 'News' priority: 20 condition: #showAllTabs>

	^SSProjectRSS model: self model! !

!SSProjectView methodsFor: 'actions' stamp: 'topa 3/14/2011 15:43'!
feedUrl

	<linkNamed: 'Project Feed' priority: 10 condition: #always>
	
	^self application url
		addToPath: self model id;
		addToPath: 'feed.rss';
		yourself! !

!SSProjectView methodsFor: 'private' stamp: 'obi 3/15/2011 21:09'!
filter: someVersions

	self searchText isEmptyOrNil ifTrue: [^ someVersions].

	^(self searchText includes: $*)
		ifTrue: [
			someVersions select: [ :each |
				each stringsSatisfy: [:aBlock | aBlock value: [ :str |
					str notNil and: [ self searchText match: str ] ] ] ] ]
		ifFalse: [
			someVersions select: [ :each |
				each stringsSatisfy: [:aBlock | aBlock value:  [ :str |
					str notNil and: [ str includesSubstring: self searchText
						caseSensitive: false ] ] ] ] ].! !

!SSProjectView methodsFor: 'actions' stamp: 'topa 10/22/2010 19:07'!
graphBuilder

	"Disabled , still"
	"<actionNamed: 'Ancestory' > "
	"(self model isMember: self session user allowedTo: SSAccessPolicy read)
			ifTrue: [
				SSGraphBuilder formats , #(pdf) do: [ :each |
					stream nextPutAll: (Array
						with: 'Ancestory ', each asUppercase
						with: '/', self project id,'/'  ,SSGraphBuilder filename, '.', each) ] ]"! !

!SSProjectView methodsFor: 'testing' stamp: 'topa 10/22/2010 18:56'!
hasConfigs

	^ self model hasConfigs! !

!SSProjectView methodsFor: 'actions' stamp: 'topa 10/22/2010 18:57'!
import
	<actionNamed: 'Import versions' priority: 60 access: #write>

	self call: (SSVersionImporter model: self model).
	self saveSession! !

!SSProjectView methodsFor: 'initialize-release' stamp: 'topa 10/26/2010 19:21'!
initializeAnnouncer
	
	self announcer: Announcer new.
	self announcer on: SSProjectViewCallAnnoucement send: #callFromTabContent: to: self.! !

!SSProjectView methodsFor: 'initialize-release' stamp: 'topa 3/14/2011 15:45'!
initializeTabPanel
	self tabPanel: SSTabPanel new.
	
	self priorizedTabs sorted do: [:assoc |
		| name component |
		name := assoc value first.
		component := assoc value second.
		self tabPanel addTab: component named: name].

	self tabPanel selectFirst.! !

!SSProjectView methodsFor: 'private' stamp: 'pmm 9/8/2007 21:02'!
instantiate: aClass
	^aClass
		model: self model
		announcer: self announcer
		searchTerm: self searchText! !

!SSProjectView methodsFor: 'testing' stamp: 'topa 12/20/2010 08:45'!
isInFavorites

	^ self user notAnonymous and: [self user includesFavorite: self model]! !

!SSProjectView methodsFor: 'private' stamp: 'topa 10/25/2010 16:32'!
isMember: aMember allowedTo: aACLSymbol

	^ self project isMember: aMember allowedTo: aACLSymbol! !

!SSProjectView methodsFor: 'testing' stamp: 'topa 12/20/2010 08:46'!
isNotInFavorites
	"note: is _not_  the same as 'self isInFavorites not' with respect to users."
	
	^ self user notAnonymous and: [(self user includesFavorite: self model) not]! !

!SSProjectView methodsFor: 'tab components' stamp: 'topa 11/2/2010 10:29'!
priorizedTabs

	^ self priorizedTabsIn: self class! !

!SSProjectView methodsFor: 'tab components' stamp: 'topa 4/4/2011 15:59'!
priorizedTabsIn: aClass

	^ Array streamContents: [ :stream |
		(Pragma allNamed: #tabNamed:priority:condition: in: aClass) 
			do: [:pragma |
				(self perform: (pragma argumentAt: 3)) ifTrue: [
					stream 	nextPut: (pragma argumentAt: 2) ->  
						{ pragma argumentAt: 1. self perform: pragma selector}]]]! !

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 8/29/2006 07:09'!
project
	^self model! !

!SSProjectView methodsFor: 'tab components' stamp: 'topa 10/26/2010 12:01'!
projectBlessedVersions

	<tabNamed: 'Blessings' priority: 40 condition: #showBlessings>

	^ self instantiate: SSProjectBlessedVersions! !

!SSProjectView methodsFor: 'tab components' stamp: 'topa 10/26/2010 12:02'!
projectLatestVersions

	<tabNamed: 'Latest' priority: 60 condition: #showAllTabs>

	^ self instantiate: SSProjectLatestVersions! !

!SSProjectView methodsFor: 'tab components' stamp: 'topa 11/2/2010 10:28'!
projectOverview

	<tabNamed: 'Overview' priority: 0 condition: #always>

	^ (SSOverview model: self model)
		announcer: self announcer;
		yourself! !

!SSProjectView methodsFor: 'tab components' stamp: 'topa 10/26/2010 12:01'!
projectReleases

	<tabNamed: 'Releases' priority: 30 condition: #showReleases>

	^ self instantiate: SSProjectReleases! !

!SSProjectView methodsFor: 'tab components' stamp: 'topa 10/26/2010 12:02'!
projectStats

	<tabNamed: 'Statistics' priority: 70 condition: #showAllTabs>

	^ SSProjectStats model: self model! !

!SSProjectView methodsFor: 'tab components' stamp: 'topa 10/26/2010 12:01'!
projectVersions

	<tabNamed: 'Versions' priority: 50 condition: #showAllTabs>
	
	^ self instantiate: SSProjectVersions! !

!SSProjectView methodsFor: 'actions' stamp: 'topa 10/22/2010 21:54'!
removeFromFavorites
	<actionNamed: 'Remove from favorites' priority: 100 condition: #isInFavorites>

	self user removeFavorite: self model.
	self saveSession! !

!SSProjectView methodsFor: 'rendering' stamp: 'topa 10/26/2010 19:22'!
renderContentOn: html
	self renderTitleOn: html.
	html render: self tabPanel! !

!SSProjectView methodsFor: 'rendering' stamp: 'topa 5/3/2011 15:16'!
renderTitleOn: html

	html heading 
		level1; 
		with: [
			html anchor 
				url: html actionUrl;
				with: self model title].! !

!SSProjectView methodsFor: 'private' stamp: 'topa 10/26/2010 19:23'!
saveSession

	self session save.
	self tabPanel resetReports! !

!SSProjectView methodsFor: 'accessing' stamp: 'bf 12/19/2005 10:16'!
searchText
	^searchText! !

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 9/8/2007 21:02'!
searchText: aString
	| announcement |
	searchText := aString ifNotNil: [ aString withBlanksTrimmed ].
	announcement := SSSearchAnnoucement searchText: self searchText.
	self announcer announce: announcement! !

!SSProjectView methodsFor: 'updating' stamp: 'topa 10/26/2010 19:25'!
selectTab: aString

	self tabPanel select: aString! !

!SSProjectView methodsFor: 'initialize-release' stamp: 'pmm 9/8/2007 20:14'!
setModel: aModel
	super setModel: aModel.
	self initializeAnnouncer.
	self initializeTabPanel! !

!SSProjectView methodsFor: 'testing' stamp: 'topa 12/20/2010 08:46'!
showAllTabs

	^self project isMember: self user allowedTo: SSAccessPolicy read! !

!SSProjectView methodsFor: 'testing' stamp: 'topa 3/14/2011 18:26'!
showBlessings

	^ self repository blessingsEnabled 
	and: [self showAllTabs 
	and: [self model canBless]].! !

!SSProjectView methodsFor: 'testing' stamp: 'topa 10/26/2010 12:00'!
showReleases

	^ self showAllTabs and: [self model hasReleases]! !

!SSProjectView methodsFor: 'accessing' stamp: 'topa 10/26/2010 19:25'!
tabPanel
	"Answer the value of tabPanel"

	^ tabPanel! !

!SSProjectView methodsFor: 'accessing' stamp: 'topa 10/26/2010 19:20'!
tabPanel: anObject
	"Set the value of tabPanel"

	tabPanel := anObject! !

!SSProjectView methodsFor: 'updating' stamp: 'topa 10/26/2010 19:25'!
updateRoot: html

	super updateRoot: html.
	html link
		beAlternate; beRss; 
		title: self model title; 
		url: self feedUrl.! !

!SSProjectView methodsFor: 'updating' stamp: 'topa 4/4/2011 13:34'!
updateUrl: anUrl
	super updateUrl: anUrl.
	anUrl addToPath: self model relativeHomepageUrl! !

!SSProjectView methodsFor: 'tab components' stamp: 'topa 10/26/2010 12:02'!
wiki

	<tabNamed: 'Wiki' priority: 10 condition: #showAllTabs>

	^ SSWiki on: self model! !

SSComponent subclass: #SSRegisterSqueakMap
	instanceVariableNames: 'default form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSRegisterSqueakMap methodsFor: 'accessing' stamp: 'pmm 8/25/2007 17:57'!
children
	^Array with: form! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:53'!
package
	^default 
		propertyAt: SSVersion smPackageProperty
		ifAbsent: [ nil ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:56'!
package: aString
	self version 
		propertyAt: SSVersion smPackageProperty
		put: aString! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:53'!
password
	^default 
		propertyAt: SSVersion smPasswordProperty
		ifAbsent: [ nil ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:56'!
password: aString
	self version 
		propertyAt: SSVersion smPasswordProperty
		put: aString! !

!SSRegisterSqueakMap methodsFor: 'accessing' stamp: 'lr 2/11/2004 11:20'!
project
	^self model first! !

!SSRegisterSqueakMap methodsFor: 'rendering' stamp: 'lr 2/11/2004 11:21'!
renderContentOn: html
	html render: form! !

!SSRegisterSqueakMap methodsFor: 'rendering' stamp: 'pmm 9/1/2007 16:54'!
setModel: aModel
	super setModel: aModel.
	default := (self version propertyIncludes: SSVersion smPackageProperty)
		ifTrue: [ self version ]
		ifFalse: [
			self project versionsSorted
				detect: [ :each | 
					each packageName = self version packageName 
						and: [ each propertyIncludes: SSVersion smPackageProperty ] ]
				ifNone: [ SSVersion new ] ].
	form := SSMember new asRegisterComponent
		addTitle: 'SqueakMap Release for ' , self version fileName; 
		addValidatedForm;
		yourself.
	form onAnswer: [ :value | self answer: value ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:53'!
username
	^default 
		propertyAt: SSVersion smUsernameProperty
		ifAbsent: [ nil ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:56'!
username: aString
	self version 
		propertyAt: SSVersion smUsernameProperty
		put: aString! !

!SSRegisterSqueakMap methodsFor: 'accessing' stamp: 'lr 2/11/2004 11:20'!
version
	^self model second! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'al 3/3/2004 18:22'!
versionComment
	^default 
		propertyAt: SSVersion smVersionCommentProperty 
		ifAbsent: [ nil ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'al 3/3/2004 18:22'!
versionComment: aString
	self version 
		propertyAt: SSVersion smVersionCommentProperty
		put: aString! !

SSComponent subclass: #SSSearchableWithReport
	instanceVariableNames: 'report searchText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

SSSearchableWithReport subclass: #SSMembers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSMembers methodsFor: 'accessing' stamp: 'pmm 1/19/2006 10:12'!
all
	^self model members! !

!SSMembers methodsFor: 'accessing' stamp: 'pmm 1/19/2006 10:15'!
heading
	^'Members'! !

!SSMembers methodsFor: 'columns' stamp: 'topa 5/10/2011 08:39'!
loginColumn: aColumn

	<columnNamed: 'Login' priority: 20 >
	
	aColumn 
		accessor: #login.! !

!SSMembers methodsFor: 'columns' stamp: 'topa 5/10/2011 08:38'!
nameColumn: aColumn

	<columnNamed: 'Name' priority: 10 >
	<sortColumn>
	
	aColumn 
		accessor: #fullname;
		renderer: [ :each :html | 
			html anchor
				callback: [ self call: each view ];
				with: each fullname ];
		sorter: [ :a :b |
			a fullname caseInsensitiveLessOrEqual: b fullname ]! !

!SSMembers methodsFor: 'actions' stamp: 'lr 3/15/2004 18:27'!
registerMember
	super registerMember.
	self resetModel.! !

!SSMembers methodsFor: 'updating' stamp: 'topa 4/4/2011 13:34'!
updateUrl: anUrl
	super updateUrl: anUrl.
	anUrl addToPath: 'Members'! !

SSSearchableWithReport subclass: #SSProjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSProjects methodsFor: 'columns' stamp: 'topa 5/10/2011 09:06'!
adminsColumn: aColumn

	<columnNamed: 'Admins' priority: 20>
	
	aColumn accessor: #admins;
		renderer: (self renderMemberBlockFor: #admins);
		sorter: nil! !

!SSProjects methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:47'!
all

	^ self model visibleProjectsTo: self user! !

!SSProjects methodsFor: 'columns' stamp: 'topa 5/10/2011 09:06'!
developersColumn: aColumn

	<columnNamed: 'Developers' priority: 30>
	
	aColumn 
		accessor: #developers;
		renderer: (self renderMemberBlockFor: #developers);
		sorter: nil.! !

!SSProjects methodsFor: 'columns' stamp: 'topa 5/10/2011 09:07'!
guestsColumn: aColumn

	<columnNamed: 'Guests' priority: 40>
	
	aColumn 
		accessor: #guests;
		renderer: (self renderMemberBlockFor: #guests);
		sorter: nil.! !

!SSProjects methodsFor: 'accessing' stamp: 'pmm 1/19/2006 10:15'!
heading
	^'Projects'! !

!SSProjects methodsFor: 'columns' stamp: 'topa 5/10/2011 09:05'!
projectColumn: aColumn

	<columnNamed: 'Project' priority: 10>
	<sortColumn>
	
	aColumn renderer: [ :each :html |
		html anchor
			extraPath: each relativeHomepageUrl;
			callback: [ self call: (each view searchText: searchText) ];
			with: each title ]! !

!SSProjects methodsFor: 'actions' stamp: 'lr 3/15/2004 19:50'!
registerProject
	super registerProject.
	self resetModel.! !

!SSProjects methodsFor: 'initialization' stamp: 'topa 10/21/2010 17:43'!
renderMemberBlockFor: aSymbol
	^[ :item :html |
		(item perform: aSymbol)
			do: [ :each | html anchor
				callback: [ self call: each view ];
				with: each login ]
			separatedBy: [ html text: ', ' ] ]! !

!SSProjects methodsFor: 'updating' stamp: 'topa 4/4/2011 13:35'!
updateUrl: anUrl
	super updateUrl: anUrl.
	anUrl addToPath: 'Projects'! !

SSProjects subclass: #SSProjectsWithTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSProjectsWithTag methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:47'!
all
	
	^ self model projects! !

!SSProjectsWithTag methodsFor: 'accessing' stamp: 'pmm 2/5/2006 15:22'!
heading
	^self model name , ' Projects'! !

!SSSearchableWithReport methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:47'!
all

	self subclassResponsibility.! !

!SSSearchableWithReport methodsFor: 'accessing' stamp: 'pmm 8/25/2007 18:04'!
children
	^Array with: report! !

!SSSearchableWithReport methodsFor: 'accessing' stamp: 'pmm 8/25/2007 18:04'!
heading
	self subclassResponsibility! !

!SSSearchableWithReport methodsFor: 'columns' stamp: 'topa 5/10/2011 09:55'!
isSortColumn: aMethod

	aMethod pragmas detect: [:p | p keyword = #sortColumn] ifNone: [^ false].
	^ true! !

!SSSearchableWithReport methodsFor: 'columns' stamp: 'topa 5/10/2011 08:55'!
priorizedColumns

	^ self priorizedColumnsIn: self class! !

!SSSearchableWithReport methodsFor: 'columns' stamp: 'topa 5/10/2011 09:55'!
priorizedColumnsIn: aClass

	^ Array streamContents: [ :stream | 

		"look for columns in superclasses"
		(aClass name = #SSSearchableWithReport) 
			ifFalse: [stream nextPutAll: (self priorizedColumnsIn: aClass superclass)].

		(Pragma allNamed: #columnNamed:priority:  in: aClass) 
			do: [:pragma | | column |
				column := MAColumn new label: (pragma argumentAt: 1).
				self perform: pragma selector with: column.
				(self isSortColumn: pragma method)
					ifTrue: [column propertyAt: #isSortColumn put: true].
				stream nextPut: (pragma argumentAt: 2) -> column]].! !

!SSSearchableWithReport methodsFor: 'rendering' stamp: 'pmm 1/19/2006 10:14'!
renderContentOn: html
	html heading: self heading.
	self renderSearchOn: html.
	html render: report! !

!SSSearchableWithReport methodsFor: 'rendering' stamp: 'topa 5/10/2011 15:05'!
renderSearchOn: html
	html form
		defaultAction: [ self search ];
		with: [
			html div: [
				html searchInput
					on: #searchText of: self]].
	html break.! !

!SSSearchableWithReport methodsFor: 'actions' stamp: 'obi 3/15/2011 21:09'!
search
	| all found |
	all := self all.
	searchText isEmptyOrNil ifTrue: [
		^report rows: all].
	found := (searchText includes: $*)
		ifTrue: [
			all select: [ :each |
				each stringsSatisfy: [:aBlock | aBlock value:  [:str |
					str notNil and: [ searchText match: str ] ] ] ]]
		ifFalse: [
			all select: [ :each |
				each stringsSatisfy: [:aBlock | aBlock value: [:str |
					str notNil and: [ str includesSubstring: searchText
						caseSensitive: false ] ] ] ] ].
	report rows: found.! !

!SSSearchableWithReport methodsFor: 'accessing' stamp: 'pmm 1/19/2006 10:09'!
searchText
	^searchText! !

!SSSearchableWithReport methodsFor: 'accessing' stamp: 'pmm 1/19/2006 10:10'!
searchText: aString
	searchText := aString ifNotNil: [ aString withBlanksTrimmed ]! !

!SSSearchableWithReport methodsFor: 'initialize' stamp: 'topa 5/10/2011 08:42'!
setModel: aModel

	super setModel: aModel.
	self setupReport! !

!SSSearchableWithReport methodsFor: 'initialize' stamp: 'topa 5/10/2011 09:03'!
setupReport

	report := MAReport new
		rowPeriod: 1;
		batchSize: self repository batchSize;
		rows: self all.
	
	self priorizedColumns sorted do: [:assoc | |column|
		column := assoc value.
		report addColumn: column.
		((column hasProperty: #isSortColumn) and: [column propertyAt: #isSortColumn])
			ifTrue: [report sortColumn: column]]! !

SSComponent subclass: #SSSendPassword
	instanceVariableNames: 'login'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSSendPassword class methodsFor: 'as yet unclassified' stamp: 'dkh 05/18/2011 12:16'!
messageTemplate

	^ 'Hi {1},

We received a request (presumeably by you) that you forgot your password. To log into your account and to change your password please visit the link below:

  {2}
	
If you didn''t send this request, please forget about this mail. Your account information won''t be changed and you will be able to access your account with your old password.

-- 
{3}'! !

!SSSendPassword methodsFor: 'actions' stamp: 'topa 10/19/2010 07:42'!
cancel

	self answer: nil.! !

!SSSendPassword methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:48'!
initials

	self flag: #Compatibility.
	^ self login! !

!SSSendPassword methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:48'!
initials: aString

	self flag: #Compatibility.
	self login: aString.! !

!SSSendPassword methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:48'!
login

	^ login! !

!SSSendPassword methodsFor: 'accessing' stamp: 'topa 10/19/2010 07:48'!
login: aString

	login := aString.! !

!SSSendPassword methodsFor: 'rendering' stamp: 'dkh 05/18/2011 13:03'!
renderContentOn: html
	| url |
	url := html urlForAction: [ | member |
		member := self model memberAt: self login.
		self session login: member.
		self editMember: 'Change password'].
	html heading: 'I forgot my password'.
	html text: 'You will get an e-mail with a secure url that takes you to your personal member-settings where you are able to set a new password. The url will be available for a few minutes only, so check your e-mail soon.'.
	html break; break.
	html form
		defaultAction: [ self sendPasswordToUserWithLogin: self login url: url ];
		with: [
			html div: [
				html table
					cellspacing: 0;
					cellpadding: 0;
						with: [
						html tableRow: [
							html tableData
								class: 'smallLabel';
								with: 'Login:  '.
							html tableData: [
								html textInput
									size: 5;
									on: #login of: self ] ] ].
					html break.
					html submitButton
						callback: [ self sendPasswordToUserWithLogin: self login url: url ];
						text: 'Send'.
					html space.
					html submitButton
						callback: [ self cancel ];
						text: 'Cancel' ] ]! !

!SSSendPassword methodsFor: 'actions' stamp: 'topa 5/19/2011 20:42'!
sendMailWithUrl: aUrl toMember: aMember

	| messageText email message |
	messageText := self class messageTemplate 
		format: { aMember fullname .  aUrl . self repository rootUrl}.
	email := self repository superUserEmail first.
	message := WAEmailMessage
		from: email
		toAll: (Array with: aMember fullEmailAddress with: email)
		subject: self repository title ,' -- Forgot Password'.
	message setStringBody: messageText wrap: true.
	message send.! !

!SSSendPassword methodsFor: 'actions' stamp: 'dkh 05/18/2011 11:50'!
sendPasswordToUserWithLogin: aLogin url: url

	| member |
	member := self model memberAt: aLogin.
	member ifNil: [
		self informOnlyAdmin: 'You specified an unknown account. Please contact the administrator.'.
		self answer].
	member email ifNil: [
		self informOnlyAdmin: 'No e-mail address specified for this account. Please contact the administrator.'.
		self answer].
	member isSuperUser ifTrue: [
		self inform: 'Superusers shoud never forget their password.'.
		self answer].
	[ self sendMailWithUrl: 'http://', (self repository requestContext request headers at: 'host'), url greaseString toMember: member ]
		on: Error
		do: [ :error | ^self informOnlyAdmin: error messageText, '. Please contact the administrator.'; answer].
	self inform: 'An e-mail has been successfully sent to you.'.
	self answer! !

SSComponent subclass: #SSSimpleObjectChooser
	instanceVariableNames: 'heading selection info infoBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSSimpleObjectChooser class methodsFor: 'instance creation' stamp: 'lr 2/8/2004 12:03'!
model: aModel heading: aString
	^(self model: aModel)
		heading: aString;
		yourself! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'lr 2/8/2004 12:02'!
heading
	^heading! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'pmm 8/25/2007 18:15'!
heading: aString
	heading := aString! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'topa 3/14/2011 17:43'!
infoBlock

	^ infoBlock! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'topa 3/14/2011 17:43'!
infoBlock: anObject

	infoBlock := anObject! !

!SSSimpleObjectChooser methodsFor: 'rendering' stamp: 'topa 4/4/2011 13:36'!
renderContentOn: html
	html heading: self heading.
	self infoBlock ifNotNil: [:infoBlock | 
		html div: [
			infoBlock value: html]].
	html form: [
		html div: [
			html select
				size: 15;
				style: 'width: 100%';
				list: self model;
				on: #selection of: self.
			html break; break.
			html submitButton
				callback: [ self answer: self selection ];
				text: 'Ok'.
			html submitButton
				callback: [ self answer: nil ];
				text: 'Cancel' ] ]! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'lr 3/22/2004 19:05'!
selection
	^selection! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'pmm 8/25/2007 18:15'!
selection: anObject
	selection := anObject! !

SSComponent subclass: #SSTags
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSTags methodsFor: 'accessing' stamp: 'pmm 3/15/2006 21:48'!
all
	^self model tags! !

!SSTags methodsFor: 'testing' stamp: 'obi 8/31/2009 22:38'!
alreadyExists: aString
	self inform: 'A tag "', aString , '" already exists!!'! !

!SSTags methodsFor: 'testing' stamp: 'topa 12/20/2010 09:09'!
canCreateTag

	^ self session isValidUser
		and: [self repository allowCreateTag
			or: [self user isSuperUser]]! !

!SSTags methodsFor: 'accessing' stamp: 'pmm 8/25/2007 18:18'!
children
	^Array with: report! !

!SSTags methodsFor: 'actions' stamp: 'topa 3/14/2011 17:22'!
createTag

	<actionNamed: 'Create Tag' priority: 60 condition: #canCreateTag>
	| name newTags |
	name := ''.
	[ name isEmptyOrNil ] whileTrue: [
		name := self request: 'Name of the tag(s), use "," as separator: ' ].
	newTags :=  name findTokens: ','.
	newTags do: [:tag | 
		(self repository hasTagNamed: tag)
			ifFalse: [ 
				self repository createTagNamed: tag ] ].
	self session save.
	self resetModel.! !

!SSTags methodsFor: 'actions' stamp: 'obi 9/5/2009 09:19'!
deleteTag: aTag
	(self confirm: 'Do you really want to remove the tag `' , aTag name , '''?') == true
		ifTrue: [
			self repository deleteTag: aTag.
			self session save.
			self resetModel ]! !

!SSTags methodsFor: 'accessing' stamp: 'pmm 3/15/2006 21:48'!
heading
	^'Tags'! !

!SSTags methodsFor: 'actions' stamp: 'pmm 4/23/2007 00:54'!
renameTag: aTag
	| newName |
	newName := ''.
	[ newName isEmptyOrNil ] whileTrue: [
		newName := self request: 'New name of the tag: ' ].
	(self repository hasTagNamed: newName)
		ifTrue: [ self alreadyExists: newName ]
		ifFalse: [ 
			self repository renameTag: aTag to: newName.
			self session save.
			self resetModel ]! !

!SSTags methodsFor: 'rendering' stamp: 'pmm 1/24/2006 22:28'!
renderContentOn: html
	html heading: self heading.
	html render: report! !

!SSTags methodsFor: 'initialization' stamp: 'jgf 7/24/2009 11:33'!
setModel: aModel
	| sort tagActiviy maxActivity |
	super setModel: aModel.
	tagActiviy := aModel tagActiviy.
	maxActivity := tagActiviy sortedElements inject: 0 into: [ :result :assoc |
		result max: assoc value ].
	maxActivity = 0 ifTrue: [ maxActivity := 1 ].
	report := MAReport new
		rowPeriod: 1;
		batchSize: self repository batchSize;
		rows: self all;
		addColumn: (sort := MAColumn new
				accessor: #yourself;
				label: 'Name';
				renderer: [ :each :html | 
					html anchor
						callback: [ self displayProjectsWithTag: each ];
						with: each name ]
				yourself);
		addColumn: (MAColumn new
				accessor: #numberOfProjects;
				label: '#';
				sorter: [ :a : b | a numberOfProjects > b numberOfProjects ];
				yourself);
		addColumn: (MAColumn new
				accessor: #yourself;
				label: 'Projects';
				renderer: [ :each :html | 
					html table
						cellspacing: 0;
						cellpadding: 0;
						class: 'activityTable';
						with: [
							html tableRow: [
								html tableData
									style: 'background-color: ', (Color activity: (tagActiviy occurrencesOf: each) / maxActivity) asHTMLColor;
									with: [ html space; space; space ] ] ] ];
				sorter: [ :a : b | a maxActivity > b maxActivity ];
				yourself);
		yourself.
	self session isSuperUser ifTrue: [
		report addColumn: (MAColumn new 
			accessor: #yourself;
			label: 'Actions';
			renderer: [ :each :html | 
				html anchor
					callback: [ self renameTag: each ];
					with: 'rename'.
				html space.
				html anchor
					callback: [ self deleteTag: each ];
					with: 'delete' ];
			sorter: nil;
			yourself) ].

	report sortColumn: sort! !

!SSTags methodsFor: 'updating' stamp: 'topa 4/4/2011 13:35'!
updateUrl: anUrl
	super updateUrl: anUrl.
	anUrl addToPath: 'Tags'! !

SSComponent subclass: #SSVersionImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSVersionImporter methodsFor: 'rendering' stamp: 'lr 2/6/2004 16:51'!
renderContentOn: html
	self renderTitleOn: html.
	self renderUploadsOn: html.! !

!SSVersionImporter methodsFor: 'rendering' stamp: 'pmm 8/25/2007 18:22'!
renderTitleOn: html
	html heading: 'Import into ', self model title! !

!SSVersionImporter methodsFor: 'rendering' stamp: 'topa 6/19/2010 21:00'!
renderUpload: anInteger on: html
	html tableRow: [
		html tableData
			class: 'label';
			with: anInteger greaseString, ':'.
		html tableData: [
			html fileUpload
				callback: [ :file |
					(file notNil and: [ file rawContents notEmpty ])
						ifTrue: [ self uploadFile: file ] ] ] ]! !

!SSVersionImporter methodsFor: 'rendering' stamp: 'jgf 7/24/2009 11:23'!
renderUploadsOn: html
	html form
		multipart;
		with: [
			html div: [
				html table
					cellspacing: 0;
					cellpadding: 0;
					with: [
						1 to: 10 do: [ :each |
							self renderUpload: each on: html ] ].
				html break.
				html submitButton
					callback: [ self answer ];
					text: 'Upload' ] ]! !

!SSVersionImporter methodsFor: 'actions' stamp: 'dkh 05/17/2011 15:47'!
uploadFile: aFile
	
	[	| version |
	 	version := self model
			addVersion: aFile rawContents
			author: self session user.
		version setTimestampFromVersionInfo.
		self session save
	] on: Error do: [ :error |
		self inform: 'There was an error importing the file ', aFile fileName , '. The file has to be in mcz format!!' ]! !

SSComponent subclass: #SSWindow
	instanceVariableNames: 'title content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSWindow methodsFor: 'accessing' stamp: 'pmm 8/26/2007 10:27'!
children
	^Array with: content! !

!SSWindow methodsFor: 'accessing' stamp: 'pmm 8/26/2007 10:26'!
content: aComponent
	content := aComponent! !

!SSWindow methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:08'!
renderCloseButtonOn: html
	html anchor
		callback: [self answer];
		with: 'close'! !

!SSWindow methodsFor: 'rendering' stamp: 'pmm 8/26/2007 10:34'!
renderContentOn: html
	html table
		cellspacing: 0;
		with: [
			html tableRow
				id: 'window-titlebar';
				with: [
					html tableData
						id: 'window-title';
						with: title.
					html tableData
						id: 'window-close';
						with: [ self renderCloseButtonOn: html ] ].
			html tableRow
				id: 'window-content';
				with: [
					html tableData
						colSpan: 2;
						with: content ] ]! !

!SSWindow methodsFor: 'accessing' stamp: 'pmm 8/26/2007 10:28'!
title: aString
	title := aString! !

!SSWindow methodsFor: 'updating' stamp: 'pmm 10/8/2007 06:44'!
updateRoot: html
	super updateRoot: html.
	html title: title! !

!WAComponent methodsFor: '*SqueakSource-Core-View' stamp: 'pmm 9/2/2007 20:47'!
addTitle: aString
	self addDecoration: (SSHeadingDecoration message: aString)! !

!WAComponent methodsFor: '*SqueakSource-Core-View' stamp: 'bf 1/7/2006 13:18'!
resetModel! !

MAListCompositonComponent subclass: #SSListCompositionComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

!SSListCompositionComponent methodsFor: 'actions' stamp: 'topa 12/20/2010 08:26'!
add
	| added |
	self availableSelected ifNil: [^ self].
	
	added := (self availableSelected "copy"). 	"If it is a copy then it is not found in the available list!!"
	self add: added.
	self selectedSelected: added.
	self description isDistinct
		ifTrue: [ self availableSelected: nil ]! !

!SSListCompositionComponent methodsFor: 'rendering' stamp: 'pmm 9/17/2007 06:57'!
renderEditorOn: html
	html table
		id: self labelId;
			with: [
				html tableHead: [
					html tableRow: [
						html tableHeading: 'Available:'.
						html tableHeading: [ html space ].
						html tableHeading: 'Selected:'.
						html tableHeading: [ html space ] ] ].
				html tableRow: [
					html tableData: [
						self renderEditorAvailableOn: html ].
					html tableData
						align: 'center';
						with: [ self renderEditorButtonAddOn: html ].
					html tableData: [
						self renderEditorSelectedOn: html ].
					self isOrdered ifTrue: [
						html tableData
							align: 'center';
							with: [ self renderEditorButtonOrderOn: html ] ] ] ]! !

MAElementComponent subclass: #SSColorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

!SSColorComponent class methodsFor: 'testing' stamp: 'pmm 9/16/2007 21:45'!
isAbstract
	^ false! !

!SSColorComponent methodsFor: 'actions' stamp: 'topa 6/19/2010 18:30'!
boxStyle
	^String streamContents: [ :stream |
		stream
			nextPutAll: 'width: ';
			nextPutAll: self width greaseString;
			nextPutAll: 'px; ';
			nextPutAll: 'height: ';
			nextPutAll: self height greaseString;
			nextPutAll: 'px; ';
			nextPutAll: 'background-color: ';
			nextPutAll: self value asHTMLColor ]! !

!SSColorComponent methodsFor: 'testing' stamp: 'pmm 9/16/2007 21:56'!
hasLabelId
	^ self isReadonly not! !

!SSColorComponent methodsFor: 'accessing' stamp: 'pmm 9/16/2007 21:45'!
height
	^ 15! !

!SSColorComponent methodsFor: 'rendering' stamp: 'pmm 9/16/2007 21:54'!
renderBoxOn: html
	html div
		style: self boxStyle! !

!SSColorComponent methodsFor: 'rendering' stamp: 'pmm 9/16/2007 21:58'!
renderEditorOn: html
	self renderInputOn: html.
	self renderUpdateOn: html.
	self renderBoxOn: html! !

!SSColorComponent methodsFor: 'rendering' stamp: 'topa 6/19/2010 15:28'!
renderInputOn: html
	html textInput
		id: self labelId;
		on: #string of: self! !

!SSColorComponent methodsFor: 'rendering' stamp: 'pmm 9/16/2007 21:57'!
renderUpdateOn: html
	html submitButton
		text: 'Update'! !

!SSColorComponent methodsFor: 'rendering' stamp: 'pmm 9/16/2007 21:48'!
renderViewerOn: html
	self renderBoxOn: html! !

!SSColorComponent methodsFor: 'accessing' stamp: 'pmm 9/16/2007 21:45'!
value
	^ super value ifNil: [ self description kind transparent ]! !

!SSColorComponent methodsFor: 'accessing' stamp: 'pmm 9/16/2007 21:45'!
width
	^ 30! !

WASimpleNavigation subclass: #SSTabPanel
	instanceVariableNames: 'tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSTabPanel methodsFor: 'actions' stamp: 'obi 9/5/2009 18:41'!
addTab: aComponent named: aString
	components add: aString -> aComponent! !

!SSTabPanel methodsFor: 'rendering' stamp: 'topa 5/3/2011 15:28'!
renderContentOn: html
	"copied from WANavigation and a little bit tweaked"
	
	html div class: 'tabnav'; with: [
		html div
			class: 'navigation-options';
			with: [ self renderOptionsOn: html ].
		html div
			class: 'navigation-content';
			style: 'clear: none; line-height: 1.1';
			with: [ self renderSelectionOn: html ] ]! !

!SSTabPanel methodsFor: 'actions' stamp: 'dkh 01/04/2010 16:14'!
resetReports

	^ components do: [ :each | each value resetReport ]! !

!SSTabPanel methodsFor: 'actions' stamp: 'obi 9/5/2009 18:49'!
selectFirst
	components isEmpty ifFalse: [self select: components first key]! !

!SSTabPanel methodsFor: 'accessing' stamp: 'obi 9/5/2009 18:42'!
states
	^Array with: self selectedComponent! !

!SSTabPanel methodsFor: 'updating' stamp: 'topa 4/4/2011 13:35'!
updateUrl: anUrl

	| assoc |
	super updateUrl: anUrl.

	assoc := components detect: [ :each | each key = self selection ] ifNone: [ ^ self ].
	anUrl addToPath: assoc key! !

Error subclass: #SSVersionAlreadyExists
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Model'!

Announcement subclass: #SSCallAnnoucement
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Announcements'!

!SSCallAnnoucement class methodsFor: 'instance creation' stamp: 'pmm 9/8/2007 20:06'!
component: aComponent
	^self new
		component: aComponent;
		yourself! !

!SSCallAnnoucement methodsFor: 'accessing' stamp: 'pmm 9/8/2007 20:06'!
component
	^component! !

!SSCallAnnoucement methodsFor: 'accessing' stamp: 'pmm 9/8/2007 20:06'!
component: aComponent
	component := aComponent! !

SSCallAnnoucement subclass: #SSProjectViewCallAnnoucement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Announcements'!

SSCallAnnoucement subclass: #SSVersionViewCallAnnoucement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Announcements'!

Announcement subclass: #SSSearchAnnoucement
	instanceVariableNames: 'searchText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Announcements'!

!SSSearchAnnoucement class methodsFor: 'instance creation' stamp: 'pmm 9/8/2007 19:18'!
searchText: aString
	^self new
		searchText: aString;
		yourself! !

!SSSearchAnnoucement methodsFor: 'accessing' stamp: 'pmm 9/8/2007 19:18'!
searchText
	^searchText! !

!SSSearchAnnoucement methodsFor: 'accessing' stamp: 'pmm 9/8/2007 19:18'!
searchText: aString
	searchText := aString! !

WAEmailErrorHandler subclass: #SSEmailErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'topa 5/19/2011 20:32'!
bodyFor: anException
	
	^ WAStringEmailBody string: (String streamContents: [ :stream |
		self printDescriptionOf: anException on: stream.
		self printWalkbackOf: (self causingContextOf: anException) on: stream ])! !

!SSEmailErrorHandler methodsFor: 'private' stamp: 'pmm 10/4/2007 20:28'!
causingContextOf: anException
	| context |
	context := anException signalerContext. 
	[ context receiver isKindOf: Exception ]
		whileTrue: [ context := context sender ].
	^context! !

!SSEmailErrorHandler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2011 20:30'!
from
	^ WAEmailAddress 
		address: self repository superUserEmail first address
		username: self repository title! !

!SSEmailErrorHandler methodsFor: 'actions' stamp: 'topa 5/19/2011 20:37'!
handleDefault: anError

	| contents |

	contents := WARenderCanvas builder
		fullDocument: true;
		rootBlock: [ :root |
			root title: 'Internal Error' ];
		render: [ :html |
			html heading level1; with: 'Error'.
			html text: 'There has been an internal error. The system administrator has been notified.' ].
		
	self requestContext respond: [:response |
		response
			internalError;
			nextPutAll: contents]! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 10/4/2007 20:11'!
printDescriptionOf: anException on: aResponse
	aResponse nextPutAll: anException description; cr! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 8/26/2007 14:31'!
printFooterForStackFrame: aContext on: aStream
	aStream nextPutAll: '--------'! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 8/26/2007 14:31'!
printHeaderForStackFrame: aContext on: aStream
	aStream cr; nextPutAll: aContext fullPrintString	; cr! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 8/26/2007 14:31'!
printObject: anObject labelled: aString on: aStream
	aStream space; space; space; nextPutAll: aString.
	(20 - aString size) timesRepeat: [aStream space].
	aStream nextPutAll: (anObject printStringLimitedTo: 100).
	aStream cr.! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 10/4/2007 20:16'!
printStackFrame: aContext on: aStream
	self printHeaderForStackFrame: aContext on: aStream.
	self printObject: aContext receiver labelled: 'self' on: aStream.
		
	aContext tempNames withIndexDo: [ :name :index |
		self printObject: (aContext tempAt: index) labelled: name on: aStream].

	self printFooterForStackFrame: aContext on: aStream.! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 8/26/2007 14:31'!
printStackFrameListEndOn: aStream! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 8/26/2007 14:31'!
printStackFrameListStartOn: aStream! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'topa 5/19/2011 21:28'!
printWalkbackOf: aContext on: aStream

	self printStackFrameListStartOn: aStream.
	aContext errorReportOn: aStream.
	self printStackFrameListEndOn: aStream.! !

!SSEmailErrorHandler methodsFor: 'accessing' stamp: 'pmm 10/4/2007 20:29'!
repository
	^ SSRepository current! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'topa 5/19/2011 21:20'!
sendFailFor: anError
	| message |
	message := WAEmailMessage
		from: self from
		toAll: self to
		subject: (self subjectFor: anError).
	message body: (self bodyFor: anError).
	message send! !

!SSEmailErrorHandler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2011 20:41'!
subjectFor: anException

	^ (self causingContextOf: anException) printString! !

!SSEmailErrorHandler methodsFor: 'accessing' stamp: 'topa 5/19/2011 20:30'!
to
	^ self repository superUserEmail! !

MAObjectTest subclass: #SSConditionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

SSConditionTest subclass: #SSSizeConditionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Magritte'!

!SSSizeConditionTest methodsFor: 'private' stamp: 'pmm 9/2/2007 13:06'!
actualClass
	^ SSSizeCondition! !

!SSSizeConditionTest methodsFor: 'testing' stamp: 'pmm 9/2/2007 13:09'!
testAtLeast
	| collection sizeCondition |
	collection := #(1 2 3) asOrderedCollection.
	sizeCondition := SSSizeCondition atLeast: 4.
	self deny: (sizeCondition value: collection).
	collection add: 4.
	self assert: (sizeCondition value: collection).
	collection add: 5.
	self assert: (sizeCondition value: collection)! !

!SSSizeConditionTest methodsFor: 'testing' stamp: 'pmm 9/2/2007 13:08'!
testAtMost
	| collection sizeCondition |
	collection := #(1 2 3) asOrderedCollection.
	sizeCondition := SSSizeCondition atMost: 4.
	self assert: (sizeCondition value: collection).
	collection add: 4.
	self assert: (sizeCondition value: collection).
	collection add: 5.
	self deny: (sizeCondition value: collection).
	collection add: 6.
	self deny: (sizeCondition value: collection)! !

WAFileLibrary subclass: #SSFileLibrary
	instanceVariableNames: 'logo color style'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSFileLibrary class methodsFor: 'accessing-defaults' stamp: 'topa 5/3/2011 16:06'!
defaultColor

	^ Color h: 0 s: 0 v: 0.258823529! !

!SSFileLibrary class methodsFor: 'accessing-defaults' stamp: 'topa 5/3/2011 14:56'!
defaultLogo
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 1 144 0 0 0 100 8 3 0 0 0 159 21 150 69 0 0 0 90 80 76 84 69 255 255 255 102 102 102 179 179 179 217 217 217 255 255 255 153 153 153 227 227 227 204 204 204 236 236 236 140 140 140 189 46 35 188 188 188 206 98 90 197 72 63 131 131 131 243 216 214 121 121 121 169 169 169 230 177 173 204 51 51 251 243 242 222 151 145 247 230 228 218 138 132 214 125 118 235 190 187 201 85 76 204 102 102 239 203 201 226 164 159 36 167 253 59 0 0 0 1 116 82 78 83 0 64 230 216 102 0 0 8 252 73 68 65 84 120 94 236 216 233 142 211 64 20 132 209 91 183 247 246 154 117 22 224 253 95 19 39 35 15 198 202 200 61 32 80 27 234 252 139 37 71 138 62 149 219 138 252 231 136 136 136 136 136 136 136 136 136 136 136 136 136 136 136 136 136 136 200 6 117 41 37 167 193 203 95 64 198 24 249 88 112 88 112 141 252 105 4 64 62 226 19 38 78 85 231 46 242 47 243 141 166 148 84 141 173 52 72 192 164 145 59 171 184 137 82 183 235 241 169 237 114 206 93 123 25 228 83 172 142 120 151 66 117 65 230 30 254 231 143 70 42 54 60 117 121 161 59 74 185 128 73 239 84 15 9 55 182 190 32 126 222 199 172 1 16 164 90 95 219 188 246 90 188 18 7 64 231 8 254 0 87 225 66 122 0 163 44 37 64 165 82 215 247 28 93 219 182 175 249 205 169 112 36 13 208 71 249 193 198 250 130 24 76 116 125 201 85 27 36 223 124 57 206 155 120 121 126 43 82 180 145 8 192 214 254 150 229 30 28 25 35 146 212 234 57 119 199 179 44 12 247 153 116 133 15 172 32 181 7 193 131 32 13 80 241 251 149 172 156 239 69 190 201 38 11 140 82 123 144 248 40 136 7 100 71 206 167 178 137 24 192 85 31 196 224 166 89 95 149 93 185 228 201 181 228 72 215 157 4 233 101 215 134 60 121 145 45 186 135 32 30 119 70 118 45 79 46 37 11 57 200 38 99 172 20 42 191 57 26 255 169 67 29 189 149 77 222 24 47 191 46 198 249 107 108 249 95 159 113 241 11 127 59 136 217 60 212 191 211 114 174 235 113 163 48 24 110 0 33 168 187 4 146 30 210 54 185 255 219 220 224 241 248 51 18 62 141 159 234 95 71 128 45 94 36 131 68 106 233 150 87 137 195 8 37 198 9 160 143 81 161 44 49 182 211 193 232 220 176 24 166 223 115 9 27 64 124 156 198 163 67 68 66 73 83 59 19 196 132 89 83 98 110 176 89 99 98 22 253 57 222 188 144 171 197 69 27 130 161 33 150 96 200 5 32 144 157 80 96 227 19 100 24 219 151 25 101 148 173 99 59 152 205 162 243 132 178 73 163 151 85 32 126 78 143 240 212 54 249 237 55 133 80 0 228 81 240 182 104 183 160 239 248 70 211 2 63 136 84 66 16 110 150 12 20 102 39 155 82 129 188 239 3 161 205 133 87 70 215 176 117 245 80 53 179 2 49 251 64 208 153 56 124 18 224 56 118 70 30 36 23 246 24 84 3 1 143 155 228 93 171 203 168 13 213 251 114 51 111 148 4 144 33 10 32 0 62 2 161 187 214 105 28 34 203 108 70 11 45 223 186 208 166 3 255 170 64 190 239 3 113 24 169 75 43 207 51 28 168 18 57 2 4 168 3 66 35 124 129 147 109 102 189 116 129 132 202 3 221 239 146 185 107 69 90 100 131 221 52 63 243 72 9 64 96 202 18 200 0 32 11 56 30 168 141 175 78 68 98 115 65 243 63 44 158 184 38 53 249 251 231 104 174 55 249 109 239 1 31 115 24 200 208 234 29 44 113 114 7 21 26 32 152 98 110 223 114 146 104 55 121 84 1 17 224 20 111 3 32 77 24 181 30 232 111 45 227 98 18 66 92 122 72 90 192 177 240 202 190 124 84 7 121 57 158 125 55 174 171 72 78 18 58 10 196 139 206 186 61 220 190 40 32 224 129 71 67 162 151 207 21 209 204 137 104 15 32 232 33 107 142 233 6 36 62 37 182 102 238 237 82 107 71 193 219 82 243 76 218 174 92 252 196 65 125 95 252 24 35 213 54 193 101 44 58 252 116 20 72 84 157 9 74 149 188 1 16 240 48 202 147 33 8 178 136 56 78 55 118 39 128 148 219 192 55 191 10 49 243 220 174 153 24 102 60 98 9 128 149 139 232 84 214 251 225 138 97 233 197 130 161 19 20 249 40 16 175 58 235 44 13 60 63 0 200 204 131 122 235 6 194 194 31 68 251 137 219 9 32 230 169 147 15 48 98 96 241 208 162 94 98 139 199 143 51 7 34 210 72 114 175 106 125 20 8 233 206 88 255 218 115 68 139 168 120 160 148 174 247 91 5 132 196 111 79 238 36 16 225 214 1 191 72 49 82 133 239 142 146 231 177 154 251 118 178 174 62 228 54 22 248 110 246 136 14 2 65 231 70 27 250 166 13 45 16 2 15 181 110 32 4 208 152 123 177 45 27 206 2 33 97 173 104 36 230 95 167 119 122 238 241 227 107 149 95 231 120 224 104 229 55 211 142 102 31 200 68 179 244 250 218 62 16 3 32 224 177 123 252 43 205 247 162 155 109 137 103 129 176 114 16 116 211 95 180 56 9 130 169 110 249 50 186 199 235 239 179 52 112 4 242 136 36 15 3 97 152 38 92 65 228 52 140 49 81 0 89 227 161 143 105 22 209 73 189 203 212 234 44 16 171 54 11 102 181 134 169 37 179 186 123 242 58 186 199 219 247 243 48 176 161 15 8 48 15 2 169 205 82 148 146 151 214 121 131 181 222 0 225 189 154 178 163 246 164 16 53 16 36 72 220 21 32 81 0 81 188 39 43 205 167 88 149 97 252 249 251 126 19 232 13 101 144 135 136 16 86 235 163 64 232 169 47 70 44 243 59 39 0 225 3 165 15 110 92 36 119 129 24 180 120 24 136 216 60 236 170 32 159 151 77 230 235 63 31 143 226 192 199 201 95 6 82 195 80 79 60 146 142 52 88 7 198 11 51 11 246 88 123 68 202 216 233 95 1 9 235 64 252 54 144 239 95 33 127 1 228 49 33 216 121 9 200 214 116 226 24 170 129 208 23 183 127 9 110 0 133 127 5 68 39 168 14 169 144 217 133 252 121 185 2 132 97 231 37 32 97 189 4 3 187 53 16 170 45 228 238 223 245 78 147 85 0 228 169 15 36 92 6 146 78 20 149 177 179 250 54 202 159 249 194 220 251 35 40 112 228 188 252 81 47 48 77 73 134 174 3 228 238 0 25 16 56 211 154 139 8 54 26 200 151 171 64 250 59 12 15 213 182 60 127 76 80 126 93 42 108 95 221 246 98 135 171 133 225 234 125 32 234 104 104 59 150 7 80 64 82 92 3 73 151 182 189 50 73 163 85 39 46 150 190 93 5 210 191 254 64 98 246 52 144 173 188 149 6 173 129 232 228 162 87 116 49 199 112 150 161 183 237 45 151 128 100 244 147 146 192 123 95 94 94 175 248 136 171 118 174 166 78 196 161 65 107 237 170 18 86 110 159 212 81 46 196 176 185 15 132 22 206 66 189 25 243 34 207 116 14 8 173 250 1 220 242 144 60 191 30 73 246 238 133 20 100 223 69 182 23 54 177 208 2 8 65 169 161 109 59 29 198 10 96 200 106 217 96 170 162 8 232 154 1 26 28 3 2 123 208 17 226 240 125 201 238 160 143 84 32 223 30 222 246 114 39 253 14 59 140 174 213 200 18 26 110 179 236 3 9 43 78 87 80 25 138 218 114 190 207 55 38 199 72 61 48 38 224 59 0 4 146 59 183 93 28 209 170 42 174 242 25 191 35 207 15 30 12 179 40 186 170 228 14 162 138 83 38 217 189 191 223 136 50 46 40 32 192 75 24 184 116 66 6 183 241 195 73 125 68 107 44 103 168 183 128 0 171 224 228 199 242 13 84 9 91 81 11 67 148 188 31 253 138 184 78 153 112 89 19 243 2 214 56 207 152 218 34 98 29 128 4 21 124 225 88 36 108 238 3 113 243 151 154 183 242 176 168 216 146 208 99 219 206 237 114 182 9 85 174 77 32 184 50 20 25 165 119 219 170 200 223 224 161 248 222 147 255 14 198 172 72 65 86 229 168 169 242 248 118 198 205 2 136 189 153 4 131 216 0 8 62 55 13 125 144 194 205 201 21 32 56 31 90 85 35 76 109 180 240 114 126 81 72 0 177 42 133 45 155 207 206 241 134 36 177 220 5 20 181 62 103 137 241 198 128 49 38 84 9 192 251 242 183 230 224 87 116 194 102 170 240 193 159 132 227 83 64 37 130 218 205 112 153 215 135 227 209 179 134 27 16 16 201 140 130 215 144 121 94 138 3 198 228 47 10 8 104 77 113 72 92 126 179 224 209 18 41 200 7 183 206 109 100 142 51 98 50 219 232 100 183 234 198 13 102 47 53 201 237 93 126 95 209 233 155 119 137 198 186 132 222 206 15 119 45 229 106 175 60 157 208 114 125 240 200 151 161 245 105 212 214 177 105 28 156 208 43 211 244 64 174 24 162 4 130 241 211 50 60 16 91 107 135 177 95 113 189 156 124 54 214 218 146 235 99 67 163 79 226 210 74 108 202 92 134 48 239 57 22 110 62 212 232 40 134 245 73 102 178 175 0 129 87 100 48 206 198 173 23 77 201 226 208 160 171 69 20 58 159 53 94 190 114 46 65 247 170 207 203 29 32 8 77 101 114 192 70 162 237 215 18 181 94 23 81 236 140 56 21 70 174 107 33 81 87 196 250 5 40 211 80 222 6 114 226 26 80 96 83 214 255 3 17 199 134 170 178 201 149 67 188 161 24 239 90 103 109 80 99 83 29 219 180 138 105 204 249 234 179 190 95 142 123 210 78 22 180 226 16 250 118 12 148 42 248 56 244 12 241 37 86 103 159 72 81 38 118 128 217 138 239 116 173 125 89 143 202 84 85 177 132 255 219 185 155 20 132 97 32 128 194 163 118 33 161 65 72 155 88 243 115 255 107 170 40 204 38 32 40 118 178 120 223 21 222 38 9 153 145 15 202 119 23 145 177 231 73 166 211 187 207 239 38 217 153 215 99 175 109 16 232 252 84 24 38 8 54 61 245 218 6 129 126 237 221 134 9 130 226 30 18 65 134 26 137 142 98 31 4 250 248 158 101 144 32 216 116 243 140 125 16 212 172 61 118 13 130 212 187 127 232 102 166 157 131 32 185 18 82 255 15 208 188 202 191 156 245 181 10 157 177 78 63 199 86 159 98 156 189 123 89 154 24 64 118 93 75 92 197 2 66 175 72 14 118 57 144 90 241 78 45 165 37 177 134 90 91 124 184 213 85 204 1 0 0 0 0 0 0 0 128 59 126 218 85 94 85 186 176 65 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!SSFileLibrary class methodsFor: 'accessing' stamp: 'topa 5/3/2011 14:55'!
logoFileModel
	^MAMemoryFileModel new
		filename: 'logo.png';
		mimetype: (self mimetypeFor: 'png') greaseString;
		contents: self default logoPng! !

!SSFileLibrary class methodsFor: 'accessing' stamp: 'pmm 9/13/2007 06:46'!
logoFileModel: aMAMemoryFileModel
	self default setLogoContents: aMAMemoryFileModel contents! !

!SSFileLibrary methodsFor: 'uploaded' stamp: 'topa 5/3/2011 14:55'!
logoPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 1 144 0 0 0 100 8 3 0 0 0 159 21 150 69 0 0 0 90 80 76 84 69 255 255 255 102 102 102 179 179 179 217 217 217 255 255 255 153 153 153 227 227 227 204 204 204 236 236 236 140 140 140 189 46 35 188 188 188 206 98 90 197 72 63 131 131 131 243 216 214 121 121 121 169 169 169 230 177 173 204 51 51 251 243 242 222 151 145 247 230 228 218 138 132 214 125 118 235 190 187 201 85 76 204 102 102 239 203 201 226 164 159 36 167 253 59 0 0 0 1 116 82 78 83 0 64 230 216 102 0 0 8 252 73 68 65 84 120 94 236 216 233 142 211 64 20 132 209 91 183 247 246 154 117 22 224 253 95 19 39 35 15 198 202 200 61 32 80 27 234 252 139 37 71 138 62 149 219 138 252 231 136 136 136 136 136 136 136 136 136 136 136 136 136 136 136 136 136 136 200 6 117 41 37 167 193 203 95 64 198 24 249 88 112 88 112 141 252 105 4 64 62 226 19 38 78 85 231 46 242 47 243 141 166 148 84 141 173 52 72 192 164 145 59 171 184 137 82 183 235 241 169 237 114 206 93 123 25 228 83 172 142 120 151 66 117 65 230 30 254 231 143 70 42 54 60 117 121 161 59 74 185 128 73 239 84 15 9 55 182 190 32 126 222 199 172 1 16 164 90 95 219 188 246 90 188 18 7 64 231 8 254 0 87 225 66 122 0 163 44 37 64 165 82 215 247 28 93 219 182 175 249 205 169 112 36 13 208 71 249 193 198 250 130 24 76 116 125 201 85 27 36 223 124 57 206 155 120 121 126 43 82 180 145 8 192 214 254 150 229 30 28 25 35 146 212 234 57 119 199 179 44 12 247 153 116 133 15 172 32 181 7 193 131 32 13 80 241 251 149 172 156 239 69 190 201 38 11 140 82 123 144 248 40 136 7 100 71 206 167 178 137 24 192 85 31 196 224 166 89 95 149 93 185 228 201 181 228 72 215 157 4 233 101 215 134 60 121 145 45 186 135 32 30 119 70 118 45 79 46 37 11 57 200 38 99 172 20 42 191 57 26 255 169 67 29 189 149 77 222 24 47 191 46 198 249 107 108 249 95 159 113 241 11 127 59 136 217 60 212 191 211 114 174 235 113 163 48 24 110 0 33 168 187 4 146 30 210 54 185 255 219 220 224 241 248 51 18 62 141 159 234 95 71 128 45 94 36 131 68 106 233 150 87 137 195 8 37 198 9 160 143 81 161 44 49 182 211 193 232 220 176 24 166 223 115 9 27 64 124 156 198 163 67 68 66 73 83 59 19 196 132 89 83 98 110 176 89 99 98 22 253 57 222 188 144 171 197 69 27 130 161 33 150 96 200 5 32 144 157 80 96 227 19 100 24 219 151 25 101 148 173 99 59 152 205 162 243 132 178 73 163 151 85 32 126 78 143 240 212 54 249 237 55 133 80 0 228 81 240 182 104 183 160 239 248 70 211 2 63 136 84 66 16 110 150 12 20 102 39 155 82 129 188 239 3 161 205 133 87 70 215 176 117 245 80 53 179 2 49 251 64 208 153 56 124 18 224 56 118 70 30 36 23 246 24 84 3 1 143 155 228 93 171 203 168 13 213 251 114 51 111 148 4 144 33 10 32 0 62 2 161 187 214 105 28 34 203 108 70 11 45 223 186 208 166 3 255 170 64 190 239 3 113 24 169 75 43 207 51 28 168 18 57 2 4 168 3 66 35 124 129 147 109 102 189 116 129 132 202 3 221 239 146 185 107 69 90 100 131 221 52 63 243 72 9 64 96 202 18 200 0 32 11 56 30 168 141 175 78 68 98 115 65 243 63 44 158 184 38 53 249 251 231 104 174 55 249 109 239 1 31 115 24 200 208 234 29 44 113 114 7 21 26 32 152 98 110 223 114 146 104 55 121 84 1 17 224 20 111 3 32 77 24 181 30 232 111 45 227 98 18 66 92 122 72 90 192 177 240 202 190 124 84 7 121 57 158 125 55 174 171 72 78 18 58 10 196 139 206 186 61 220 190 40 32 224 129 71 67 162 151 207 21 209 204 137 104 15 32 232 33 107 142 233 6 36 62 37 182 102 238 237 82 107 71 193 219 82 243 76 218 174 92 252 196 65 125 95 252 24 35 213 54 193 101 44 58 252 116 20 72 84 157 9 74 149 188 1 16 240 48 202 147 33 8 178 136 56 78 55 118 39 128 148 219 192 55 191 10 49 243 220 174 153 24 102 60 98 9 128 149 139 232 84 214 251 225 138 97 233 197 130 161 19 20 249 40 16 175 58 235 44 13 60 63 0 200 204 131 122 235 6 194 194 31 68 251 137 219 9 32 230 169 147 15 48 98 96 241 208 162 94 98 139 199 143 51 7 34 210 72 114 175 106 125 20 8 233 206 88 255 218 115 68 139 168 120 160 148 174 247 91 5 132 196 111 79 238 36 16 225 214 1 191 72 49 82 133 239 142 146 231 177 154 251 118 178 174 62 228 54 22 248 110 246 136 14 2 65 231 70 27 250 166 13 45 16 2 15 181 110 32 4 208 152 123 177 45 27 206 2 33 97 173 104 36 230 95 167 119 122 238 241 227 107 149 95 231 120 224 104 229 55 211 142 102 31 200 68 179 244 250 218 62 16 3 32 224 177 123 252 43 205 247 162 155 109 137 103 129 176 114 16 116 211 95 180 56 9 130 169 110 249 50 186 199 235 239 179 52 112 4 242 136 36 15 3 97 152 38 92 65 228 52 140 49 81 0 89 227 161 143 105 22 209 73 189 203 212 234 44 16 171 54 11 102 181 134 169 37 179 186 123 242 58 186 199 219 247 243 48 176 161 15 8 48 15 2 169 205 82 148 146 151 214 121 131 181 222 0 225 189 154 178 163 246 164 16 53 16 36 72 220 21 32 81 0 81 188 39 43 205 167 88 149 97 252 249 251 126 19 232 13 101 144 135 136 16 86 235 163 64 232 169 47 70 44 243 59 39 0 225 3 165 15 110 92 36 119 129 24 180 120 24 136 216 60 236 170 32 159 151 77 230 235 63 31 143 226 192 199 201 95 6 82 195 80 79 60 146 142 52 88 7 198 11 51 11 246 88 123 68 202 216 233 95 1 9 235 64 252 54 144 239 95 33 127 1 228 49 33 216 121 9 200 214 116 226 24 170 129 208 23 183 127 9 110 0 133 127 5 68 39 168 14 169 144 217 133 252 121 185 2 132 97 231 37 32 97 189 4 3 187 53 16 170 45 228 238 223 245 78 147 85 0 228 169 15 36 92 6 146 78 20 149 177 179 250 54 202 159 249 194 220 251 35 40 112 228 188 252 81 47 48 77 73 134 174 3 228 238 0 25 16 56 211 154 139 8 54 26 200 151 171 64 250 59 12 15 213 182 60 127 76 80 126 93 42 108 95 221 246 98 135 171 133 225 234 125 32 234 104 104 59 150 7 80 64 82 92 3 73 151 182 189 50 73 163 85 39 46 150 190 93 5 210 191 254 64 98 246 52 144 173 188 149 6 173 129 232 228 162 87 116 49 199 112 150 161 183 237 45 151 128 100 244 147 146 192 123 95 94 94 175 248 136 171 118 174 166 78 196 161 65 107 237 170 18 86 110 159 212 81 46 196 176 185 15 132 22 206 66 189 25 243 34 207 116 14 8 173 250 1 220 242 144 60 191 30 73 246 238 133 20 100 223 69 182 23 54 177 208 2 8 65 169 161 109 59 29 198 10 96 200 106 217 96 170 162 8 232 154 1 26 28 3 2 123 208 17 226 240 125 201 238 160 143 84 32 223 30 222 246 114 39 253 14 59 140 174 213 200 18 26 110 179 236 3 9 43 78 87 80 25 138 218 114 190 207 55 38 199 72 61 48 38 224 59 0 4 146 59 183 93 28 209 170 42 174 242 25 191 35 207 15 30 12 179 40 186 170 228 14 162 138 83 38 217 189 191 223 136 50 46 40 32 192 75 24 184 116 66 6 183 241 195 73 125 68 107 44 103 168 183 128 0 171 224 228 199 242 13 84 9 91 81 11 67 148 188 31 253 138 184 78 153 112 89 19 243 2 214 56 207 152 218 34 98 29 128 4 21 124 225 88 36 108 238 3 113 243 151 154 183 242 176 168 216 146 208 99 219 206 237 114 182 9 85 174 77 32 184 50 20 25 165 119 219 170 200 223 224 161 248 222 147 255 14 198 172 72 65 86 229 168 169 242 248 118 198 205 2 136 189 153 4 131 216 0 8 62 55 13 125 144 194 205 201 21 32 56 31 90 85 35 76 109 180 240 114 126 81 72 0 177 42 133 45 155 207 206 241 134 36 177 220 5 20 181 62 103 137 241 198 128 49 38 84 9 192 251 242 183 230 224 87 116 194 102 170 240 193 159 132 227 83 64 37 130 218 205 112 153 215 135 227 209 179 134 27 16 16 201 140 130 215 144 121 94 138 3 198 228 47 10 8 104 77 113 72 92 126 179 224 209 18 41 200 7 183 206 109 100 142 51 98 50 219 232 100 183 234 198 13 102 47 53 201 237 93 126 95 209 233 155 119 137 198 186 132 222 206 15 119 45 229 106 175 60 157 208 114 125 240 200 151 161 245 105 212 214 177 105 28 156 208 43 211 244 64 174 24 162 4 130 241 211 50 60 16 91 107 135 177 95 113 189 156 124 54 214 218 146 235 99 67 163 79 226 210 74 108 202 92 134 48 239 57 22 110 62 212 232 40 134 245 73 102 178 175 0 129 87 100 48 206 198 173 23 77 201 226 208 160 171 69 20 58 159 53 94 190 114 46 65 247 170 207 203 29 32 8 77 101 114 192 70 162 237 215 18 181 94 23 81 236 140 56 21 70 174 107 33 81 87 196 250 5 40 211 80 222 6 114 226 26 80 96 83 214 255 3 17 199 134 170 178 201 149 67 188 161 24 239 90 103 109 80 99 83 29 219 180 138 105 204 249 234 179 190 95 142 123 210 78 22 180 226 16 250 118 12 148 42 248 56 244 12 241 37 86 103 159 72 81 38 118 128 217 138 239 116 173 125 89 143 202 84 85 177 132 255 219 185 155 20 132 97 32 128 194 163 118 33 161 65 72 155 88 243 115 255 107 170 40 204 38 32 40 118 178 120 223 21 222 38 9 153 145 15 202 119 23 145 177 231 73 166 211 187 207 239 38 217 153 215 99 175 109 16 232 252 84 24 38 8 54 61 245 218 6 129 126 237 221 134 9 130 226 30 18 65 134 26 137 142 98 31 4 250 248 158 101 144 32 216 116 243 140 125 16 212 172 61 118 13 130 212 187 127 232 102 166 157 131 32 185 18 82 255 15 208 188 202 191 156 245 181 10 157 177 78 63 199 86 159 98 156 189 123 89 154 24 64 118 93 75 92 197 2 66 175 72 14 118 57 144 90 241 78 45 165 37 177 134 90 91 124 184 213 85 204 1 0 0 0 0 0 0 0 128 59 126 218 85 94 85 186 176 65 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!SSFileLibrary methodsFor: 'css' stamp: 'topa 5/4/2011 22:42'!
navigationCss

	^ 
'.tabnav .navigation-options {
	clear: both;
	height: 4em;
	line-height: 4em;
	background-color: #ccc;
	background: -webkit-linear-gradient(top, #bbbbbb 0%, #d0d0d0 100%);
	background: -webkit-gradient(linear,left top, left bottom, color-stop(0%,#bbbbbb);  color-stop(100%,#d0d0d0));
	background: -o-linear-gradient(top, #bbbbbb 0%, #d0d0d0 100%);
	background: -moz-linear-gradient(top, #bbbbbb 0%, #d0d0d0 100%);
	background: -ms-linear-gradient(top, #bbbbbb 0%, #d0d0d0 100%);
	filter: progid:DXImageTransform.Microsoft.gradient( startColorstr=''#BBBBBB'', endColorstr=''#D0D0D0'',GradientType=0 );
	background: linear-gradient(top, #bbbbbb 0%, #d0d0d0 100%);

	border-radius:			7px;
	-moz-border-radius:		7px;
	-o-border-radius:		7px;
	-webkit-border-radius:	7px;
}

.tabnav .navigation-options ul, 
.tabnav .navigation-options li	{
	display: inline;
	height: 4em;
	line-height: 4em;
	list-style-type : none;
	margin : 0;
	padding : 2px;
}


.tabnav .navigation-options a {
	letter-spacing: 1px;
	font-size: large;
	height: 4em;
    text-shadow: white 0 1px 0;
	border: none;
	padding : 0 10px;
    margin: 0 8px;
}

.tabnav .navigation-options a:active 
.tabnav .navigation-options a:link.active, 
.tabnav .navigation-options a:visited.active	{
    color: black;
    text-shadow: none;
}

.tabnav .navigation-options ul a:hover	{
    background-color: #aaa;
    padding-top: 10px;
    padding-bottom: 10px;
    border-radius:			5px;
	-moz-border-radius:		5px;
	-o-border-radius:		5px;
	-webkit-border-radius:	5px;
}

.tabnav .navigation-options .option-selected a {
	font-weight: bold;
    background-color: #eee;
    padding: 7px 7px;
    border-top: 1px solid #999;
    border-left: 1px solid #999;
    border-bottom: 1px solid #fff;
    border-right: 1px solid #fff;   
    border-radius:			5px;
	-moz-border-radius:		5px;
	-o-border-radius:		5px;
	-webkit-border-radius:	5px;

}

.tabnav .navigation-options .option-selected a:hover {
    background-color: #eee;
    padding-top: 7px;
    padding-bottom: 7px;
}

.tabnav .navigation-options .option-selected a {
	color : #000;
}

.tabnav .navigation-content {
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 2px 15px 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}


#contents .navigation-content .magritte h1 {
	margin-top: 1em;
    font-size: 24px;
}
'! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/18/2007 19:32'!
renderStyleBatchOn: aStream
	aStream nextPutAll: '.batch {'.
	aStream nextPutAll: 		'text-align: center;'.
	aStream nextPutAll: 		'margin-top: 8px;'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'topa 5/3/2011 16:24'!
renderStyleBottomOn: aStream
	aStream
		nextPutAll: '#bottom {';
		nextPutAll: 		'padding-left: 5px;';
		nextPutAll: 		'padding-right: 5px;';
		nextPutAll: 		'margin: 0px;';
		nextPutAll: 		'clear: both;';
		nextPutAll: 		'border-top: 1px solid black;';
		nextPutAll: 		'background: white;';
		nextPutAll: '}';
		yourself! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'topa 10/27/2010 16:08'!
renderStyleCodeTabsOn: aStream

	aStream
		nextPutAll: '/* ================================================================ 
This copyright notice must be untouched at all times.

The original version of this stylesheet and the associated (x)html
is available at http://www.cssplay.co.uk/menu/one_page.html
Copyright (c) 2005-2007 Stu Nicholls. All rights reserved.
This stylesheet and the assocaited (x)html may be modified in any 
way to fit your requirements.
=================================================================== */';
	"/* set up the overall width of the menu div, the font and the margins with a relative position*/"
		nextPutAll: '.codetab {';
		nextPutAll:	'position:relative;';
		nextPutAll:	'z-index:100;';
		nextPutAll:	'}';
	"/* remove the bullets and set the margin and padding to zero for the unordered list */"
		nextPutAll: '.codetab ul {';
		nextPutAll:	'padding:0;';
		nextPutAll:	'margin:0;';
		nextPutAll:	'list-style: none;';
		nextPutAll:	'border:0;';
		nextPutAll: '}';
		nextPutAll: '.codetab ul table {border-collapse:collapse; margin:-1px -10px; font-size:1em;}';
		"/*float the list so that the items are in a line */"
		nextPutAll: '.codetab ul li {';
		nextPutAll:	'float:left;';
		nextPutAll: '}';
		nextPutAll: '.codetab ul li a, .codetab ul li a:visited {';
		nextPutAll:	'display:block;';
		nextPutAll:	'text-align:center;';
		nextPutAll:	'text-decoration:none;';
		nextPutAll:	'font-weight: bold;';
		nextPutAll:	'padding: 0 2em;';
		nextPutAll:	'height:30px;';
		nextPutAll:	'color:#000;';
		nextPutAll:	'border:1px solid #fff;';
		nextPutAll:	'border-width:1px 1px 0 0;';
		nextPutAll:	'background:#E8EBF0;';
		nextPutAll:	'line-height:30px;';
		nextPutAll:	'font-size:12px;';
		nextPutAll: '}';
		"/* make the dropdown ul invisible */"
		nextPutAll: '.codetab ul ul {';
		nextPutAll:	'position:absolute; left:-9999px; height:0;';
		nextPutAll: '}';
		"/* set the background and foreground color of the main codetab items on hover */"
		nextPutAll: '.codetab ul li a:hover,';
		nextPutAll: '.codetab ul li:hover a {';
		nextPutAll:	'color:#fff;';
		nextPutAll:	'background: #666;';
		nextPutAll: '}';
		"/* make the sub codetab ul visible and position it beneath the first list item */"
		nextPutAll: '.codetab ul :hover ul {';
		nextPutAll:	'top:30px; ';
		nextPutAll:	'height:auto;';
		nextPutAll:	'left:0;';
		nextPutAll:	'text-align:left;';
		nextPutAll:	'z-index:100;';
		nextPutAll:'}';
		"/* make the sub codetab ul li the full width with padding and border. Add an auto scroll bar */"
		nextPutAll:'.codetab ul :hover ul li {';
		nextPutAll:	'background:#E8EBF0; ';
		nextPutAll:	'color:#000;';
		nextPutAll:	'padding: .7em 1.5em;';
		nextPutAll:	'width: auto;';
		nextPutAll:	'min-width: 200px;';
		nextPutAll:	'overflow:auto;';
		nextPutAll:	'border:5px solid #666;';
		nextPutAll:	'}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'topa 5/3/2011 16:09'!
renderStyleContainerOn: aStream
	aStream nextPutAll: '#container {'.
	aStream nextPutAll: 		'margin: auto;'.
	aStream nextPutAll: 		'width: 860px;'.
	aStream nextPutAll: 		'text-align: left;'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'topa 5/3/2011 16:38'!
renderStyleContentsOn: aStream
	aStream 
		nextPutAll: '#contents {';
		nextPutAll: 		'width: 100%;';
		nextPutAll: 		'min-height: 680px;';
		nextPutAll: 		'float: right;';
		nextPutAll: 		'text-align: justify;';
		nextPutAll: '}';

		nextPutAll: '#contents h1 {';
		nextPutAll: 		'margin: 0px;';
		nextPutAll: 		'text-align: left;';				
		nextPutAll: 		'font-size: 36px;';
		nextPutAll: '}';
	
		nextPutAll: '#contents h1 a {';
		nextPutAll: 		'text-decoration: none;';
		nextPutAll: 		'border: none;';				
		nextPutAll: '}';
		
		nextPutAll: '#contents h2 {';
		nextPutAll: 		'margin: 1em 0 0.5em;';
		nextPutAll: 		'text-align: left;';				
		nextPutAll: 		'font-size: 21px;';
		nextPutAll: '}';
	
		nextPutAll: '#contents h3 {';
		nextPutAll: 		'margin-bottom: 5px;';
		nextPutAll: 		'text-align: left;';				
		nextPutAll: 		'font-size: 18px;';
		nextPutAll: '}';

		nextPutAll: '#contents hr {';
		nextPutAll: 		'border: none;';
		nextPutAll: 		'border-bottom: 1px dotted black;';
		nextPutAll: '}';
		yourself.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'topa 5/3/2011 16:46'!
renderStyleHtmlOn: aStream
	aStream 
		nextPutAll: 'body {';
		nextPutAll:		'margin: 0px;';
		nextPutAll:	 	'padding: 10px;';
		nextPutAll: 		'border: 0px;';
		nextPutAll: 		'background: transparent;';
		nextPutAll: 		'text-align: center;';
		nextPutAll: 		'line-height: 1.2;';  
		nextPutAll: '}';

		nextPutAll: 'body, div, table, tr, td, th, form input, form submit {';
		nextPutAll: 		'font-family: ''Helvetica Neue'', Helvetica, Geneva, Swiss, Arial, sans-serif;';
		nextPutAll: '}';
		nextPutAll: 'label, td.readonly {line-height:24px}';
		nextPutAll: 'table, tr, td, th, form {';
		nextPutAll: 		'margin: 0px;';
		nextPutAll: 		'padding: 0px;';
		nextPutAll: 		'border: 0px;';
		nextPutAll: 		'border-spacing: 0px;';
		nextPutAll: '}';
	
		nextPutAll: 'th {';
		nextPutAll: 		'text-align: left;';
		nextPutAll: '}';
	
		nextPutAll: 'thead tr td {';
		nextPutAll: 		'font-weight: bold;';
		nextPutAll: '}';
	
		nextPutAll: 'code, pre {';
		nextPutAll: 		'white-space: pre;';
		nextPutAll: 		'line-height: 1;';
		nextPutAll: '}';

		nextPutAll: 'input.text {';
		nextPutAll: 		'width: 500px;';
		nextPutAll: '}';

		nextPutAll: 'textarea {';
		nextPutAll: 		'width: 500px;';
		nextPutAll: '}';

		nextPutAll: 'a, a:visited {';
		nextPutAll: 		'color: '; nextPutAll: self styleColor asHTMLColor; nextPutAll: ';';
		nextPutAll: 		'text-decoration: none;';
		nextPutAll: '}';
		
		nextPutAll: 'a:hover {';
		nextPutAll: 		'border-bottom: 1px dotted;';
		nextPutAll: '}';  
		
		nextPutAll: 'form div {';
		nextPutAll:		'border: 1px solid transparent;';
		nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'topa 5/3/2011 16:36'!
renderStyleNavigationOn: aStream
	aStream
		nextPutAll: '#navigation {';
		nextPutAll: 		'text-align: right;';
		nextPutAll: 		'width: 20%;';
		nextPutAll: 		'float: right;';
		nextPutAll: 		'position: relative;';
		nextPutAll: 		'margin-left: -22%;';
		nextPutAll: 		'padding-right: 1em';
		nextPutAll: '}';

		nextPutAll: '#navigation .title {';
		nextPutAll: 		'margin-top: 2em;';
		nextPutAll: 		'font-weight: bold;';
		nextPutAll: '}';
		yourself! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'topa 10/27/2010 15:52'!
renderStyleOn: aStream
	self
		renderStyleHtmlOn: aStream;
		renderStyleContainerOn: aStream;
		renderStyleTopOn: aStream;
		renderStyleToolbarOn: aStream;
		renderStylePageOn: aStream;
		renderStyleNavigationOn: aStream;
		renderStyleContentsOn: aStream;
		renderStyleBottomOn: aStream;
		renderStyleBatchOn: aStream;
		renderStyleTableRowOn: aStream;
		renderStyleCodeTabsOn: aStream;
		renderWindowOn: aStream! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'topa 5/3/2011 16:16'!
renderStylePageOn: aStream
	aStream 
		nextPutAll: '#page {';
		nextPutAll: 		'padding: 0px;';
		nextPutAll: 		'clear: both;';
		nextPutAll: '}';
	
		nextPutAll: '#page td, #page th {';
		nextPutAll: 		'padding-right: 5px;';
		nextPutAll: 		'vertical-align: top;';
		nextPutAll: '}';
		yourself! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'topa 3/14/2011 09:35'!
renderStyleTableRowOn: aStream
	aStream nextPutAll: 'tr.even {'.
	aStream nextPutAll: 		'background-color: '; nextPutAll: self styleColor veryMuchLighter asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: 'tr.odd {'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '.largeLabel {'.
	aStream nextPutAll:		'font-weight: bold'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '.mediumLabel {'.
	aStream nextPutAll:		'width: 100px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '.smallLabel {'.
	aStream nextPutAll:		'width: 80px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '.activityTable {'.
	aStream nextPutAll:		'margin-left: auto;'.
	aStream nextPutAll:		'margin-right: auto;'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'topa 5/3/2011 16:47'!
renderStyleToolbarOn: aStream
	aStream 
		nextPutAll: '#sstoolbar {';
		nextPutAll: 		'float: right;';
		nextPutAll: '}';
		
		nextPutAll: '#sstoolbar a {';
		nextPutAll: 		'text-decoration: none;';
		nextPutAll: 		'color: black;';
		nextPutAll: 		'text-shadow: white 0 1px 0;';
		nextPutAll: 		'border: none;';
		nextPutAll: 		'padding: 0px 1em 0px;';
		nextPutAll: '}';
		
		nextPutAll: '#sstoolbar a:hover {';
		nextPutAll: 		'border: none;';
		nextPutAll: 		'color: '; nextPutAll: self styleColor asHTMLColor; nextPutAll: ';';
		nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'topa 5/3/2011 16:27'!
renderStyleTopOn: aStream
	aStream 
		nextPutAll: '#top {';
		nextPutAll: 		'width: 860px;';
		nextPutAll: 		'height: 100px;';
		nextPutAll: 		'background: url(', (self urlOf: #logoPng) greaseString, ') no-repeat;';
		nextPutAll: 		'text-align: right;';
		nextPutAll: '}';
		yourself! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'topa 5/3/2011 16:26'!
renderWindowOn: aStream
	
	aStream 
		nextPutAll: '#window-titlebar {';
		nextPutAll: 		'background-color: '; nextPutAll: self styleColor muchLighter asHTMLColor; nextPutAll: ';';
		nextPutAll: 		'margin-bottom: 10px;';
		nextPutAll: 		'width: 100%;';
		nextPutAll: '}';
		
		nextPutAll: 	'#window-title {';
		nextPutAll: 		'text-align: right;';
		nextPutAll: 		'width: 66%;';
		nextPutAll: 	'}';
	
		nextPutAll: 	'#window-close {';
		nextPutAll: 		'text-align: right;';
		nextPutAll: '}';
		yourself! !

!SSFileLibrary methodsFor: 'css' stamp: 'obi 9/4/2009 20:25'!
resetCss
	"SSFileLibrary default resetCss"
	style := nil.
	self stylesheetCss! !

!SSFileLibrary methodsFor: 'accessing' stamp: 'topa 5/3/2011 16:29'!
selectorsToInclude
	^#(stylesheetCss navigationCss)! !

!SSFileLibrary methodsFor: 'accessing' stamp: 'pmm 9/13/2007 06:46'!
setLogoContents: aByteArray
	logo := aByteArray! !

!SSFileLibrary methodsFor: 'accessing' stamp: 'topa 12/20/2010 08:23'!
styleColor

	color ifNil: [color := self class defaultColor].
	^ color! !

!SSFileLibrary methodsFor: 'accessing' stamp: 'obi 9/5/2009 09:17'!
styleColor: aColor
	color ~= aColor
		ifTrue: [
			color := aColor.
			self resetCss]! !

!SSFileLibrary methodsFor: 'css' stamp: 'topa 12/20/2010 08:23'!
stylesheetCss

	style ifNil: [ style := String streamContents: [ :stream |
			self renderStyleOn: stream]].
	^ style! !

!SSFileLibrary methodsFor: 'as yet unclassified' stamp: 'topa 5/12/2011 13:54'!
updateRoot: aHtmlRoot
	
	aHtmlRoot if lessThan; ie: '9';
 		do: [aHtmlRoot script beJavascript; url: 'http://html5shim.googlecode.com/svn/trunk/html5.js'].
	super updateRoot: aHtmlRoot.! !

!GRPlatform methodsFor: '*SqueakSource-Core' stamp: 'topa 10/22/2010 07:57'!
squeaksourceDoWithoutProgressNotification: aBlock

	self subclassResponsibility! !

TWWiki subclass: #SSWiki
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSWiki methodsFor: 'accessing' stamp: 'obi 8/31/2009 20:57'!
actions
	^Array streamContents: [ :stream |
		(self project isMember: self session user allowedTo: SSAccessPolicy write) ifTrue: [ 
			stream nextPut: #( 'View' #view: $v).
			stream nextPut: #( 'Edit' #edit: $e) ].
		stream nextPut: #( 'Home' #home $h) ].! !

!SSWiki methodsFor: 'events' stamp: 'pmm 8/26/2007 11:12'!
onSaved
	self session save! !

!SSWiki methodsFor: 'accessing' stamp: 'lr 3/28/2004 20:12'!
project
	^project! !

!SSWiki methodsFor: 'rendering' stamp: 'pmm 9/8/2007 08:58'!
renderContentOn: html
	html break.
	super renderContentOn: html! !

!SSWiki methodsFor: 'actions' stamp: 'dkh 01/04/2010 16:15'!
resetReport! !

!SSWiki methodsFor: 'initialization' stamp: 'pmm 8/26/2007 11:12'!
setModel: aModel
	super setModel: (project := aModel) wiki! !

!SSWiki methodsFor: 'rendering' stamp: 'lr 3/29/2004 22:41'!
style
	^
'.wikiheader h1 {
	display: none; 
}
.wikiheader .list {
	margin-top: 5px;
	margin-bottom: 10px;
}
.wikiheader .listItem {
	display: inline;
	margin-right: 10px;
}

.wikicontent p { 
	margin: 0px;
	margin-bottom: 5px;
}

.wikifooter h1 {
	display: none;
}
.wikifooter .list:before {
	content: "References: ";
	font-weight: bold;
}
.wikifooter .list {
	margin-top: 10px;
	border-top: 1px dotted black;
}
.wikifooter .listItem {
	display: inline;
	margin-right: 10px;
}'! !

WADecoration subclass: #SSConfirmConfigurationDeleteDecoration
	instanceVariableNames: 'configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Decorations'!

!SSConfirmConfigurationDeleteDecoration class methodsFor: 'instance creation' stamp: 'pmm 9/18/2007 21:47'!
configuration: aConfiguration
	^self new
		configuration: aConfiguration;
		yourself! !

!SSConfirmConfigurationDeleteDecoration methodsFor: 'accessing' stamp: 'pmm 9/18/2007 21:45'!
configuration
	^configuration! !

!SSConfirmConfigurationDeleteDecoration methodsFor: 'accessing' stamp: 'pmm 9/18/2007 21:45'!
configuration: aConfiguration
	configuration := aConfiguration! !

!SSConfirmConfigurationDeleteDecoration methodsFor: 'rendering' stamp: 'topa 6/19/2010 19:08'!
renderContentOn: html
	html text: self configuration fileName.
	html heading level3 with: [
		html withLineBreaks: self configuration summary ].
	html text: 'Really delete ', self configuration fileName, '? There is no backup!!'.
	self renderNextOn: html! !

WADecoration subclass: #SSExplanationDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Decorations'!

!SSExplanationDecoration methodsFor: 'rendering' stamp: 'topa 6/19/2010 19:08'!
renderContentOn: html
	html paragraph: 'SqueakSource allows a fine-grained control about the people being allowed to read, write and admin your project. The following settings are available:'.
	html unorderedList: [
		html listItem: 'Global specifies the default right for users not being marked as guest, developer or administrator of this project.'.
		html listItem: 'Administrators are allowed to edit the project settings, to update the rss-feed, to make releases and to open and save versions.'.
		html listItem: 'Developers are allowed to open and save versions.'.
		html listItem: 'Guests are allowed to open versions.' ].
	self renderNextOn: html! !

WADecoration subclass: #SSHeadingDecoration
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Decorations'!

!SSHeadingDecoration class methodsFor: 'instance creation' stamp: 'pmm 8/25/2007 14:41'!
message: aString
	^self new
		message: aString;
		yourself! !

!SSHeadingDecoration methodsFor: 'accessing' stamp: 'pmm 8/25/2007 14:40'!
message
	^message! !

!SSHeadingDecoration methodsFor: 'accessing' stamp: 'pmm 8/25/2007 14:40'!
message: aString
	message := aString! !

!SSHeadingDecoration methodsFor: 'rendering' stamp: 'topa 6/19/2010 19:09'!
renderContentOn: html
	html heading: self message.
	self renderNextOn: html! !

WADecoration subclass: #SSIntroductionDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Decorations'!

!SSIntroductionDecoration methodsFor: 'rendering' stamp: 'topa 6/19/2010 19:09'!
renderContentOn: html
	html paragraph: 'To register a new project please fill-in the following form. Note that the project name has to be unique within SqueakSource, it cannot be changed after registration and should not contain blanks or other special characters.'.
	self renderNextOn: html! !

WADecoration subclass: #SSVersionListingDecoration
	instanceVariableNames: 'actionName version versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Decorations'!

!SSVersionListingDecoration class methodsFor: 'instance creation' stamp: 'topa 3/14/2011 17:34'!
actionName: aString version: aVersion versions: aCollection
	^self new
		actionName: aString;
		version: aVersion;
		versions: aCollection;
		yourself! !

!SSVersionListingDecoration methodsFor: 'accessing' stamp: 'topa 3/14/2011 17:34'!
actionName
	"Answer the value of actionName"

	^ actionName! !

!SSVersionListingDecoration methodsFor: 'accessing' stamp: 'topa 3/14/2011 17:34'!
actionName: anObject
	"Set the value of actionName"

	actionName := anObject! !

!SSVersionListingDecoration methodsFor: 'rendering' stamp: 'topa 5/10/2011 15:49'!
renderContentOn: html
	html text: 'Really ', self actionName greaseString, ' of package "', self version packageName, '"?'.
	html unorderedList: [
		self versions do: [ :each |
			html listItem: each fileName ] ].
	self renderNextOn: html! !

!SSVersionListingDecoration methodsFor: 'accessing' stamp: 'pmm 9/18/2007 21:38'!
version
	^version! !

!SSVersionListingDecoration methodsFor: 'accessing' stamp: 'pmm 9/18/2007 21:38'!
version: aVersion
	version := aVersion! !

!SSVersionListingDecoration methodsFor: 'accessing' stamp: 'pmm 9/18/2007 21:36'!
versions
	^versions! !

!SSVersionListingDecoration methodsFor: 'accessing' stamp: 'pmm 9/18/2007 21:36'!
versions: aCollection
	versions := aCollection! !

WATask subclass: #SSInstallWizzard
	instanceVariableNames: 'options squeaksource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-View-Components'!

!SSInstallWizzard class methodsFor: 'accessing' stamp: 'dkh 05/20/2011 09:43'!
applicationName

	^'installSS'! !

!SSInstallWizzard class methodsFor: 'class-initialization' stamp: 'jgf 7/24/2009 08:46'!
description

	^'Create a SqueakSource Repository'.! !

!SSInstallWizzard class methodsFor: 'description' stamp: 'topa 10/12/2010 18:40'!
descriptionAdminFullname

	^ MAStringDescription new
		label: 'Administrator (full name)';
		propertyAccessor: #adminFullname;
		default: 'Administrator';
		priority: 300;
		beRequired;
		yourself! !

!SSInstallWizzard class methodsFor: 'description' stamp: 'topa 10/21/2010 17:31'!
descriptionAdminLogin

	^ MAStringDescription new
		label: 'Administrator Login';
		propertyAccessor: #adminLogin;
		default: 'adm';
		priority: 400;
		beRequired;
		yourself! !

!SSInstallWizzard class methodsFor: 'description' stamp: 'topa 10/12/2010 19:03'!
descriptionAdminPassword

	| default |
	default := 'seaside'.
	^ MAPasswordDescription new
		label: 'Password (default: ', default, ')';
		propertyAccessor: #adminPassword;
		default: default;
		priority: 500;
		beRequired;
		yourself! !

!SSInstallWizzard class methodsFor: 'description' stamp: 'topa 5/24/2011 16:46'!
descriptionCacheTimeout

	^ MANumberDescription new
		label: 'Cache timeout (seconds; affects session length)';
		propertyAccessor: #cacheTimeout;
		default: 600;
		priority: 700;
		yourself! !

!SSInstallWizzard class methodsFor: 'description' stamp: 'dkh 05/20/2011 10:11'!
descriptionRepositoryTitle

	^ MAStringDescription new
		label: 'Repository Title';
		propertyAccessor: #repositoryTitle;
		default: 'SqueakSource3';
		priority: 200;
		beRequired;
		yourself! !

!SSInstallWizzard class methodsFor: 'description' stamp: 'topa 10/12/2010 18:44'!
descriptionStorageClass

	^ MASingleOptionDescription new
		label: 'Storage Class';
		propertyAccessor: #storageClass;
		reference: MAClassDescription new;
		options: [SSStorage allSubclasses] magritteDynamicObject;
		default: SSStorage defaultSubclass;
		priority: 600;
		beRequired;
		yourself! !

!SSInstallWizzard class methodsFor: 'description' stamp: 'topa 10/12/2010 18:39'!
descriptionUrl

	^ MAStringDescription new
		label: 'Installation URL';
		propertyAccessor: #url;
		default: 'ss';
		priority: 100;
		beRequired;
		yourself! !

!SSInstallWizzard class methodsFor: 'class-initialization' stamp: 'dkh 05/20/2011 09:44'!
initialize
	"self initialize"

	self register! !

!SSInstallWizzard class methodsFor: 'class-initialization' stamp: 'dkh 05/20/2011 09:44'!
register
	"self register"

	WAAdmin 
		register: self
		asApplicationAt: self applicationName! !

!SSInstallWizzard class methodsFor: 'class-initialization' stamp: 'dkh 05/20/2011 09:41'!
unregister
	"self unregister"
	
	WAAdmin unregister: self applicationName! !

!SSInstallWizzard methodsFor: 'magritte' stamp: 'dkh 05/18/2011 11:13'!
description

	" can't use super implementation here, as this is essentially a Component, 
	and thus uses self class description in another way"
	MADescriptionBuilder default flush. "clear cache"
	^MADescriptionBuilder for: self class! !

!SSInstallWizzard methodsFor: 'running' stamp: 'topa 10/13/2010 07:30'!
go
	| editor |
	editor := self asComponent
		addValidatedForm;
		addTitle: 'SqueakSource Installation Wizard';
		yourself.
	(self call: editor)
		ifNil: [self requestContext redirectTo: '/'.]
		ifNotNil: [self install]! !

!SSInstallWizzard methodsFor: 'processing' stamp: 'topa 4/4/2011 15:55'!
install

	| admin repository |
	admin := (SSMember login: (self options at: #adminLogin))
		fullname: (self options at: #adminFullname);
		superuser: true;
		password: (self options at: #adminPassword);
		yourself.

	repository := SSRepository new
		title: (self options at: #repositoryTitle);
		addMember: admin;
		yourself.
	SSRepository 
		setRepository: repository
		storage: (self options at: #storageClass) new.

	GRPlatform current addToStartUpList: SSRepository.

	self squeaksource: (SSFrame registerAsApplication: (self options at: #url)).

	"process optionals"
	(Pragma allNamed: #options in: self class) do: [:pragma |
		self perform: pragma selector].

	"go"
	self requestContext redirectTo: '/', (self options at: #url)! !

!SSInstallWizzard methodsFor: 'processing' stamp: 'topa 5/24/2011 16:45'!
installCachge

	<options>
	self squeaksource 
		cache expiryPolicy configuration
		at: #cacheTimeout put: (self options at: #cacheTimeout).! !

!SSInstallWizzard methodsFor: 'accessing' stamp: 'topa 10/11/2010 17:00'!
options

	^ options ifNil: [options := Dictionary new]! !

!SSInstallWizzard methodsFor: 'accessing' stamp: 'topa 10/13/2010 07:31'!
options: anObject
	"Set the value of options"

	options := anObject! !

!SSInstallWizzard methodsFor: 'accessing' stamp: 'topa 10/13/2010 07:32'!
properties

	"alias for Magritte"
	^ self options! !

!SSInstallWizzard methodsFor: 'accessing' stamp: 'topa 10/13/2010 07:31'!
squeaksource
	"Answer the value of squeaksource"

	^ squeaksource! !

!SSInstallWizzard methodsFor: 'accessing' stamp: 'topa 10/13/2010 07:31'!
squeaksource: anObject
	"Set the value of squeaksource"

	squeaksource := anObject! !

WAPragmaBasedRestfulFilter subclass: #SSUrlFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Core-Server'!

!SSUrlFilter methodsFor: 'errors' stamp: 'pmm 6/27/2010 17:37'!
authResponseFor: aProject

	self responseGenerator authenticate: aProject title! !

!SSUrlFilter methodsFor: 'private' stamp: 'topa 3/21/2011 09:02'!
basicPutVersionOfProject: projectName
	self writeProjectNamed: projectName do: [ :project :author |
		| data version blessed |
		data := self requestContext request rawBody.
		version := [ project addVersion: data author: author ]
			on: SSVersionAlreadyExists
			do: [ :exception |
				self requestContext respond: [ :response |
					response
						status: 409;
						contentType: WAMimeType textPlain;
						nextPutAll: 'Version already exists: ';
						nextPutAll: exception messageText]].
			^ version ].
		^ nil! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'topa 12/20/2010 09:10'!
blessed: projectName
	<GET>
	<Path: '/{projectName}/blessed'>
	self projectNamed: projectName do: [ :project |
		(SSBlessedVersionListing user: self user project: project) respondRendered ]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'pmm 6/28/2010 07:02'!
blessedVersion: fileName ofProject: projectName
	<GET>
	<Path: '/{projectName}/blessed/{fileName}.mcz'>
	self version: fileName ofProject: projectName! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'dkh 05/18/2011 14:12'!
changes: fileName ofProject: projectName
	<GET>
	<Path: '/{projectName}/changes/{fileName}.cs'>
	self projectNamed: projectName do: [ :project |
		(self isAllowed: SSAccessPolicy read in: project)
			ifFalse: [ self authResponseFor: project ]
			ifTrue: [ | version |
				(version := project versionAt: (MCDiffyVersion verNameFrom: fileName), '.mcz')
					ifNil: [ self errorNotFound: fileName].
				(self isAllowed: SSAccessPolicy read for: version in: project)
					ifFalse: [ self authResponseFor: project ]
					ifTrue: [ | mcdData |
						(mcdData := version getDiffyVersion: fileName in: project)
							ifNil: [ self errorNotFound: fileName ].
						self requestContext respond: [ :response |
							GRPlatform current squeaksourceDoWithoutProgressNotification: [
								response 
									contentType: WAMimeType textPlain;
									nextPutAll: (String streamContents: [:s |
										(SSChangesWriter on: s) writeVersion: (MCMcdReader versionFromStream: (RWBinaryOrTextStream on: mcdData))])]]]]]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'topa 3/31/2011 20:47'!
changesOfProject: projectName
	<GET>
	<Path: '/{projectName}/changes/'>
	self changesOfProject: projectName view: 'collapse'.! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'topa 3/31/2011 20:48'!
changesOfProject: projectName view: expand
	<GET>
	<Path: '/{projectName}/changes/?view={expand}'>
	self projectNamed: projectName do: [ :project |
		(SSChangesListing
			user: self user
			project: project)
			expand: (expand = 'expand');
			respondRendered ]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'pmm 6/28/2010 06:58'!
configuration: fileName ofProject: projectName
	<GET>
	<Path: '/{projectName}/{fileName}.mcm'>
	self projectNamed: projectName do: [ :project |
		project configs at: fileName, '.mcm' ifPresent: [ :config |
			self requestContext respond: [ :response |
				response
					contentType: WAMimeType textPlain;
					nextPutAll: (String streamContents: [ :stream |
						config fileOutOn: stream ]) ] ].
			self errorNotFound: fileName, '.mcm' ]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'topa 5/17/2011 06:37'!
deleteVersion: fileName ofProject: projectName
	<DELETE>
	<Path: '/{projectName}/{fileName}.mcz'>
	self projectNamed: projectName do: [ :project |
		 | version |
		(version := project versionAt: fileName, '.mcz')
			ifNil: [ self errorNotFound: fileName ].
		(self isAllowed: SSAccessPolicy read for: version in: project)
			ifFalse: [ self authResponseFor: project ]
			ifTrue: [ | author |
				author := self user.
				project deleteVersion: version.
				self storage log: 'DELETE ', self requestContext request url greaseString, ' (', author login, ')'.
				self save.
				self requestContext respond: [ :response |
					response
					status: 204]]]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'topa 3/31/2011 09:49'!
diffText: fileName ofProject: projectName
	<GET>
	<Path: '/{projectName}/{fileName}.diff'>
	self projectNamed: projectName do: [ :project |
		"For efficiency, this should use the cached .mcd instead of diffing all the time"
		| version |
		(version := project versionAt: fileName, '.mcz')
			ifNil: [ self errorNotFound: fileName ].
		(self isAllowed: SSAccessPolicy read for: version in: project)
			ifFalse: [ self authResponseFor: project ]
			ifTrue: [
				self requestContext respond: [ :response |
					response 
						contentType: WAMimeType textPlain;
						nextPutAll: (String streamContents: [:s |
							(SSDiffyTextWriter on: s) writeVersion: version for: project])]]]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'topa 3/31/2011 09:54'!
diffyVersion: fileName ofProject: projectName
	<GET>
	<Path: '/{projectName}/{fileName}.mcd'>
	self projectNamed: projectName do: [ :project |
			| verName version mcdData |
			verName := MCDiffyVersion verNameFrom: fileName.
			version := project versionAt: verName, '.mcz'.
			version ifNil: [ self errorNotFound: fileName ].
			(self isAllowed: SSAccessPolicy read for: version in: project)
				ifFalse: [ self authResponseFor: project ]
				ifTrue: [
					mcdData := version getDiffyVersion: fileName in: project.
					mcdData ifNil: [ self errorNotFound: fileName ].
					version increaseDownloadCounterForType: self downloadTypeOfCurrentRequest.
					self requestContext respond: [ :response |
						response
							contentType: (WAMimeType main: 'application' sub: 'x-monticello');
							binary;
							nextPutAll: mcdData ] ] ]! !

!SSUrlFilter methodsFor: 'private' stamp: 'pmm 6/27/2010 23:03'!
downloadTypeOfCurrentRequest
	| agent |
	agent := self requestContext request
		headerAt: 'user-agent'
		ifAbsent: [ 'unknown' ].
	^(agent beginsWith: 'Squeak')
		ifTrue: [ #Squeak ]
		ifFalse: [ #Web ]! !

!SSUrlFilter methodsFor: 'errors' stamp: 'pmm 6/30/2010 09:02'!
errorNotFound: aString
	self requestContext responseGenerator notFound; respond! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'pmm 6/29/2010 16:13'!
fakeApacheListingOfProject: projectName
	<GET>
	<Path: '/{projectName}/?C=M;O%3DD'>
	self listingOfProject: projectName! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'pmm 6/30/2010 17:53'!
faviconIco
	<GET>
	<Path: 'favicon.ico'>
	self requestContext respond:  [ :response |
		response
			contentType: (WAMimeType main: 'image' sub: 'x-icon');
			binary;
			nextPutAll: self repository favicon ]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'topa 12/20/2010 09:10'!
feedOfProject: projectName
	<GET>
	<Path: '/{projectName}/feed.rss'>
	self projectNamed: projectName do: [ :project |
		(SSRssListing user: self user project: project) respondRendered ]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'obi 3/15/2011 08:04'!
fullFeed
	<GET>
	<Path: 'feed.rss'>
	(SSRssListing user: self user projects: (self repository visibleProjectsTo: self user)) respondRendered! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'DaleHenrichs 07/10/2010 12:22'!
groups
	<GET>
	<Path: '/Groups'>
	self noRouteFound: self requestContext! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'DaleHenrichs 07/10/2010 12:32'!
help
	<GET>
	<Path: '/Help'>
	self noRouteFound: self requestContext! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'DaleHenrichs 07/10/2010 12:33'!
home
	<GET>
	<Path: '/Home'>
	self noRouteFound: self requestContext! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'pmm 6/30/2010 08:58'!
homepageOfProject: projectName
	<GET>
	<Path: '/{projectName}.html'>
	self projectNamed: projectName do: [ :project |
		self noRouteFound: self requestContext ]! !

!SSUrlFilter methodsFor: 'private' stamp: 'topa 12/20/2010 09:10'!
isAllowed: aSymbol for: aVersion in: aProject
	^aProject isMember: self user allowedTo: aSymbol for: aVersion! !

!SSUrlFilter methodsFor: 'private' stamp: 'topa 12/20/2010 09:10'!
isAllowed: aSymbol in: aProject
	^aProject isMember: self user allowedTo: aSymbol! !

!SSUrlFilter methodsFor: 'private' stamp: 'pmm 6/29/2010 16:17'!
isGooglebot
	^(self requestContext request headerAt: 'user-agent' ifAbsent: [ '' ])
		includesSubString: 'Googlebot'! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'topa 12/20/2010 09:10'!
listingOfProject: projectName
	<GET>
	<Path: '/{projectName}'>
	self projectNamed: projectName do: [ :project |
		(SSDirectoryListing
			user: self user
			project: project
			fakeZips: self isGooglebot) respondRendered ]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'DaleHenrichs 07/10/2010 12:32'!
members
	<GET>
	<Path: '/Members'>
	self noRouteFound: self requestContext! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'topa 3/31/2011 14:04'!
noRouteFound: aRequestContext
	self next handleFiltered: aRequestContext! !

!SSUrlFilter methodsFor: 'private' stamp: 'topa 12/20/2010 11:11'!
projectNamed: aString do: aOneArgumentBlock

	| project |
	project := self
		projectNamed: aString
		ifNotAllowed: [:pjct | self authResponseFor: pjct].
	project 
		ifNil: [self errorNotFound: aString]
		ifNotNil: [aOneArgumentBlock value: project].! !

!SSUrlFilter methodsFor: 'private' stamp: 'topa 12/20/2010 09:11'!
projectNamed: aString ifNotAllowed: aBlock
	| project |
	project := self repository projectAt: aString ifAbsent: [ ^nil ].
	^ (self repository isVisible: project to: self user)
		ifTrue: [ project ]
		ifFalse: [ aBlock value: project ]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'DaleHenrichs 07/10/2010 12:31'!
projects
	<GET>
	<Path: '/Projects'>
	self noRouteFound: self requestContext! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'topa 12/20/2010 11:11'!
putBlessedVersion: fileName ofProject: projectName
	<PUT>
	<Path: '/{projectName}/{fileName}.mcz/blessed'>
	self projectNamed: projectName do: [ :project |
		| version |
		version := self basicPutVersionOfProject: projectName.
		version ifNotNil: [
			| blessed |
			blessed := true.
			project
				blessVersion: version
				ifForbidden: [ blessed := false ].
			self save.
			self requestContext respond: [ :response |
				response
					status: 201;
					nextPutAll: (blessed
						ifTrue: [ 'Version blessed' ]
						ifFalse: [ 'Version NOT blessed' ] ) ] ] ]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'pmm 6/29/2010 08:08'!
putMap: fileName ofProject: projectName
	<PUT>
	<Path: '/{projectName}/{fileName}.mcm'>
	self writeProjectNamed: projectName do: [ :project :author |
		| data config |
		data := self requestContext request rawBody.
		config := project addConfig: data author: author url: self requestContext request url.
		self save.
		self requestContext respond: [ :response |
			response
				status: 201;
				nextPutAll: 'Version NOT blessed' ] ]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'obi 3/15/2011 08:13'!
putVersion: fileName ofProject: projectName
	<PUT>
	<Path: '/{projectName}/{fileName}.mcz'>
	| version |
	version := self basicPutVersionOfProject: projectName.
	version ifNotNil: [
		self save.
		self requestContext respond: [ :response |
			response
				status: 201;
				nextPutAll: 'Version NOT blessed' ] ]! !

!SSUrlFilter methodsFor: 'accessing' stamp: 'pmm 6/27/2010 16:57'!
repository
	^ SSRepository current! !

!SSUrlFilter methodsFor: 'private' stamp: 'pmm 6/27/2010 17:37'!
responseGenerator
	^ self requestContext responseGenerator! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'pmm 6/27/2010 16:55'!
robotsTxt
	<GET>
	<Path: 'robots.txt'>
	"allow
	http://squeaksource.com/
	http://squeaksource.com/ss
	http://squeaksource.com/ss/
	http://squeaksource.com/ss.html
	http://squeaksource.com/ss/SqueakSource-al.1000.zip

	disallow
	http://squeaksource.com/_s=foo&_k=bar

	attention google is picky about subdomains"
	self requestContext respond: [ :response |
		response
			contentType: WAMimeType textPlain;
			nextPutAll: 
				'User-agent: *', String crlf,
				'Disallow: /_s', String crlf,
				'Disallow: /_k' ]! !

!SSUrlFilter methodsFor: 'private' stamp: 'obi 3/15/2011 08:13'!
save
	self storage saveRepository: self repository! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'topa 12/20/2010 11:12'!
sitemapXml
	<GET>
	<Path: 'sitemap.xml'>
	| document |
	document := SSSiteMapBuilder buildForRepository: self repository.
	document ifNil: [ self errorNotFound: 'sitemap.xml' ].
	self requestContext respond: [:response |
		response
			contentType: (WAMimeType  main: 'text' sub: 'xml');
			nextPutAll: document ]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'topa 12/20/2010 11:12'!
sitemapXmlGz
	<GET>
	<Path: 'sitemap.xml.gz'>
	| document |
	document := SSSiteMapBuilder buildGzForRepository: self repository.
	document ifNil: [ self errorNotFound: 'sitemap.xml.gz' ].
	self requestContext respond: [:response |
		response
			contentType: (WAMimeType  main: 'application' sub: 'x-gzip');
			binary;
			nextPutAll: document ]! !

!SSUrlFilter methodsFor: 'accessing' stamp: 'pmm 6/27/2010 23:04'!
storage
	^ SSRepository storage! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'DaleHenrichs 07/10/2010 12:31'!
tags
	<GET>
	<Path: '/Tags'>
	self noRouteFound: self requestContext! !

!SSUrlFilter methodsFor: 'private' stamp: 'pmm 6/29/2010 16:24'!
user
	| request |
	request := self requestContext request.
	^ self repository 
		authenticateUser: request user
		password: request password! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'pmm 6/27/2010 23:08'!
version: fileName ofProject: projectName
	<GET>
	<Path: '/{projectName}/{fileName}.mcz'>
	self
		version: fileName
		ofProject: projectName
		as: (WAMimeType main: 'application' sub: 'x-monticello')! !

!SSUrlFilter methodsFor: 'private' stamp: 'pmm 6/30/2010 18:05'!
version: fileName ofProject: projectName as: aMimeType
	self projectNamed: projectName do: [ :project |
			| version |
			version := project
				versionAt: fileName, '.mcz'
				ifAbsent: [ self errorNotFound: fileName ].
			(self isAllowed: SSAccessPolicy read for: version in: project)
				ifFalse: [ self authResponseFor: project ]
				ifTrue: [ 
					version increaseDownloadCounterForType: self downloadTypeOfCurrentRequest.
					[ self requestContext respond: [ :response |
						response
							contentType: aMimeType;
							binary;
							nextPutAll: (self storage loadMonticello: version from: project) ] ]
						on: Error
						do: [ self errorNotFound: fileName ] ] ]! !

!SSUrlFilter methodsFor: 'private' stamp: 'topa 12/20/2010 09:10'!
writeProjectNamed: aString do: aTwoArgumentBlock
	self projectNamed: aString do: [ :project |
		| author |
		(self isAllowed: SSAccessPolicy write in: project)
			ifFalse: [ self authResponseFor: project ].
		author := self user.
		self storage log: 'PUT ', self requestContext request url greaseString, ' (', author login, ')'.
		aTwoArgumentBlock value: project value: author ]! !

!SSUrlFilter methodsFor: 'request-handling' stamp: 'pmm 6/27/2010 23:10'!
zippedVersion: fileName ofProject: projectName
	"Fake a ZIP for Google"
	<GET>
	<Path: '/{projectName}/{fileName}.zip'>
	self
		version: fileName
		ofProject: projectName
		as: (WAMimeType main: 'application' sub: 'zip')! !
SSRepository initialize!
SSInstallWizzard initialize!
